{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit GlsLSystemFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TLSystemForm = class(TForm)
    Panel1: TPanel;
    Label85: TLabel;
    Label89: TLabel;
    TPIEdit: TEdit;
    TCircledEdit: TEdit;
    TDegreeEdit: TEdit;
    TAxiomEdit: TEdit;
    Label129: TLabel;
    TKanEdit: TEdit;
    Label90: TLabel;
    TPruleEdit: TEdit;
    TurtleUpDown: TUpDown;
    Label5: TLabel;
    Label6: TLabel;
    TStrLenEdit: TEdit;
    Label105: TLabel;
    TProjEdit: TEdit;
    TurtleRG: TRadioGroup;
    DOfLevelEdit: TEdit;
    Label138: TLabel;
    Label101: TLabel;
    TXMinEdit: TEdit;
    Label102: TLabel;
    TYMinEdit: TEdit;
    Label103: TLabel;
    TZxmaxEdit: TEdit;
    Label104: TLabel;
    TZymaxEdit: TEdit;
    TClearBtn: TSpeedButton;
    TFileOpen: TSpeedButton;
    TurtleFileEdit: TEdit;
    TFileSave: TSpeedButton;
    THelpBtn: TBitBtn;
    TurtleOK: TBitBtn;
    Splitter1: TSplitter;
    ScrollBox1: TScrollBox;
    LSystemImage: TImage;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ExitBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure TurtleUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure TClearBtnClick(Sender: TObject);
    procedure TFileOpenClick(Sender: TObject);
    procedure TFileSaveClick(Sender: TObject);
    procedure THelpBtnClick(Sender: TObject);
    procedure TurtleOKClick(Sender: TObject);

    procedure TurtleRun;
    procedure SelectNextTurtleFun(Way: Boolean);
    procedure TurtlePresent(TurtleLevelDo: Integer);
    procedure TurtleNext(TurtleLevelDo: Integer);
    procedure TurtleLoadDo(FilesS: string);
    procedure ExitBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LSystemForm: TLSystemForm;
  TKan, Axiom: string;
   FYImageX,FYImageY,  TurtleLevel,
  TPI, TCircled, TDegrees, TurtleDirN,
  TXminI, TmaxI, TYminI, TYmaxI: Integer;
  ProductionRules: array[1..52] of string;

implementation

uses  dtmPOFvar, TreeConstants, GlsLsysTurtlep;
{$R *.DFM}


procedure TLSystemForm.FormCreate(Sender: TObject);
begin
  Left:=LSystemFormX;
  Top:=LSystemFormY;
  TurtleUpDown.Position := 1;
  TurtleLevel := 1;
  FYImageX:=640;
  FYImageY:=480;
end;
procedure TLSystemForm.ExitBtnClick(Sender: TObject);
begin
close
end;
procedure TLSystemForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  LSystemFormX:=LSystemForm.Left;
  LSystemFormY:=LSystemForm.Top;
end;


procedure TLSystemForm.TurtleUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
  if (Button = btNext) then begin
    if ((TurtleLevel + 1) < 52) then
      SelectNextTurtleFun(Button = btNext)
  end
  else begin if ((TurtleLevel - 1) >= 1) then
      SelectNextTurtleFun(Button = btNext); end;

{ When Button is btPrev, the Down or Left arrow was clicked,
  and the value of Position is about to decrease by Increment.}
end;
procedure TLSystemForm.SelectNextTurtleFun(Way: Boolean);
begin
{Read Present before changing}
  TurtlePresent(TurtleLevel);
  if Way then inc(TurtleLevel) else dec(TurtleLevel);
{Write Next to display}
  TurtleNext(TurtleLevel);
end;
procedure TLSystemForm.TurtlePresent(TurtleLevelDo: Integer);
var code: integer; TempS: string;
begin {}
  Axiom := TAxiomEdit.Text;
  TKan := TKanEdit.Text;
  if (TPIEdit.Text <> '0') then begin
    val(TPIEdit.Text, TPI, Code);
    //    Codefx(TPIEdit.Text, Code);
    TCircled := (TPI * 2); {TPI  Convert the PI to 2 circled}
    str(TCircled, TempS); TCircledEdit.Text := TempS;
    TDegrees := (360 div TCircled); {TPI  Convert the PI to degrees}
    str(TDegrees, TempS); TDegreeEdit.Text := TempS;
  end else
    if (TCircledEdit.Text <> '0') then begin
      val(TCircledEdit.Text, TCircled, Code);
      //  Codefx(TCircledEdit.Text, Code);
      TPI := (TCircled div 2); {TPI  Convert the 2PI to degrees}
      val(TPIEdit.Text, TPI, Code);
      //Codefx(TPIEdit.Text, Code);
      TDegrees := (360 div TCircled);
        {TPI  Convert the 2PI to degrees}
      str(TDegrees, TempS); TDegreeEdit.Text := TempS;
    end else
      if (TDegreeEdit.Text <> '0') then begin
        val(TDegreeEdit.Text, TDegrees, Code);
        //  Codefx(TDegreeEdit.Text, Code);
        TPI := (180 div TDegrees);
          {TDegrees  Convert the degrees to PI }
        str(TPI, TempS); TPIEdit.Text := TempS;
        TCircled := (TPI * 2); {TPI  Convert the PI to 2 circled}
        str(TCircled, TempS); TCircledEdit.Text := TempS;
      end else {DoMessages(30204)};

{  TurtleDirN:=TPI;     }
  TurtleDirN := TCircled;
  val(TXMinEdit.Text, TXminI, Code);// Codefx(TXMinEdit.Text, Code);
  val(TYMinEdit.Text, TYminI, Code);// Codefx(TYMinEdit.Text, Code);
  val(TZxmaxEdit.Text, TmaxI, Code);// Codefx(TZxmaxEdit.Text, Code);
  val(TZymaxEdit.Text, TYmaxI, Code);// Codefx(TZymaxEdit.Text, Code);
{Get Turtle(TurtleLevel);}
  ProductionRules[TurtleLevelDo] := TProjEdit.Text;
end;

procedure TLSystemForm.TurtleNext(TurtleLevelDo: Integer);
begin {}
{Get Turtle(TurtleLevel);}
  TProjEdit.Text := ProductionRules[TurtleLevelDo];
end;

procedure TLSystemForm.TClearBtnClick(Sender: TObject);
var i, code: integer;
  SizeStr: string;
begin
  TPIEdit.Text := 'Turtle.FLA';
  TProjEdit.Text := '';
  for i := 1 to 52 do begin
    ProductionRules[i] := '';
    TurtleUpDown.Position := 1;
    TurtleLevel := 1;
    Axiom := '';
    TAxiomEdit.Text := Axiom;
    TKan := '';
    TKanEdit.Text := TKan;
{TPI:Extended;}
    TPIEdit.Text := '0';
    val(TPIEdit.Text, TPI, Code);
 {   Codefx(TPIEdit.Text, Code); }
{TCircledEdit:Extended;}
    TCircledEdit.Text := '0';
    val(TCircledEdit.Text, TCircled, Code);
   {  Codefx(TCircledEdit.Text,   Code); }
{TDegrees:Extended;}
    TDegreeEdit.Text := '0';
    val(TDegreeEdit.Text, TDegrees, Code);
  {  Codefx(TDegreeEdit.Text,   Code); }
    TurtleRG.ItemIndex := 0;
{TXminI}
    TXMinEdit.Text := '0';
    val(TXMinEdit.Text, TXminI, Code);
 {   Codefx(TXMinEdit.Text, Code);    }
{TYminI}
    TYMinEdit.Text := '0';
    val(TYMinEdit.Text, TYminI, Code);
   {  Codefx(TYMinEdit.Text, Code); }
{TmaxI}
    str(FYImageX, SizeStr);
    TZxmaxEdit.Text := SizeStr;
    val(TZxmaxEdit.Text, TmaxI, Code);
    { Codefx(TZxmaxEdit.Text, Code);}
{TYmaxI:Integer;}
    str(FYImageY, SizeStr);
    TZymaxEdit.Text := SizeStr;
    val(TZymaxEdit.Text, TYmaxI, Code);
 {   Codefx(TZymaxEdit.Text,   Code);   }
  end;
end;

procedure TLSystemForm.TFileOpenClick(Sender: TObject);
var MyFilesS: string;
begin { Display Open dialog box }
  OpenDialog1.InitialDir:=ProjectPath;
  OpenDialog1.Filter := 'Turtle (*.FLA)|*.FLA';
  OpenDialog1.Filename := TurtleFileEdit.Text;
  if OpenDialog1.Execute then begin
    MyFilesS := Uppercase(ExtractFileExt(OpenDialog1.FileName));
    ProjectPath:=ExtractFilePath(OpenDialog1.FileName);
    if MyFilesS = '.FLA' then begin
      MyFilesS := ExtractFileName(OpenDialog1.FileName);
      TurtleFileEdit.Text := MyFilesS;
      TurtleLoadDo(OpenDialog1.FileName);
    end;
  end;
end;
procedure TLSystemForm.TurtleLoadDo(FilesS: string);
var
  fTurtleFile: TextFile;
  TurtleLeveled, i, Code: Integer;
  MyFilesS: string;
begin
  AssignFile(fTurtleFile, FilesS);
  Reset(fTurtleFile);
  if IoResult <> 0 then
  begin
   { DoMessages(30102)};
  end else
  begin {Readln Turtle files}
{Axiom:String;}
    Readln(fTurtleFile, Axiom);
    TAxiomEdit.Text := Axiom;
{TKan:String;}
    Readln(fTurtleFile, TKan);
    TKanEdit.Text := TKan;
{Get Turtle(TurtleLevel);}
    Readln(fTurtleFile, MyFilesS);
    val(MyFilesS, TurtleLeveled, Code); //Codefx(MyFilesS, Code);
    TurtleRG.ItemIndex := TurtleLeveled;
{TurtleLevel:=TurtleLeveled; }
{TPI:Extended;}
    Readln(fTurtleFile, MyFilesS);
    TPIEdit.Text := MyFilesS;
    val(TPIEdit.Text, TPI, Code); //Codefx(TPIEdit.Text, Code);
{TCircled:Extended;}
    Readln(fTurtleFile, MyFilesS);
    TCircledEdit.Text := MyFilesS;
    val(TCircledEdit.Text, TCircled, Code);
    //Codefx(TCircledEdit.Text,  Code);
{TDegrees:Extended;}
    Readln(fTurtleFile, MyFilesS);
    TDegreeEdit.Text := MyFilesS;
    val(TDegreeEdit.Text, TDegrees, Code);
    //Codefx(TDegreeEdit.Text,  Code);
{TXminI} Readln(fTurtleFile, MyFilesS);
    TXminEdit.Text := MyFilesS;
    val(TXMinEdit.Text, TXminI, Code);
    // Codefx(TXMinEdit.Text, Code);
{TYminI} Readln(fTurtleFile, MyFilesS);
    TYMinEdit.Text := MyFilesS;
    val(TYMinEdit.Text, TYminI, Code);
    //Codefx(TYMinEdit.Text, Code);
{TmaxI} Readln(fTurtleFile, MyFilesS);
    TZxmaxEdit.Text := MyFilesS;
    val(TZxmaxEdit.Text, TmaxI, Code);
    //Codefx(TZxmaxEdit.Text, Code);
{TYmaxI:Integer;} Readln(fTurtleFile, MyFilesS);
    TZymaxEdit.Text := MyFilesS;
    val(TZymaxEdit.Text, TYmaxI, Code);
    //Codefx(TZymaxEdit.Text,  Code);
    for i := 1 to 52 do begin
{ProductionRules:Array [0..127] of String;}
      Readln(fTurtleFile, MyFilesS);
      ProductionRules[i] := MyFilesS;
    end;
    TurtleUpDown.Position := 1;
    TProjEdit.Text := ProductionRules[1];
  end;
  CloseFile(fTurtleFile);
end;

procedure TLSystemForm.TFileSaveClick(Sender: TObject);
var MyFilesS: string;
  fTurtleFile: TextFile;
  TurtleLeveled, Code: Integer;
begin { Display Open dialog box }
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter := 'Turtle (*.FLA)|*.FLA';
  SaveDialog1.Filename := TurtleFileEdit.Text;
  if SaveDialog1.Execute then begin
    MyFilesS := Uppercase(ExtractFileExt(SaveDialog1.FileName));
    ProjectPath:=ExtractFilePath(SaveDialog1.FileName); 
    if MyFilesS = '.FLA' then begin
      MyFilesS := ExtractFileName(SaveDialog1.FileName);
      TurtleFileEdit.Text := MyFilesS;
      AssignFile(fTurtleFile, SaveDialog1.FileName);
      Rewrite(fTurtleFile);
      if IoResult <> 0 then
      begin
{        DoMessages(30103);  }
      end else
      begin {Write Turtle files}
{Axiom:String;}
        Axiom := TAxiomEdit.Text;
        Writeln(fTurtleFile, Axiom);
{TKan:String;}
        TKan := TKanEdit.Text;
        Writeln(fTurtleFile, TKan);
{Get Turtle(TurtleLevel);}
        TurtleLeveled := TurtleRG.ItemIndex;
        str(TurtleLeveled, MyFilesS);
        Writeln(fTurtleFile, MyFilesS);
{TurtleLevel:=TurtleLeveled;}
{TPI:Extended;} Writeln(fTurtleFile, TPIEdit.Text);
        val(TPIEdit.Text, TPI, Code);
 {       Codefx(TPIEdit.Text, Code); }
{TCircled:Extended;}
        Writeln(fTurtleFile, TCircledEdit.Text);
        val(TCircledEdit.Text, TCircled, Code);
{          Codefx(TCircledEdit.Text, Code); }
{TDegrees:Extended;} Writeln(fTurtleFile, TDegreeEdit.Text);
        val(TDegreeEdit.Text, TDegrees, Code);
{          Codefx(TDegreeEdit.Text, Code); }
{TXminI} Writeln(fTurtleFile, TXMinEdit.Text);
        val(TXMinEdit.Text, TXminI, Code);
    {    Codefx(TXMinEdit.Text,     Code);}
{TYminI} Writeln(fTurtleFile, TYMinEdit.Text);
        val(TYMinEdit.Text, TYminI, Code);
       { Codefx(TYMinEdit.Text,    Code);   }
{TmaxI} Writeln(fTurtleFile, TZxmaxEdit.Text);
        val(TZxmaxEdit.Text, TmaxI, Code);
       { Codefx(TZxmaxEdit.Text,   Code);  }
{TYmaxI:Integer;} Writeln(fTurtleFile, TZymaxEdit.Text);
        val(TZymaxEdit.Text, TYmaxI, Code);
      {  Codefx(TZymaxEdit.Text,  Code); }
{Get Turtle(TurtleLevel);}
        ProductionRules[TurtleLevel] := TProjEdit.Text;
        for Code := 1 to 52 do begin
{ProductionRules:Array [0..127] of String;}
          Writeln(fTurtleFile, ProductionRules[Code]);
        end;
      end;
      CloseFile(fTurtleFile);
    end;
  end;
end;
(**************************************************)
(**************************************************)


procedure TLSystemForm.THelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(3100); {Turtle}
end;

procedure TLSystemForm.TurtleOKClick(Sender: TObject);
var
  PhBitmap: TBitmap;
begin
  PhBitmap:= TBitmap.create;
  PhBitmap.Width := 640;
  PhBitmap.Height := 480;
  PhBitmap.PixelFormat :=pf24bit;

  LSystemImage.Picture.Bitmap.Assign(PhBitmap);
  LSystemImage.canvas.draw(0, 0, PhBitmap);
  PhBitmap.free;
  TurtleRun;
end;
procedure TLSystemForm.TurtleRun;
var Input: Integer;
begin
  TurtlePresent(TurtleLevel);
  if (TurtleRG.ItemIndex > -1) then begin {U_Math_P}
    case TurtleRG.ItemIndex of
      0..19: Input := (TurtleRG.ItemIndex + 1);
      20: Input := 25;
      21: Input := 30;
      22: Input := 60;
      23: Input := 90;
      24: Input := 180;
    else Input := 1;
    end; {of case}
  end else Input := 1;
  Plot_System(Input);
{TAxiom:String;
TPI:Extended;
TDegrees:Extended;
TXminI,TmaxI, TYminI, TYmaxI:Integer;
ProductionRules:Array [0..127] of String;}
end;




end.
