{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit GlsMathPopulation;

interface

procedure bifurc(Rin, Din: Extended; Which,Step: Integer);
procedure feigen;
procedure bifbaum(Rin, Din: Extended; Which,Step: Integer);
procedure Malthus_1(Step: Integer);
procedure Malthus_2(Step: Integer);

implementation

uses GlsMathingsFrm;


procedure bifurc(Rin, Din: Extended; Which,Step: Integer);
var  r, x, delta_r: Extended;
  //maxcolx,   maxrowy,
  i: integer;
  //row,
  col: longint;
Begin
//    maxcolx := 200;//(FYImageX - 1);
//    maxrowy := 200;//(FYImageY - 1);
    r := 0.95;
    delta_r := 0.005;
    if ((Which = 0)) then begin
      r := 0.95;
      delta_r := 0.005;
    end;
    if ((Which = 1)) then begin
      r := 3.55;
      delta_r := 0.0005;
    end;
    if ((Which = 2)) then begin
      r := Rin { 0.95};
      delta_r := Din {0.005};
    end;
    //for col := 0 to Step{maxcolx} do
     col := Step;
    begin
      x := 0.5;
      r := r + delta_r;
      i := 0;

      repeat
        x := r * x * (1 - x);

{  COMPUTATION FOR rx(1-x)}
//        row := maxrowy - Round(x * 200{FYImageY});
                     {  COMPUTATION FOR x(1-x)}{960}
{	           row := Round(maxrowy -((x/r)*1820));}
         if i > 64 then {throw out first 64}
         { if row <= maxrowy then
            if row >= 0 then
              if col >= 0 then
                if col <= maxcolx then }
                begin
          xr :=//(maxrowy - (x * maxrowy))/10;
          x;
          //row/10;
          Yr :=col/10;
         // Zr :=Zr+0.01;//col/10;
                end; 
        Inc(i);
      until (x > 1000) or (x < -1000) or (i > 255);
    end; {Columns}
    Zr :=Zr+0.01;//col/10;
    If Step > 99 then Zr :=0;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
  //end; {End of part 1}
End;

procedure feigen;
Begin
{ NOT a graphic program - Text numbers}
End;

procedure bifbaum(Rin, Din: Extended; Which,Step: Integer);
var
  r, x, delta_r: Extended;
  //maxcolx,
  maxrowy, i, Row3: integer;
  row, col: longint;
begin
//    maxcolx := 200;//(FYImageX - 1);
    maxrowy := 200;//(FYImageY - 1);
    Row3 := ({FYImageY}200 * 3);
//    x :=0;
    r := 0.95;
    delta_r := 0.005;
    if ((Which = 0)) then begin
      r := 0.95;
      delta_r := 0.005;
    end;
    if ((Which = 1)) then begin
      r := 3.55;
      delta_r := 0.0005;
    end;
    if ((Which = 2)) then begin
      r := Rin { 0.95};
      delta_r := Din {0.005};
    end;
    for col := 0 to step{maxcolx} do
    begin
      x := 0.5;
      r := r + delta_r;
      i := 0;
      repeat
        x := r * x * (1 - x);
{  COMPUTATION FOR rx(1-x)}
{                   row := 479 - Round(x*480);          }
                     {  COMPUTATION FOR x(1-x)}{960}
        row := Round(maxrowy - ((x / r) * Row3));
        if i > 64 then {1820}xr :=row;
        //Pixels[col, row] := TempColor;
        Inc(i);
      until (x > 1000) or (x < -1000) or (i > 255);
    end; {Columns}
          xr :=xr /100;//xr :=x;
          Yr :=step/100;
          Zr :=1;//z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);

End;

procedure Malthus_1(Step: Integer);
var
  //MaxGen,
  MaxX, MaxY: integer;
  i, j, //Color,
  Count, X, Y: integer;
  PopOld, PopNew, Rate: Extended;
Begin
   {                                    }
   {    Malthusean Population Growth    }
   {     Pn+1 = R * Pn * ( 1 - Pn )     }
   {                                    }
//  MaxGen := 32766;
  Rate := 2.3;
  //Color := 0;
  x:=0;y:=0;

  begin
    MaxX :=200;// (FYImageX - 1);
    MaxY :=200;// (FYImageY - 1);
    for j := 1 to 151 do
    begin
      //inc(Color);

      Count := 0;
      Rate := Rate + 0.01; { increment Rate   }
      PopOld := 0.01; { reset Population }
      for i := 1 to (Step*100){MaxGen} do
      begin
        PopNew := Rate * (PopOld * (1 - PopOld));
        X := trunc(PopOld * MaxX);
        Y := trunc(MaxY - (PopNew * MaxY));
        //Pixels[X, Y] := TempColor;
        if PopOld = PopNew then inc(Count)
        else Count := 0;
        if Count > 10 then Break; { i := MaxGen;}
           { stagnant -- break out }
        PopOld := PopNew;
      end;
    end;
          xr :=x /100;
          Yr :=y/100;
          Zr :=1;//z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
  end;

End;

procedure Malthus_2(Step: Integer);
var
 // MaxX, MaxY,
  i, j, k, Count: integer;
  PopOld, PopNew, X, Y, Rate: Extended;
begin
  { PopOld := 0.0;
   PopNew := 0.0;}
  Rate := 2.3;
  Y := 0;
  //  MaxX :=2;// (FYImageX - 1);
  //  MaxY :=2;//  (FYImageY - 1);

    for j := 1 to 15 do
    begin
      for k := 1 to 10 do
      begin
        Count := 0;
        Rate := Rate + 0.01;
        PopOld := 0.01;
        for i := 1 to step*10{10000} do
        begin
          PopNew := Rate * (PopOld * (1 - PopOld));
          X := PopNew - PopOld;
          xr :=((X * MaxX / 2) + MaxX / 2) /100;
          Yr :=((MaxY / 2) - (Y * MaxY / 2))/100;
          if PopOld = PopNew then inc(Count)
          else Count := 0;
            Zr :=Count/10;
          if Count > 100 then break; {i := 10000;}
          PopOld := PopNew;
          Y := X;
        end;
      end;
    end; 
         // Zr :=1;//z;
  AlphaRF:=AlphaRF-Incremental ;//(255);
  AlphaGF:=AlphaGF+Incremental ;//(255);
  AlphaBF:=AlphaBF+Incremental ;//(255);
end; { of procedure Malthus_2; }


end.
