{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
{cribbed from: 8645t = Beast}
{: This bench stresses particle systems management in GLScene.<p>
This proggy basicly creates and moves the highest quantity its framerate
allows (one particle is created after each render, particles live for 3 sec).
Particles are made of a dummycube (used as axis, hosting an inertia) and a
child Sprite (untextured, unblended). Depth test is disabled.<p>
}
unit GlsMathingsFrm;

interface

uses
  Windows,SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,
  GLScene, GLTexture,
  GLCadencer, GLMisc, GLObjects, GLParticles, GLBehaviours, VectorGeometry,
  GLWin32Viewer,
  Messages, Menus,  ExtCtrls, StdCtrls;

type
  TMathingsForm = class(TForm)
	 GLSceneViewer1: TGLSceneViewer;
	 GLScene1: TGLScene;
	 GLCadencer1: TGLCadencer;
    GLCamera: TGLCamera;
	 GLParticles1: TGLParticles;
    Sprite1: TGLSprite;
    Timer1: TTimer;
    DummyCube1: TGLDummyCube;
    MainMenu1: TMainMenu;
    mmExit1: TMenuItem;
    mmHelp1: TMenuItem;
    mmHelp2: TMenuItem;
    mmAbout1: TMenuItem;
    Panel1: TPanel;
    FPSLabel: TLabel;

    mmAttractors1: TMenuItem;
    mmCyclesOfLimit1: TMenuItem;
    mmRayleigh1: TMenuItem;   {31}
    mmVanderpol1: TMenuItem;
    mmBrusselator1: TMenuItem;
    mmAll3in11: TMenuItem;

    mmStrangeAttractors1: TMenuItem;
    mmLorenzxyz1: TMenuItem;  {41}
    mmVortexxz1: TMenuItem;
    mmDuffing1: TMenuItem;
    mmRossler1: TMenuItem;
    mmHenonStairs1: TMenuItem;

    mmStrangeChemicals1: TMenuItem;
    mmAstraw1: TMenuItem;   {51}
    mmBeckon1: TMenuItem;
    mmCorkscrew1: TMenuItem;
    mmD3V1: TMenuItem;
    mmE31: TMenuItem;
    mmF2V1: TMenuItem;
    mmGoogle21: TMenuItem;
    mmAlphabetSoup1: TMenuItem;

    mmStranger1: TMenuItem;
    mmKaneko1: TMenuItem;     {61}
    mmKaneko21: TMenuItem;
    mmHenonRange1: TMenuItem;


    Population1: TMenuItem;
    mmBifurcation1: TMenuItem;
    mmBifurcation2: TMenuItem;
    mmBifurcation3: TMenuItem;
    mmFiegenbaum1: TMenuItem;
    mmFiegenbaum2: TMenuItem;
    mmFiegenbaum3: TMenuItem;
    mmFiegenbaum4: TMenuItem;
    mmMalthusian1: TMenuItem;
    mmMalthusian2: TMenuItem;

    mmRandom1: TMenuItem;
    mmOneDRandomr1: TMenuItem;
    mmTwoDLinearr1: TMenuItem;
    mmFractalG: TMenuItem;
    mmWhite1: TMenuItem;
    mmCellarWalk1: TMenuItem;
    mmWrapped1: TMenuItem;
    mmZapped1: TMenuItem;
    mmHiFiLines1: TMenuItem;
    mmChaser1: TMenuItem;
    N1: TMenuItem;

    Label19: TLabel;
    REdit: TEdit;
    Label20: TLabel;
    DEdit: TEdit;
    Label1: TLabel;
    TEdit: TEdit;
    Label2: TLabel;
    HEdit: TEdit;
    IEdit: TEdit;
    Label100: TLabel;
    BEVRG: TRadioGroup;
    XEdit: TEdit;
    YEdit: TEdit;
    ZEdit: TEdit;
    WhirlWind1: TMenuItem;
    WEdit: TEdit;
    N2: TMenuItem;
    ZoomIn1: TMenuItem;
    ZoomOut1: TMenuItem;
    BirdsEyeViewDC: TGLDummyCube;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure mmExit1Click(Sender: TObject);
    procedure mmHelp2Click(Sender: TObject);
    procedure mmAbout1Click(Sender: TObject);

    procedure GLSceneViewer1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure GLSceneViewer1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure ZoomIn1Click(Sender: TObject);
    procedure ZoomOut1Click(Sender: TObject);

    procedure Timer1Timer(Sender: TObject);
    procedure DummyCube1Progress(Sender: TObject; const deltaTime,
      newTime: Double);

    procedure mmChaser1Click(Sender: TObject);
procedure AllBtnsUp;

    procedure GLCadencer1Progress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure GLParticles1ActivateParticle(Sender: TObject;
      particle: TGLBaseSceneObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure BEVRGClick(Sender: TObject);


  private
    { Dclarations prives }
    mx,my : integer;{Mouse}
    BirdsEyeView, md:Boolean;

    CurrentMathing:Integer;
  public
    { Dclarations publiques }
  end;

var
  MathingsForm: TMathingsForm;
  //alphaA,alphaR,alphaG,alphaB:Byte;
  Incremental:Single;
  //IncrementalSign,
  IncrementalSignCounter: integer;
  alphaRF,alphaGF,alphaBF:Single;
  maxx,minx,maxy,miny,maxz,minz,   wr,//alpha,
  xr,yr,zr : Single;{  (sr, 3*r-3, cr)}
implementation


uses
  GlsMathRandom,  {  F: DLA   fumathp: random}
  GlsMathPopulation,   {fumathp:}
  GlsMathAttractors, {fUMathA; SA }
  TreeConstants,
  KeyBoard;
{$R *.DFM}

procedure TMathingsForm.FormCreate(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  Left:=MathingsFormX;
  Top:=MathingsFormY;
  Randomize;
  BirdsEyeView:=False;
  Incremental:=0.01;
  //IncrementalSign:=1;
  IncrementalSignCounter:=0;
  //alpha:=0;
  xr:=0;yr:=0;zr:=0;
  alphaRF:=1;
  alphaGF:=0;
  alphaBF:=0;
  maxx:=strtofloat(XEdit.text);
  minx:=strtofloat(XEdit.text) * -1;
  maxy:=strtofloat(yEdit.text);
  miny:=strtofloat(yEdit.text) * -1;
  maxz:=strtofloat(zEdit.text);
  minz:=strtofloat(zEdit.text) * -1;
  CurrentMathing:=0;
  //Load a Textue to the Sprite
    //Sprite1.Material.FrontProperties.Emission.Alpha:=AlphaA;
end;
procedure TMathingsForm.mmExit1Click(Sender: TObject);
begin
  Close;
end;
procedure TMathingsForm.FormShow(Sender: TObject);
begin
   Timer1.Enabled:=True;
   GLCadencer1.Enabled:=True;
end;

procedure TMathingsForm.FormHide(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
end;
procedure TMathingsForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MathingsFormX:=MathingsForm.Left;
  MathingsFormY:=MathingsForm.Top;
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  Application.ProcessMessages;
end;
procedure TMathingsForm.mmHelp2Click(Sender: TObject);
begin
  Application.HelpContext(3500);
end;

procedure TMathingsForm.mmAbout1Click(Sender: TObject);
begin
{}
end;


procedure TMathingsForm.GLSceneViewer1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  mx:=X; my:=Y;
  md:=True;
end;

procedure TMathingsForm.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
{var  d : Single; }
begin
   if md and (ssLeft in Shift) then
   begin
      {if ssLeft in Shift then begin }
      if ssCtrl  in Shift then begin
         {d:=GLCamera.DistanceToTarget*0.01*(x-mx+y-my);
         if IsKeyDown('x') then
            GLParticles1.Translate(d, 0, 0)
         else if IsKeyDown('y') then
            GLParticles1.Translate(0, d, 0)
         else if IsKeyDown('z') then
            GLParticles1.Translate(0, 0, d)
        else} GLCamera.RotateObject(GLParticles1, my-y, mx-x);
      end else
      GLCamera.MoveAroundTarget(my-y, mx-x);
      mx:=x; my:=y;
   end;
end;

procedure TMathingsForm.GLSceneViewer1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   md:=False;
end;

procedure TMathingsForm.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  GLCamera.AdjustDistanceToTarget(Power(1.05, WheelDelta/120));
  GLCamera.DepthOfView:=2*GLCamera.DistanceToTarget
                            {+2*TreeFreeForm.BoundingSphereRadius};
  Handled:=True;
end;

procedure TMathingsForm.ZoomIn1Click(Sender: TObject);
var  h : Boolean;
begin
  FormMouseWheel(Self, [], -120, Point(0, 0), h)
end;

procedure TMathingsForm.ZoomOut1Click(Sender: TObject);
var  h : Boolean;
begin
  FormMouseWheel(Self, [], 120, Point(0, 0), h);
end;



procedure TMathingsForm.DummyCube1Progress(Sender: TObject; const deltaTime,
  newTime: Double);
var   life : Double;
begin
  with TGLCustomSceneObject(Sender) do
  begin
 { if newTime-TagFloat>3 then
   GLParticles1.KillParticle(TGLCustomSceneObject(Sender));}
      life:=(newTime-TagFloat);
      if life>10 then
         // old particle to kill
         GLParticles1.KillParticle(TGLSprite(Sender))
      else if life<1 then
         // baby particles become brighter in their 1st second of life...
         Material.FrontProperties.Diffuse.Alpha:=life
      else // ...and slowly disappear in the darkness
         Material.FrontProperties.Diffuse.Alpha:=(9-life)/9;
  end;
end;

procedure TMathingsForm.Timer1Timer(Sender: TObject);
begin
  FPSLabel.Caption:=Format('%d particles, %.1f FPS',
    [GLParticles1.Count, GLSceneViewer1.FramesPerSecond]);
  GLSceneViewer1.ResetPerformanceMonitor;
end;

procedure TMathingsForm.mmChaser1Click(Sender: TObject);
begin
  //alpha:=0;alphaAF:=255;
  xr:=0;yr:=0;zr:=0;
  Incremental:=0.01;
  //IncrementalSign:=1;
  IncrementalSignCounter:=0;
  alphaRF:=1;
  alphaGF:=0;
  alphaBF:=0;
 { alphaRF:=random;//0.5;
  alphaGF:=random;//0.5;
  alphaBF:=random;//0.5; }
  maxx:=strtofloat(XEdit.text);
  minx:=strtofloat(XEdit.text) * -1;
  maxy:=strtofloat(yEdit.text);
  miny:=strtofloat(yEdit.text) * -1;
  maxz:=strtofloat(zEdit.text);
  minz:=strtofloat(zEdit.text) * -1;
  wr:=strtofloat(wEdit.text);
  CurrentMathing:= TMenuItem(Sender).Tag;
  AllBtnsUp;
  TMenuItem(Sender).Checked:=True;
end;
procedure TMathingsForm.AllBtnsUp;
Begin
  WhirlWind1.Checked:=False;
  mmOneDRandomr1.Checked:=False;
  mmTwoDLinearr1.Checked:=False;
  mmFractalG.Checked:=False;
  mmWhite1.Checked:=False;
  mmCellarWalk1.Checked:=False;
  mmWrapped1.Checked:=False;
  mmZapped1.Checked:=False;
  mmHiFiLines1.Checked:=False;
  mmChaser1.Checked:=False;
  {mmdla1.Checked:=False;
  mmdla2.Checked:=False;
  mmdla3.Checked:=False; }

  mmBifurcation1.Checked:=False;
  mmBifurcation2.Checked:=False;
  mmBifurcation3.Checked:=False;
  mmFiegenbaum1.Checked:=False;
  mmFiegenbaum2.Checked:=False;
  mmFiegenbaum3.Checked:=False;
  mmFiegenbaum4.Checked:=False;
  mmMalthusian1.Checked:=False;
  mmMalthusian2.Checked:=False;

  mmRayleigh1.Checked:=False;
  mmVanderpol1.Checked:=False;
  mmBrusselator1.Checked:=False;
  mmAll3in11.Checked:=False;
  mmLorenzxyz1.Checked:=False;
  mmVortexxz1.Checked:=False;
  mmDuffing1.Checked:=False;
  mmRossler1.Checked:=False;
  mmHenonStairs1.Checked:=False;
  mmAstraw1.Checked:=False;
  mmBeckon1.Checked:=False;
  mmCorkscrew1.Checked:=False;
  mmD3V1.Checked:=False;
  mmE31.Checked:=False;
  mmF2V1.Checked:=False;
  mmGoogle21.Checked:=False;
  mmAlphabetSoup1.Checked:=False;
  mmKaneko1.Checked:=False;
  mmKaneko21.Checked:=False;
  mmHenonRange1.Checked:=False;
End;

procedure TMathingsForm.GLCadencer1Progress(Sender: TObject; const deltaTime,
  newTime: Double);
var Ralph:Double;
begin
  If IncrementalSignCounter > 100 then
  begin
    IncrementalSignCounter:=0;
    //IncrementalSign:=IncrementalSign*-1;
    Incremental:=Incremental*-1;
  end;
   inc(IncrementalSignCounter);
  {Compute a Particles Position... Set in the Create method
   It Disappears sometime later...}
    Case CurrentMathing of
{GlsMathRandom  F: DLA   fumathp: random}

      1:
      begin    {mmOneDRandomr1}
        BBrownian(Round(StrtoFloat(REdit.Text)),IncrementalSignCounter);
      end;
      2:
      begin    {mmTwoDLinearr1}
        BBrown2d(Round(StrtoFloat(REdit.Text)),IncrementalSignCounter);
      end;
      3:
      begin    {mmFractalG}
        Brown_Gauss(
           StrtoFloat(REdit.Text),
           StrtoFloat(DEdit.Text),
           IncrementalSignCounter );
       //    Round(StrtoFloat(TEdit.Text)) );
      end;
      4:
      begin    {mmWhite1}
      WhiteBrown(IncrementalSignCounter);
      end;
      5:
      begin    {mmCellarWalk1}
        Cellar;
      end;
      6:
      begin    {mmWrapped1}
        CellTorus;
      end;
      7:
      begin   {mmZapped1}
        CellZap;
      end;
      8:
      begin    {mmHiFiLines1}
      HiFiLines;
      end;
      9:
      begin    {mmChaser1}
      Chaser(
           Strtoint(iEdit.Text),
           IncrementalSignCounter );
      end;



{GlsMathPopulation  fumathp:}
      21: bifurc(0.95, 0.005, 0,IncrementalSignCounter);{mmBifurcation1}
      22:bifurc(0.95, 0.005, 1,IncrementalSignCounter);{mmBifurcation2}
      23:bifurc(
           StrtoFloat(REdit.Text),
           StrtoFloat(DEdit.Text),
           2,IncrementalSignCounter);{mmBifurcation3}
      //24:feigen;{mmFiegenbaum1}
      25:bifbaum(
           StrtoFloat(REdit.Text),
           StrtoFloat(DEdit.Text),
           0,IncrementalSignCounter );{mmFiegenbaum2}
      26:bifbaum(
           StrtoFloat(REdit.Text),
           StrtoFloat(DEdit.Text),
           1,IncrementalSignCounter );{mmFiegenbaum3}
      27:bifbaum(
           StrtoFloat(REdit.Text),
           StrtoFloat(DEdit.Text),
           2,IncrementalSignCounter );{mmFiegenbaum4}
      28: Malthus_1(IncrementalSignCounter );{mmMalthusian1}
      29:Malthus_2(IncrementalSignCounter );{mmMalthusian2}

{GlsMathAttractors  fUMathA; SA }
      31:LimitCycles(0,IncrementalSignCounter);{mmRayleigh1}   {31}
      32:LimitCycles(1,IncrementalSignCounter);{mmVanderpol1}
      33:LimitCycles(2,IncrementalSignCounter);{mmBrusselator1}
      34:LimitCycles(3,IncrementalSignCounter);{mmAll3in11}
      41: Lorenz(IncrementalSignCounter);{mmLorenzxyz1}  {41}
      42: Strange(IncrementalSignCounter);{mmVortexxz1}
      43: Duffing(IncrementalSignCounter);{mmDuffing1}
      44: Rossler(IncrementalSignCounter);{mmRossler1}
      45: Henon_Attractor(IncrementalSignCounter);{mmHenonStairs1}
      51: StrangeChemicalsa(IncrementalSignCounter);   { mmAstraw1} {51}
      52: StrangeChemicalsb(IncrementalSignCounter);{mmBeckon1}
      53: StrangeChemicalsc(IncrementalSignCounter);{ mmCorkscrew1}
      54: StrangeChemicalsd(IncrementalSignCounter);{mmD3V1}
      55: StrangeChemicalse(IncrementalSignCounter);{mmE31}
      56: StrangeChemicalsf(IncrementalSignCounter);{mmF2V1}
      57: StrangeChemicalsg(IncrementalSignCounter);{mmGoogle21}
      58: SetChemical(IncrementalSignCounter);{mmAlphabetSoup1}
(*
      61:{61    mmKaneko1}
          Kaneko1
           ({KanA}01.3, {KanD} 0.1, {KanStep} 0.01,
           {DisKan} 30, {KanTeen }3000,IncrementalSignCounter);
      62:{62 mmKaneko21}
          Kaneko2
           ({KanA}0.3, {KanD}1.75, {KanStep} 0.02,
           {DisKan} 36, {KanTeen }3000,IncrementalSignCounter);
      63:{63 mmHenonRange1}
           Henon2(1,{Target, KamStep} 1.2,
                 {Incoming}26,IncrementalSignCounter);
*)
      else
      begin
        AllBtnsUp;
        CurrentMathing:=0;
        WhirlWind1.Checked:=True;
        Ralph:=Random*2*PI;
        yr:=2*Random;
        SinCos(Ralph, yr*yr, xr, zr);
        yr:=  3*yr-3;
        alphaRF:=Random;
        alphaGF:=Random;
        alphaBF:=Random;
      end;       {SetPoint(xr, yr, zr);}
    End;
  GLParticles1.CreateParticle;
end;

procedure TMathingsForm.GLParticles1ActivateParticle(Sender: TObject;
                                  particle: TGLBaseSceneObject);
begin
  with particle do
  begin
    //Sprite1.Material.FrontProperties.Emission.Alpha:=AlphaA;
    //Sprite1.Material.FrontProperties.Emission.Blue:=AlphaB;
    //Sprite1.Material.FrontProperties.Emission.Green:=AlphaG;
    //Sprite1.Material.FrontProperties.Emission.Red:=AlphaR;
     Sprite1.Material.FrontProperties.Emission.Color:=
     PointMake(AlphaRF, AlphaGF, AlphaBF);
         // our halo starts transparent
         Sprite1.Material.FrontProperties.Diffuse.Alpha:=0;
    Children[0].Position.SetPoint(xr, yr, zr);
    If BirdsEyeView then
    begin
    BirdsEyeViewDC.Position:= Children[0].Position;
    GLCamera.TargetObject:= BirdsEyeViewDC;
    end else GLCamera.TargetObject:= GLParticles1;
    If CurrentMathing=0 then
    GetOrCreateInertia(particle).TurnSpeed:=Random(30);
    TGLCustomSceneObject(particle).TagFloat:=GLCadencer1.CurrentTime;
  end;
end;

procedure TMathingsForm.BEVRGClick(Sender: TObject);
begin
//Change the Camera Target...
  If BEVRG.Itemindex=0 then
  BirdsEyeView:= True else BirdsEyeView:=False;
end;






end.
