//marcus?
unit UFrmLightmapFaceGroups;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, Menus, ImgList, ToolWin, ComCtrls, GLMisc, GLUtils,
  GLScene, GLWin32Viewer, GLMesh,GLVectorFileObjects, GLObjects, VectorGeometry,
  GLTexture, OpenGL1X, GLContext,GLMeshOptimizer,
  GLFile3ds,GLFileOCT,GLFileMS3D,GLFileGTS,GLFileLWO,GLFileMD2,GLFileMD3,
  GLFileNMF,GLFileNurbs,GLFileObj,GLFilePLY,GLFileQ3BSP,GLFileSMD,
  GLFileSTL,GLFileTIN,
  ExtDlgs,JPEG,TGA, StdCtrls, Spin, GLNavigator, ExtCtrls, GLCadencer,
  Buttons;

type
  TFrmLightmapFaceGroups = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    lstFG: TListBox;
    lstLM: TListBox;
    Facegroups: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    AssignButton: TButton;
    DeleteButton: TButton;
    LMFHelpBtn: TSpeedButton;
    procedure AssignButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure LMFHelpBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    Mesh : TGLBaseMesh;
    procedure refreshLightmaps;
  public
    { Public declarations }
    procedure init(MO : TGLBaseMesh);
  end;

var
  FrmLightmapFaceGroups: TFrmLightmapFaceGroups;

implementation
uses dtmPOFvar;
{$R *.dfm}
procedure TFrmLightmapFaceGroups.FormCreate(Sender: TObject);
begin
  top := FrmLightmapFaceGroupsY;{0;}
  left := FrmLightmapFaceGroupsX;{488;}
end;

procedure TFrmLightmapFaceGroups.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  FrmLightmapFaceGroupsX := FrmLightmapFaceGroups.left;
  FrmLightmapFaceGroupsY := FrmLightmapFaceGroups.top;
  DoSaver;
end;
procedure TFrmLightmapFaceGroups.LMFHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(1001);
end;
{ TFrmLightmapFaceGroups }

procedure TFrmLightmapFaceGroups.init(MO: TGLBaseMesh);
var
   m,f: integer;
begin
     Mesh := MO;
     lstFG.Clear;
     for m := 0 to MO.MeshObjects.Count-1 do
     begin
          for f := 0 to MO.MeshObjects[m].Facegroups.count-1 do
          begin
               lstFG.Items.AddObject(MO.MeshObjects[m].FaceGroups[f].MaterialName+' : MO '+inttostr(m)+' FG '+inttostr(f)+' LM '+Inttostr(MO.MeshObjects[m].FaceGroups[f].LightMapIndex),MO.MeshObjects[m].FaceGroups[f]);
          end;
     end;

     RefreshLightmaps;
end;

procedure TFrmLightmapFaceGroups.refreshLightmaps;
var
   m : integer;
begin
     lstLM.Clear;
     for m := 0 to Mesh.LightmapLibrary.Materials.Count-1 do
     begin
          lstLM.Items.AddObject(Mesh.LightmapLibrary.Materials[m].Name,Mesh.LightmapLibrary.Materials[m]);
     end;
end;


procedure TFrmLightmapFaceGroups.AssignButtonClick(Sender: TObject);
var
   t: integer;
begin
     for t:= 0 to lstFG.items.Count-1 do
     begin
          if lstFG.Selected[t] then
          begin
               TFaceGroup(lstFG.Items.Objects[t]).LightMapIndex := lstLM.ItemIndex;
          end;
     end;
     Mesh.StructureChanged;
end;

procedure TFrmLightmapFaceGroups.DeleteButtonClick(Sender: TObject);
begin
     Mesh.LightmapLibrary.Materials.Delete(lstLM.ItemIndex);
     Mesh.StructureChanged;
     RefreshLightmaps;
end;





end.
