{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmDtpPlatoReader;

interface

uses Windows, Messages, Graphics, SysUtils;


{Plant List}
type
  DtpAslSampleRec= record
   BillboardsCB:Boolean;
   ShadowRadius,Darkness,
   Width, Height: Integer;
   CommonName,LatinName:String;
   EcoTypeNumber:  Array of Integer;
  end;
  DtpAslRec= record
   SpeciesID, USNVCID,
   NumberOfSamples, SampleNumber: Integer;
   ObjectFileName,TextureImage:String;
   SampleArrayNumber:  Array of DtpAslSampleRec;
  end;
var
   {DtpEldRecord.EcoTypeNumber[ObjectNumber]}
  DtpAslRecord: Array of DtpAslRec;
{Vegetation Domain  BioRegion Plants}


type
  DtpAblRec= record
   SpeciesID: Integer;
   CommonName:String;
   Density : Double;
  end;
  DtpBioRegionRec= record
   NumberOfPlants, PlantNumber: Integer;
   //PlantsArray:  Array of DtpPlantsRec;
   end;
  {BioRegion Bld file}
  DtpBldRec= record
   NumberOfGroups, GroupNumber: Integer;
   GroupsArray:  Array of DtpAblRec;
  end;
var   {DtpBldRecord.GroupsArray[GroupNumber].PlantsArray[PlantNumber].SpeciesID}
  DtpBldRecord: DtpBldRec;

 {Domain Dld file}
type
  DtpAldRec= record
   DuplicatesCB, BillboardsCB:Boolean;
   NumberOfObjects, ObjectNumber: Integer;
   BioRegionName:  Array of String;{BioRegion Bld files}
  end;
var
   {DtpDldRecord.BioRegionName[ObjectNumber]}
  DtpAldRecord: DtpAldRec;

 {Points Pld file}
type
  DtpPldRec= record
   PldDisplay,
   NumberOfObjects, ObjectNumber: Integer;
   BuildingFileName:  Array of String;{Building files}
  end;
var
   {DtpDldRecord.BioRegionName[ObjectNumber]}
  DtpPldRecord: DtpPldRec;


procedure LoadDtpAldFile(FileName:String);

implementation

uses   dtmPOFvar, dtmGlobals;

procedure LoadDtpAldFile(FileName:String);
var
  I:Integer;
  InVerstring, WhatsMyLine: string;
  AldTextFile: Textfile;
Begin
  Try
    AssignFile(AldTextFile, FileName);
    Reset(AldTextFile);
    ReadLn(AldTextFile, InVerstring);{ERROR ?}
    Readln(AldTextFile, WhatsMyLine);
      If WhatsMyLine='True' then DtpAldRecord.DuplicatesCB:=True
                            else DtpAldRecord.DuplicatesCB:=False;
    Readln(AldTextFile, WhatsMyLine);
      If WhatsMyLine='True' then DtpAldRecord.BillboardsCB:=True
                            else DtpAldRecord.BillboardsCB:=False;
    Readln(AldTextFile, WhatsMyLine);
    DtpAldRecord.NumberOfObjects:=Strtoint(WhatsMyLine);
    Readln(AldTextFile, WhatsMyLine);
    DtpAldRecord.ObjectNumber:=Strtoint(WhatsMyLine);
    for I := 0 to DtpAldRecord.NumberOfObjects-1 do
    begin
      ReadLn(AldTextFile, WhatsMyLine);
      DtpAldRecord.BioRegionName[I]:=(WhatsMyLine);
    end;
  Finally
    CloseFile(AldTextFile);
  End;
End;

end.
