{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmDtpdtmreader;

interface

uses Windows, Messages, Dialogs, Graphics,
  GLUtils,//StrtoFloatDef
  SysUtils;

//Called from Main dtmfrm form and or dtmDTPFrm form
procedure DodtmMapLoad(InDtmFilename:String);
procedure DodtmMapSave(InDtmFilename:String;Annotated:Boolean);

{procedure DodtmDtsLoad(InDtsFilename:String);
procedure DodtmDtsSave(InDtsFilename:String);}
implementation

uses   dtmPOFvar, dtmGlobals;

procedure DodtmMapLoad(InDtmFilename:String);
var
  ShapeFileInT: Textfile;
  WhatsMyLine,InVersion:String;
Begin
  MapsPath:=ExtractFilePath(InDtmFilename);
  MapName:= ExtractFileName(InDtmFilename);
  Try
    AssignFile(ShapeFileInT, InDtmFilename);
    Reset(ShapeFileInT);
   Readln(ShapeFileInT, InVersion); {Version}
    If ('1.1'<>InVersion) then {ErrorMessage};
   Readln(ShapeFileInT, WhatsMyLine);
    HTFName:= ExtractFileName(WhatsMyLine);
    HTFPath:= ExtractFilePath(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    DtmHtfDisplay:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    HTFPaletteName:= WhatsMyLine;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseFlippedHTF:= True else UseFlippedHTF:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseSavedTextures:= True else UseSavedTextures:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      CreateTexturesOnDemand:= True else CreateTexturesOnDemand:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      SaveCreatedTextures:= True else SaveCreatedTextures:=False;

   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseXScale:= True else UseXScale:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseZScale:= True else UseZScale:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseSeaLevel:= True else UseSeaLevel:=False;
   Readln(ShapeFileInT, WhatsMyLine);
    XScaleUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    ZScaleUsed:= StrtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    SeaLevelUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    BumpRanger:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    MaximumShapeLevels:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    MaximumShapeObjects:= strtoint(WhatsMyLine);

   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseEcoTypes:= True else UseEcoTypes:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseBumpMap:= True else UseBumpMap:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseImageMap:= True else UseImageMap:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseConglomeration:= True else UseConglomeration:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      LoadDTPOnStart:= True else LoadDTPOnStart:=False;

   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      LoadDTCOnStart:= True else LoadDTCOnStart:=False;
   Readln(ShapeFileInT, WhatsMyLine);
    DtmDtcLoad:= WhatsMyLine;

   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseClouds:= True else UseClouds:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseWaves:= True else UseWaves:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseStormClouds:= True else UseStormClouds:=False;


   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      RunDTS:= True else RunDTS:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseDOV:= True else UseDOV:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseClodP:= True else UseClodP:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseQualityD:= True else UseQualityD:=False;
   Readln(ShapeFileInT, WhatsMyLine);
    DOVUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    ClodPUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    QualityDUsed:= strtoFloatDef(WhatsMyLine);

   Readln(ShapeFileInT, WhatsMyLine);
    SunMovingUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseCloudsSRange:= True else UseCloudsSRange:=False;

   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseCloudsRange:= True else UseCloudsRange:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseSunMoving:= True else UseSunMoving:=False;

   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      DisplayFPS:= True else DisplayFPS:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseCloudFile:= True else UseCloudFile:=False;
   Readln(ShapeFileInT, WhatsMyLine);
    StormCloudsRateUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    StormCloudsRangeUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    WavesRateUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    WavesRangeUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    CloudChangeAmount:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    CloudSharpUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    CloudSharpRangeUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    CloudRandomSeedUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    CloudMinUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    CloudMinRangeUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    CloudImageSizeUsed:= strtoint(WhatsMyLine);
//
   Readln(ShapeFileInT, WhatsMyLine);
  StormMovingFileUsed:=WhatsMyLine;
   Readln(ShapeFileInT, WhatsMyLine);
  StormWindDirectionUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormWindSpeedUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormWindDirectionVarUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormWindSpeedVariationUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormCloudsDirectionUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormCloudsSpeedUsed:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormCloudsNumberUsed:= strtoint(WhatsMyLine);

   Readln(ShapeFileInT, WhatsMyLine);
  RainDensityUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  RainDensityVarUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  LightningFrequencyUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  LightningForceUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  TornadoeFrequencyUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  TornadoeForceUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormCloudsPosXUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormCloudsPosYUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormCloudsPosZUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormCloudsNumRangeUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormCloudsNumRangeVarUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormCloudsRangeXUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormCloudsRangeYUsed:= strtoFloatDef(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
  StormCloudsRangeZUsed:= strtoFloatDef(WhatsMyLine);

   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseCloudsSetting:= True else UseCloudsSetting:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseStormLinear:= True else UseStormLinear:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseStormMoving:= True else UseStormMoving:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseStormMovingDirS:= True else UseStormMovingDirS:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseStormMovingPath:= True else UseStormMovingPath:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseStormRain:= True else UseStormRain:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseStormLightning:= True else UseStormLightning:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseStormTornadoes:= True else UseStormTornadoes:=False;
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseStormWind:= True else UseStormWind:=False;
//
   Readln(ShapeFileInT, WhatsMyLine);
    PixelEnlargement:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    TilesperTexture:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    TextureFileType:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    SlopeDirection:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    SlopeCellSize:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    TotalContours:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
    ContourInterval:= strtoint(WhatsMyLine);
   Readln(ShapeFileInT, WhatsMyLine);
      If ( WhatsMyLine = 'True') then
      UseContourColors:= True else UseContourColors:=False;
    If InVersion <> '1.1' then
    begin
      {Ready for new version activities here}
    end;
  Finally
    CloseFile(ShapeFileInT);
  End;
End;

procedure DodtmMapSave(InDtmFilename:String;Annotated:Boolean);
var
  ShapeFileInT: Textfile;
  WhatsMyLine{,InVersion}:String;
Begin
  MapsPath:=ExtractFilePath(InDtmFilename);
  MapName:= ExtractFileName(InDtmFilename);
  Try
    AssignFile(ShapeFileInT, InDtmFilename);
    Rewrite(ShapeFileInT);
    If Annotated then ;//Add Annotation
   Writeln(ShapeFileInT, '1.1'); {Version}
    //HTFName:= ExtractFileName(WhatsMyLine);
    //HTFPath:= ExtractFilePath(WhatsMyLine);
   Writeln(ShapeFileInT, HTFPath+HTFName);
    //DtmHtfDisplay:= strtoint(WhatsMyLine);
   Writeln(ShapeFileInT, inttostr(DtmHtfDisplay));
    //HTFPaletteName:= WhatsMyLine;
   Writeln(ShapeFileInT, HTFPaletteName);
    // in-out flipped Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseFlippedHTF = True) then
    WhatsMyLine:= 'True' else WhatsMyLine:='False';
   Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseSavedTextures = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';    Writeln(ShapeFileInT, WhatsMyLine);
   Writeln(ShapeFileInT, WhatsMyLine);
      If ( CreateTexturesOnDemand = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';    Writeln(ShapeFileInT, WhatsMyLine);
   Writeln(ShapeFileInT, WhatsMyLine);
      If ( SaveCreatedTextures = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);

      If ( UseXScale = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseZScale = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseSeaLevel = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);

     WhatsMyLine:= Floattostr(XScaleUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= Floattostr(ZScaleUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(SeaLevelUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(BumpRanger);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(MaximumShapeLevels);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(MaximumShapeObjects);
    Writeln(ShapeFileInT, WhatsMyLine);

      If ( UseEcoTypes = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseBumpMap = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseImageMap = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseConglomeration = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( LoadDTPOnStart = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);

      If ( LoadDTCOnStart = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= DtmDtcLoad;
    Writeln(ShapeFileInT, WhatsMyLine);

      If ( UseClouds = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseWaves = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseStormClouds = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);

      If ( RunDTS = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseDOV = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseClodP = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseQualityD = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= Floattostr(DOVUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= Floattostr(ClodPUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= Floattostr(QualityDUsed);
    Writeln(ShapeFileInT, WhatsMyLine);

     WhatsMyLine:= inttostr(SunMovingUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseCloudsSRange = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);

      If ( UseCloudsRange = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseSunMoving = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( DisplayFPS = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseCloudFile = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= Floattostr(StormCloudsRateUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= Floattostr(StormCloudsRangeUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= Floattostr(WavesRateUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(WavesRangeUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= Floattostr(CloudAnime);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= Floattostr(CloudChangeAmount);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= Floattostr(CloudSharpUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= Floattostr(CloudSharpRangeUsed);
    Writeln(ShapeFileInT, WhatsMyLine);

     WhatsMyLine:= inttostr(CloudRandomSeedUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(CloudMinUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(CloudMinRangeUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(CloudImageSizeUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
//
  WhatsMyLine:=StormMovingFileUsed;
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=Inttostr(StormWindDirectionUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=Inttostr(StormWindSpeedUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=Inttostr(StormWindDirectionVarUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=Inttostr(StormWindSpeedVariationUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=Inttostr(StormCloudsDirectionUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=Inttostr(StormCloudsSpeedUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=Inttostr(StormCloudsNumberUsed);
    Writeln(ShapeFileInT, WhatsMyLine);

  WhatsMyLine:=floattostr(RainDensityUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(RainDensityVarUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(LightningFrequencyUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(LightningForceUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(TornadoeFrequencyUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(TornadoeForceUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(StormCloudsPosXUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(StormCloudsPosYUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(StormCloudsPosZUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(StormCloudsNumRangeUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(StormCloudsNumRangeVarUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(StormCloudsRangeXUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(StormCloudsRangeYUsed);
    Writeln(ShapeFileInT, WhatsMyLine);
  WhatsMyLine:=floattostr(StormCloudsRangeZUsed);
    Writeln(ShapeFileInT, WhatsMyLine);

      If ( UseCloudsSetting = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseStormLinear = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseStormMoving = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseStormMovingDirS = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseStormMovingPath = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseStormRain = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseStormLightning = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseStormTornadoes = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseStormWind = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
//
     WhatsMyLine:= inttostr(PixelEnlargement);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(TilesperTexture);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(TextureFileType);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(SlopeDirection);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(SlopeCellSize);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(TotalContours);
    Writeln(ShapeFileInT, WhatsMyLine);
     WhatsMyLine:= inttostr(ContourInterval);
    Writeln(ShapeFileInT, WhatsMyLine);
      If ( UseContourColors = True) then
      WhatsMyLine:= 'True' else WhatsMyLine:='False';
    Writeln(ShapeFileInT, WhatsMyLine);
     {Ready for new version activities here}
     {If InVersion <> '1.1' then
     begin

     end;}
  Finally
    CloseFile(ShapeFileInT);
  End;
End;
(*
procedure DodtmDtsLoad(InDtsFilename:String);
var
  ShapeFileInT: Textfile;
  WhatsMyLine,InVersion:String;
Begin
  //ProjectPath:=ExtractFilePath(InDtmFilename);
  //Phase2EditText:= ExtractFileName(InDtmFilename);
  Try
    AssignFile(ShapeFileInT, InDtsFilename);
    Reset(ShapeFileInT);
    Readln(ShapeFileInT, InVersion); {Version}
    If ('1.1'<>InVersion) then {ErrorMessage};
  {  Readln(ShapeFileInT, WhatsMyLine);
    Phase2PaleCommandFile:= ExtractFileName(WhatsMyLine); }
   { Readln(ShapeFileInT, WhatsMyLine);
    P2LayerPaleCommand:= strtoint(WhatsMyLine); }
    If InVersion <> '1.1' then
    begin
      {Ready for new version activities here}
    end;
  Finally
    CloseFile(ShapeFileInT);
  End;
End;
procedure DodtmDtsSave(InDtsFilename:String);
var
  ShapeFileInT: Textfile;
  WhatsMyLine{,InVersion}:String;
Begin
  //ProjectPath:=ExtractFilePath(InDtmFilename);
  //Phase2DTSEditText:= ExtractFileName(InDtmFilename);
  Try
    AssignFile(ShapeFileInT, InDtsFilename);
    Rewrite(ShapeFileInT);
    Writeln(ShapeFileInT, '1.1'); {Version}
   { Writeln(ShapeFileInT, Phase2PaleCommandFile);
    WhatsMyLine:=inttostr(P2LayerPaleCommand);
    Writeln(ShapeFileInT,WhatsMyLine) }
  Finally
    CloseFile(ShapeFileInT);
  End;
End;
 *)

end.
