{: GLSViewer main form.<p>

   Requires RxLib to compile
   (go to http://sourceforge.net/projects/rxlib for Delphi6 version)
   and Mike Lischke's GraphicEx
   (http://www.delphi-gems.com/)
}
unit dtmGLSViewerFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, GLCadencer, ExtDlgs, GLTexture, GLScene, GLObjects,
  GLVectorFileObjects, GLMisc,GLUtils, ImgList, ActnList, Menus, GLWin32Viewer,
  GLFileOBJ, GLFileSTL, GLFileLWO,
  GLFileDXF, 
  GLMeshOptimizer,
   GLFileQ3BSP, GLFileOCT, PersistentClasses, MeshUtils,
  ComCtrls, ToolWin,   VectorGeometry,
  OpenGL1x, GLContext, VectorLists, StdCtrls, Spin, Buttons;

type
  TdtmGLSViewerForm = class(TForm)
    MainMenu: TMainMenu;
    ImageList: TImageList;
    ToolBar: TToolBar;
    MIFile: TMenuItem;
    MIAbout: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    ToolButton1: TToolButton;
    StatusBar: TStatusBar;
    GLScene: TGLScene;
    MIOptions: TMenuItem;
    MIAntiAlias: TMenuItem;
    MIAADefault: TMenuItem;
    MIAA2x: TMenuItem;
    MIAA4X: TMenuItem;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    MIView: TMenuItem;
    ZoomIn1: TMenuItem;
    ZoomOut1: TMenuItem;
    FreeForm: TGLFreeForm;
    OpenDialog: TOpenDialog;
    GLLightSource: TGLLightSource;
    GLMaterialLibrary: TGLMaterialLibrary;
    CubeExtents: TGLCube;
    Resetview1: TMenuItem;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    N2: TMenuItem;
    Smoothshading1: TMenuItem;
    Flatshading1: TMenuItem;
    Hiddenlines1: TMenuItem;
    Wireframe1: TMenuItem;
    ToolButton10: TToolButton;
    Faceculling1: TMenuItem;
    N3: TMenuItem;
    MIBgColor: TMenuItem;
    ColorDialog: TColorDialog;
    MITexturing: TMenuItem;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    OpenPictureDialog: TOpenPictureDialog;
    MIPickTexture: TMenuItem;
    DCTarget: TGLDummyCube;
    GLCamera: TGLCamera;
    DCAxis: TGLDummyCube;
    ToolButton13: TToolButton;
    FlatShadingwithlines1: TMenuItem;
    MIActions: TMenuItem;
    InvertNormals1: TMenuItem;
    N4: TMenuItem;
    Saveas1: TMenuItem;
    SaveDialog: TSaveDialog;
    ReverseRenderingOrder1: TMenuItem;
    ConverttoIndexedTriangles1: TMenuItem;
    FramesPerSecond1: TMenuItem;
    GLCadencer: TGLCadencer;
    Timer: TTimer;
    SDTextures: TSaveDialog;
    Savetextures1: TMenuItem;
    MIOpenTexLib: TMenuItem;
    ODTextures: TOpenDialog;
    About1: TMenuItem;
    Help1: TMenuItem;
    ShowSizes1: TMenuItem;
    Lights1: TMenuItem;
    LightMapMaker1: TMenuItem;
    ShowSizesAxis1: TMenuItem;
    OptimizeMesh1: TMenuItem;
    LightMapMakerWizard1: TMenuItem;
    ImportLMM3ds: TMenuItem;
    FaceGroupsLightMaps1: TMenuItem;
    N5: TMenuItem;
    FreeLook1: TMenuItem;
    ScaleObject1: TMenuItem;
    N6: TMenuItem;
    ShowMeshInfo1: TMenuItem;
    ToolButton14: TToolButton;
    SpinTexture: TSpinEdit;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    SpinLightmapTexture: TSpinEdit;
    ImageList1: TImageList;
    GLMaterialLibraryLightmaps: TGLMaterialLibrary;
    AmbientLight: TGLLightSource;
    SpotLight: TGLLightSource;
    SpotLightOn1: TMenuItem;
    CameraLightOn1: TMenuItem;
    AmbientLightOn1: TMenuItem;
    ResetSpotLight1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    ShowSizePanel: TPanel;
    xLabelmin: TLabel;
    yLabelmin: TLabel;
    yLabelMax: TLabel;
    xLabelMax: TLabel;
    zLabelMax: TLabel;
    zLabelmin: TLabel;
    GLSceneViewer: TGLSceneViewer;
    Image1: TImage;
    Image1LoadBtn: TSpeedButton;
    Image1SaveBtn: TSpeedButton;
    Image1ApplyBtn: TSpeedButton;
    Image1RG: TRadioGroup;
    Image1TrackBar: TTrackBar;
    Image1ColorPanel: TPanel;
    ColorDialog1: TColorDialog;
    procedure MIAboutClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ACOpenExecute(Sender: TObject);
    procedure GLSceneViewerMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewerMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure GLSceneViewerMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ACZoomInExecute(Sender: TObject);
    procedure ACZoomOutExecute(Sender: TObject);
    procedure ACExitExecute(Sender: TObject);
  {  procedure ACShadeSmoothExecute(Sender: TObject);}
    procedure GLSceneViewerBeforeRender(Sender: TObject);
    procedure MIAADefaultClick(Sender: TObject);
    procedure GLSceneViewerAfterRender(Sender: TObject);
    procedure ACResetViewExecute(Sender: TObject);
    procedure ACCullFaceExecute(Sender: TObject);
    procedure MIBgColorClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure GLMaterialLibraryTextureNeeded(Sender: TObject;
      var textureFileName: String);
    procedure ACTexturingExecute(Sender: TObject);
    procedure MIPickTextureClick(Sender: TObject);
    procedure MIFileClick(Sender: TObject);
    procedure ACInvertNormalsExecute(Sender: TObject);
    procedure ACSaveAsExecute(Sender: TObject);
  {  procedure ACSaveAsUpdate(Sender: TObject);}
    procedure ACReverseRenderingOrderExecute(Sender: TObject);
    procedure ACConvertToIndexedTrianglesExecute(Sender: TObject);
    procedure GLCadencerProgress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure ACFPSExecute(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure ACSaveTexturesExecute(Sender: TObject);
    procedure MIOpenTexLibClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

procedure AllBtnsUp;    
    procedure Smoothshading1Click(Sender: TObject);
    procedure Flatshading1Click(Sender: TObject);

    procedure Hiddenlines1Click(Sender: TObject);
    procedure Wireframe1Click(Sender: TObject);
    procedure FlatShadingwithlines1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure ShowSizes1Click(Sender: TObject);
    procedure actPickMaterialTextureExecute(Sender: TObject);
    procedure actPickLightmapTextureExecute(Sender: TObject);
    procedure LightMapMakerWizard1Click(Sender: TObject);
    procedure ImportLMM3dsClick(
      Sender: TObject);
    procedure FaceGroupsLightMaps1Click(Sender: TObject);
    procedure OptimizeMesh1Click(Sender: TObject);
    procedure ScaleObject1Click(Sender: TObject);
    procedure ShowMeshInfo1Click(Sender: TObject);
    procedure ShowSizesAxis1Click(Sender: TObject);
    procedure FreeLook1Click(Sender: TObject);
    procedure SpotLightOn1Click(Sender: TObject);
    procedure CameraLightOn1Click(Sender: TObject);
    procedure ResetSpotLight1Click(Sender: TObject);
    procedure AmbientLightOn1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1ColorPanelClick(Sender: TObject);
    procedure Image1LoadBtnClick(Sender: TObject);
    procedure Image1SaveBtnClick(Sender: TObject);
    procedure Image1ApplyBtnClick(Sender: TObject);
  private
    { Private declarations }
    procedure DoResetCamera;
    procedure ApplyShadeModeToMaterial(aMaterial : TGLMaterial);
    procedure ApplyShadeMode;
    procedure ApplyFSAA;
    procedure ApplyFaceCull;
    procedure ApplyBgColor;
    procedure ApplyTexturing;
    procedure ApplyFPS;

    procedure DoOpen(const fileName : String);
    procedure SetExtents;
  public
    { Public declarations }
    OptimizeCalled : boolean; // stores if we clicked "Optimize"
    md, nthShow : Boolean;
    mx, my : Integer;
    hlShader : TGLShader;
    lastFileName : String;
    lastLoadWithTextures : Boolean;
    procedure UpdateState;
  end;

var
  dtmGLSViewerForm: TdtmGLSViewerForm;

implementation

{$R *.dfm}

uses KeyBoard, GraphicEx, {Registry,}
  dtmfrm, dtmPOFvar, dtmGlobals,
 UFInfo, ULightMapTools, UFrmLMMWizard,
  UFrmLightmapFaceGroups,
 dtmGLSViewerAboutFrm;

type

   // Hidden line shader (specific implem for the viewer, *not* generic)
   THiddenLineShader = class (TGLShader)
      private
         LinesColor : TColorVector;
         BackgroundColor : TColorVector;
         PassCount : Integer;
      public
         procedure DoApply(var rci : TRenderContextInfo; Sender : TObject); override;
         function DoUnApply(var rci : TRenderContextInfo) : Boolean; override;
   end;

procedure THiddenLineShader.DoApply(var rci : TRenderContextInfo; Sender : TObject);
begin
   PassCount:=1;
   rci.GLStates.SetGLPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
   glPushAttrib(GL_ENABLE_BIT);
   glPushAttrib(GL_CURRENT_BIT+GL_ENABLE_BIT);
   glColor3fv(@BackgroundColor);
   glDisable(GL_TEXTURE_2D);
   glEnable(GL_POLYGON_OFFSET_FILL);
   glPolygonOffset(1, 2);
end;

function THiddenLineShader.DoUnApply(var rci : TRenderContextInfo) : Boolean;
begin
   case PassCount of
      1 : begin
         PassCount:=2;
         rci.GLStates.SetGLPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
         glPopAttrib;
         glColor3fv(@LinesColor);
         glDisable(GL_LIGHTING);
         Result:=True;
      end;
      2 : begin
         glPopAttrib;
         Result:=False;
      end;
   else
      // doesn't hurt to be cautious
      Assert(False);
      Result:=False;
   end;
end;

procedure TdtmGLSViewerForm.FormCreate(Sender: TObject);
{var
   reg : TRegistry;
   shellCmd : String;
   keyOkay : Boolean;
const
   cKeyName : String = 'Applications\GLSViewer.exe\shell\open\command';
   cFriendlyKeyName : String = 'Applications\GLSViewer.exe';}
begin
   // instantiate our specific hidden-lines shader
  hlShader:=THiddenLineShader.Create(Self);

  FreeForm.IgnoreMissingTextures:=True;
  GLCadencer.Enabled:=False;
  top := GLSViewerFormY;
  left := GLSViewerFormX;
end;
procedure TdtmGLSViewerForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  NoGLRunning:=True;
  Timer.Enabled:=False;  
  GLCadencer.Enabled:=False;
  GLSViewerFormY := dtmGLSViewerForm.top;
  GLSViewerFormX := dtmGLSViewerForm.left;
  DoSaver;
end;
procedure TdtmGLSViewerForm.FormShow(Sender: TObject);
{var  i : Integer; }
begin
   if not nthShow then
   begin
      OpenDialog.Filter:=VectorFileFormatsFilter;
      SaveDialog.Filter:=VectorFileFormatsSaveFilter;
     { with ActionList do for i:=0 to ActionCount-1 do
         if Actions[i] is TCustomAction then
            with TCustomAction(Actions[i]) do Hint:=Caption; }
      ApplyFSAA;
      ApplyFaceCull;
      ApplyBgColor; //Sets color to Menu too

      if ParamCount>0 then
      if UpperCase(ExtractFileExt(ParamStr(1))) <> '.HTF' then
         DoOpen(ParamStr(1));
      nthShow:=True;
   end;
   Saveas1.Enabled:=(FreeForm.MeshObjects.Count>0);

end;

procedure TdtmGLSViewerForm.GLSceneViewerBeforeRender(Sender: TObject);
begin
   THiddenLineShader(hlShader).LinesColor:=VectorMake(107/256, 123/256, 173/256, 1);
   THiddenLineShader(hlShader).BackgroundColor:=ConvertWinColor(GLSceneViewer.Buffer.BackgroundColor);
   if not GL_ARB_multisample then
   begin
      MIAADefault.Checked:=True;
      MIAA2x.Enabled:=False;
      MIAA4X.Enabled:=False;
   end;
end;

procedure TdtmGLSViewerForm.GLSceneViewerAfterRender(Sender: TObject);
begin
   ApplyFSAA;
   Screen.Cursor:=crDefault;
end;

procedure TdtmGLSViewerForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(11000);
end;
procedure TdtmGLSViewerForm.MIAboutClick(Sender: TObject);
begin
  dtmGLSViewerAboutForm:=TdtmGLSViewerAboutForm.Create(Application);
  dtmGLSViewerAboutForm.ShowModal;
  dtmGLSViewerAboutForm.Release;
end;

procedure TdtmGLSViewerForm.DoResetCamera;
var objSize : Single;
begin
   DCTarget.Position.AsVector:=NullHmgPoint;
   GLCamera.Position.SetPoint(7, 3, 5);
   FreeForm.Position.AsVector:=NullHmgPoint;
   FreeForm.Up.Assign(DCAxis.Up);
   FreeForm.Direction.Assign(DCAxis.Direction);

   objSize:=FreeForm.BoundingSphereRadius;
   if objSize>0 then begin
      if objSize<1 then begin
         GLCamera.SceneScale:=1/objSize;
         objSize:=1;
      end else GLCamera.SceneScale:=1;
      GLCamera.AdjustDistanceToTarget(objSize*0.27);
      GLCamera.DepthOfView:=1.5*GLCamera.DistanceToTarget+2*objSize;
   end;
end;

procedure TdtmGLSViewerForm.ApplyShadeModeToMaterial(aMaterial : TGLMaterial);
begin
   with aMaterial do begin
      if {ACShadeSmooth}Smoothshading1.Checked then begin
         GLSceneViewer.Buffer.Lighting:=True;
         GLSceneViewer.Buffer.ShadeModel:=smSmooth;
         aMaterial.FrontProperties.PolygonMode:=pmFill;
         aMaterial.BackProperties.PolygonMode:=pmFill;
      end else if {ACFlatShading}Flatshading1.Checked then begin
         GLSceneViewer.Buffer.Lighting:=True;
         GLSceneViewer.Buffer.ShadeModel:=smFlat;
         aMaterial.FrontProperties.PolygonMode:=pmFill;
         aMaterial.BackProperties.PolygonMode:=pmFill;
      end else if {ACFlatLined}FlatShadingwithlines1.Checked then begin
         GLSceneViewer.Buffer.Lighting:=True;
         GLSceneViewer.Buffer.ShadeModel:=smFlat;
         aMaterial.FrontProperties.PolygonMode:=pmLines;
         aMaterial.BackProperties.PolygonMode:=pmLines;
      end else if {ACHiddenLines}Hiddenlines1.Checked then begin
         GLSceneViewer.Buffer.Lighting:=False;
         GLSceneViewer.Buffer.ShadeModel:=smSmooth;
         aMaterial.FrontProperties.PolygonMode:=pmLines;
         aMaterial.BackProperties.PolygonMode:=pmLines;
      end else if {ACWireframe}Wireframe1.Checked then begin
         GLSceneViewer.Buffer.Lighting:=False;
         GLSceneViewer.Buffer.ShadeModel:=smSmooth;
         aMaterial.FrontProperties.PolygonMode:=pmLines;
         aMaterial.BackProperties.PolygonMode:=pmLines;
      end;
   end;
end;

procedure TdtmGLSViewerForm.ApplyShadeMode;
var i : Integer;
begin
   with GLMaterialLibrary.Materials do for i:=0 to Count-1 do
   begin
      ApplyShadeModeToMaterial(Items[i].Material);
      if (Hiddenlines1.Checked) or (FlatShadingwithlines1.Checked) then
         Items[i].Shader:=hlShader
      else Items[i].Shader:=nil;
   end;
   FreeForm.StructureChanged;
end;

procedure TdtmGLSViewerForm.ApplyFSAA;
begin
   with GLSceneViewer.Buffer do
   begin
      if MIAADefault.Checked then AntiAliasing:=aaDefault
      else if MIAA2X.Checked then AntiAliasing:=aa2x
      else if MIAA4X.Checked then AntiAliasing:=aa4x;
   end;
end;

procedure TdtmGLSViewerForm.ApplyFaceCull;
begin
   with GLSceneViewer.Buffer do begin
      if {ACCullFace}Faceculling1.Checked then begin
         FaceCulling:=True;
         ContextOptions:=ContextOptions-[roTwoSideLighting];
      end else begin
         FaceCulling:=False;
         ContextOptions:=ContextOptions+[roTwoSideLighting];
      end;
   end;
end;

procedure TdtmGLSViewerForm.ApplyBgColor;
var
   bmp : TBitmap;
   col : TColor;
begin
   bmp:=TBitmap.Create;
   try
      bmp.Width:=16;
      bmp.Height:=16;
      col:=ColorToRGB(ColorDialog.Color);
      GLSceneViewer.Buffer.BackgroundColor:=col;
      with bmp.Canvas do begin
         Pen.Color:=col xor $FFFFFF;
         Brush.Color:=col;
         Rectangle(0, 0, 16, 16);
      end;
      MIBgColor.Bitmap:=bmp;
   finally
      bmp.Free;
   end;
end;

procedure TdtmGLSViewerForm.ApplyTexturing;
var
   i : Integer;
begin
   with GLMaterialLibrary.Materials do for i:=0 to Count-1 do begin
      with Items[i].Material.Texture do begin
         if Enabled then
            Items[i].Tag:=Integer(True);
         Enabled:=Boolean(Items[i].Tag) and {ACTexturing}MITexturing.Checked;
      end;
   end;
   FreeForm.StructureChanged;
end;

procedure TdtmGLSViewerForm.ApplyFPS;
begin
   if {ACFPS}FramesPerSecond1.Checked then begin
      Timer.Enabled:=True;
      GLCadencer.Enabled:=True;
   end else begin
      Timer.Enabled:=False;
      GLCadencer.Enabled:=False;
      StatusBar.Panels[1].Text:='--- FPS';
   end;
end;

procedure TdtmGLSViewerForm.DoOpen(const fileName : String);
var
   i : Integer;
   libMat : TGLLibMaterial;
begin
   if not FileExists(fileName) then Exit;

   Screen.Cursor:=crHourGlass;
   TigerPath:=ExtractFilePath(FileName);
   Caption:='GLSViewer - '+{ExtractFileName}(fileName);

   FreeForm.MeshObjects.Clear;
   GLMaterialLibrary.Materials.Clear;
   GLMaterialLibraryLightmaps.Materials.Clear;

   if Uppercase(ExtractFileExt(filename))='.GLSM' then
   begin
        try
           if FileExists(ChangeFileExt(fileName,'.ML')) then
              GLMaterialLibrary.LoadFromFile(ChangeFileExt(fileName,'.ML'));
        except
              ShowMessage('Error loading MaterialLibrary "'+ChangeFileExt(fileName,'.ML')+'"');
        end;

        try
           if FileExists(ChangeFileExt(fileName,'.GLML')) then
              GLMaterialLibrary.LoadFromFile(ChangeFileExt(fileName,'.GLML'));
        except
              ShowMessage('Error loading MaterialLibrary "'+ChangeFileExt(fileName,'.GLML')+'"');
        end;

        try
           if FileExists(ChangeFileExt(fileName,'.LML')) then
              GLMaterialLibraryLightmaps.LoadFromFile(ChangeFileExt(fileName,'.LML'));
        except
              ShowMessage('Error loading MaterialLibrary "'+ChangeFileExt(fileName,'.LML')+'"');
        end;
   end;

   FreeForm.LoadFromFile(fileName);
   try
   with GLMaterialLibrary do begin
      if Materials.Count=0 then begin
         FreeForm.Material.MaterialLibrary:=GLMaterialLibrary;
         libMat:=Materials.Add;
         FreeForm.Material.LibMaterialName:=libMat.Name;
         //libMat.Material.FrontProperties.Diffuse.Red:=0;
      end;
      for i:=0 to Materials.Count-1 do
         with Materials[i].Material do BackProperties.Assign(FrontProperties);
   end;
   except on e : exception do
          ShowMessage(e.Message);
   end;
   ApplyShadeMode;
   ApplyTexturing;
   ApplyFPS;

   StatusBar.Panels[0].Text:=ExtractFileName(fileName);
   //1 is FPS
   StatusBar.Panels[2].Text:=IntToStr(FreeForm.MeshObjects.TriangleCount)+' tris';

   {ACSaveTextures}Savetextures1.Enabled:=(GLMaterialLibrary.Materials.Count>0);
   //ACSaveAsUpdate
   {ACSaveAs}Saveas1.Enabled:=(FreeForm.MeshObjects.Count>0);
   MIOpenTexLib.Enabled:=(GLMaterialLibrary.Materials.Count>0);
   lastFileName:=fileName;
   lastLoadWithTextures:={ACTexturing}MITexturing.Enabled;

SetExtents;

   DoResetCamera;
   OptimizeCalled := false;
   //ActionList.UpdateAction(ActionList.Actions[0]);
   UpdateState;
end;

procedure TdtmGLSViewerForm.ShowSizes1Click(Sender: TObject);
begin
  ShowSizes1.Checked:= (not ShowSizes1.Checked);
  If ShowSizes1.Checked then
  begin
  GLSceneViewer.Align:= alNone;  //alClient
  ShowSizePanel.Align:= alTop;
  ShowSizePanel.Visible:= True;
  GLSceneViewer.Align:= alClient;
  end else
  begin
  GLSceneViewer.Align:= alNone;  //alClient
  ShowSizePanel.Align:= alNone;
  ShowSizePanel.Visible:= False;
  GLSceneViewer.Align:= alClient;
  end
end;


procedure TdtmGLSViewerForm.ACOpenExecute(Sender: TObject);
begin
   OpenDialog.InitialDir := TigerPath;
   if OpenDialog.Execute then
      DoOpen(OpenDialog.FileName);
end;

procedure TdtmGLSViewerForm.GLSceneViewerMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   mx:=x; my:=y;
   md:=True;
end;

procedure TdtmGLSViewerForm.GLSceneViewerMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
   d : Single;
begin
   if md and (Shift<>[]) then begin
      if ssLeft in Shift then
      begin
         d:=GLCamera.DistanceToTarget*(x-mx+y-my);
         if IsKeyDown('x') then
            SpotLight.Translate(d, 0, 0)
         else if IsKeyDown('y') then
            SpotLight.Translate(0, d, 0)
         else if IsKeyDown('z') then
            SpotLight.Translate(0, 0, d)
         else
         if ssShift in Shift then
            GLCamera.MoveAroundTarget((my-y)*0.1, (mx-x)*0.1)
         else GLCamera.MoveAroundTarget(my-y, mx-x)
      end
      else if ssRight in Shift then begin
         d:=GLCamera.DistanceToTarget*0.01*(x-mx+y-my);
         if IsKeyDown('x') then
            FreeForm.Translate(d, 0, 0)
         else if IsKeyDown('y') then
            FreeForm.Translate(0, d, 0)
         else if IsKeyDown('z') then
            FreeForm.Translate(0, 0, d)
         else begin
            if ssShift in Shift then
               GLCamera.RotateObject(FreeForm, (my-y)*0.1, (mx-x)*0.1)
            else GLCamera.RotateObject(FreeForm, my-y, mx-x);
         end;
      end;
      mx:=x; my:=y;
   end;
end;

procedure TdtmGLSViewerForm.GLSceneViewerMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   md:=False;
end;

procedure TdtmGLSViewerForm.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
   if FreeForm.MeshObjects.Count>0 then begin
      GLCamera.AdjustDistanceToTarget(Power(1.05, WheelDelta/120));
      GLCamera.DepthOfView:=2*GLCamera.DistanceToTarget+2*FreeForm.BoundingSphereRadius;
   end;
   Handled:=True;
end;

procedure TdtmGLSViewerForm.ACZoomInExecute(Sender: TObject);
var
   h : Boolean;
begin
   FormMouseWheel(Self, [], -120*4, Point(0, 0), h);
end;

procedure TdtmGLSViewerForm.ACZoomOutExecute(Sender: TObject);
var
   h : Boolean;
begin
   FormMouseWheel(Self, [], 120*4, Point(0, 0), h);
end;

procedure TdtmGLSViewerForm.ACExitExecute(Sender: TObject);
begin
   Close;
end;

{procedure TdtmGLSViewerForm.ACShadeSmoothExecute(Sender: TObject);
begin
   ApplyShadeMode;
end; }
procedure TdtmGLSViewerForm.AllBtnsUp;
Begin
  Smoothshading1.Checked:=False;
  ToolButton6.Down:=False;
  Flatshading1.Checked:=False;
  ToolButton7.Down:=False;
  Hiddenlines1.Checked:=False;
  ToolButton8.Down:=False;
  Wireframe1.Checked:=False;
  ToolButton9.Down:=False;
  FlatShadingwithlines1.Checked:=False;
  ToolButton13.Down:=False;
End;
procedure TdtmGLSViewerForm.Smoothshading1Click(Sender: TObject);
begin
  AllBtnsUp;
  Smoothshading1.Checked:=True;
  ToolButton6.Down:=True;
  ApplyShadeMode;
end;

procedure TdtmGLSViewerForm.Flatshading1Click(Sender: TObject);
begin
  AllBtnsUp;
  Flatshading1.Checked:=True;
  ToolButton7.Down:=True;
  ApplyShadeMode;
end;
procedure TdtmGLSViewerForm.FlatShadingwithlines1Click(Sender: TObject);
begin
  AllBtnsUp;
  FlatShadingwithlines1.Checked:=True;
  ToolButton13.Down:=True;
  ApplyShadeMode;
end;
procedure TdtmGLSViewerForm.Hiddenlines1Click(Sender: TObject);
begin
  AllBtnsUp;
  Hiddenlines1.Checked:=True;
  ToolButton8.Down:=True;
  ApplyShadeMode;
end;

procedure TdtmGLSViewerForm.Wireframe1Click(Sender: TObject);
begin
  AllBtnsUp;
  Wireframe1.Checked:=True;
  ToolButton9.Down:=True;
  ApplyShadeMode;
end;

procedure TdtmGLSViewerForm.MIAADefaultClick(Sender: TObject);
begin    //Should use this for the Shading buttons
   (Sender as TMenuItem).Checked:=True;
   ApplyFSAA;
end;

procedure TdtmGLSViewerForm.ACResetViewExecute(Sender: TObject);
begin
   DoResetCamera;
end;

procedure TdtmGLSViewerForm.ACCullFaceExecute(Sender: TObject);
begin      //ACCullFace
   Faceculling1.Checked:=not Faceculling1.Checked;
   ApplyFaceCull;
end;

procedure TdtmGLSViewerForm.MIBgColorClick(Sender: TObject);
begin
   if ColorDialog.Execute then ApplyBgColor;
end;

procedure TdtmGLSViewerForm.GLMaterialLibraryTextureNeeded(Sender: TObject;
  var textureFileName: String);
begin       //ACTexturing
   if not MITexturing.Enabled then
      textureFileName:='';
end;

procedure TdtmGLSViewerForm.ACTexturingExecute(Sender: TObject);
begin        //ACTexturing
   MITexturing.Checked:=not MITexturing.Checked;
   if MITexturing.Checked then
      if lastLoadWithTextures then
         ApplyTexturing
      else begin
         DoOpen(lastFileName);
      end
   else ApplyTexturing;
end;

procedure TdtmGLSViewerForm.MIFileClick(Sender: TObject);
begin
   MIPickTexture.Enabled:=(GLMaterialLibrary.Materials.Count>0);
end;

procedure TdtmGLSViewerForm.MIPickTextureClick(Sender: TObject);
begin
   OpenPictureDialog.InitialDir := TigerPath;
   if OpenPictureDialog.Execute then
   begin
      with GLMaterialLibrary.Materials do
      begin
         with Items[Count-1] do
         begin
            Tag:=1;
            Material.Texture.Image.LoadFromFile(OpenPictureDialog.FileName);
            Material.Texture.Enabled:=True;
         end;
      end;
      ApplyTexturing;
   end;
end;

procedure TdtmGLSViewerForm.MIOpenTexLibClick(Sender: TObject);
var
   i : Integer;
begin
   if ODTextures.Execute then with GLMaterialLibrary do
   begin
      LoadFromFile(ODTextures.FileName);
      for i:=0 to Materials.Count-1 do
         with Materials[i].Material do BackProperties.Assign(FrontProperties);
      //What Setting should be Done?
      ApplyShadeMode;
      ApplyTexturing;
   end;
end;

procedure TdtmGLSViewerForm.ACInvertNormalsExecute(Sender: TObject);
{var  i : Integer;  }
begin
   InvertNormals1.Checked := (not InvertNormals1.Checked);
     if InvertNormals1.Checked then
        FreeForm.NormalsOrientation := mnoInvert
     else
         FreeForm.NormalsOrientation := mnoDefault;
  { with FreeForm.MeshObjects do
      for i:=0 to Count-1 do
         Items[i].Normals.Scale(-1);
   FreeForm.StructureChanged;}
end;

procedure TdtmGLSViewerForm.ACReverseRenderingOrderExecute(Sender: TObject);
var
   i, j, n : Integer;
   fg : TFaceGroup;
begin
   ReverseRenderingOrder1.Checked := (not ReverseRenderingOrder1.Checked);
   with FreeForm.MeshObjects do
   begin
      // invert meshobjects order
      for i:=0 to (Count div 2) do
         Exchange(i, Count-1-i);
      // for each mesh object
      for i:=0 to Count-1 do with Items[i] do
      begin
         // invert facegroups order
         n:=FaceGroups.Count;
         for j:=0 to (n div 2) do
            Exchange(j, n-1-j);
         // for each facegroup
         for j:=0 to n-1 do
         begin
            fg:=FaceGroups[j];
            fg.Reverse;
         end;
      end;
   end;
   FreeForm.StructureChanged;
end;

procedure TdtmGLSViewerForm.ACSaveAsExecute(Sender: TObject);
var    ext : String;
var   st1,st2,st3:string;
begin
   if SaveDialog.Execute then
   begin
      ext:=ExtractFileExt(SaveDialog.FileName);
      if ext='' then
         SaveDialog.FileName:=ChangeFileExt(SaveDialog.FileName,
            '.'+GetVectorFileFormats.FindExtByIndex(SaveDialog.FilterIndex, False, True));
      if GetVectorFileFormats.FindFromFileName(SaveDialog.FileName)=nil then
       //  ShowMessage('Unsupported or unspecified file extension.')
     begin
          st1 := ChangeFileExt(SaveDialog.FileName,'.GLSM');
          st2 := ChangeFileExt(SaveDialog.FileName,'.ML');
          st3 := ChangeFileExt(SaveDialog.FileName,'.LML');
          FreeForm.SaveToFile(st1);
          GLMaterialLibrary.SaveToFile(st2);
          GLMaterialLibraryLightmaps.SaveToFile(st3);
          ShowMessage('Saved:'+#13+'Mesh in "'+extractFileName(st1)+'"'+#13+
                                   'MaterialLibrary in "'+extractFileName(st2)+'"'+#13+
                                   'LightmapLibrary in "'+extractFileName(st3)+'"'+#13);

     end
      else FreeForm.SaveToFile(SaveDialog.FileName);
   end;
end;

{procedure TdtmGLSViewerForm.ACSaveAsUpdate(Sender: TObject);
begin
   ACSaveAs.Enabled:=(FreeForm.MeshObjects.Count>0);
end; }

procedure TdtmGLSViewerForm.ACConvertToIndexedTrianglesExecute(Sender: TObject);
var
   v : TAffineVectorList;
   i : TIntegerList;
   m : TMeshObject;
   fg : TFGVertexIndexList;
begin
   ConverttoIndexedTriangles1.Checked :=
      (not ConverttoIndexedTriangles1.Checked);
   v:=FreeForm.MeshObjects.ExtractTriangles;
   try
      i:=BuildVectorCountOptimizedIndices(v);
      try
         RemapAndCleanupReferences(v, i);
         IncreaseCoherency(i, 8);
         FreeForm.MeshObjects.Clean;
         m:=TMeshObject.CreateOwned(FreeForm.MeshObjects);
         m.Vertices:=v;
         m.BuildNormals(i, momTriangles);
         m.Mode:=momFaceGroups;
         fg:=TFGVertexIndexList.CreateOwned(m.FaceGroups);
         fg.VertexIndices:=i;
         fg.Mode:=fgmmTriangles;
         FreeForm.StructureChanged;
      finally
         i.Free;
      end;
   finally
      v.Free;
   end;
end;

procedure TdtmGLSViewerForm.GLCadencerProgress(Sender: TObject; const deltaTime,
  newTime: Double);
begin
   GLSceneViewer.Invalidate;
end;

procedure TdtmGLSViewerForm.ACFPSExecute(Sender: TObject);
begin     //ACFPS
   FramesPerSecond1.Checked:=not FramesPerSecond1.Checked;
   ApplyFPS;
end;

procedure TdtmGLSViewerForm.TimerTimer(Sender: TObject);
begin
   StatusBar.Panels[1].Text:=Format('%.1f FPS', [GLSceneViewer.FramesPerSecond]);
   GLSceneViewer.ResetPerformanceMonitor;
end;

procedure TdtmGLSViewerForm.ACSaveTexturesExecute(Sender: TObject);
begin
   if SDTextures.Execute then
      GLMaterialLibrary.SaveToFile(SDTextures.FileName);
end;



procedure TdtmGLSViewerForm.actPickMaterialTextureExecute(Sender: TObject);
begin
   OpenPictureDialog.InitialDir := TigerPath;
   if OpenPictureDialog.Execute then
   with GLMaterialLibrary.Materials do
   begin
      with Items[SpinTexture.Value] do
      begin
         Tag:=1;
         Material.Texture.Image.LoadFromFile(OpenPictureDialog.FileName);
         Material.Texture.Enabled:=True;
      end;
      ApplyTexturing;
   end;
end;

procedure TdtmGLSViewerForm.actPickLightmapTextureExecute(Sender: TObject);
begin
   OpenPictureDialog.InitialDir := TigerPath;
   if OpenPictureDialog.Execute then
   with GLMaterialLibraryLightmaps.Materials do
   begin
      with Items[SpinLightmapTexture.Value] do
      begin
         Tag:=1;
         Material.Texture.Image.LoadFromFile(OpenPictureDialog.FileName);
         Material.Texture.Enabled:=True;
      end;
      ApplyTexturing;
   end;
end;

procedure TdtmGLSViewerForm.LightMapMakerWizard1Click(Sender: TObject);
var
   F: TfrmLMMWizard;
begin
     F := TfrmLMMWizard.Create(self);
     F.DestFreeForm := FreeForm;
     F.ShowModal;
     SetExtents;
     DoResetCamera;
     UpdateState;
end;

procedure TdtmGLSViewerForm.ImportLMM3dsClick(
  Sender: TObject);
begin
   OpenDialog.InitialDir := TigerPath;
     if OpenDialog.Execute then
     begin
       ImportLMMLightMap(FreeForm,OpenDialog.FileName,OptimizeCalled);
     end;
end;
//GEOMTRY1.ICO   info
//4IDEA2.ICO
procedure TdtmGLSViewerForm.FaceGroupsLightMaps1Click(Sender: TObject);
var
   F: TFrmLightmapFaceGroups;
begin
     F:= TFrmLightmapFaceGroups.Create(self);
     F.init(FreeForm);
     F.ShowModal;
     F.Free;
     UpdateState;
end;

procedure TdtmGLSViewerForm.OptimizeMesh1Click(Sender: TObject);
begin
     OptimizeMesh(FreeForm.MeshObjects,[mooVertexCache, mooSortByMaterials,mooMergeObjects]);
     FreeForm.StructureChanged;
     OptimizeCalled := true;
end;

procedure TdtmGLSViewerForm.ScaleObject1Click(Sender: TObject);
var
   st : string;
   s: single;
begin
     st := Floattostr(FreeForm.Scale.X);
     if InputQuery('Scale','Enter scale:',st) then
     begin
          s := GLUtils.StrToFloatDef(st,1);
          FreeForm.Scale.X := s;
          FreeForm.Scale.Y := s;
          FreeForm.Scale.Z := s;
          ACResetViewExecute(Sender);
          //ACResetView.Execute;
     end;
end;

procedure TdtmGLSViewerForm.AmbientLightOn1Click(Sender: TObject);
begin
  AmbientLightOn1.Checked:= (not AmbientLightOn1.Checked);
  AmbientLight.Shining := AmbientLightOn1.Checked;
end;
procedure TdtmGLSViewerForm.SpotLightOn1Click(Sender: TObject);
begin
  SpotLightOn1.Checked:= (not SpotLightOn1.Checked);
  SpotLight.Shining := SpotLightOn1.Checked;
end;
procedure TdtmGLSViewerForm.ResetSpotLight1Click(Sender: TObject);
begin
  SpotLight.Position.X:=0;
  SpotLight.Position.Y:=0;
  SpotLight.Position.Z:=0;
end;
procedure TdtmGLSViewerForm.CameraLightOn1Click(Sender: TObject);
begin
  CameraLightOn1.Checked:= (not CameraLightOn1.Checked);
  GLLightSource.Shining := CameraLightOn1.Checked;
end;


procedure TdtmGLSViewerForm.SetExtents;
var
   min, max : TAffineVector;
begin
   FreeForm.GetExtents(min, max);
   with CubeExtents do begin
      CubeWidth:=max[0]-min[0];
      CubeHeight:=max[1]-min[1];
      CubeDepth:=max[2]-min[2];
      Position.AsAffineVector:=VectorLerp(min, max, 0.5);
   end;
   xLabelMax.Caption:= floattostr(max[0]);
   xLabelmin.Caption:= floattostr(min[0]);
   yLabelMax.Caption:= floattostr(max[1]);
   yLabelmin.Caption:= floattostr(min[1]);
   zLabelMax.Caption:= floattostr(max[2]);
   zLabelmin.Caption:= floattostr(min[2]);
end;

procedure TdtmGLSViewerForm.UpdateState;
begin
     //actPickMaterialTexture
     ToolButton15.Enabled:=(GLMaterialLibrary.Materials.Count>0);
     //actPickLightmapTexture
     ToolButton16.Enabled:=(GLMaterialLibraryLightmaps.Materials.Count>0);

     SpinLightmapTexture.MaxValue := GLMaterialLibraryLightmaps.Materials.Count-1;
     SpinTexture.MaxValue := GLMaterialLibrary.Materials.Count-1;
     StatusBar.Panels[2].Text:=
     IntToStr(FreeForm.MeshObjects.TriangleCount)+
     ' tris | '+
     Inttostr(GLMaterialLibrary.Materials.Count)+
     ' Materials | '+
     Inttostr(GLMaterialLibraryLightmaps.Materials.Count)+
     ' Mat.LightMs' ;
end;

procedure TdtmGLSViewerForm.ShowMeshInfo1Click(Sender: TObject);
var
   F : TFInfo;
begin
     F := TFInfo.Create(self);
     F.Show;
     F.Filltree;
end;

procedure TdtmGLSViewerForm.ShowSizesAxis1Click(Sender: TObject);
begin
  ShowSizesAxis1.Checked:= (not ShowSizesAxis1.Checked);
  CubeExtents.Visible := ShowSizesAxis1.Checked;
  DCAxis.Visible      := ShowSizesAxis1.Checked;
end;

procedure TdtmGLSViewerForm.FreeLook1Click(Sender: TObject);
begin
//Marcus Viewer uses GL Navigator  to move camera...
end;
////////////////////////////////////////
////////////////////////////////////////




////////////////////////////////////////
////////////////////////////////////////



procedure TdtmGLSViewerForm.Image1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Image1.Canvas.Pixels[x,y]:=Image1ColorPanel.Color;
end;

procedure TdtmGLSViewerForm.Image1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
  var Halvsies:Integer;
begin
  Halvsies:=(Image1TrackBar.Position div 2);
    Image1.Canvas.Pen.Color := Image1ColorPanel.Color;
    Image1.Canvas.Brush.Color := Image1ColorPanel.Color;
    Image1.Canvas.Brush.Style := bsSolid;
    If Image1RG.Itemindex=0 then
    Image1.Canvas.Ellipse(x-Halvsies, y-Halvsies, x+Halvsies, y+Halvsies)
    else
    Image1.Canvas.Rectangle(x-Halvsies, y-Halvsies, x+Halvsies, y+Halvsies);
end;

procedure TdtmGLSViewerForm.Image1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
//
end;

procedure TdtmGLSViewerForm.Image1ColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:=Image1ColorPanel.Color;
  If ColorDialog1.execute then
    Image1ColorPanel.Color:=ColorDialog1.Color;
end;

procedure TdtmGLSViewerForm.Image1LoadBtnClick(Sender: TObject);
begin
   OpenPictureDialog.InitialDir := TigerPath;
   if OpenPictureDialog.Execute then
   begin
     Image1.Picture.Bitmap.LoadFromFile(OpenPictureDialog.FileName);
     TigerPath:=ExtractFilePath(OpenPictureDialog.FileName);
   end;
end;

procedure TdtmGLSViewerForm.Image1SaveBtnClick(Sender: TObject);
begin
   SaveDialog.InitialDir := TigerPath;
   if SaveDialog.Execute then
   begin
     Image1.Picture.Bitmap.SavetoFile(SaveDialog.FileName);
     TigerPath:=ExtractFilePath(SaveDialog.FileName);
   end;
end;

procedure TdtmGLSViewerForm.Image1ApplyBtnClick(Sender: TObject);
begin
//
end;
////////////////////////////////////////
////////////////////////////////////////

end.
