{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmGlHeight;
//Landscape Demo By Ren Lindsay  program Navigator;
{Drag with the Left mouse-button to rotate the camera.
Use the mouse-wheel, or slider to adjust camera distance.
Use the cursor keys to control the actor around the terrain.}

interface

uses
  Windows, Messages, SysUtils, Classes, ExtDlgs,
  Graphics, Controls, Forms, Dialogs, ExtCtrls,StdCtrls,
  Buttons, ComCtrls, Keyboard,
  jpeg, //jpg,
  GLScene, GLMisc, GLObjects, GLWin32Viewer,
  GLCadencer,
  GLFILESMD,GLFileMD2, 
  GLGraph, GLVectorFileObjects, VectorGeometry, VectorTypes,
  GLSkydome, GLTexture, GLProcTextures,
  GLFireFX, GLParticleFX, GLThorFX,
  Joystickex,{Joystick, }
  Menus;


type

  ObjectRecord = record
     Positionx,Positiony,Positionz,
     Scalex,Scaley,Scalez,
     Upx,Upy,Upz,
     Directionx,Directiony,Directionz  :Single;
  end;

  TdtmGlHeightForm = class(TForm)
    GLCadencer1: TGLCadencer;
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLLightSource1: TGLLightSource;
    GLCamera1: TGLCamera;
    Actor1: TGLActor;
    ActorCube: TGLDummyCube;
    HeightField1: TGLHeightField;
    AllObjects: TGLDummyCube;
    AfterSky: TGLDummyCube;
    Timer1: TTimer;
    OpenPictureDialog1: TOpenPictureDialog;
    Actor2: TGLActor;
    OpenDialog1: TOpenDialog;
    ShpFreeForm: TGLFreeForm;
    FlyByLight: TGLLightSource;
    TimerInputx: TTimer;
    Joystick1: TJoystickex;
    PopupMenu1: TPopupMenu;
    Exit1: TMenuItem;
    SaveSetObjectLocations1: TMenuItem;
    N1: TMenuItem;
    PlaceObjects1: TMenuItem;
    LoadShapeshp1: TMenuItem;
    N2: TMenuItem;
    ClearSetObjects1: TMenuItem;
    SaveDialog1: TSaveDialog;
    GLMaterialLibrary1: TGLMaterialLibrary;
    LoadActorqc1: TMenuItem;
    LoadActorots1: TMenuItem;
    N3: TMenuItem;
    JoystickActive1: TMenuItem;
    Reset1: TMenuItem;
    N4: TMenuItem;
    HeightMaxMin1: TMenuItem;
    LoadsmdTexture1: TMenuItem;
    LoadActorsmd1: TMenuItem;
    N5: TMenuItem;
    HeightRange1: TMenuItem;
    Plus21: TMenuItem;
    Minus21: TMenuItem;
    Plus051: TMenuItem;
    Minus051: TMenuItem;
    MouseSign1: TMenuItem;
    LoadActor1: TMenuItem;
    LoadActorMd2: TMenuItem;
    AdjustForm1: TMenuItem;

procedure ResetMousePos;
    procedure GLCadencer1Progress(Sender: TObject;
               const deltaTime, newTime: Double);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject;
               Shift: TShiftState;
               WheelDelta: Integer;
               MousePos: TPoint;
               var Handled: Boolean);
    procedure ActorDo(action:string; perform:boolean);
    procedure Timer1Timer(Sender: TObject);
    procedure HeightField1GetHeight(const x, y: Single; var z: Single;
      var color: TVector4f; var texPoint: TTexPoint);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormHide(Sender: TObject);
procedure FormShowDown(Wide,High:Integer);

procedure DoQcOpen(const fileName : String);

procedure LoadActorots(Filename:String);

    procedure Exit1Click(Sender: TObject);
    procedure PlaceObjects1Click(Sender: TObject);
    procedure SaveSetObjectLocations1Click(Sender: TObject);
    procedure LoadShapeshp1Click(Sender: TObject);
    procedure ClearSetObjects1Click(Sender: TObject);
    procedure LoadActorqc1Click(Sender: TObject);
    procedure LoadActorots1Click(Sender: TObject);
    procedure JoystickActive1Click(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure HeightMaxMin1Click(Sender: TObject);
    procedure LoadActorsmd1Click(Sender: TObject);
    procedure LoadsmdTexture1Click(Sender: TObject);
    procedure Plus21Click(Sender: TObject);
    procedure Plus051Click(Sender: TObject);
    procedure Minus051Click(Sender: TObject);
    procedure Minus21Click(Sender: TObject);
    procedure MouseSign1Click(Sender: TObject);
    procedure LoadActorMd2Click(Sender: TObject);
    procedure AdjustForm1Click(Sender: TObject);
    procedure TimerInputxTimer(Sender: TObject);
{    procedure CloudSharpnessTrackBarChange(Sender: TObject);
    procedure CloudCoverTrackBarChange(Sender: TObject);
    procedure CloudWidthTrackBarChange(Sender: TObject);
    procedure CloudHeightTrackBarChange(Sender: TObject);}
  private
    { Private declarations }
    ProjectLoaded, ObjectsDone, JoystickActive,
    ActorSmdLoaded, Actor2SmdLoaded,
    ActorMd2Loaded, Actor2Md2Loaded:Boolean;
    ObjectRecordArray: Array of ObjectRecord;
    ObjectRecordArrayCount:Integer;
//    CloudAnime,
LocalSizeX,LocalSizeY,
  JoyX, JoyY, OldJoyX, OldJoyY,
  MouseSign:integer;
  {mx,my,mx2,my2:integer;}
    HeightMultiple:Single;
  //FdeltaTime,
  CamHeight: Double;      
  public
    { Public declarations }
  end;

var
  dtmGlHeightForm: TdtmGlHeightForm;


implementation

{$R *.DFM}

uses dtmfrm, dtmPOFvar, dtmSmdQcUSMDStuff, dtmGlobals;

procedure TdtmGlHeightForm.FormCreate(Sender: TObject);
begin
  top := DtmGlBaseFormY;
  left := DtmGlBaseFormX;
   LocalSizeX:=10;
   LocalSizeY:=10;
//  FdeltaTime:=0;
//  CloudAnime:=0;
  MouseSign:=1;
  CamHeight:=1.2;
  HeightMultiple:=5;
  //TimerInput.Enabled:=false;
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  GLSceneViewer1.Cursor:=crNone;
  ActorSmdLoaded:=False;
  Actor2SmdLoaded:=False;
  ActorMd2Loaded:=False;
  Actor2Md2Loaded:=False;
  ObjectsDone:=False;
  SetLength(ObjectRecordArray,0);
  ObjectRecordArrayCount:=0;
  ProjectLoaded:=False;
  Heightfield1.Material.Texture.Disabled:=True;{False;}
  JoystickActive:=False; //Changed IF Joystick available AND Menu checked
  Joystick1.Capture:=True;
  //  TimerInput.Enabled:=true;
  if Joystick1.Capture=False then
  begin
    JoystickActive1.Enabled:=False;
    JoyX:=0;
    OldJoyX:=0;
    JoyY:=0;
    OldJoyY:=0;
    ShowMessage('No Joystick Detected');
  end else
  begin
    JoyX:=Joystick1.XPosition+JoyCentroidX;
    OldJoyX:=Joystick1.XPosition+JoyCentroidX;
    JoyY:=Joystick1.YPosition+JoyCentroidY;
    OldJoyY:=Joystick1.YPosition+JoyCentroidY;
    Joystick1.Threshold:=ThresholdBarPosition;
    Joystick1.Interval:=IntervalBarPosition;
    //TimerInputTimer(Sender);
  end;
  TimerInputx.Enabled:=false;
end;

procedure TdtmGlHeightForm.FormShowDown(Wide,High:Integer);
{var ILoad:Integer;}
begin
   LocalSizeX:=Wide;
   LocalSizeY:=High;
  Heightfield1.Material.Texture.Disabled:=False;
  Timer1.Enabled:=True;
  GLCadencer1.Enabled:=True;
  Heightfield1.StructureChanged;
  Application.ProcessMessages;

  If isRunningOnDtp then
  Begin {Load Actor, etc... Shape Objects,... ???}
    If ProjectLoaded then exit;  //??? duplicate clone
    If LoadDTPOnStart then
    begin
      //Load the Data...
      //It is in FileName Strings or the Shape file attributes
      If ((ProjectRobotRldFilename<> NoName)
      and( FileExists(ProjectRobotRldFilename)) )then
      begin
        LoadActorots(ProjectRobotRldFilename);
        {For ILoad := 1 to  LayersLoaded do
        begin
        end;}
        {Load Path and Run}
        ProjectLoaded:=True;
      end;
    end;
  End; {isRunningOnDtp}
end;

procedure TdtmGlHeightForm.LoadShapeshp1Click(Sender: TObject);
begin
{For 1 Shape file... ?
 a Project can have Many...? Layers of .shp files}
{Need to Get Min Max area 4 Corners
 to Decide to display the Object or NOT}

end;

procedure TdtmGlHeightForm.Exit1Click(Sender: TObject);
begin
  Close
end;
procedure TdtmGlHeightForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  //TimerInput.Enabled:=false;
  Timer1.Enabled:=False;
  ObjectsDone:=False;
  SetLength(ObjectRecordArray,0);
  GLCadencer1.Enabled:=False;
  NoGLRunning:=True;
  DtmGlBaseFormY := dtmGlHeightForm.top;
  DtmGlBaseFormX := dtmGlHeightForm.left;
  DoSaver;
end;
procedure TdtmGlHeightForm.FormHide(Sender: TObject);
begin
  //TimerInput.Enabled:=false;
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  NoGLRunning:=True;
end;
{==============================================================}
{==============================================================}

{==============================================================}
{==============================================================}
procedure TdtmGlHeightForm.Timer1Timer(Sender: TObject);
begin
   Caption:='Gl Base '+Format('%.1f FPS', [GLSceneViewer1.FramesPerSecond]);
   GLSceneViewer1.ResetPerformanceMonitor;
end;

procedure TdtmGlHeightForm.MouseSign1Click(Sender: TObject);
begin
  MouseSign1.Checked:= (not MouseSign1.Checked);
  If MouseSign1.Checked then MouseSign:= 1 else  MouseSign:= -1;
end;

procedure TdtmGlHeightForm.AdjustForm1Click(Sender: TObject);
begin
  AdjustForm1.Checked:= (not AdjustForm1.Checked);
  If AdjustForm1.Checked then
  begin
    Timer1.Enabled:=False;
    GLCadencer1.Enabled:=False;
    GLSceneViewer1.Cursor:=crDefault;
  end else
  begin
    GLSceneViewer1.Cursor:=crNone;
    Timer1.Enabled:=True;
    GLCadencer1.Enabled:=True;
  end;
end;

procedure TdtmGlHeightForm.TimerInputxTimer(Sender: TObject);
begin
    Joystick1.GetPosition; // Get Joystick state
end;
procedure TdtmGlHeightForm.GLCadencer1Progress(Sender: TObject;
                const deltaTime, newTime: Double);
var
  Joystick1PointOfView:Integer;
   moving : String;
   speed, alpha : Single;
   newMousePos : TPoint;
   hgt :single;
   HV :THomogeneousFltVector;
   tp  :TTexPoint;
   xpos,zpos :single;
   proxy : TGLProxyObject;
{var NewnewTime:Double;}
begin
 if IsKeyDown(VK_ESCAPE) then Close;
                          //md2               //smd
 If ActorMd2Loaded then  moving:='stand'else moving:='idle';

  If JoystickActive then //( JoystickActive1.Checked)
  begin
    Joystick1PointOfView:= -2;
    {Joystick's R and Z axes do not fire events. You have to check their state
     manually. I do this here with a timer event called every 0.1 second.}
    //Joystick1.GetPosition; // Get Joystick state


    // Rotate our 3d stick (=cylinder), a dummycube is used as its rotation axis
    {Axis position values go from -100 to 100}
    ActorCube.PitchAngle:=-Joystick1.XPosition/3;
    ActorCube.RollAngle:=Joystick1.YPosition/3;
    //Just a check.. if it has Zthat then it has R
    if Joystick1.HasZAxis then
    begin
      ActorCube.TurnAngle:=-Joystick1.RPosition/3; // Rudder axis
      //Throttle
      speed:=deltaTime *(-Joystick1.ZPosition+100)/200+0.1 // Throttle axis
    end  else speed:=2*deltaTime;

    //WASTED code.. Nothing DONE with results...
    {Point of view button takes values between 0 and 360  (655 when idle)}
    case Joystick1.PointOfViewType of
      pvtCTS:{Point-of-view button takes values between 0 and 360  (-1 when idle)}
        if Joystick1.PointOfView=-1 then begin Joystick1PointOfView:=-1; end else
        Joystick1PointOfView:=Joystick1.PointOfView;
      pvt4Dir:{Point-of-view changes the button states}
           {Caption:='Point of view: Look at the buttons!';}
        if Joystick1.PointOfView= -1  then
        begin {Some signal with buttons}
          IF ( (jbButtonex1 in Joystick1.JoyButtons)
          and (jbButtonex2 in Joystick1.JoyButtons)
          and (jbButtonex3 in Joystick1.JoyButtons)
          and (jbButtonex4 in Joystick1.JoyButtons) )
          then Joystick1PointOfView:=0 // Caption:='Point of view: Forward'
          else
          IF ( (jbButtonex1 in Joystick1.JoyButtons)
          and (jbButtonex2 in Joystick1.JoyButtons)
          and (jbButtonex3 in Joystick1.JoyButtons) )
          then  Joystick1PointOfView:=180 //Caption:='Point of view: Down'
          else
          IF ( (jbButtonex1 in Joystick1.JoyButtons)
          and (jbButtonex2 in Joystick1.JoyButtons)
          and (jbButtonex4 in Joystick1.JoyButtons) )
          then Joystick1PointOfView:=90 //Caption:='Point of view: Right'
          else
          IF ( (jbButtonex1 in Joystick1.JoyButtons)
          and (jbButtonex2 in Joystick1.JoyButtons) )
          then  Joystick1PointOfView:=270 {Caption:='Point of view: Left' else
          Caption:='Point of view: '
                +Joystick1.ProductName+
              ', ManufacturerID: '+Inttostr(Joystick1.ManufacturerID)
             +', ProductID: '+Inttostr(Joystick1.ProductID);}
        end {Some signal with actual POV data}
        else if Joystick1.PointOfView= 655  then
        begin Joystick1PointOfView:=-1; end else
        Joystick1PointOfView:=Joystick1.PointOfView;
          {Caption:='Point of view: '
                +Joystick1.ProductName+
              ', ManufacturerID: '+Inttostr(Joystick1.ManufacturerID)+
              ', ProductID: '+Inttostr(Joystick1.ProductID)
          else Caption:=Format('Point of view: %d',[Joystick1.PointOfView]);}
      pvtNone:{No point-of-view button}
        {Caption:='Point of view: not supported by: '
                +Joystick1.ProductName+
               ', ManufacturerID: '+Inttostr(Joystick1.ManufacturerID)+
               ', ProductID: '+Inttostr(Joystick1.ProductID)};
    end;//case
    If Joystick1PointOfView<0 then
    begin
      //Reset Point of View to NONE
    end else
    begin
      //Change Point of View
      Caption:='Gl Base POV: '+Inttostr(Joystick1PointOfView);
    end;
    {Fire=1,  Down=2,   Up=3,  Reset=4,}
    If jbButtonex1 in Joystick1.JoyButtons then
       begin
         Caption:='Gl Base button 1';
       end;
    If jbButtonex2 in Joystick1.JoyButtons then
       begin
          Caption:='Gl Base button 2';
       end;
    If jbButtonex3 in Joystick1.JoyButtons then
       begin
       Caption:='Gl Base button 3';
       end;
    If jbButtonex4 in Joystick1.JoyButtons then
       begin
       Caption:='Gl Base button 4';
       end;

    If ((abs(Joystick1.YPosition) > JoyNullRange)
     or (abs(Joystick1.XPosition) > JoyNullRange))then
    with GLCamera1.Position do
    begin
      ActorCube.Position.AddScaledVector(((Joystick1.YPosition)+(JoyCentroidY))*speed*-1, GLCamera1.AbsoluteVectorToTarget);
      ActorCube.Position.AddScaledVector(((Joystick1.XPosition)+(JoyCentroidX))*speed, GLCamera1.AbsoluteRightVectorToTarget);
    end;
  end else
  begin
    // first, are we running ? if yes give animation & speed a boost
    if IsKeyDown(VK_SHIFT) then  speed:=10{0}*deltaTime
      else speed:=2{0}*deltaTime;
    //   Actor1.Interval:=round(speed);
    //Actor2.Interval:=Actor1.Interval;
    // CameraCubeposition:=ActorCube.Position;
    with GLCamera1.Position do
    begin
      if IsKeyDown(VK_UP) then begin moving:='run';
         ActorCube.Position.AddScaledVector(speed, GLCamera1.AbsoluteVectorToTarget); end;
      if IsKeyDown(VK_DOWN) then begin moving:='run';
         ActorCube.Position.AddScaledVector(-speed, GLCamera1.AbsoluteVectorToTarget);  end;
      if IsKeyDown(VK_LEFT) then begin moving:='run';
         ActorCube.Position.AddScaledVector(-speed, GLCamera1.AbsoluteRightVectorToTarget);  end;
      if IsKeyDown(VK_RIGHT) then begin moving:='run';
         ActorCube.Position.AddScaledVector(speed, GLCamera1.AbsoluteRightVectorToTarget);  end;
      if IsKeyDown(VK_PRIOR) then    // pageUp
         CamHeight:=CamHeight+speed;
      if IsKeyDown(VK_NEXT) then     // pageDown
         CamHeight:=CamHeight-speed;
    end;
    // mouse movements and actions
    if IsKeyDown(VK_LBUTTON) then
    begin
      alpha:=ActorCube.Position.Y;
      ActorCube.Position.AddScaledVector((MouseSign*speed), GLCamera1.AbsoluteVectorToTarget);
      CamHeight:=CamHeight+ActorCube.Position.Y-alpha;
    end;
    {if IsKeyDown(VK_RBUTTON) then
     begin
      alpha:=ActorCube.Position.Y;
      ActorCube.Position.AddScaledVector(-speed, GLCamera1.AbsoluteVectorToTarget);
      CamHeight:=CamHeight+ActorCube.Position.Y-alpha;
     end;}
    GetCursorPos(newMousePos);
    GLCamera1.MoveAroundTarget((Screen.Height div 2-newMousePos.Y)*0.25,
                             (Screen.Width div 2-newMousePos.X)*0.25);
    ResetMousePos;
  end;

     //calc actors position on heightfield
  xpos:=-(ActorCube.position.x/HeightField1.Scale.x);
  zpos:=(ActorCube.position.z/HeightField1.Scale.y);
  Heightfield1GetHeight(Xpos,Zpos,hgt,HV,tp);
    //get hgt ---this is the same procedure used
     //to get the heightfields heights
    //place actor just above heightfield
  ActorCube.position.Y:=
                 (hgt*HeightField1.Scale.z)
                 +(HeightField1.Position.y)+CamHeight;
    //move camera to actors position
    //CameraCube.position:=ActorCube.Position;
  GLLightSource1.Position.X:=ActorCube.Position.X{*20};
  GLLightSource1.Position.Y:=ActorCube.Position.Y{*20};
  GLLightSource1.Position.Z:=ActorCube.Position.Z{*20};
  //----   Move camera around the target.
  //----   This code is placed here so the
  //  camera-movements would not cause the Actor to pause
  // the key must move actor at same time else resets to standing
  { if ((mx<>mx2)or(my<>my2)) then
  begin
    GLCamera1.MoveAroundTarget(my-my2, mx-mx2);
    //move the camera around the target if mouse was dragged
    mx:=mx2; my:=my2;
  end;}


  If ActorMd2Loaded or ActorSmdLoaded then
  begin
    if Actor1.CurrentAnimation<>moving then
    begin
      Actor1.SwitchToAnimation(moving);
      If Actor2Md2Loaded then Actor2.Synchronize(Actor1);
      If Actor2SmdLoaded then Actor2.Synchronize(Actor1);
    end;
  end;

  if (ObjectsDone and IsKeyDown(VK_CONTROL){VK_SPACE}) then
  begin
    proxy:=TGLProxyObject(AfterSky.AddNewChild(TGLProxyObject));
    with proxy do
    begin
      ProxyOptions:=[pooObjects];
      MasterObject:=ShpFreeForm;
       // retrieve reference attitude
      Direction:=ShpFreeForm.Direction;
      Up:=ShpFreeForm.Up;
      Scale.SetVector(0.05, 0.05, 0.05, 0);
      Position:=ActorCube.Position;
      {Store Location into a List so it can be SAVED}
      //Position  Scale  Up  Direction
     SetLength(ObjectRecordArray,ObjectRecordArrayCount+1);
     ObjectRecordArray[ObjectRecordArrayCount].Positionx:=ActorCube.Position.x;
     ObjectRecordArray[ObjectRecordArrayCount].Positiony:=ActorCube.Position.y;
     ObjectRecordArray[ObjectRecordArrayCount].Positionz:=ActorCube.Position.z;
     ObjectRecordArray[ObjectRecordArrayCount].Scalex:=ShpFreeForm.Scale.x;
     ObjectRecordArray[ObjectRecordArrayCount].Scaley:=ShpFreeForm.Scale.y;
     ObjectRecordArray[ObjectRecordArrayCount].Scalez:=ShpFreeForm.Scale.z;
     ObjectRecordArray[ObjectRecordArrayCount].Upx:=ShpFreeForm.Up.x;
     ObjectRecordArray[ObjectRecordArrayCount].Upy:=ShpFreeForm.Up.y;
     ObjectRecordArray[ObjectRecordArrayCount].Upz:=ShpFreeForm.Up.z;
     ObjectRecordArray[ObjectRecordArrayCount].Directionx:=ActorCube.Direction.x;
     ObjectRecordArray[ObjectRecordArrayCount].Directiony:=ActorCube.Direction.y;
     ObjectRecordArray[ObjectRecordArrayCount].Directionz:=ActorCube.Direction.z;
     inc(ObjectRecordArrayCount);
    end;
  end;

  {show sky}
  {  NewnewTime:= newTime/300;
  if (Trunc(NewnewTime*300)>CloudAnime) then
  begin
    TimeLabel.caption:=IntToStr(Trunc(NewnewTime*300));
    CloudAnime:=Trunc(NewnewTime*300);
    TGLProcTextureClouds(GLMaterialLibrary1.Materials[0].Material.Texture.Image).CloudAnimate(NewnewTime);
  end;
  GLMaterialLibrary1.Materials[0].TextureOffset.Y := -NewnewTime;
  GLMaterialLibrary1.Materials[0].TextureOffset.x := NewnewTime;}
end;

{==============================================================}
{==============================================================}

{procedure TdtmGlHeightForm.CloudSharpnessTrackBarChange(Sender: TObject);
var cs : single;
begin
  cs := CloudSharpnessTrackBar.Position/100;
  Label2.Caption := FloatToStr(cs);
  TGLProcTextureClouds(GLMaterialLibrary1.Materials[0].Material.Texture.Image).CloudSharpness := cs;
end;

procedure TdtmGlHeightForm.CloudCoverTrackBarChange(Sender: TObject);
var cc : Byte;
begin
  cc := CloudCoverTrackBar.Position;
  Label4.Caption := IntToStr(cc);
  TGLProcTextureClouds(GLMaterialLibrary1.Materials[0].Material.Texture.Image).CloudCover := cc;
end;

procedure TdtmGlHeightForm.CloudWidthTrackBarChange(Sender: TObject);
var cw : Integer;
begin
  cw := CloudWidthTrackBar.Position;
  Label6.Caption := IntToStr(cw);
  TGLProcTextureClouds(GLMaterialLibrary1.Materials[0].Material.Texture.Image).Width := cw;
end;

procedure TdtmGlHeightForm.CloudHeightTrackBarChange(Sender: TObject);
var ch : Integer;
begin
  ch := CloudHeightTrackBar.Position;
  Label8.Caption := IntToStr(ch);
  TGLProcTextureClouds(GLMaterialLibrary1.Materials[0].Material.Texture.Image).Height := ch;
end;}
{==============================================================}
{==============================================================}


procedure TdtmGlHeightForm.ResetMousePos;
begin
  if GLSceneViewer1.Cursor=crNone then
      SetCursorPos(Screen.Width div 2, Screen.Height div 2);
end;
procedure TdtmGlHeightForm.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
   GLCamera1.AdjustDistanceToTarget(Power(1.1, WheelDelta/120));
   //Adjust Camera distance with mousewheel
end;
{==============================================================}
{==============================================================}



{==============================================================}
{==============================================================}
procedure TdtmGlHeightForm.JoystickActive1Click(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  JoystickActive1.Checked:= (not JoystickActive1.Checked);
  Application.ProcessMessages;
  JoystickActive:= (JoystickActive1.Checked);
  TimerInputx.Enabled:=JoystickActive;
  Timer1.Enabled:=True;
  GLCadencer1.Enabled:=True;
end;
procedure TdtmGlHeightForm.Reset1Click(Sender: TObject);
begin
     ActorCube.ResetAndPitchTurnRoll(0,0,0);
     {CameraCube.ResetRotations;}
     {CameraCube.PitchAngle:=0;
      CameraCube.RollAngle:=0;
      CameraCube.TurnAngle:=0;} // Rudder axis
    // ActorCube.Scale.Y:=1; // Throttle axis
    { FlyByCube.position:=CameraCube.Position;
     FlyByGLCamera.position:=FlyByCube.Position;
     GLSceneViewer1.Camera:= FlyByGLCamera;}
    // TimerInput.Enabled:=(not TimerInput.Enabled);

     JoyCentroidX:=0;
     JoyCentroidY:=0;
     ThresholdBarPosition:=500;
     //ThresholdBar.Position:=ThresholdBarPosition;
     Joystick1.Threshold:=ThresholdBarPosition;
     IntervalBarPosition:=100;
     //IntervalBar.Position:=IntervalBarPosition;
     Joystick1.Interval:=IntervalBarPosition;
    //ThresholdLabel.Caption:=Inttostr(ThresholdBar.Position);
    //IntervalLabel.Caption:=Inttostr(IntervalBar.Position);
end;
{==============================================================}
{==============================================================}




{==============================================================}
{==============================================================}
procedure TdtmGlHeightForm.HeightMaxMin1Click(Sender: TObject);
begin
  HeightMaxMin1.Checked := (not HeightMaxMin1.Checked );
    Heightfield1.StructureChanged;
end;

procedure TdtmGlHeightForm.Plus21Click(Sender: TObject);
begin
  HeightMultiple:= HeightMultiple+2;
      Heightfield1.StructureChanged;
end;

procedure TdtmGlHeightForm.Plus051Click(Sender: TObject);
begin
  HeightMultiple:= HeightMultiple+0.5;
    Heightfield1.StructureChanged;
end;

procedure TdtmGlHeightForm.Minus051Click(Sender: TObject);
begin
  HeightMultiple:= HeightMultiple-0.5;
  If HeightMultiple < 1 then HeightMultiple:=1;
    Heightfield1.StructureChanged;
end;

procedure TdtmGlHeightForm.Minus21Click(Sender: TObject);
begin
  HeightMultiple:= HeightMultiple-2;
  If HeightMultiple < 1 then HeightMultiple:=1;
    Heightfield1.StructureChanged;
end;

procedure TdtmGlHeightForm.HeightField1GetHeight(
          const x, y: Single;
          var z: Single;
          var color: TVector4f;
          var texPoint: TTexPoint);
var
  val : integer;
begin        // LocalSizeY  FileSizeY
    If ((round(x*(LocalSizeX-1))>0)and
        (round(x*(LocalSizeX-1))<LocalSizeX)and
        (((y)*(LocalSizeY-1))>0)and
        (((y)*(LocalSizeY-1))<LocalSizeY))
    then
    begin
      val:=ManMatrix[round(x*(LocalSizeX-1)),
                     round(y*(LocalSizeY-1))];
      {HeightTrackBar1.Position  1..20}
       //Height Exageration      Heightfield1.StructureChanged;
      If HeightMaxMin1.Checked then
         z:=val*(   HeightMultiple
                  /(  MaximumElevation-MinimumElevation))
         else z:=val*(HeightMultiple/1000);
    end else z:=1; {Off the planet}
end;

{==============================================================}
{==============================================================}


{==============================================================}
{==============================================================}
procedure TdtmGlHeightForm.ActorDo(action:string; Perform:boolean);
begin
   if ((Action<>Actor1.CurrentAnimation)and(Perform=True)) then
      Actor1.SwitchToAnimation(action);
If ActorSmdLoaded then
   if ((Action=Actor1.CurrentAnimation)and(Perform=False)) then
      Actor1.SwitchToAnimation('idle')
      else
If ActorMd2Loaded then
   if ((Action=Actor1.CurrentAnimation)and(Perform=False)) then
      Actor1.SwitchToAnimation('stand');
   //Actor2.Synchronize(Actor1);
   If Actor2Md2Loaded then Actor2.Synchronize(Actor1);
   If Actor2SmdLoaded then Actor2.Synchronize(Actor1);
end;
{==============================================================}
{==============================================================}






{==============================================================}
{==============================================================}
procedure TdtmGlHeightForm.LoadActorqc1Click(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  OpenDialog1.Filter := 'lifeless (*.qc)|*.qc';
  OpenDialog1.InitialDir := TigerPath;
  OpenDialog1.Filename:='*.qc';
  if OpenDialog1.Execute then
     DoQcOpen(OpenDialog1.FileName);
  Timer1.Enabled:=True;
  GLCadencer1.Enabled:=True;
end;


procedure TdtmGlHeightForm.DoQcOpen(const fileName : String);
begin
  ActorSmdLoaded:=False;
  Actor2SmdLoaded:=False;
  ActorMd2Loaded:=False;
  Actor2Md2Loaded:=False;
       TigerPath:=ExtractFilePath(FileName);
       Application.ProcessMessages;
       dtmGlHeightForm.Cursor:=crHourGlass;
{       Timer1.Enabled:=True;
       GLCadencer1.Enabled:=True;  }
       // LOAD THE Filename, into Actor1, with MODEL, + with ANIMATIONS
       LoadQC(FileName,Actor1,True,True);
      ActorSmdLoaded:=True;
       Actor1.StructureChanged;

     Actor1.OverlaySkeleton:=False;
     Actor1.Interval := 50;
 If ActorMd2Loaded then
  Actor1.SwitchToAnimation('stand0')
  else Actor1.SwitchToAnimation('idle');


     dtmGlHeightForm.Cursor:=crDefault;

end;


procedure TdtmGlHeightForm.LoadActorots1Click(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  ActorSmdLoaded:=False;
  Actor2SmdLoaded:=False;
  ActorMd2Loaded:=False;
  Actor2Md2Loaded:=False;
  begin
    OpenDialog1.Filter:='Object + Texture Set (*.ots)|*.ots';
    OpenDialog1.InitialDir:=ProjectPath;
    OpenDialog1.Filename:='*.ots';
    if OpenDialog1.Execute then
    begin
      if UpperCase(ExtractFileExt(OpenDialog1.Filename)) = '.OTS' then
      begin
        LoadActorots(OpenDialog1.Filename);
        Timer1.Enabled:=True;
        GLCadencer1.Enabled:=True;
      end;
    end;
  end;
end;

procedure TdtmGlHeightForm.LoadActorots(Filename:String);
var
 ActorFileName,TextureFileName,
 WeaponFileName, WpnTextureFileName,
 S : string;
 F: TextFile;
 ActorScale:Double;
 begin
        ProjectPath:=ExtractFilePath(Filename);
        AssignFile(F, FileName);
        Reset(F);
        Readln(F, S);
        If (S='GlobalObjectActorTerrain Version 1.0') then
        begin
           {Read file and get ActorFileName
             and TextureFileName
                  WeaponFileName
                  WpnTextureFileName
               Filenames...}
    Readln(F, S);  If S <> 'True' then exit;
    Readln(F, S);  //Not for other type
    Readln(F, S);
    Readln(F, S);
    Readln(F, S);
    Readln(F, S);
          Readln(F, ActorFileName);
          If FileExists(ActorFileName) then
          If lowercase(ExtractFileExt(ActorFileName))='qc' then
          DoQcOpen(ActorFileName)else Exit;
          {Actor1.LoadFromFile(ActorFileName) else Exit;}
          Readln(F, TextureFileName);
          If FileExists(TextureFileName) then
          Actor1.Material.Texture.Image.LoadFromFile(TextureFileName);
          //Actor1.Scale.SetVector(0.05, 0.05, 0.05, 0);
          Readln(F, WeaponFileName);
          If FileExists(WeaponFileName) then
          begin
          Actor2.LoadFromFile(WeaponFileName);
          Actor2Md2Loaded:=True;
          end;
          Readln(F, WpnTextureFileName);
          If FileExists(WpnTextureFileName) then
          Actor2.Material.Texture.Image.LoadFromFile(WpnTextureFileName);
          Readln(F, WpnTextureFileName);
          ActorScale:=Strtofloat(WpnTextureFileName);
          Actor1.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
          CloseFile(F);

          // Define animation properties
          Actor1.AnimationMode:=aamLoop;
          Actor1.FrameInterpolation:=afpLinear;
          {Actor1.Animations.SetToStrings(CBAnimations.Items);
          CBAnimations.ItemIndex:=0;
          CBAnimationsChange(Self);
          If Actor2Md2Loaded then
          begin
          Actor2.Animations.Assign(Actor1.Animations);
          Actor2.Synchronize(Actor1);
          end;

          ActorLoaded:=True; }
        end;
end;


procedure TdtmGlHeightForm.LoadActorsmd1Click(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  ActorSmdLoaded:=False;
  Actor2SmdLoaded:=False;
  ActorMd2Loaded:=False;
  Actor2Md2Loaded:=False;
  begin
    {Load Actor base}
    OpenDialog1.Filter:='actor |*.smd';
    OpenDialog1.InitialDir:=TigerPath;
    OpenDialog1.Filename:='*.*';
    if OpenDialog1.Execute then
    begin
      TigerPath:=ExtractFilePath(OpenDialog1.FileName);
      //----Load the main Actor and skin----
      Actor1.LoadFromFile(OpenDialog1.FileName{'.\alita\tris.md2'});
      ActorsmdLoaded:=True;
      {Load Actor texture}
      OpenDialog1.Filter:='smd texture (jpg)|*.jpg;*.bmp';
      OpenDialog1.InitialDir:=TigerPath;
      OpenDialog1.Filename:='*.*';
      if OpenDialog1.Execute then
      begin        {Load Actor texture}
        Actor1.Material.Texture.Image.LoadFromFile(OpenDialog1.FileName);
        //Actor1.Scale.SetVector(0.05, 0.05, 0.05, 0);
        {Actor Weapon}
       { OpenDialog1.Filter:='smd weapon |*.md2;*.smd';
        OpenDialog1.InitialDir:=TigerPath;
        OpenDialog1.Filename:='*.*';
        if OpenDialog1.Execute then
        begin
          Actor2.LoadFromFile(OpenDialog1.FileName);

          OpenDialog1.Filter:='weapon texture (jpg)|*.jpg';
          OpenDialog1.InitialDir:=TigerPath;
          OpenDialog1.Filename:='*.jpg';
          if OpenDialog1.Execute then
          begin
            Actor2.Material.Texture.Image.LoadFromFile(OpenDialog1.FileName);
          end;
          Actor2.Animations.Assign(Actor1.Animations);
          Actor2smdLoaded:=True;
        end;}
      end;
      // Define animation properties
      Actor1.AnimationMode:=aamLoop;
      Actor1.FrameInterpolation:=afpLinear;
      //Actor1.Animations.SetToStrings(CBAnimations.Items);
      //CBAnimations.ItemIndex:=0;
      //CBAnimationsChange(Self);
      If Actor2smdLoaded then Actor2.Synchronize(Actor1);
      //Actor2Loaded:=True;
    end;
  end;
  Timer1.Enabled:=True;
  GLCadencer1.Enabled:=True;
end;

procedure TdtmGlHeightForm.LoadsmdTexture1Click(Sender: TObject);
begin
  If ActorSmdLoaded then
  begin
      OpenDialog1.Filter:='smd texture (jpg)|*.jpg;*.bmp';
      OpenDialog1.InitialDir:=TigerPath;
      OpenDialog1.Filename:='*.*';
      if OpenDialog1.Execute then
      begin                          {'.\alita\alita2.jpg'}
        Actor1.Material.Texture.Image.LoadFromFile(OpenDialog1.FileName);
      end;
  end;
end;

procedure TdtmGlHeightForm.LoadActorMd2Click(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  ActorSmdLoaded:=False;
  Actor2SmdLoaded:=False;
  ActorMd2Loaded:=False;
  Actor2Md2Loaded:=False;
  begin
    {Load Actor base}
    OpenDialog1.Filter:='actor |*.md2';
    OpenDialog1.InitialDir:=TigerPath;
    OpenDialog1.Filename:='*.*';
    if OpenDialog1.Execute then
    begin
      TigerPath:=ExtractFilePath(OpenDialog1.FileName);
      //----Load the main Actor and skin----
      Actor1.LoadFromFile(OpenDialog1.FileName{'.\alita\tris.md2'});
      Actormd2Loaded:=True;
      If FileExists(ChangeFileExt(OpenDialog1.FileName ,'.jpg')) then
      begin    {Load Actor texture}
        Actor1.Material.Texture.Image.LoadFromFile(ChangeFileExt(OpenDialog1.FileName ,'.jpg'));

        {Actor Weapon}
        {OpenDialog1.Filter:='md2 weapon |*.md2';
        OpenDialog1.InitialDir:=TigerPath;
        OpenDialog1.Filename:='*.*';
        if OpenDialog1.Execute then
        begin
          Actor2.LoadFromFile(OpenDialog1.FileName);

          If FileExists(ChangeFileExt(OpenDialog1.FileName ,'.jpg')) then
          Actor2.Material.Texture.Image.LoadFromFile(ChangeFileExt(OpenDialog1.FileName ,'.jpg'));
          Actor2.Animations.Assign(Actor1.Animations);
          Actor2md2Loaded:=True;
        end;}
      end;
      // Define animation properties
      Actor1.AnimationMode:=aamLoop;
      Actor1.FrameInterpolation:=afpLinear;
      //Actor1.Animations.SetToStrings(CBAnimations.Items);
      //CBAnimations.ItemIndex:=0;
      //CBAnimationsChange(Self);
      If Actor2md2Loaded then Actor2.Synchronize(Actor1);
      //Actor2Loaded:=True;
    end;
  end;
  Timer1.Enabled:=True;
  GLCadencer1.Enabled:=True;
end;

{==============================================================}
{==============================================================}






{==============================================================}
{==============================================================}
{Scale ... Focal Length ... Height of Observer}
{Size of Object... Perspective ... X,Y,Z Location}
{Shape file Import into Vector Mesh
  <> Overlay as colors on bitmap
 Level of Detail <> Terrain Size}
 {Sun Azimuth for Lights .. Moon & Twinkle stars at night..}
  {Actors <> Objects}
  {md2..smd ??  Textures and Weapons
  3DS Point Objects .. Line Objects (Roads, Bridges)
  Billboard Textures for Objects}
{==============================================================}
{==============================================================}


{==============================================================}
{==============================================================}
{Once loaded they are set in Keyboard routine}
procedure TdtmGlHeightForm.PlaceObjects1Click(Sender: TObject);
begin
If ObjectsDone then
begin
{?? Kill the objects}
    ObjectsDone:=False;
    ObjectRecordArrayCount:=0;
    SetLength(ObjectRecordArray,0);
end else
  begin
    {Load the FreeForm data}
     // Load mushroom mesh
    OpenDialog1.Filter:='3ds or smd|*.3ds;*.smd';
    OpenDialog1.Filename:='*.3ds';
    OpenDialog1.InitialDir:=DXFPath;
    if OpenDialog1.Execute then
    begin
      If (ExtractFileExt(OpenDialog1.FileName)='.3ds')
         then DXFPath :=ExtractFilePath(OpenDialog1.FileName)
         else {TigerPath smd}
      If (ExtractFileExt(OpenDialog1.FileName)='.smd')
         then TigerPath :=ExtractFilePath(OpenDialog1.FileName);
      ShpFreeForm.LoadFromFile(OpenDialog1.FileName);
 {?}     ShpFreeForm.Scale.SetVector(0.05, 0.05, 0.05, 0);
      ShpFreeForm.Position:=ActorCube.Position;
      ObjectsDone:=True;
      SetLength(ObjectRecordArray,ObjectRecordArrayCount+1);
     ObjectRecordArray[ObjectRecordArrayCount].Positionx:=ShpFreeForm.Position.x;
     ObjectRecordArray[ObjectRecordArrayCount].Positiony:=ShpFreeForm.Position.y;
     ObjectRecordArray[ObjectRecordArrayCount].Positionz:=ShpFreeForm.Position.z;
     ObjectRecordArray[ObjectRecordArrayCount].Scalex:=ShpFreeForm.Scale.x;
     ObjectRecordArray[ObjectRecordArrayCount].Scaley:=ShpFreeForm.Scale.y;
     ObjectRecordArray[ObjectRecordArrayCount].Scalez:=ShpFreeForm.Scale.z;
     ObjectRecordArray[ObjectRecordArrayCount].Upx:=ShpFreeForm.Up.x;
     ObjectRecordArray[ObjectRecordArrayCount].Upy:=ShpFreeForm.Up.y;
     ObjectRecordArray[ObjectRecordArrayCount].Upz:=ShpFreeForm.Up.z;
     ObjectRecordArray[ObjectRecordArrayCount].Directionx:=ShpFreeForm.Direction.x;
     ObjectRecordArray[ObjectRecordArrayCount].Directiony:=ShpFreeForm.Direction.y;
     ObjectRecordArray[ObjectRecordArrayCount].Directionz:=ShpFreeForm.Direction.z;
     inc(ObjectRecordArrayCount);
    end;
  end;
end;

procedure TdtmGlHeightForm.ClearSetObjects1Click(Sender: TObject);
begin
  If ObjectsDone then
  begin     {?? Kill the objects}
    ObjectsDone:=False;
    ObjectRecordArrayCount:=0;
    SetLength(ObjectRecordArray,0);
  end;
end;

procedure TdtmGlHeightForm.SaveSetObjectLocations1Click(Sender: TObject);
var
  F: TextFile;
  i:Integer;   //  S: string;
begin
  If ObjectsDone then
  begin
  if SaveDialog1.Execute then          { Display Open dialog box }
  begin
    AssignFile(F, SaveDialog1.FileName);   { File selected in dialog box }
    Rewrite(F);
    writeln(F,'DTM Object Locations');
    writeln(F,'Count then Position  Scale  Up  Direction');
    writeln(F,inttostr(ObjectRecordArrayCount));
      //Position  Scale  Up  Direction
    For I:= 0 to ObjectRecordArrayCount-1 do
begin
    writeln(F,Floattostr(ObjectRecordArray[I].Positionx));
    writeln(F,Floattostr(ObjectRecordArray[I].Positiony));
    writeln(F,Floattostr(ObjectRecordArray[I].Positionx));
    writeln(F,Floattostr(ObjectRecordArray[I].Scalex));
    writeln(F,Floattostr(ObjectRecordArray[I].Scaley));
    writeln(F,Floattostr(ObjectRecordArray[I].Scalez));
    writeln(F,Floattostr(ObjectRecordArray[I].Upx));
    writeln(F,Floattostr(ObjectRecordArray[I].Upy));
    writeln(F,Floattostr(ObjectRecordArray[I].Upz));
    writeln(F,Floattostr(ObjectRecordArray[I].Directionx));
    writeln(F,Floattostr(ObjectRecordArray[I].Directiony));
    writeln(F,Floattostr(ObjectRecordArray[I].Directionz));
End;
    CloseFile(F);
  end;
  end;
end;
{==============================================================}
{==============================================================}











end.
