{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
{ Global Variables that are passed around and temporary }
{*******************************************************}
unit dtmGlobals;

interface
uses
  HeightTileFile,{HTF file}
  dtmRasterImageFile,{RIF }
  Graphics;
  
const
  SELDIRHELP = 120;{SelectDirectory help}
  NeedlessErrorMessage = 'Houston, we have a problem';
  NoName='Nada';
  Verstring1_2='ILH Version 1.2';
  PathVersion='Gizmo Path File V1.0';
  GoatVersion='GlobalObjectActorTerrain Version 1.0';
type
  TDrawingTool =
    (dtEllipse, dtCSEllipse, dtPolygon,
    dtVTriangle, dtTriangle, dtTSTriangle,
    dtVPRectangle, dtVERectangle, dtVSRectangle,
    dtVDRectangle, dtVTRectangle, dtVFRectangle, dtVNRectangle,
    dtVMRectangle, dtVARectangle, dtVWRectangle, dtVCRectangle,
    dtVBRectangle, dtVRectangle, dtRectangle, dtRoundRect,
    dtSqRectangle,
    dtLine, dtMLine,dtPBrush);
{    type
  aLineRecord = record
  p1,p2:TPoint;
  end;
  LineRecord = record
  Start,Finish,Result:Array[0..1] of TPoint;
  DeltaXs,DeltaYs,DeltaXf,DeltaYf,DeltaXr,DeltaYr:Integer;
  Lengths,Lengthf,Lengthr:Double;
  LengthSQs,LengthSQf,LengthSQr:Integer;
  end;}
var
  ProgressMsgString:String;
  {Extents used in Drawing.. ? always positive?}
  DataScalerX, DataScalerY, //DataScaler  Width/Size
  DataSizeMinOffX, DataSizeMaxOffX,    {htf.SizeX Offset is +- to center data to 0,0}
  DataSizeMinOffY, DataSizeMaxOffY,
  MaxExtentX, MaxExtentY,{Store difference : MinOffX, MaxOffX}
  MaxOffsetX, MaxOffsetY:Double;{Offset is +- to center data to 0,0}
  {MinOffX, MaxOffX,MinOffY, MaxOffY:Double; }{resize view data}

  ScreenScale:Double;
  DrawingTool: TDrawingTool;
  {full Screen X,Y sizes.. not -1}
  ScreenWidth,ScreenHeight  :Integer;

var
  htf : THeightTileFile;{Contains data}
  rif : TImageTileFile;
  ManMatrix: array of array of Smallint;
  NullDemValue,
  MaximumElevation, MinimumElevation, {ContourInterval,}
  AutoMinimumElevation,AutoMaximumElevation,AutoDefaultZ,  
  FileSizeX, FileSizeY: Integer;
  CellSizeX, CellSizeY,
  DemiBottomY2e, DemiRightX2e,
  DemiTopY1e, DemiLeftX1e:Double;
{    MorphArray:Array of LineRecord;
    MorphArrayFile:File of LineRecord;
    GrabMDistance:Integer;}
 // MyPixelFormat: TPixelFormat;
  //PixelScanSize:Integer;

  NoGLRunning, isRunningOnDtp,
  isReallyGone,  isHTFLoaded  :Boolean;

{  CropXWide,CropYTall,
  MagnifierSize,   GCImageWidth,GCImageHeight,
  MorphTweens,MorLineCount,
  DrawingToolPBrushWidth, ITriangling, Cropping: Integer;
pointStart,pointEnd,DIYX3Y3,DIYX4Y4,Origin, MovePt:TPoint;}
    Sample, SampleW,
    BottomRow, TopRow, RightColumn, LeftColumn: Integer;
    DShiftOffsetX,DShiftOffsetY,
  dXTemp, dYTemp, dXMIN, dYMIN, dXMAX, dYMAX: Double;

type
  Array3DRecord = record
  RX,GY,BZ:Byte;
  Count:Integer;
  end;
var
  Array3D: array of Array3DRecord;
  Array3DCounter:Integer;
  His3DMatrix: array of array of array of Byte;

{  ResultFileList : TStringList; THIS is the Passing RESULT LIST}

implementation

end.
