{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmHtfDTEDFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TdtmHtfDTEDForm = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    ProgressBar1: TProgressBar;
    Button1: TButton;
    Memo1: TMemo;
    RichMemo: TRichEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    CloseUpShop:Boolean;
    {Decimeter:Boolean;}
    FromF: file;
    NumRead: Integer;
    {NewFileName, No name in this header}
    SaveFileName:String;
      {FileSizeX:=maxcolsX;
       FileSizeY:=maxrowsY;}
    maxcolsX, maxrowsY, CellSize:Integer;
    INVAL : Integer;{ = -9999}
    Procedure ReadDTEDHeader;
    Procedure ProcessDTEDHeader;
  public
    { Public declarations }
    {Called from dtmHtfFrm : Converts a DEM into ManMatrix array}
    Function DoDTEDtoBin(var InfileName:String):Boolean;
  end;

var
  dtmHtfDTEDForm: TdtmHtfDTEDForm;

implementation

{$R *.DFM}

uses   dtmGlobals, dtmPOFvar, dtmErrMsg, dtmHtfFrm;

type
  TDTEDHeader = Record
     UHL:array[1..3] of char;
     CellSizeX:array[1..4] of char;
     CellSizeY:array[1..4] of char;
     DSI:array[1..3] of char;
     BottomLeftY:array[1..7] of char;
     BottomLeftX:array[1..8] of char;
     TopLeftY:array[1..7] of char;
     TopLeftX:array[1..8] of char;
     TopRightY:array[1..7] of char;
     TopRightX:array[1..8] of char;
     BottomRightY:array[1..7] of char;
     BottomRightX:array[1..8] of char;
     maxcolsX:array[1..4] of char;
     maxrowsY:array[1..5] of char;
     ACC:array[1..3] of char;
   end;
var
    DTEDHeader: TDTEDHeader;

procedure TdtmHtfDTEDForm.FormCreate(Sender: TObject);
begin
{duplicate of dtmHtfDem24kForm}
    INVAL := -9999;
end;

procedure TdtmHtfDTEDForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
{}
end;

procedure TdtmHtfDTEDForm.Button1Click(Sender: TObject);
begin
  CloseUpShop:=True;
end;

{UHL 80, DSI 647, ACC 2700 = 3427
Data record x 1, Count 3, Lon 2, Lat 2, Data 2 bytes each, Checksum 4}
procedure TdtmHtfDTEDForm.ReadDTEDHeader;
var  Buf: array[1..2700] of Char;
Begin
{UHL 80 bytes}
  BlockRead(FromF, DTEDHeader.UHL,SizeOf(DTEDHeader.UHL){3}, NumRead);
{  BlockRead(FromF, Buf,1, NumRead); } {1Memo1.Lines.Add(Buf);}
  BlockRead(FromF, Buf,9{8}, NumRead);  {lon Memo1.Lines.Add(Buf);}
  BlockRead(FromF, Buf,8, NumRead);  {lat Memo1.Lines.Add(TempString);}
  BlockRead(FromF, DTEDHeader.CellSizeX,SizeOf(DTEDHeader.CellSizeX){4}, NumRead);
  BlockRead(FromF, DTEDHeader.CellSizeY,SizeOf(DTEDHeader.CellSizeY){4}, NumRead);
  BlockRead(FromF, Buf,4, NumRead);  {Absolute Vertical Accuracy Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,3, NumRead);  {security TSCUR Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,12, NumRead);  {Unique Reference Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,4, NumRead);  {lon count Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,4, NumRead);  {lat points Memo1.Lines.Add(TempString);}
  {get it from DSI}
  BlockRead(FromF, Buf,1, NumRead);  {multiple accuracy 0 or 1 Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,24, NumRead);  {unused reserved Memo1.Lines.Add(TempString);}

{DSI 648 bytes  REALLY only 647 !}
  BlockRead(FromF, DTEDHeader.DSI,SizeOf(DTEDHeader.DSI){3}, NumRead);
  BlockRead(FromF, Buf,1, NumRead);  {security TSCUR Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,2, NumRead);  {security DMA Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,27, NumRead);  {security Handling Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,26, NumRead);  {unused reserved Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,5, NumRead);  {DTED1 or DTED2 Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,15, NumRead);  {Unique Reference Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,8, NumRead);  {unused reserved Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,2, NumRead);  {Data Edition # Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,1, NumRead);  {UHL Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,4, NumRead);  {UHL Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,4, NumRead);  {UHL Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,4, NumRead);  {Maintenance code Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,8, NumRead);  {producer Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,16, NumRead);  {unused reserved Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,9, NumRead);  {UHL Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,2, NumRead);  {UHL Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,4, NumRead);  {date Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,3, NumRead);  {Vertical datum Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,5, NumRead);  {WGS84 Horizontal datum Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,10, NumRead);  {UHL Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,4, NumRead);  {UHL Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,22, NumRead);  {UHL Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,9, NumRead);  {lat Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,10, NumRead);  {lon Memo1.Lines.Add(TempString);}

{lat sw}  BlockRead(FromF, DTEDHeader.BottomLeftY,SizeOf(DTEDHeader.BottomLeftY){7}, NumRead);
{lon sw}  BlockRead(FromF, DTEDHeader.BottomLeftX,SizeOf(DTEDHeader.BottomLeftX){8}, NumRead);
{lat nw}  BlockRead(FromF, DTEDHeader.TopLeftY,SizeOf(DTEDHeader.TopLeftY){7}, NumRead);
{lon nw}  BlockRead(FromF, DTEDHeader.TopLeftX,SizeOf(DTEDHeader.TopLeftX){8}, NumRead);
{lat ne}  BlockRead(FromF, DTEDHeader.TopRightY,SizeOf(DTEDHeader.TopRightY){7}, NumRead);
{lon ne}  BlockRead(FromF, DTEDHeader.TopRightX,SizeOf(DTEDHeader.TopRightX){8}, NumRead);
{lat se}  BlockRead(FromF, DTEDHeader.BottomRightY,SizeOf(DTEDHeader.BottomRightY){7}, NumRead);
{lon se}  BlockRead(FromF, DTEDHeader.BottomRightX,SizeOf(DTEDHeader.BottomRightX){8}, NumRead);
  BlockRead(FromF, Buf,9, NumRead);  {angle Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,4, NumRead);  {lat interval Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,4, NumRead);  {lon Memo1.Lines.Add(TempString);}
{}  BlockRead(FromF, DTEDHeader.maxcolsX,SizeOf(DTEDHeader.maxcolsX){4}, NumRead);
{}  BlockRead(FromF, DTEDHeader.maxrowsY,SizeOf(DTEDHeader.maxrowsY){4}, NumRead);
  BlockRead(FromF, Buf,2, NumRead);  {partial Memo1.Lines.Add(TempString);}
          {DSI is listed as 648 REALLY 647 so dropped i byte here}
  BlockRead(FromF, Buf,100, NumRead);  {reserved dma Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,100, NumRead);  {reserved Memo1.Lines.Add(TempString);}
  BlockRead(FromF, Buf,156, NumRead);  {reserved Memo1.Lines.Add(TempString);}
{ACC 3 record  2700}
  BlockRead(FromF, DTEDHeader.ACC,SizeOf(DTEDHeader.ACC){3}, NumRead);
  BlockRead(FromF, Buf,2697, NumRead);  {ACC record Memo1.Lines.Add(TempString);}
End;

{UHL 80, DSI 647, ACC 2700 = 3427
Data record x 1, Count 3, Lon 2, Lat 2, Data 2 bytes each, Checksum 4}
procedure TdtmHtfDTEDForm.ProcessDTEDHeader;
var
  i:Integer;
  sign, TemProj:Double;
  TempString:String;
function packedDMSToDouble(  packedDMS:double ):double;
var  min,deg,sign:Double;
Begin
  sign := 1.0;
  if ( packedDMS < 0.0 )then
  begin
    sign := -1.0;
    packedDMS := -packedDMS;
  end;      {DDDMMSS.SS}
  deg := packedDMS / 10000;
  packedDMS := packedDMS-(deg * 10000);
  min := packedDMS / 100;
  packedDMS := packedDMS-(min * 100);
  result := deg;
  result := result+(min / 60.0);
  result := result+(packedDMS / 3600.0);
  result := result*sign;
End;
Begin
  Memo1.Clear;
  Memo1.Lines.Add('FileName '+ SaveFileName);
  {BlockRead(var F: File; var Buf; Count: Integer [; var AmtTransferred: Integer]);}
  Memo1.Lines.Add('Header Follows');
  TempString:='';
{UHL 80 bytes}
   Setlength(TempString,3);  For i:= 1 to 3 do TempString[i]:=' ';
  For i:= 1 to 3 do TempString[i]:=DTEDHeader.UHL[i];
   TempString:=Trim(TempString);
    Memo1.Lines.Add('UHL '+TempString);
  If (not('UHL'=TempString) ) then
     begin showmessage('UHL ERROR'); Application.Terminate; end;

   Setlength(TempString,4);  For i:= 1 to 4 do TempString[i]:=' ';
  For i:= 1 to 4 do TempString[i]:=DTEDHeader.CellSizeX[i];
   TempString:=Trim(TempString); If Length(TempString) >0 then
    CellSize:=Strtoint(TempString);
    Memo1.Lines.Add('CellSize X'+TempString);{physical size}
   Setlength(TempString,4);  For i:= 1 to 4 do TempString[i]:=' ';
  For i:= 1 to 4 do TempString[i]:=DTEDHeader.CellSizeX[i];
   TempString:=Trim(TempString);
    Memo1.Lines.Add('CellSize Y'+TempString);{lat data interval}
  If (CellSize<>strtoint(trim(TempString))) then
     begin showmessage('Data size ERROR'); Application.Terminate; end;


{DSI 648 bytes}
   Setlength(TempString,3);  For i:= 1 to 3 do TempString[i]:=' ';
  For i:= 1 to 3 do TempString[i]:=DTEDHeader.DSI[i];
   TempString:=Trim(TempString);
    Memo1.Lines.Add('DSI '+TempString);
  If (not('DSI'=Uppercase(TempString)) ) then
     begin showmessage('DSI ERROR'); Application.Terminate; end;

dtmHtfForm.InDatumCB.itemindex:=14;{WGS84}
dtmHtfForm.SpheroidCB.itemindex:=12;{WGS84}
dtmHtfForm.SourceCB.itemindex:=11;{DTED}
dtmHtfForm.ProjectionCB.itemindex:=0;{Geo}

{lat sw}
   Setlength(TempString,7);  For i:= 1 to 7 do TempString[i]:=' ';
   For i:= 1 to 7 do TempString[i]:=DTEDHeader.BottomLeftY[i];
   If (Uppercase(TempString[7]) ='N')then
    begin TempString[7]:=' '; sign:= 1;end
    else begin TempString[7]:=' '; sign:= -1; end;
   TempString:=Trim(TempString);
    TemProj:=packedDMSToDouble(strtofloat(TempString)*sign);
    dtmHtfForm.BottomLeftYEdit.Text:=floattostr(TemProj);
    Memo1.Lines.Add('BottomLeftY: '+TempString);
{lon}
   Setlength(TempString,8);  For i:= 1 to 8 do TempString[i]:=' ';
  For i:= 1 to 8 do TempString[i]:=DTEDHeader.BottomLeftX[i];
  If (Uppercase(TempString[8]) ='E')then
    begin TempString[8]:=' '; sign:= 1;end
    else begin TempString[8]:=' '; sign:= -1; end;
   TempString:=Trim(TempString);
    TemProj:=packedDMSToDouble(strtofloat(TempString)*sign);
   dtmHtfForm.BottomLeftXEdit.Text:=floattostr((TemProj));
   Memo1.Lines.Add('BottomLeftX: '+TempString);

{lat nw}
   Setlength(TempString,7);  For i:= 1 to 7 do TempString[i]:=' ';
   For i:= 1 to 7 do TempString[i]:=DTEDHeader.TopLeftY[i];
  If (Uppercase(TempString[7]) ='N')then
    begin TempString[7]:=' '; sign:= 1;end
    else begin TempString[7]:=' '; sign:= -1; end;
   TempString:=Trim(TempString);
    TemProj:=packedDMSToDouble(strtofloat(TempString)*sign);
   dtmHtfForm.TopLeftYEdit.Text:=floattostr((TemProj));
   Memo1.Lines.Add('TopLeftY: '+TempString);
{lon}
   Setlength(TempString,8);  For i:= 1 to 8 do TempString[i]:=' ';
   For i:= 1 to 8 do TempString[i]:=DTEDHeader.TopLeftX[i];
  If (Uppercase(TempString[8]) ='E')then
    begin TempString[8]:=' '; sign:= 1;end
    else begin TempString[8]:=' '; sign:= -1; end;
   TempString:=Trim(TempString);
   TemProj:=packedDMSToDouble(strtofloat(TempString)*sign);
   dtmHtfForm.TopLeftXEdit.Text:=floattostr((TemProj));
   Memo1.Lines.Add('TopLeftX: '+TempString);

{lat ne}
   Setlength(TempString,7);  For i:= 1 to 7 do TempString[i]:=' ';
   For i:= 1 to 7 do TempString[i]:=DTEDHeader.TopRightY[i];
  If (Uppercase(TempString[7]) ='N')then
    begin TempString[7]:=' '; sign:= 1;end
    else begin TempString[7]:=' '; sign:= -1; end;
   TempString:=Trim(TempString);
    TemProj:=packedDMSToDouble(strtofloat(TempString)*sign);
   dtmHtfForm.TopRightYEdit.Text:=floattostr((TemProj));
   Memo1.Lines.Add('TopRightY: '+TempString);
{lon}
   Setlength(TempString,8);  For i:= 1 to 8 do TempString[i]:=' ';
   For i:= 1 to 8 do TempString[i]:=DTEDHeader.TopRightX[i];
  If (Uppercase(TempString[8]) ='E')then
    begin TempString[8]:=' '; sign:= 1;end
    else begin TempString[8]:=' '; sign:= -1; end;
   TempString:=Trim(TempString);
    TemProj:=packedDMSToDouble(strtofloat(TempString)*sign);
   dtmHtfForm.TopRightXEdit.Text:=floattostr((TemProj));
   Memo1.Lines.Add('TopRightX: '+TempString);

{lat se}
   Setlength(TempString,7);  For i:= 1 to 7 do TempString[i]:=' ';
   For i:= 1 to 7 do TempString[i]:=DTEDHeader.BottomRightY[i];
  If (Uppercase(TempString[7]) ='N')then
    begin TempString[7]:=' '; sign:= 1;end
    else begin TempString[7]:=' '; sign:= -1; end;
   TempString:=Trim(TempString);
    TemProj:=packedDMSToDouble(strtofloat(TempString)*sign);
   dtmHtfForm.BottomRightYEdit.Text:=floattostr((TemProj));
   dtmHtfForm.SEYNSEdit.Text:=Inttostr(Round(TemProj));
   Memo1.Lines.Add('BottomRightY: '+TempString);
{lon}
   Setlength(TempString,8);  For i:= 1 to 8 do TempString[i]:=' ';
   For i:= 1 to 8 do TempString[i]:=DTEDHeader.BottomRightX[i];
  If (Uppercase(TempString[8]) ='E')then
    begin TempString[8]:=' '; sign:= 1;end
    else begin TempString[8]:=' '; sign:= -1; end;
   TempString:=Trim(TempString);
    TemProj:=packedDMSToDouble(strtofloat(TempString)*sign);
   dtmHtfForm.BottomRightXEdit.Text:=floattostr((TemProj));
   dtmHtfForm.SEXEWEdit.Text:=Inttostr(Round(TemProj));
   Memo1.Lines.Add('BottomRightX: '+TempString);

{lat count}
   Setlength(TempString,4);  For i:= 1 to 4 do TempString[i]:=' ';
  For i:= 1 to 4 do TempString[i]:=DTEDHeader.maxcolsX[i];
   TempString:=Trim(TempString);
    maxcolsX:=Strtoint(TempString);
    Memo1.Lines.Add('maxcolsX X: '+TempString);

   Setlength(TempString,4);  For i:= 1 to 4 do TempString[i]:=' ';
  For i:= 1 to 4 do TempString[i]:=DTEDHeader.maxrowsY[i];
   TempString:=Trim(TempString);
    maxrowsY:=Strtoint(TempString);
    Memo1.Lines.Add('maxrowsY Y: '+TempString);
  FileSizeX:=maxcolsX;
  FileSizeY:=maxrowsY;

{ACC 2700 record}
   Setlength(TempString,3);  For i:= 1 to 3 do TempString[i]:=' ';
  For i:= 1 to 3 do TempString[i]:=DTEDHeader.ACC[i];
   TempString:=Trim(TempString);
    Memo1.Lines.Add('ACC '+TempString);
  If (not('ACC'=TempString) ) then
     begin
     Memo1.Lines.Add('ACC ERROR '+TempString);
     showmessage('ACC ERROR');
     Application.Terminate;
     end;
End;

{A Header of 3427 bytes followed by DATA ? x ?
   UHL 80, DSI 647, ACC 2700 = 3427
Columns of data S to North in Rows W to E
Each Column has
 Data record x 1, Count 3, Lon 2, Lat 2 : 8 bytes of header
 Data 2 bytes each...
 Checksum 4 bytes: Checksum at end of each}
Function TdtmHtfDTEDForm.DoDTEDtoBin(var InfileName:String):Boolean;
var
  ElevationCount{,k}: Smallint;
  wd : Word;
  i,j:Integer;
  Buf4: array[1..4] of Char;
  Buf8: array[1..8] of Char;
Begin
  CloseUpShop:=False;
  SaveFileName:=InfileName;
  Label1.Caption:=ExtractFileName(InfileName);
  Label2.Caption:=DemPath;
  ProgressBar1.Position:=0;
  Application.ProcessMessages;
  AssignFile(FromF, InfileName);
  Reset(FromF, 1);	{ Record size = 1 }
  ProgressBar1.Position:=25;
  Application.ProcessMessages;
  ReadDTEDHeader;
  ProcessDTEDHeader;
  try
    SetLength(ManMatrix, maxcolsX, maxrowsY);
  except
    on EOutOfMemory do
    begin
      SetLength(ManMatrix,0);
      Application.Terminate;
    end;
  end;
  ProgressBar1.Position:=1;
  Application.ProcessMessages;
  For I := 0 to maxcolsX-1 do {from left to right}
  begin
    ProgressBar1.Position:=Round( (i /maxcolsX )*100);
      Label2.Caption:=inttostr(i);
    Application.ProcessMessages;
    BlockRead(FromF, Buf8,{SizeOf(Buf8)}8, NumRead);
    (* a good programmer would use these to verify
    BlockRead(FromF, TempString,1, NumRead);
    BlockRead(FromF, TempString,3, NumRead);{Count}
    BlockRead(FromF, TempString,2, NumRead);{Lon}
    BlockRead(FromF, TempString,2, NumRead);{Lat}*)
    For J := maxrowsY-1 downto 0 do {from bottom to top}
    begin
      BlockRead(FromF, ElevationCount,2, NumRead);
      {Erics  16bits non-Intel }
      wd:=ElevationCount;
      ElevationCount :=((wd and 255) shl 8)+(wd shr 8);
      {ElevationCount := Swap(ElevationCount);}
      ManMatrix[i,j]:=ElevationCount;
    end;
    BlockRead(FromF, Buf4,{SizeOf(Buf4)}4, NumRead);
  end;
  CloseFile(FromF);
  dtmHtfForm.NullValueEdit.Text :=Inttostr(Round(INVAL));{'DefaultZ='+NullValueEdit.Text;}
  dtmHtfForm.MissingValueEdit.Text :=Inttostr(Round(INVAL));
                               {Converted to smallint}
  dtmHtfForm.IntegerorFloatCB.Checked:={False;}True; {bit 32 (single) bit 16 (Intel)}
  FileSizeX:=maxcolsX;
  FileSizeY:=maxrowsY;
  dtmHtfForm.EDSizeX.Text:=IntToStr(FileSizeX);
  dtmHtfForm.EDSizeY.Text:=IntToStr(FileSizeY); {tpcfg}
  dtmHtfForm.XWidthEdit.Text:=IntToStr(FileSizeX);
  dtmHtfForm.YHeightEdit.Text:=IntToStr(FileSizeY);    {width}
  dtmHtfForm.PixelXSizeEdit.Text:=IntToStr( Round(CellSize));  {physical size}
  dtmHtfForm.PixelYSizeEdit.Text:=IntToStr( Round(CellSize));
  dtmHtfForm.PixelCoordinateCB.Itemindex:=0; {i guess}
  {dtmHtfForm.PixelsPerDegreeEdit.Text:=FloatToStr(Compute it);
  dtmHtfForm.KiloPerPixelEdit.Text:=FloatToStr(Compute it);}
  dtmHtfForm.MapZUnitsCB.Itemindex:=2;{Meters}
  dtmHtfForm.InUnitCB.Itemindex:=4;{DDegrees}
  {HtfForm.ZSizeEdit.Text:= Inttostr((DEMVal.zsize));}
  ProgressBar1.Position:=0;
  Label1.Caption:='DONE HERE';
  Label2.Caption:='';
  Application.ProcessMessages;
  If CloseUpShop then
  begin
    RichMemo.Text:=Memo1.Text;
    RichMemo.Lines.SaveToFile(ChangeFileExt(SaveFileName,'.doc'));
  end;
  Result:=True;
  InfileName:=SaveFileName;{DemPath+NewFileName;}
End;

end.
