{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmPathGizmoFrm;
//Glommed  from GLS Pathcontrol Demo and the Gizmo by adirex
//GizmoCube is what the Gizmo is built on
//TargetCube is what the camera looks at
//PathCube is the Moving cube along the Path ..NOT the Nodes
//NodeCube is the Holder for the Nodes
  // TGLPathNode
  // TGLPathNodes ... Owner: TGLMovementPath;
  //TGLMovementPath
//  TGLMovement = class;
//TGLMovementPaths ...Owner: TGLMovement;
   { function AddPath: TGLMovementPath;
    //add one path to the new one
    function AddPath(Path: TGLMovementPath):
      //Result is current path
    function DeletePath(Path: TGLMovementPath): TGLMovementPath; overload;
    function DeletePath(Index: integer): TGLMovementPath; overload;
    function DeletePath: TGLMovementPath; overload;}

{TO DO:
  Multi Paths uhm, just add them to Movement ?
  Save as Nodes per GLS .. dunno how..i will never use ?
  Routing: Use Speed to compute Travel Time.. well not really
  Path: Linear or Spline Curve
   // TLineSplineMode
   : Available spline modes for a TLine.
   TLineSplineMode = (lsmLines, lsmCubicSpline, lsmBezierSpline, lsmNURBSCurve,
                      lsmSegments);}

{: This Form demonstrates basic "Pathcontrol" movements.<p>
   You can modified the Looped property of the path to enable the path-looping.
   Set ShowPath property to turn on or turn off the path-displaying}

{Click an object to select it.
Navigation:Select one of the arrows or corners with mouse and drag it.
Use mouse scroll to scroll-Zoom the view.
Right mouse button click and move to rotate the camera.
Demo for using 3dsmax Gizmos
Arvydas Juskevicius aka adirex
arvydas@adirex.com
This demo shows the implementation of Gizmos like in 3D Studio Max.
Gizmos are very useful when moving objects in 3D.}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons, Menus,
  GLWin32Viewer, GLScene, GLObjects, GLTexture, OpenGL1X,
  GLState, GLGeomObjects, GLGraph, GLCadencer, VectorTypes, VectorGeometry,
  GLUtils, //StrtoFloatDef
  GLMisc,
  GLBehaviours,  GLMovement,
  dtmPathGizmo;

type
  TMovingAxis = (maAxisX, maAxisY, maAxisZ, maAxisXY, maAxisXZ, maAxisYZ);

  TNode =Record  //Yes this is duplicated here and in the Main form
    Position: TVector;
    Scale: TVector;
    Rotation: TVector;
    Speed: single;
    NodeNumber : Integer;
   end;

  TGizmoPathForm = class(TForm)
    GLScene1: TGLScene;
    Scn: TGLSceneViewer;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GizmoCube: TGLDummyCube;
    TargetCube: TGLDummyCube;
    GLXYZGrid1: TGLXYZGrid;
    StatusBar: TStatusBar;
    PathCube: TGLCube;
    Timer1: TTimer;
    Panel2: TPanel;
    LoadBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    RunBtn: TSpeedButton;
    AddBtn: TSpeedButton;
    TotalNodesLabel: TLabel;
    MoveRotateCB: TCheckBox;
    PositionXEdit: TEdit;
    PositionYEdit: TEdit;
    PositionZEdit: TEdit;
    RollEdit: TEdit;
    PitchEdit: TEdit;
    TurnEdit: TEdit;
    ScaleXEdit: TEdit;
    ScaleZEdit: TEdit;
    ScaleYEdit: TEdit;
    SpeedEdit: TEdit;
    NumberEdit: TEdit;
    UpDown1: TUpDown;
    ShowPathCB: TCheckBox;
    NewBtn: TSpeedButton;
    FlyTheCubeCB: TCheckBox;
    LoopPathCB: TCheckBox;
    NodeCubeDC: TGLDummyCube;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    CameraCube: TGLDummyCube;
    F2CB: TCheckBox;
    SetBtn: TSpeedButton;
    UpDown2: TUpDown;
    GLCadencer1: TGLCadencer;
    PopupMenu1: TPopupMenu;
    SettheSquare1: TMenuItem;
    SquarePanel: TPanel;
    XMaxEdit: TEdit;
    Label4: TLabel;
    XMinEdit: TEdit;
    YMaxEdit: TEdit;
    ZMaxEdit: TEdit;
    ZMinEdit: TEdit;
    YMinEdit: TEdit;
    SquareCloseBtn: TSpeedButton;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    SquareUseBtn: TSpeedButton;
    AddBlueBtn: TSpeedButton;
    XOffsetEdit: TEdit;
    Label10: TLabel;
    YOffsetEdit: TEdit;
    Label11: TLabel;
    LoopedEdit: TEdit;
    Help1: TMenuItem;
    AddAtLastBtn: TSpeedButton;
    SaveAsPathNodesBinary1: TMenuItem;
    SplineModeRG: TRadioGroup;
    XStepEdit: TEdit;
    Label12: TLabel;
    XOriginEdit: TEdit;
    Label13: TLabel;
    YStepEdit: TEdit;
    Label14: TLabel;
    YOriginEdit: TEdit;
    Label15: TLabel;
    ZStepEdit: TEdit;
    Label16: TLabel;
    ZOriginEdit: TEdit;
    Label17: TLabel;
    ZOffsetEdit: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    XScaleEdit: TEdit;
    YScaleEdit: TEdit;
    ZScaleEdit: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    GismoHelpBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure Help1Click(Sender: TObject);

    procedure ScnMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ScnMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure ScnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);

    procedure NewBtnClick(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure AddBlueBtnClick(Sender: TObject);
    procedure AddAtLastBtnClick(Sender: TObject);
procedure MakeABlank(i,Where:Integer);

    procedure RunBtnClick(Sender: TObject);

    procedure LoadBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);

    procedure FlyTheCubeCBClick(Sender: TObject);
    procedure F2CBClick(Sender: TObject);
    procedure ShowPathCBClick(Sender: TObject);
    procedure LoopPathCBClick(Sender: TObject);
    procedure MoveRotateCBClick(Sender: TObject);

    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown1ChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    //Pop Up Menu
    procedure SettheSquare1Click(Sender: TObject);
    //Areal Extents Panel
    procedure SquareUseBtnClick(Sender: TObject);
    procedure SquareCloseBtnClick(Sender: TObject);

    procedure SetBtnClick(Sender: TObject);
procedure SetNodeCubeToGPFCube(i:Integer);
procedure SetGPFCubeToNodeCube(i:Integer);
procedure SetGPFCubeToNode(i:Integer);
procedure SetGPFCubeToText(i:Integer);
procedure SetTextToGPFCube(i:Integer);
    procedure SaveAsPathNodesBinary1Click(Sender: TObject);
    procedure GismoHelpBtnClick(Sender: TObject);

  private
  rotating:Boolean;   //Gizmo is Moving or Rotating
  GizmoRotationSpeed: Single;
  //PathNodeFile
  //Areal Extents of the Grid
  XOffset,YOffset, ZOffset,
  XOrigin, YOrigin, ZOrigin,  //Areal Extents of the Grid
  XMax,  XMin, YMax, YMin, ZMax, ZMin :Integer;
  XStep,YStep,ZStep, XScale, YScale, ZScale  : Single;
  //Path Looping
  LoopCount,
  TotalNodes:Integer;
  CurrentRotationSpeed: Single;
  //Movement, Path, and Node are GLOBAL here...
  //Easy, but makes for only 1 Path and only 1 PathCube Object Behavior
  //Multiple Pathcubes Could make for many moving objects at once
  //(TGLBehaviours) Type name: Movement controls
      //(TGLMovementPaths)
          //(TGLPathNodes)
  //PathCube.Behaviours[0].Paths[0].Nodes[0]
  //PathCube Could have Multiple Paths ..Run in Succession
      // Movement.ActivePathIndex := 0;
  //PathCube.OnProgress:    PathCubeProgress is
  //WHEN OTHER Stuff would Happen along the Path
  Movement: TGLMovement;
    //FormCreate  Movement   := GetOrCreateMovement(PathCube);
  Path:     TGLMovementPath;
    //New or Load  Path       := Movement.AddPath;
  Node:     TGLPathNode;
   //MakeABlank  Node := Path.AddNodeFromObject(NewObject);
  GPFNodes: Array of TNode;
procedure RotateAroundArbitraryAxis(anObject:TGLBaseSceneObject;
                   Axis, Origin:TAffineVector; angle:Single);
procedure RotateSelected(DeltaX, DeltaY: Integer);
    function MouseWorldPos(x, y: Integer): TVector;
    { Private declarations }
    procedure PathTravelStop(Sender: TObject; Path: TGLMovementPath; var Looped: Boolean);
    procedure PathAllTravelledOver(Sender: TObject);    
  public
    { Public declarations }
    MovingAxis: TMovingAxis;
    pick : TGLCustomSceneObject;
    SelectedObject: TGLCustomSceneObject;
    OldCursorPick: TGLCustomSceneObject;

    GizmoX,
    GizmoY,
    GizmoZ: TGLGizmoArrow;
    GizmoCornerXY,
    GizmoCornerXZ,
    GizmoCornerYZ: TGLGizmoCorner;

    mx, my : Integer;
    lastMouseWorldPos: TVector;
    procedure UpdateGizmo;

  end;

var
  GizmoPathForm: TGizmoPathForm;

implementation

{$R *.dfm}
uses
  dtmGlobals,//PathVersion  PathVersion='Gizmo Path File V1.0';
  dtmPOFvar;  // GizmoPathFormY

procedure TGizmoPathForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Setlength(GPFNodes,0);
  GizmoPathFormY := GizmoPathForm.top;
  GizmoPathFormX := GizmoPathForm.left;
  DoSaver;
end;

procedure TGizmoPathForm.FormCreate(Sender: TObject);
begin
  top := GizmoPathFormY;
  left := GizmoPathFormX;
  //Node stuff
  CurrentRotationSpeed:=1;
  Movement   := GetOrCreateMovement(PathCube);
  TotalNodes:=0;
  LoopCount:=0;
  //Grid .. Area stuff
  XMax:=10; XMin:=-10;
  YMax:=10; YMin:=-10;
  ZMax:=10; ZMin:=-10;
  XOffset:=0;YOffset:=0;ZOffset:=0;
  XOrigin:=0;YOrigin:=0;ZOrigin:=0;
  XStep:=0.5;YStep:=0.5;ZStep:=0.5;
  XScale:=1;YScale:=1;ZScale:=1;
  //Gizmo stuff
  rotating:=False;
  GizmoRotationSpeed:= -0.25;
  GizmoX := TGLGizmoArrow.Create(GLScene1);
  GizmoX.GizmoType := gtAxisX;
  GizmoX.Name := 'GizmoX';
  GizmoX.Height := 0.5;

  GizmoCube.AddChild(GizmoX);

  GizmoY := TGLGizmoArrow.Create(GLScene1);
  GizmoY.GizmoType := gtAxisY;
  GizmoY.Name := 'GizmoY';
  GizmoY.Height := 0.5;

  GizmoCube.AddChild(GizmoY);

  GizmoZ := TGLGizmoArrow.Create(GLScene1);
  GizmoZ.GizmoType := gtAxisZ;
  GizmoZ.Name := 'GizmoZ';
  GizmoZ.Height := 0.5;

  GizmoCube.AddChild(GizmoZ);

  GizmoCornerXY := TGLGizmoCorner.Create(GLScene1);
  GizmoCornerXY.GizmoType := gtPlaneXY;
  GizmoCornerXY.Name := 'GizmoXY';
  GizmoCornerXY.Height := 0.2;
  GizmoCornerXY.Distance := 0.5;

  GizmoCube.AddChild(GizmoCornerXY);

  GizmoCornerXZ := TGLGizmoCorner.Create(GLScene1);
  GizmoCornerXZ.GizmoType := gtPlaneXZ;
  GizmoCornerXZ.Name := 'GizmoXZ';
  GizmoCornerXZ.Height := 0.2;
  GizmoCornerXZ.Distance := 0.5;

  GizmoCube.AddChild(GizmoCornerXZ);

  GizmoCornerYZ := TGLGizmoCorner.Create(GLScene1);
  GizmoCornerYZ.GizmoType := gtPlaneYZ;
  GizmoCornerYZ.Name := 'GizmoYZ';
  GizmoCornerYZ.Height := 0.2;
  GizmoCornerYZ.Distance := 0.5;

  GizmoCube.AddChild(GizmoCornerYZ);
end;

procedure TGizmoPathForm.ScnMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  mx:=x; my:=y;

  if Shift=[ssLeft] then
  begin
  	pick:=(Scn.Buffer.GetPickedObject(x, y) as TGLCustomSceneObject);

    if Assigned(Pick) then
    begin
      if Pick.Name = 'GizmoX' then
      begin
        MovingAxis := maAxisX;
      end
      else if Pick.Name = 'GizmoY' then
      begin
        MovingAxis := maAxisY;
      end
      else if Pick.Name = 'GizmoZ' then
      begin
        MovingAxis := maAxisZ;
      end
      else if Pick.Name = 'GizmoXY' then
      begin
        MovingAxis := maAxisXY;
      end
      else if Pick.Name = 'GizmoXZ' then
      begin
        MovingAxis := maAxisXZ;
      end
      else if Pick.Name = 'GizmoYZ' then
      begin
        MovingAxis := maAxisYZ;
      end
      else if Pick.Tag = 0 then
      begin
        SelectedObject := Pick;
        GizmoCube.Visible := True;
        UpdateGizmo;
      end;

      lastMouseWorldPos := MouseWorldPos(x, y);
    end
    else
    begin
      GizmoCube.Visible := False;
      SelectedObject := nil;
      UpdateGizmo;
    end;
  end;
end;

procedure TGizmoPathForm.ScnMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
   vec1,
   vec2,
   newPos : TVector;
   CursorPick: TGLCustomSceneObject;
begin
  if Shift=[ssRight] then
  begin
    GLCamera1.MoveAroundTarget(my-y, mx-x);
    mx:=x; my:=y;
    UpdateGizmo;
  end;
  //Move or Rotate the Picked object
  if ((Shift=[ssLeft]) and (SelectedObject <> nil)) then
  begin
    newPos:=MouseWorldPos(x, y);
    if (VectorNorm(lastMouseWorldPos)<>0) then
    begin
       vec1 := newPos;
       vec2 := lastMouseWorldPos;

       case MovingAxis of
         maAxisX : begin
                     vec1[1] := 0;
                     vec1[2] := 0;
                     vec1[3] := 0;
                     vec2[1] := 0;
                     vec2[2] := 0;
                     vec2[3] := 0;
                   end;
         maAxisY : begin
                     vec1[0] := 0;
                     vec1[2] := 0;
                     vec1[3] := 0;
                     vec2[0] := 0;
                     vec2[2] := 0;
                     vec2[3] := 0;
                   end;
         maAxisZ : begin
                     vec1[0] := 0;
                     vec1[1] := 0;
                     vec1[3] := 0;
                     vec2[0] := 0;
                     vec2[1] := 0;
                     vec2[3] := 0;
                   end;
       end;                           //  DeltaX, DeltaY: Integer
       if rotating then RotateSelected(mx - x, my - y) else
       SelectedObject.Position.Translate(VectorSubtract(vec1, vec2));
    end;
    lastMouseWorldPos:=newPos;
    UpdateGizmo;
  end
  else if Shift = [] then
  begin
    CursorPick := (Scn.Buffer.GetPickedObject(x, y) as TGLCustomSceneObject);
    if OldCursorPick <> CursorPick then
    begin
      if (CursorPick <> nil) and (Pos('Gizmo', CursorPick.Name) = 1) then
      begin
        Scn.Cursor := crSizeAll;

        if CursorPick is TGLGizmoArrow then
          (CursorPick as TGLGizmoArrow).Selected := True;

        if CursorPick is TGLGizmoCorner then
        begin
          (CursorPick as TGLGizmoCorner).Selected := True;
          if CursorPick.Name = 'GizmoXY' then
          begin
            GizmoX.Selected := True;
            GizmoY.Selected := True;
          end
          else if CursorPick.Name = 'GizmoXZ' then
          begin
            GizmoX.Selected := True;
            GizmoZ.Selected := True;
          end
          else if CursorPick.Name = 'GizmoYZ' then
          begin
            GizmoY.Selected := True;
            GizmoZ.Selected := True;
          end;
        end;
      end
      else
      begin
        Scn.Cursor := crDefault;
      end;

      if (OldCursorPick is TGLGizmoArrow) then
        (OldCursorPick as TGLGizmoArrow).Selected := False;

      if (OldCursorPick is TGLGizmoCorner) then
      begin
        (OldCursorPick as TGLGizmoCorner).Selected := False;
        if OldCursorPick.Name = 'GizmoXY' then
        begin
          GizmoX.Selected := False;
          GizmoY.Selected := False;
        end
        else if OldCursorPick.Name = 'GizmoXZ' then
        begin
          GizmoX.Selected := False;
          GizmoZ.Selected := False;
        end
        else if OldCursorPick.Name = 'GizmoYZ' then
        begin
          GizmoY.Selected := False;
          GizmoZ.Selected := False;
        end;
      end;

      OldCursorPick := CursorPick;
    end;
  end;
end;

procedure TGizmoPathForm.MoveRotateCBClick(Sender: TObject);
begin
  Rotating:= MoveRotateCB.Checked;
end;

procedure TGizmoPathForm.RotateSelected(DeltaX, DeltaY: Integer);
var
 // i: Integer;
  Center: TVector;
begin
              //   SelectedObject.Position.
  //for i := 0 to FSelected.Count - 1 do
  begin
    //if RotationType = rtGizmo then  Center := FSelectionCenter else
      Center := //(FSelected[i] as TGLBaseSceneObject).
      SelectedObject.Position.AsVector;

    case MovingAxis of
      maAxisX : begin
                  RotateAroundArbitraryAxis(SelectedObject{FSelected[i] as TGLBaseSceneObject}, XVector, AffineVectorMake(Center), DeltaY * GizmoRotationSpeed);
                end;
      maAxisY : begin
                  RotateAroundArbitraryAxis(SelectedObject{FSelected[i] as TGLBaseSceneObject}, YVector, AffineVectorMake(Center), DeltaY * GizmoRotationSpeed);
                end;
      maAxisZ : begin
                  RotateAroundArbitraryAxis(SelectedObject{FSelected[i] as TGLBaseSceneObject}, ZVector, AffineVectorMake(Center), DeltaY * GizmoRotationSpeed);
                end;
      maAxisXY: begin
                  RotateAroundArbitraryAxis(SelectedObject{FSelected[i] as TGLBaseSceneObject}, XVector, AffineVectorMake(Center), DeltaY * GizmoRotationSpeed);
                  RotateAroundArbitraryAxis(SelectedObject{FSelected[i] as TGLBaseSceneObject}, YVector, AffineVectorMake(Center), DeltaX * GizmoRotationSpeed);
                end;
      maAxisXZ: begin
                  RotateAroundArbitraryAxis(SelectedObject{FSelected[i] as TGLBaseSceneObject}, XVector, AffineVectorMake(Center), DeltaY * GizmoRotationSpeed);
                  RotateAroundArbitraryAxis(SelectedObject{FSelected[i] as TGLBaseSceneObject}, ZVector, AffineVectorMake(Center), DeltaX * GizmoRotationSpeed);
                end;
      maAxisYZ: begin
                  RotateAroundArbitraryAxis(SelectedObject{FSelected[i] as TGLBaseSceneObject}, YVector, AffineVectorMake(Center), DeltaY * GizmoRotationSpeed);
                  RotateAroundArbitraryAxis(SelectedObject{FSelected[i] as TGLBaseSceneObject}, ZVector, AffineVectorMake(Center), DeltaX * GizmoRotationSpeed);
                end;
    end;
  end;
  UpdateGizmo;//UpdateBB;
end;

procedure TGizmoPathForm.RotateAroundArbitraryAxis(anObject:TGLBaseSceneObject;
                   Axis, Origin:TAffineVector; angle:Single);
var
  M,M1,M2,M3:TMatrix;
begin
  M1 := CreateTranslationMatrix(VectorNegate(Origin));
  M2 := CreateRotationMatrix(Axis, Angle * PI/180);
  M3 := CreateTranslationMatrix(Origin);
  M := MatrixMultiply(M1, M2);
  M := MatrixMultiply(M, M3);
  anObject.Matrix := MatrixMultiply(anObject.Matrix,M);

  //Just a workarround to update angles...
  anObject.Roll(0);
  anObject.Pitch(0);
  anObject.Turn(0);
end;


function TGizmoPathForm.MouseWorldPos(x, y : Integer) : TVector;
var
   v : TVector;
begin
   y:=Scn.Height-y;
   if Assigned(SelectedObject) then begin
     SetVector(v, x, y, 0);

     case MovingAxis of
       maAxisX : begin
                   Scn.Buffer.ScreenVectorIntersectWithPlaneXZ(v, SelectedObject.Position.Y, Result);
                 end;
       maAxisY : begin
                   Scn.Buffer.ScreenVectorIntersectWithPlaneYZ(v, SelectedObject.Position.X, Result);
                 end;
       maAxisZ : begin
                   Scn.Buffer.ScreenVectorIntersectWithPlaneYZ(v, SelectedObject.Position.X, Result);
                 end;
       maAxisXY: begin
                   Scn.Buffer.ScreenVectorIntersectWithPlaneXY(v, SelectedObject.Position.Z, Result);
                 end;
       maAxisXZ: begin
                   Scn.Buffer.ScreenVectorIntersectWithPlaneXZ(v, SelectedObject.Position.Y, Result);
                 end;
       maAxisYZ: begin
                   Scn.Buffer.ScreenVectorIntersectWithPlaneYZ(v, SelectedObject.Position.X, Result);
                 end;
     end;

   end
   else SetVector(Result, NullVector);
end;


procedure TGizmoPathForm.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  GLCamera1.AdjustDistanceToTarget(Power(1.1, WheelDelta / 120));
  UpdateGizmo;
end;

procedure TGizmoPathForm.UpdateGizmo;
var
   absDir: TVector;
   s:String;
   i:Integer;
begin
  if SelectedObject = nil then
  begin
    StatusBar.Panels[1].Text := 'X:';
    StatusBar.Panels[2].Text := 'Y:';
    StatusBar.Panels[3].Text := 'Z:';
    StatusBar.Panels[4].Text := 'Px:';
    StatusBar.Panels[5].Text := 'Ty:';
    StatusBar.Panels[6].Text := 'Rz:';
    Exit;
  end;
  absDir := VectorSubtract(SelectedObject.absolutePosition, GLCamera1.AbsolutePosition);
  NormalizeVector(absDir);

  ScaleVector(absDir, 4);

  absDir := VectorAdd(GLCamera1.AbsolutePosition, absDir);

  GizmoCube.Position.AsVector := absDir;

  StatusBar.Panels[0].Text := SelectedObject.Name;
  StatusBar.Panels[1].Text := Format('X: %.2f', [SelectedObject.Position.X]);
  StatusBar.Panels[2].Text := Format('Y: %.2f', [SelectedObject.Position.Y]);
  StatusBar.Panels[3].Text := Format('Z: %.2f', [SelectedObject.Position.Z]);
  StatusBar.Panels[4].Text := Format('RPx: %.2f', [SelectedObject.PitchAngle]);
  StatusBar.Panels[5].Text := Format('RTy: %.2f', [SelectedObject.TurnAngle]);
  StatusBar.Panels[6].Text := Format('RRz: %.2f', [SelectedObject.RollAngle]);
    //Rotation.X means PitchAngle;
    //Rotation.Y means TurnAngle;
    //Rotation.Z means RollAngle;
  If (SelectedObject.Name = PathCube.Name) then begin end else
  begin
    s:=  Copy(SelectedObject.Name, Pos('_',SelectedObject.Name)+1, 1);
    i:= strtoint(s);
    SetNodeCubeToGPFCube(i);
    SetGPFCubeToNode(i);
    SetGPFCubeToText(i);  //NumberEdit.Text:= inttostr(i);
    //Path.UpdatePathLine;
  end;
end;

procedure TGizmoPathForm.ScnMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  pick := nil;
  //  SelectedObject := nil;
end;


procedure TGizmoPathForm.Timer1Timer(Sender: TObject);
begin
   Caption:=Format('%.2f FPS', [Scn.FramesPerSecond]);
   Scn.ResetPerformanceMonitor;
end;

procedure TGizmoPathForm.RunBtnClick(Sender: TObject);
//var  Movement: TGLMovement;
begin
  //Movement := GetMovement(PathCube);
  if Assigned(Movement) then
  begin
    Case SplineModeRG.Itemindex of  //{TLineSplineMode  LCBNS
    0:Path.PathSplineMode:= lsmLines;
    1:Path.PathSplineMode:= lsmCubicSpline; //The ONLY 
    2:Path.PathSplineMode:= lsmBezierSpline;
    3:Path.PathSplineMode:= lsmNURBSCurve;
    4:Path.PathSplineMode:= lsmSegments;
    end;
    Path.ShowPath := ShowPathCB.Checked;
    Path.Looped := LoopPathCB.Checked;
    LoopCount:= Strtoint(LoopedEdit.Text);
    Movement.StartPathTravel;
    GLCadencer1.Enabled := True;
  end else showmessage('No Path'); //this should never happen here
end;

procedure TGizmoPathForm.ShowPathCBClick(Sender: TObject);
begin
  Path.ShowPath := ShowPathCB.Checked;
end;

procedure TGizmoPathForm.LoopPathCBClick(Sender: TObject);
begin
  Path.Looped := LoopPathCB.Checked;
end;


//Need Method to Target the Current Cube... in Edit Mode
procedure TGizmoPathForm.FlyTheCubeCBClick(Sender: TObject);
begin    //Need to Change the Camera Position .. Target
  If FlyTheCubeCB.Checked then
   //View the moving Target from a Stationary position
    GLCamera1.TargetObject:=PathCube
  //View the Center stage regardless of Cube movement
    else  GLCamera1.TargetObject:=TargetCube;

   { If FlyTheCubeCB.Checked then GLCamera1.TargetObject:=TargetCube
    else  GLCamera1.TargetObject:=PathCube;}
    //PathCube.Visible:=FlyTheCubeCB.Checked;
end;

//View from moving Target .. to WHERE ? 2 Paths Flight..Target
procedure TGizmoPathForm.F2CBClick(Sender: TObject);
begin
    If F2CB.Checked then GLCamera1.Moveto(PathCube)
    else  GLCamera1.Moveto(CameraCube);
end;

procedure TGizmoPathForm.NewBtnClick(Sender: TObject);
begin
  //Reload Path data
  PathCube.Position.X := 0;
  PathCube.Position.Y := 0;
  PathCube.Position.Z := 0;
  PathCube.ResetAndPitchTurnRoll(0,0,0);
  //PathCube.Roll(0);
  //PathCube.Pitch(0);
  //PathCube.Turn(0);

  TargetCube.Position.X:=0;
  TargetCube.Position.Y:=0;
  TargetCube.Position.Z:=0;
  FlyTheCubeCB.Checked:=False;
  GLCamera1.TargetObject:=TargetCube;

  XMax:=10; XMin:=-10;
  YMax:=10; YMin:=-10;
  ZMax:=10; ZMin:=-10;
  XOffset:=0;YOffset:=0;ZOffset:=0;
  XOrigin:=0;YOrigin:=0;ZOrigin:=0;
  XStep:=0.5;YStep:=0.5;ZStep:=0.5;
  XScale:=1;YScale:=1;ZScale:=1;
    GLXYZGrid1.XSamplingScale.Max:=XMax-XOffset;
    GLXYZGrid1.XSamplingScale.Min:=XMin-XOffset;
    GLXYZGrid1.YSamplingScale.Max:=YMax-YOffset;
    GLXYZGrid1.YSamplingScale.Min:=YMin-YOffset;
  //GLXYZGrid1.ZSamplingScale.Max:=10;   //Z makes it TOO FULL to see
  //GLXYZGrid1.ZSamplingScale.Min:=-10;
    GLXYZGrid1.XSamplingScale.Origin:=XOrigin;
    GLXYZGrid1.YSamplingScale.Origin:=YOrigin;
    GLXYZGrid1.ZSamplingScale.Origin:=ZOrigin;
    GLXYZGrid1.XSamplingScale.Step:=XStep;
    GLXYZGrid1.YSamplingScale.Step:=YStep;
    GLXYZGrid1.ZSamplingScale.Step:=ZStep;

 // Movement   := GetOrCreateMovement(PathCube);
  Movement.ClearPaths;
  Path       := Movement.AddPath;
  Path.ShowPath := ShowPathCB.Checked;
  Path.Looped := LoopPathCB.Checked;
  Case SplineModeRG.Itemindex of  //{TLineSplineMode  LCBNS
    0:Path.PathSplineMode:= lsmLines;
    1:Path.PathSplineMode:= lsmCubicSpline;
    2:Path.PathSplineMode:= lsmBezierSpline;
    3:Path.PathSplineMode:= lsmNURBSCurve;
    4:Path.PathSplineMode:= lsmSegments;
  end;
  Movement.ActivePathIndex := 0;
  //  FAutoStartNextPath := True;
  //  FOnAllPathTravelledOver := nil;
  //  FOnPathTravelStart := nil;
  //  FOnPathTravelStop := nil;
  //ActivePath
  Movement.OnPathTravelStop := PathTravelStop;
  Movement.OnAllPathTravelledOver := PathAllTravelledOver;
  NodeCubeDC.DeleteChildren;
  TotalNodes:=1;
  TotalNodesLabel.Caption:=inttostr(TotalNodes);
  MakeABlank(TotalNodes-1,0);
  SetGPFCubeToText(TotalNodes-1);//  SetGPFCubeToNodeCube(i);SetGPFCubeToNode(i);
  //UpdateGizmo;
end;
procedure TGizmoPathForm.PathTravelStop(Sender: TObject; Path: TGLMovementPath; var Looped: Boolean);
begin
   {if not Application.Terminated then
      InformationDlg('Path Travel Stopped');}
end;

procedure TGizmoPathForm.PathAllTravelledOver(Sender: TObject);
begin
   if not Application.Terminated then
    //  InformationDlg('All Path(es) Traveled Over');
   dec(LoopCount);
   If (LoopCount <= 0) then
   begin
   Path.Looped:=False;
   Movement.StopPathTravel;
   end;
end;
 //Node  NodeCube_0  GPFNodes[0]
procedure TGizmoPathForm.MakeABlank(i,Where:Integer);
var  NewObject: TGLCube;
begin
  Setlength(GPFNodes,TotalNodes);
  //Make a New NodeCube_
  NewObject:=(NodeCubeDC.AddNewChild(TGLCube) as TGLCube);
  NewObject.Name:='NodeCube_'+inttostr(i);
  NewObject.Material.FrontProperties.Diffuse.Red  := 1;
  NewObject.Material.FrontProperties.Diffuse.Green:= 0.5;
  NewObject.Material.FrontProperties.Diffuse.Blue := 0;
  NewObject.Material.FrontProperties.Diffuse.Alpha:=1;
  //The blue one is semitransparent when Gizmoed..
  //trying to make other cubes see through.. not working
  NewObject.Material.Texture.EnvColor.Red  := 0;
  NewObject.Material.Texture.EnvColor.Green:= 0;
  NewObject.Material.Texture.EnvColor.Blue := 0;
  NewObject.Material.Texture.EnvColor.Alpha:=0;
  NewObject.Material.Texture.Disabled:=True;
  NewObject.Up:=NodeCubeDC.Up;
  NodeCubeDC.Children[i].ResetAndPitchTurnRoll(0, 0, 0);
  NewObject.Scale.X:=1;
  NewObject.Scale.Y:=1;
  NewObject.Scale.Z:=1;
  Case Where of
    0: //Center
    begin
      NewObject.Position.X:=0;
      NewObject.Position.Y:=0;
      NewObject.Position.Z:=0;
    end;
    1: //Blue Cube Location
    begin
      NewObject.Position.X:=PathCube.Position.X;
      NewObject.Position.Y:=PathCube.Position.Y;
      NewObject.Position.Z:=PathCube.Position.Z;
    end;
    2: //Last Cube Location
    begin
      NewObject.Position.X:=GPFNodes[TotalNodes-2].Position[0];
      NewObject.Position.Y:=GPFNodes[TotalNodes-2].Position[1];
      NewObject.Position.Z:=GPFNodes[TotalNodes-2].Position[2];
      NodeCubeDC.Children[i].ResetAndPitchTurnRoll(
      GPFNodes[TotalNodes-2].Rotation[0],
      GPFNodes[TotalNodes-2].Rotation[1],
      GPFNodes[TotalNodes-2].Rotation[2]);
      NewObject.Scale.X:=GPFNodes[TotalNodes-2].Scale[0];
      NewObject.Scale.Y:=GPFNodes[TotalNodes-2].Scale[1];
      NewObject.Scale.Z:=GPFNodes[TotalNodes-2].Scale[2];
      CurrentRotationSpeed:=GPFNodes[TotalNodes-2].Speed;
    end;
  End;//Case
  GPFNodes[i].Position[0]:=NewObject.Position.X;
  GPFNodes[i].Position[1]:=NewObject.Position.Y;
  GPFNodes[i].Position[2]:=NewObject.Position.Z;
  GPFNodes[i].Rotation[0]:=NewObject.Rotation.X;
  GPFNodes[i].Rotation[1]:=NewObject.Rotation.Y;
  GPFNodes[i].Rotation[2]:=NewObject.Rotation.Z;
  GPFNodes[i].Scale[0]:=NewObject.Scale.X;
  GPFNodes[i].Scale[1]:=NewObject.Scale.Y;
  GPFNodes[i].Scale[2]:=NewObject.Scale.Z;
  GPFNodes[i].Speed:=CurrentRotationSpeed;
  GPFNodes[i].NodeNumber:= i;
  Node       := Path.AddNodeFromObject(NewObject);
  Node.Speed := CurrentRotationSpeed;
  SelectedObject := NewObject;//Makes the New one selected
  {Node       := Path.AddNode;
  Node.PositionAsVector := VectorMake(0, 0, 0, 1);
  Node.RotationAsVector := VectorMake(0, 0, 0, 1);
  Node.ScaleAsVector    := VectorMake(1, 1, 1, 1);
  Node.Speed := CurrentRotationSpeed;}
end;


procedure TGizmoPathForm.LoadBtnClick(Sender: TObject);
var
  //NewObject: TGLCube;
  F: TextFile;
  S: string;
  I:Integer;
begin
  OpenDialog1.Filter := 'Path files (*.pth)|*.pth';
  OpenDialog1.InitialDir:=ProjectPath;
  if OpenDialog1.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog1.FileName);
    Movement.ClearPaths;
    Path := Movement.AddPath;
    //Reset stuff
    PathCube.Position.X := 0;
    PathCube.Position.Y := 0;
    PathCube.Position.Z := 0;
    PathCube.ResetAndPitchTurnRoll(0,0,0);
    TargetCube.Position.X:=0;
    TargetCube.Position.Y:=0;
    TargetCube.Position.Z:=0;
    FlyTheCubeCB.Checked:=False;
    GLCamera1.TargetObject:=TargetCube;
    NodeCubeDC.DeleteChildren;

    AssignFile(F, OpenDialog1.FileName);
    Reset(F);
    Readln(F, S);      //Header stuff
    If (S= PathVersion) then
    begin end else
    begin
      CloseFile(F);
      showmessage('Wrong Version or File: Not '+PathVersion);
      NewBtnClick(Sender);
      Exit;
    end;
    Readln(F, S); XMax:= Strtoint(S);//XYZ Max Min to make Grids
    Readln(F, S); XMin:= Strtoint(S);//: [Default 10x10x10]
    Readln(F, S); YMax:= Strtoint(S);
    Readln(F, S); YMin:= Strtoint(S);
    Readln(F, S); ZMax:= Strtoint(S);
    Readln(F, S); ZMin:= Strtoint(S);
    Readln(F, S); XOffset:= Strtoint(S);
    Readln(F, S); YOffset:= Strtoint(S);
    Readln(F, S); ZOffset:= Strtoint(S);
    Readln(F, S); XOrigin:= Strtoint(S);
    Readln(F, S); YOrigin:= Strtoint(S);
    Readln(F, S); ZOrigin:= Strtoint(S);
    Readln(F, S); XStep:= StrtoFloatDef(S);
    Readln(F, S); YStep:= StrtoFloatDef(S);
    Readln(F, S); ZStep:= StrtoFloatDef(S);
    Readln(F, S); XScale:= StrtoFloatDef(S);
    Readln(F, S); YScale:= StrtoFloatDef(S);
    Readln(F, S); ZScale:= StrtoFloatDef(S); 
 {  XMax,  XMin, YMax, YMin, ZMax, ZMin
  XOffset,YOffset, ZOffset,
  XOrigin, YOrigin, ZOrigin,  //Areal Extents of the Grid
 :Integer;
  XStep,YStep,ZStep,
  XScale, YScale, ZScale  : Single; }
    GLXYZGrid1.XSamplingScale.Max:=XMax-XOffset;
    GLXYZGrid1.XSamplingScale.Min:=XMin-XOffset;
    GLXYZGrid1.YSamplingScale.Max:=YMax-YOffset;
    GLXYZGrid1.YSamplingScale.Min:=YMin-YOffset;  
    GLXYZGrid1.XSamplingScale.Origin:=XOrigin;
    GLXYZGrid1.YSamplingScale.Origin:=YOrigin;
    GLXYZGrid1.ZSamplingScale.Origin:=ZOrigin;
    GLXYZGrid1.XSamplingScale.Step:=XStep;
    GLXYZGrid1.YSamplingScale.Step:=YStep;
    GLXYZGrid1.ZSamplingScale.Step:=ZStep;
    Readln(F, S);//Number of Active Paths..  Paths [1]
                      //I dunno HOW so just 1.. it is # 0
    Movement.ActivePathIndex := 0;
    //TLineSplineMode
    Readln(F, S); SplineModeRG.ItemIndex:= Strtoint(S);
     //Path 1 : Count of Nodes
    Readln(F, S); TotalNodes:= Strtoint(S);
    TotalNodesLabel.Caption:=inttostr(TotalNodes);
    Readln(F, S); LoopCount:= Strtoint(S);
    LoopedEdit.Text :=inttostr(LoopCount);
    Readln(F, S); ShowPathCB.Checked:=(S='True');
    Readln(F, S); LoopPathCB.Checked:=(S='True');
    Readln(F, S); FlyTheCubeCB.Checked:=(S='True');
    Readln(F, S); F2CB.Checked:=(S='True');

    for I := 0 to TotalNodes - 1 do
    begin
      MakeABlank(I,0);
      Readln(F, S); GPFNodes[i].Position[0]:= strtofloatdef(S,0);
      Readln(F, S); GPFNodes[i].Position[1]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Position[2]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Rotation[0]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Rotation[1]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Rotation[2]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Scale[0]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Scale[1]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Scale[2]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Speed:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].NodeNumber:= Strtoint(S);
      SetGPFCubeToNodeCube(i);
      SetGPFCubeToNode(i);
    end;
    SetGPFCubeToText(TotalNodes-1);
    Path.ShowPath := ShowPathCB.Checked;
    Path.Looped := LoopPathCB.Checked;
    CloseFile(F);
  end;
end;

procedure TGizmoPathForm.SaveBtnClick(Sender: TObject);
var
  I,NodeCount:Integer;
  F: TextFile;
begin
  if Assigned(Movement) then
  begin
    //Select a filename and save data
    SaveDialog1.Filter := 'Path files (*.pth)|*.pth';
    SaveDialog1.InitialDir:=ProjectPath;
    if SaveDialog1.Execute then          { Display Open dialog box }
    begin
      ProjectPath:=ExtractFilePath(SaveDialog1.FileName);
      AssignFile(F, SaveDialog1.FileName);
      Rewrite(F);
      //Write Header stuff
      Writeln(F, PathVersion);
      Writeln(F, Inttostr(XMax));  //XYZ Max Min to make Grids
      Writeln(F, Inttostr(XMin)); //: [Default 10x10x10]
      Writeln(F, Inttostr(YMax));
      Writeln(F, Inttostr(YMin));
      Writeln(F, Inttostr(ZMax));
      Writeln(F, Inttostr(ZMin));
      Writeln(F, Inttostr(XOffset));
      Writeln(F, Inttostr(YOffset));
      Writeln(F, Inttostr(ZOffset));
      Writeln(F, Inttostr(XOrigin));
      Writeln(F, Inttostr(YOrigin));
      Writeln(F, Inttostr(ZOrigin));
      Writeln(F, Floattostr(XStep));
      Writeln(F, Floattostr(YStep));
      Writeln(F, Floattostr(ZStep));
      Writeln(F, Floattostr(XScale));
      Writeln(F, Floattostr(YScale));
      Writeln(F, Floattostr(ZScale));

      Writeln(F,'1'); //Number of Active Paths..  Paths [1]
                      //I dunno HOW so just 1.. it is # 0
      //TLineSplineMode
      Writeln(F, Inttostr(SplineModeRG.ItemIndex));
        NodeCount:= Movement.ActivePath.NodeCount; //Path 1 : Count of Nodes
      Writeln(F, Inttostr(NodeCount));
      Writeln(F, LoopedEdit.Text);      
      If ShowPathCB.Checked then Writeln(F,'True') else Writeln(F,'False');
      If LoopPathCB.Checked then Writeln(F,'True') else Writeln(F,'False');
      If FlyTheCubeCB.Checked then Writeln(F,'True') else Writeln(F,'False');
      If F2CB.Checked then Writeln(F,'True') else Writeln(F,'False');
      If (TotalNodes <>  NodeCount) then
      begin showmessage('count error');CloseFile(F); exit end;
      for I := 0 to NodeCount - 1 do
      begin
    Writeln(F,Floattostr(GPFNodes[i].Position[0]));
    Writeln(F,Floattostr(GPFNodes[i].Position[1]));
    Writeln(F,Floattostr(GPFNodes[i].Position[2]));
    Writeln(F,Floattostr(GPFNodes[i].Rotation[0]));
    Writeln(F,Floattostr(GPFNodes[i].Rotation[1]));
    Writeln(F,Floattostr(GPFNodes[i].Rotation[2]));
    Writeln(F,Floattostr(GPFNodes[i].Scale[0]));
    Writeln(F,Floattostr(GPFNodes[i].Scale[1]));
    Writeln(F,Floattostr(GPFNodes[i].Scale[2]));
    Writeln(F,Floattostr(GPFNodes[i].Speed));
    Writeln(F,Inttostr(GPFNodes[i].NodeNumber));    //Node Number #
      end;
      CloseFile(F);
    end;
  end;
end;

procedure TGizmoPathForm.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
  SpeedEdit.Text:= FloatToStrF(UpDown2.Position/10,ffFixed,8,2);
end;

procedure TGizmoPathForm.UpDown1ChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  If ((NewValue > -1)and(NewValue < TotalNodes)) then
  begin
    SetGPFCubeToText(NewValue); 
  end else AllowChange:=False;
end;

procedure TGizmoPathForm.AddBtnClick(Sender: TObject);
begin
  {Make a Node, NodeCube and GPFNode}
  inc(TotalNodes);
  TotalNodesLabel.Caption:=inttostr(TotalNodes);
  MakeABlank(TotalNodes-1,0);
  SetGPFCubeToText(TotalNodes-1);//  SetGPFCubeToNodeCube(i);  SetGPFCubeToNode(i);
  //UpdateGizmo;
end;
procedure TGizmoPathForm.AddBlueBtnClick(Sender: TObject);
begin
  inc(TotalNodes);
  TotalNodesLabel.Caption:=inttostr(TotalNodes);
  MakeABlank(TotalNodes-1,1);
  SetGPFCubeToText(TotalNodes-1);
end;
procedure TGizmoPathForm.AddAtLastBtnClick(Sender: TObject);
begin
  inc(TotalNodes);
  TotalNodesLabel.Caption:=inttostr(TotalNodes);
  MakeABlank(TotalNodes-1,2);
  SetGPFCubeToText(TotalNodes-1);
end;
procedure TGizmoPathForm.SetBtnClick(Sender: TObject);
var i:Integer;
begin
  i:=Strtoint(NumberEdit.Text);
  SetTextToGPFCube(i);
  SetGPFCubeToNodeCube(i);
  SetGPFCubeToNode(i);
  //UpdateGizmo;
end;

procedure TGizmoPathForm.SetNodeCubeToGPFCube(i:Integer);
begin          // TGLDummyCube  .. TGLBaseSceneObject
    GPFNodes[i].Position[0]:=NodeCubeDC.Children[i].Position.X;
    GPFNodes[i].Position[1]:=NodeCubeDC.Children[i].Position.Y;
    GPFNodes[i].Position[2]:=NodeCubeDC.Children[i].Position.Z;
    GPFNodes[i].Rotation[0]:=NodeCubeDC.Children[i].Rotation.X;
    GPFNodes[i].Rotation[1]:=NodeCubeDC.Children[i].Rotation.Y;
    GPFNodes[i].Rotation[2]:=NodeCubeDC.Children[i].Rotation.Z;
    GPFNodes[i].Scale[0]:=NodeCubeDC.Children[i].Scale.X;
    GPFNodes[i].Scale[1]:=NodeCubeDC.Children[i].Scale.Y;
    GPFNodes[i].Scale[2]:=NodeCubeDC.Children[i].Scale.Z;
    GPFNodes[i].Speed:= CurrentRotationSpeed;
end;
procedure TGizmoPathForm.SetGPFCubeToNode(i:Integer);
//var  Movement: TGLMovement;
begin
  //Movement := GetMovement(PathCube);
  if Assigned(Movement) then
  begin
    Movement.ActivePath.Nodes.Items[I].X:=GPFNodes[i].Position[0];
    Movement.ActivePath.Nodes.Items[I].Y:=GPFNodes[i].Position[1];
    Movement.ActivePath.Nodes.Items[I].Z:=GPFNodes[i].Position[2];
    //Movement.ActivePath.Nodes.Items[I].PitchAngle:=GPFNodes[i].Rotation[0];
    //Movement.ActivePath.Nodes.Items[I].TurnAngle:=GPFNodes[i].Rotation[1];
    //Movement.ActivePath.Nodes.Items[I].RollAngle:=GPFNodes[i].Rotation[2];
    Movement.ActivePath.Nodes.Items[I].RotationAsVector :=
    VectorMake(GPFNodes[i].Rotation[0], GPFNodes[i].Rotation[1], GPFNodes[i].Rotation[2]);
    Movement.ActivePath.Nodes.Items[I].ScaleX:=GPFNodes[i].Scale[0];
    Movement.ActivePath.Nodes.Items[I].ScaleY:=GPFNodes[i].Scale[1];
    Movement.ActivePath.Nodes.Items[I].ScaleZ:=GPFNodes[i].Scale[2];
    Movement.ActivePath.Nodes.Items[I].Speed:=GPFNodes[i].Speed;
  end;
end;
procedure TGizmoPathForm.SetGPFCubeToNodeCube(i:Integer);
begin
    NodeCubeDC.Children[i].Position.X:=GPFNodes[i].Position[0];
    NodeCubeDC.Children[i].Position.Y:=GPFNodes[i].Position[1];
    NodeCubeDC.Children[i].Position.Z:=GPFNodes[i].Position[2];
    //NodeCubeDC.Children[i].Rotation.X:=GPFNodes[i].Rotation[0];
    //NodeCubeDC.Children[i].Rotation.Y:=GPFNodes[i].Rotation[1];
    //NodeCubeDC.Children[i].Rotation.Z:=GPFNodes[i].Rotation[2];
    NodeCubeDC.Children[i].ResetAndPitchTurnRoll(GPFNodes[i].Rotation[0], GPFNodes[i].Rotation[1], GPFNodes[i].Rotation[2]);

    NodeCubeDC.Children[i].Scale.X:=GPFNodes[i].Scale[0];
    NodeCubeDC.Children[i].Scale.Y:=GPFNodes[i].Scale[1];
    NodeCubeDC.Children[i].Scale.Z:=GPFNodes[i].Scale[2];
    CurrentRotationSpeed:=GPFNodes[i].Speed;
end;
procedure TGizmoPathForm.SetGPFCubeToText(i:Integer);
begin
    PositionXEdit.Text:=Floattostr(GPFNodes[i].Position[0]);
    PositionYEdit.Text:=Floattostr(GPFNodes[i].Position[1]);
    PositionZEdit.Text:=Floattostr(GPFNodes[i].Position[2]);
    PitchEdit.Text:=Floattostr(GPFNodes[i].Rotation[0]);
    TurnEdit.Text:=Floattostr(GPFNodes[i].Rotation[1]);
    RollEdit.Text:=Floattostr(GPFNodes[i].Rotation[2]);
    ScaleXEdit.Text:=Floattostr(GPFNodes[i].Scale[0]);
    ScaleXEdit.Text:=Floattostr(GPFNodes[i].Scale[1]);
    ScaleXEdit.Text:=Floattostr(GPFNodes[i].Scale[2]);
    SpeedEdit.Text:=Floattostr(GPFNodes[i].Speed);
    CurrentRotationSpeed :=GPFNodes[i].Speed;
    NumberEdit.Text:= Inttostr(GPFNodes[i].NodeNumber);
end;
    //Rotation.X means PitchAngle;
    //Rotation.Y means TurnAngle;
    //Rotation.Z means RollAngle;
procedure TGizmoPathForm.SetTextToGPFCube(i:Integer);
begin
    GPFNodes[i].Position[0]:=StrtoFloat(PositionXEdit.Text);
    GPFNodes[i].Position[1]:=StrtoFloat(PositionYEdit.Text);
    GPFNodes[i].Position[2]:=StrtoFloat(PositionZEdit.Text);
    GPFNodes[i].Rotation[0]:=StrtoFloat(PitchEdit.Text);
    GPFNodes[i].Rotation[1]:=StrtoFloat(TurnEdit.Text);
    GPFNodes[i].Rotation[2]:=StrtoFloat(RollEdit.Text);
    GPFNodes[i].Scale[0]:=StrtoFloat(ScaleXEdit.Text);
    GPFNodes[i].Scale[1]:=StrtoFloat(ScaleYEdit.Text);
    GPFNodes[i].Scale[2]:=StrtoFloat(ScaleZEdit.Text);
    GPFNodes[i].Speed:=StrtoFloat(SpeedEdit.Text);
    CurrentRotationSpeed:=GPFNodes[i].Speed;
end;



procedure TGizmoPathForm.SquareCloseBtnClick(Sender: TObject);
begin
  Scn.Align := alNone;
  //Panel2.Align  :=alRight;
  SquarePanel.Align:=alNone;  
  SquarePanel.Visible:=False;
  Scn.Align:=alClient;
  //Timer1.Enabled:=True;
end;
procedure TGizmoPathForm.SettheSquare1Click(Sender: TObject);
begin
  //Timer1.Enabled:=False;
  Scn.Align := alNone;
  //Must NOT allow the panel to be OVER the GLS  Crashes the Card Driver
  Scn.Width:=444;//  664
  //Panel2.Align  :=alRight;
  SquarePanel.Visible:=True;
  SquarePanel.Align:=alRight;
  Scn.Align:=alClient;
  XMaxEdit.Text:=  Inttostr(XMax);
  XMinEdit.Text:=  Inttostr(XMin);
  YMaxEdit.Text:=  Inttostr(YMax);
  YMinEdit.Text:=  Inttostr(YMin);
  ZMaxEdit.Text:=  Inttostr(ZMax);
  ZMinEdit.Text:=  Inttostr(ZMin);
  XOffsetEdit.Text:=  Inttostr(XOffset);
  YOffsetEdit.Text:=  Inttostr(YOffset);
  ZOffsetEdit.Text:=  Inttostr(ZOffset);

  XOriginEdit.Text:=  Inttostr(XOrigin);
  YOriginEdit.Text:=  Inttostr(YOrigin);
  ZOriginEdit.Text:=  Inttostr(ZOrigin);
  XScaleEdit.Text:=  Floattostr(XScale);
  YScaleEdit.Text:=  Floattostr(YScale);
  ZScaleEdit.Text:=  Floattostr(ZScale);
  XStepEdit.Text:=  Floattostr(XStep);
  YStepEdit.Text:=  Floattostr(YStep);
  ZStepEdit.Text:=  Floattostr(ZStep);
end;

procedure TGizmoPathForm.SquareUseBtnClick(Sender: TObject);
begin
    XMax:= Strtoint(XMaxEdit.Text);//XYZ Max Min to make Grids
    XMin:= Strtoint(XMinEdit.Text);//: [Default 10x10x10]
    YMax:= Strtoint(YMaxEdit.Text);
    YMin:= Strtoint(YMinEdit.Text);
    ZMax:= Strtoint(ZMaxEdit.Text);
    ZMin:= Strtoint(ZMinEdit.Text);
    XOffset:= Strtoint(XOffsetEdit.Text); //Offset is Input
    YOffset:= Strtoint(YOffsetEdit.Text);
    ZOffset:= Strtoint(ZOffsetEdit.Text);
    XOrigin:= Strtoint(XOriginEdit.Text);
    YOrigin:= Strtoint(YOriginEdit.Text);
    ZOrigin:= Strtoint(ZOriginEdit.Text);
    XScale:= Strtoint(XScaleEdit.Text); //Scale is Input
    YScale:= Strtoint(YScaleEdit.Text);
    ZScale:= Strtoint(ZScaleEdit.Text);
    XStep:= Strtoint(XStepEdit.Text);
    YStep:= Strtoint(YStepEdit.Text);
    ZStep:= Strtoint(ZStepEdit.Text);

    GLXYZGrid1.XSamplingScale.Max:=XMax-XOffset;
    GLXYZGrid1.XSamplingScale.Min:=XMin-XOffset;
    GLXYZGrid1.YSamplingScale.Max:=YMax-YOffset;
    GLXYZGrid1.YSamplingScale.Min:=YMin-YOffset;
    GLXYZGrid1.XSamplingScale.Origin:=XOrigin;
    GLXYZGrid1.YSamplingScale.Origin:=YOrigin;
    GLXYZGrid1.ZSamplingScale.Origin:=ZOrigin;
    GLXYZGrid1.XSamplingScale.Step:=XStep;
    GLXYZGrid1.YSamplingScale.Step:=YStep;
    GLXYZGrid1.ZSamplingScale.Step:=ZStep;
end;


procedure TGizmoPathForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(17500);
end;
procedure TGizmoPathForm.GismoHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(17000);
end;

procedure TGizmoPathForm.SaveAsPathNodesBinary1Click(Sender: TObject);
begin
{}
end;



end.



