//stuff by Unit owner    : Patrick Van Laake 
unit dtmSdtsReader;

interface

uses  SysUtils, Forms;

Procedure  DoSDTStoBin(InFileName,OutFileName:String; Config:Integer);
Procedure WritePrjWktFile(FilePathName,PrjWktString:String);
Function ReadPrjWktFile(FilePathName:String):String;
Procedure ParseGeoString(InGeoString:String);

implementation

uses
  DSpGlobals,
  DSpSDTS_RPE,
  DSpUtils,
  DSpSDTS,
  DSpISO8211,
  dtmGlobals, dtmPOFvar, dtmErrMsg, dtmHtfFrm;

  {This reads Floating Point SDTS and Saves as SmallInt .bit data file}
Procedure  DoSDTStoBin(InFileName,OutFileName:String; Config:Integer);
var
    FSDTS              : TSDTS_RPE;
    FRows, FColumns    : integer;
    FXOrigin, FYOrigin : double;
    FXSize, FYSize     : double;
    FDataType          : TDSpDataType;
    FData              : pointer;
    RasterCommentString, GeoString,TempString, tempname:String;
    LocalTempValue, LocalNullValue, LocalMissingValue:Double;
    i, NumberOfLayers, NumberOfRasters, r, c: integer;
    p: ^single;
    mins, maxs: single;
 Begin
   { if Assigned(FSDTS) then FSDTS.Free; }{Freed at end of THIS}
   FSDTS := TSDTS_RPE.Open(InFileName);
   dtmHtfForm.DemName.Caption := FSDTS.DescriptiveName;
   {Make Filename State_Name_ID.dem}
   TempString:=Trim(Copy(FSDTS.DescriptiveName,pos(',',FSDTS.DescriptiveName)+2,2));
   tempname:=TempString+'_'+lowercase(copy(FSDTS.DescriptiveName ,0,pos(',',FSDTS.DescriptiveName)-1));
   tempname:=Trim(Lowercase(tempname));
    For i:= 0 to length(tempname) do
    If ((tempname[i]=' ') )then tempname[i]:='_';
   NumberOfRasters := FSDTS.Rasters;
   RasterCommentString:= FSDTS.RasterComment[0];
      {Line 161 of DSpSDTS_RPE}
   GeoString := FSDTS.ProjectionString;
   If dspRasterFlat= FSDTS.RasterSequencing[0] then begin end else
   begin {Raise Error} end;
   NumberOfLayers:= FSDTS.Layers[0];
   If (NumberOfRasters = NumberOfLayers)then
     begin end else begin {Raise Error} end;
   FXOrigin := FSDTS.OriginX[0];
   FYOrigin := FSDTS.OriginY[0];
   FRows := FSDTS.Rows[0];
   FColumns := FSDTS.Columns[0];
{   LayerType:= FSDTS.LayerType[0,0]; V=dspRasterBandSurface or dspRasterBandOrdinal}
   FDataType := FSDTS.DataType[0,0];  {Same as FSDTS.DataSize}
  { DataSize  := FSDTS.DataSize[0,0];   }
   FXSize := FSDTS.XSize[0];   {Grid spacing.. input DataSize}
   FYSize := FSDTS.YSize[0];
   If (FXSize = FYSize)then
     begin end else begin {Raise Error} end;

   LocalNullValue:= FSDTS.NullValue[0];
   LocalMissingValue:= FSDTS.MissingValue[0];
   ReallocMem(FData, FRows * FColumns * FSDTS.DataSize[0,0]);
   if not FSDTS.ReadRaster(0, 0, FData) then
        raise Exception.Create('Could not read raster data');
   case FDataType of
     dspFloat32:
     Begin          { RenderSingleImage;}
          {bmp.Width := FColumns; bmp.Height := FRows;}
       dtmHtfForm.SetDefaultDEMProj;
         dtmHtfForm.DEMtoBinMemo.Clear;
       {FileSizeX,FileSizeY }
       If LocalMissingValue<LocalNullValue then
         LocalTempValue:=LocalMissingValue else
         LocalTempValue:=LocalNullValue;
       dtmHtfForm.NullValueEdit.Text :=Inttostr(Round(LocalTempValue));
       {MyFilesS:='DefaultZ='+NullValueEdit.Text;}
       {Write data into .. for TPCFG}
       dtmHtfForm.IntegerorFloatCB.Checked :=True;
       {1: 10M dem2: 30M dem3: 30AS dem}
       {NEED to Check DataSize versus FXSize }
       If FXSize=10 then dtmHtfForm.SourceCB.ItemIndex :=1 else
       If FXSize=30 then dtmHtfForm.SourceCB.ItemIndex :=2 else
        begin dtmHtfForm.SourceCB.ItemIndex :=3{Raise Error} end;

         dtmHtfForm.DEMtoBinMemo.LineS.Append(GeoString);
       DemPath:=ExtractFilePath(OutFileName);
       FileSizeX:=FColumns ;
         dtmHtfForm.XWidthEdit.Text:=inttostr(FColumns);
         dtmHtfForm.DEMtoBinMemo.LineS.Append('X: '+dtmHtfForm.XWidthEdit.Text);
       FileSizeY:=FRows;
         dtmHtfForm.YHeightEdit.Text:=inttostr(FRows);
         dtmHtfForm.DEMtoBinMemo.LineS.Append('Y: '+dtmHtfForm.YHeightEdit.Text);
       dtmHtfForm.PixelXSizeEdit.Text:= Floattostr(FXSize);{X Size 5 Minute}
         dtmHtfForm.DEMtoBinMemo.LineS.Append('X Size: '+Floattostr(FXSize));
       dtmHtfForm.PixelYSizeEdit.Text:= Floattostr(FYSize);{Y Size 5 Minute}
         dtmHtfForm.DEMtoBinMemo.LineS.Append('Y Size: '+Floattostr(FYSize));
       dtmHtfForm.PixelCoordinateCB.ItemIndex:=1;
       dtmHtfForm.TopLeftXEdit.Text:= Floattostr(FXOrigin);
       dtmHtfForm.TopLeftYEdit.Text:= Floattostr(FYOrigin);
       dtmHtfForm.BottomRightXEdit.Text:= Floattostr(FXOrigin+(FColumns *FXSize ));
       dtmHtfForm.BottomRightYEdit.Text:= Floattostr(FYOrigin+(FRows *FYSize ));
       {Extent(r: integer; var n, e, s, w: TDSpFloat64);}

       {Parse Geo String to Get Projection Parameters}
       ParseGeoString(GeoString);

       p := FData;
       maxs := LocalTempValue{-32000};
       mins := 1E30;
       for r := 0 to FRows * FColumns - 1 do
       begin
         if p^ > maxs then maxs := p^
            else if (p^ > LocalMissingValue)
                    and (p^ > LocalNullValue) and  (p^ < mins) then mins := p^;
         Inc(p);
       end;
       MaximumElevation := Round(maxs);
       MinimumElevation := Round(mins);
       { LocalTempValue         LocalMissingValue LocalNullValue}
dtmHtfForm.DEMtoBinMemo.LineS.Append('LocalTempValue: '+Floattostr(LocalTempValue));
dtmHtfForm.DEMtoBinMemo.LineS.Append('LocalMissingValue: '+Floattostr(LocalMissingValue));
dtmHtfForm.DEMtoBinMemo.LineS.Append('LocalNullValue: '+Floattostr(LocalNullValue));
         dtmHtfForm.DEMtoBinMemo.LineS.Append('MaximumElevation: '+Floattostr(maxs));
         dtmHtfForm.DEMtoBinMemo.LineS.Append('MinimumElevation: '+Floattostr(mins));
       dtmHtfForm.ProgressBar.Visible := True;
       Application.ProcessMessages;
       SetLength(ManMatrix,FColumns  {FileSizeX}, FRows{FileSizeY} );

       p := FData;
       for r := 0 to FRows - 1 do
       begin
         dtmHtfForm.ProgressBar.Position := Round((r /(FRows - 1)) * 100);
         Application.ProcessMessages;
         for c := 0 to FColumns - 1 do {FileSizeX:=FColumns ;}
         begin
           if p^ < mins{-32000.0} then ManMatrix[c{Xcount},r{Zcount}]:=Round(LocalTempValue){0}
             else ManMatrix[c{Xcount},r{Zcount}]:=Round(p^);
           Inc(p);
         end;
       end;

       Application.ProcessMessages;
       dtmHtfForm.WriteProjectionFile(DemPath+tempname+'.bit');{Changes extension vrp ?}
       dtmHtfForm.WriteBitFile(DemPath+tempname+'.bit');
        If Config=0 then
       dtmHtfForm.WriteTpcfgFile(DemPath+tempname+'.bit');{Changes extension .tpcfg and path}
       WritePrjWktFile(DemPath+tempname+'.prj', GeoString);
       SetLength(ManMatrix,0,0 );
       dtmHtfForm.ProgressBar.Visible :=False;
     End;
   end;
   if FData <> nil then FreeMem(FData);
   if Assigned(FSDTS) then FSDTS.Free;
 End;

{Simple write the Geo Projection String into a .prj file
Dunno if it is Many lines or just 1}
Procedure WritePrjWktFile(FilePathName,PrjWktString:String);
var F:TextFile;
Begin
    AssignFile(F, FilePathName);
    Rewrite(F);
    Writeln(F, PrjWktString);
    CloseFile(F);
End;

{Use this to read a InGeoString then pass to ParseGeoString to fill in Form}
Function ReadPrjWktFile(FilePathName:String):String;
var
  F: TextFile;
  S: string;
Begin
    AssignFile(F, FilePathName);
    Reset(F);
    Readln(F, S);
    Result := S;
    CloseFile(F);
    ParseGeoString(S);
End;



{Write it as a .WKT or .prj file too?}
Procedure ParseGeoString(InGeoString:String);
var TempDataString:String;
Begin
  If (Copy(InGeoString,0,6) ='GEOGCS') then
  begin
    {'GEOGCS["GCS_Geographic",
    DATUM["Clarke_1866",
    SPHEROID["Clarke_1866",6378206.4,294.9786982]],
     'PRIMEM["Greenwich",0],
     UNIT["Degree",0.017453292519943295]]';}
       dtmHtfForm.MapZUnitsCB.Itemindex:=2;{Meters}
       dtmHtfForm.ProjectionCB.Itemindex:=0;  {Geo 0: Geo  1: UTM 2: SPCS 10: Stereo 31: Unknown}
       dtmHtfForm.PixelCoordinateCB.Itemindex:=0;{Center}
       dtmHtfForm.InUtmZoneCB.Itemindex:=61;{Geographic}
       dtmHtfForm.UTMZoneNorthCB.Checked:=True;
       dtmHtfForm.IntegerorFloatCB.Checked:=True;
       dtmHtfForm.InUnitCB.Itemindex:=2; { Degrees }
       dtmHtfForm.InDatumCB.Itemindex:=0;  {Clarke_1866}
       dtmHtfForm.SpheroidCB.Itemindex:=0;{Clarke_1866}
  end else
  If (Copy(InGeoString,0,6) ='PROJCS') then
  begin
  dtmHtfForm.DEMtoBinMemo.LineS.Append('PROJCS: ');
    If (Copy(InGeoString,9,6) ='UTM_Zo') then
    begin  {PROJCS["UTM_Zone_16N",}
      InGeoString:=Copy(InGeoString,pos('_',InGeoString )+4
                                   ,length(InGeoString));
      dtmHtfForm.DEMtoBinMemo.LineS.Append('ZONE: '
                   +Copy(InGeoString,pos('_',InGeoString )+1
                                    ,((pos('"',InGeoString )-1)-(pos('_',InGeoString )+1) ) )
                                    );
      TempDataString:=Copy(InGeoString,pos('_',InGeoString )+1
                                    ,((pos('"',InGeoString )-1)-(pos('_',InGeoString )+1) ) );
      dtmHtfForm.InUtmZoneCB.Itemindex:=strtoint(TempDataString)-1;
      TempDataString:=Copy(InGeoString,pos('"',InGeoString )-1,1) ;
      dtmHtfForm.DEMtoBinMemo.LineS.Append('ZONE N-S: '+ TempDataString);
      dtmHtfForm.ProjectionCB.Itemindex:=1; {UTM}
      dtmHtfForm.UTMZoneNorthCB.Checked:=TempDataString='N';

      {GEOGCS["GCS_North_American_1927",}  {Skip it}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+4
                                   ,length(InGeoString));
      {DATUM["D_North_American_1927",}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos('"',InGeoString )-1);
      dtmHtfForm.DEMtoBinMemo.LineS.Append('Datum: '+ TempDataString);
      {13:NAD27 14:NAD83}
      If (TempDataString='D_North_American_1927') then  dtmHtfForm.InDatumCB.Itemindex:=13
      else If (TempDataString='North_American_1983') then  dtmHtfForm.InDatumCB.Itemindex:=14
      {22:WGS_72 23:WGS_84 24:UNKNOWN_DATUM-1}
      else If (TempDataString='WGS_1972') then  dtmHtfForm.InDatumCB.Itemindex:=22
      else If (TempDataString='WGS_1984') then  dtmHtfForm.InDatumCB.Itemindex:=23
      else  dtmHtfForm.InDatumCB.Itemindex:=24; {WGS_1960  WGS_1966}

      {SPHEROID["Clarke_1866",6378206.4,294.9786982]],}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos('"',InGeoString )-1);
      dtmHtfForm.DEMtoBinMemo.LineS.Append('SPHEROID: '+ TempDataString);
      { Clarke_1866 GRS_1980 WGS_1960 WGS_1966 WGS_1972 WGS_1984}
      { 0       8: GRS 1980 30: WGS 60 7: WGS 66  5: WGS 72  12: WGS 84}
      If (TempDataString='Clarke_1866') then  dtmHtfForm.SpheroidCB.Itemindex:=0
      else If (TempDataString='GRS_1980') then  dtmHtfForm.SpheroidCB.Itemindex:=8
      else If (TempDataString='WGS_1960') then  dtmHtfForm.SpheroidCB.Itemindex:=30
      else If (TempDataString='WGS_1966') then  dtmHtfForm.SpheroidCB.Itemindex:=7
      else If (TempDataString='WGS_1972') then  dtmHtfForm.SpheroidCB.Itemindex:=5
      else If (TempDataString='WGS_1984') then  dtmHtfForm.SpheroidCB.Itemindex:=12
      else  dtmHtfForm.SpheroidCB.Itemindex:=0;
{Must fill in all 15 of the DLGPA1 DLGPA2 DLGPA3
A B C D E}
      InGeoString:=Copy(InGeoString,pos(',',InGeoString )+1
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos(',',InGeoString )-1);
      dtmHtfForm.DEMtoBinMemo.LineS.Append('SPHEROID a: '+ TempDataString);
      dtmHtfForm.DLGPA1.Text:= TempDataString;{SMajor}

      InGeoString:=Copy(InGeoString,pos(',',InGeoString )+1
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos(']',InGeoString )-1);
      dtmHtfForm.DEMtoBinMemo.LineS.Append('SPHEROID b: '+ TempDataString);
      dtmHtfForm.DLGPA2.Text:= TempDataString;{SMinor}

      {PRIMEM["Greenwich",0],}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos('"',InGeoString )-1);
      dtmHtfForm.DEMtoBinMemo.LineS.Append('PRIMEM: '+ TempDataString);

      {UNIT["Degree",0.017453292519943295]],}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      dtmHtfForm.InUnitCB.Itemindex:=2; { Degrees ... just because it is}

       {PROJECTION["Transverse_Mercator"],}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));

      {PARAMETER["False_Easting",500000],}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      InGeoString:=Copy(InGeoString,pos(',',InGeoString )+1
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos(']',InGeoString )-1);
      dtmHtfForm.DLGPC1.Text:= TempDataString;{False_Easting}
      dtmHtfForm.DEMtoBinMemo.LineS.Append('False_Easting: '+ TempDataString);
      {PARAMETER["False_Northing",0],}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      InGeoString:=Copy(InGeoString,pos(',',InGeoString )+1
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos(']',InGeoString )-1);
      dtmHtfForm.DLGPC2.Text:= TempDataString;{False_Northing}
      dtmHtfForm.DEMtoBinMemo.LineS.Append('False_Northing: '+ TempDataString);


      {PARAMETER["Central_Meridian",-87],   This changes per...}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      InGeoString:=Copy(InGeoString,pos(',',InGeoString )+1
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos(']',InGeoString )-1);
      dtmHtfForm.DLGPB2.Text:= TempDataString;{Central_Meridian}
      dtmHtfForm.DEMtoBinMemo.LineS.Append('Central_Meridian: '+ TempDataString);

      {PARAMETER["Scale_Factor",0.9996],}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      InGeoString:=Copy(InGeoString,pos(',',InGeoString )+1
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos(']',InGeoString )-1);
      dtmHtfForm.DLGPA3.Text:= TempDataString;{Scale_Factor}
      dtmHtfForm.DEMtoBinMemo.LineS.Append('Scale_Factor: '+ TempDataString);

      {PARAMETER["Latitude_Of_Origin",0],}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      InGeoString:=Copy(InGeoString,pos(',',InGeoString )+1
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos(']',InGeoString )-1);
      dtmHtfForm.DLGPB3.Text:= TempDataString;{Latitude_Of_Origin}
      dtmHtfForm.DEMtoBinMemo.LineS.Append('Latitude_Of_Origin: '+ TempDataString);

       {UNIT["Meter",1]]}
       dtmHtfForm.MapZUnitsCB.Itemindex:=2;{Meters}
       dtmHtfForm.PixelCoordinateCB.Itemindex:=0;{Center}
       dtmHtfForm.IntegerorFloatCB.Checked:=True;{Changed to Int? forgot what it does}
      {Format('PROJCS["UTM_Zone_%s",%s,%s,
        PROJECTION["Transverse_Mercator"],
        PARAMETER["False_Easting",500000],
        PARAMETER["False_Northing",0],
        PARAMETER["Central_Meridian",%1.0f],
        PARAMETER["Scale_Factor",0.9996],
        PARAMETER["Latitude_Of_Origin",0],
        UNIT["Meter",1]]',
        [zone, datum,GREENWICH_DEGREE, cm])}
    end else
    If (Copy(InGeoString,9,6) ='North_') then
    begin
      {Format('PROJCS["North_Pole_Stereographic",%s,%s,
       PROJECTION["Stereographic"],
       PARAMETER["False_Easting",0],
       PARAMETER["False_Northing",0],
       PARAMETER["Central_Meridian",0],
       PARAMETER["Scale_Factor",1],
       PARAMETER["Latitude_Of_Origin",90],
       UNIT["Meter",1]]',
        [datum, GREENWICH_DEGREE])}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      {DATUM["D_North_American_1927",}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos('"',InGeoString )-1);
      dtmHtfForm.DEMtoBinMemo.LineS.Append('Datum: '+ TempDataString);
      {13:NAD27 14:NAD83}
      If (TempDataString='D_North_American_1927') then  dtmHtfForm.InDatumCB.Itemindex:=13
      else If (TempDataString='North_American_1983') then  dtmHtfForm.InDatumCB.Itemindex:=14
      {22:WGS_72 23:WGS_84 24:UNKNOWN_DATUM-1}
      else If (TempDataString='WGS_1972') then  dtmHtfForm.InDatumCB.Itemindex:=22
      else If (TempDataString='WGS_1984') then  dtmHtfForm.InDatumCB.Itemindex:=23
      else  dtmHtfForm.InDatumCB.Itemindex:=24; {WGS_1960  WGS_1966}

      {SPHEROID["Clarke_1866",6378206.4,294.9786982]],}
      InGeoString:=Copy(InGeoString,pos('[',InGeoString )+2
                                   ,length(InGeoString));
      TempDataString:=Copy(InGeoString,0
                                    ,pos('"',InGeoString )-1);
      dtmHtfForm.DEMtoBinMemo.LineS.Append('SPHEROID: '+ TempDataString);
      { Clarke_1866 GRS_1980 WGS_1960 WGS_1966 WGS_1972 WGS_1984}
      { 0       8: GRS 1980 30: WGS 60 7: WGS 66  5: WGS 72  12: WGS 84}
      If (TempDataString='Clarke_1866') then  dtmHtfForm.SpheroidCB.Itemindex:=0
      else If (TempDataString='GRS_1980') then  dtmHtfForm.SpheroidCB.Itemindex:=8
      else If (TempDataString='WGS_1960') then  dtmHtfForm.SpheroidCB.Itemindex:=30
      else If (TempDataString='WGS_1966') then  dtmHtfForm.SpheroidCB.Itemindex:=7
      else If (TempDataString='WGS_1972') then  dtmHtfForm.SpheroidCB.Itemindex:=5
      else If (TempDataString='WGS_1984') then  dtmHtfForm.SpheroidCB.Itemindex:=12
      else  dtmHtfForm.SpheroidCB.Itemindex:=0;

       dtmHtfForm.MapZUnitsCB.Itemindex:=2;{Meters}
       dtmHtfForm.ProjectionCB.Itemindex:=10;  {Geo 0: Geo  1: UTM 2: SPCS 10: Stereo 31: Unknown}
       dtmHtfForm.PixelCoordinateCB.Itemindex:=0;{Center}
       dtmHtfForm.InUtmZoneCB.Itemindex:=61;{Geographic}
       dtmHtfForm.UTMZoneNorthCB.Checked:=True;
       dtmHtfForm.IntegerorFloatCB.Checked:=True;
       dtmHtfForm.InUnitCB.Itemindex:=2; { Degrees }

       dtmHtfForm.DLGPC1.Text:=  '0';
       dtmHtfForm.DLGPC2.Text:='0';
       dtmHtfForm.DLGPB2.Text:='0';
       dtmHtfForm.DLGPA3.Text:='1';
       dtmHtfForm.DLGPB3.Text:='0';
       dtmHtfForm.MapZUnitsCB.Itemindex:=2;{Meters}
       dtmHtfForm.PixelCoordinateCB.Itemindex:=0;{Center}
    end;
  end else
  If (Copy(InGeoString,0,6) ='State ') then
  begin  {No more info as of Nov 2003}
    dtmHtfForm.ProjectionCB.Itemindex:=10;
    {'State Plane Coordinate System - ' + FXref[0].ZONE;}
    dtmHtfForm.StatePlaneZoneEdit.Text:=Copy(InGeoString,pos('-',InGeoString )+1,6);
    dtmHtfForm.DEMtoBinMemo.LineS.Append('ZONE: '+Copy(InGeoString,pos('-',InGeoString )+1,6));
    dtmHtfForm.InUnitCB.Itemindex:=6; { State Plane }
  end else
  begin
   dtmHtfForm.ProjectionCB.Itemindex:=31;
   Exit;{No changes to the DEFAULT projection.. Nothing KNOWN about this data}
  end;
  Application.ProcessMessages;
End;

end.
