{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
{Mandel / Julia Explorer
Copyright 2000 Hugh Allen
Hugh.Allen@oz.quest.com
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
Phoenix, Egg, etal. added by Ivan Lee Herring Copyright 2001..2005}
unit GlsFractalFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  dtmPOFvar, //so the array sets can be used
  ExtCtrls, StdCtrls, Buttons, ComCtrls, Grids, Menus;

type
 TFractalRecord = Record
    MaxIterations  :Integer;
    Cx, Cy: Real;
    ViewLeft: real;
    ViewTop: real;
    ViewWidth: real;
    ViewHeight: real;
 end;
  TPhoenixRecord = Record
    MaxIterations:Integer;
    FXMax: Extended;
    FXMin: Extended;
    FYMax: Extended;
    FYMin: Extended;
    FHQ: Extended;
    FVP: Extended;
 end;

  TFractalForm = class(TForm)
    PageControl1: TPageControl;
    MJTabSheet: TTabSheet;
    Label5: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    Label7: TLabel;
    Label6: TLabel;
    Label4: TLabel;
    FPManDemBtn: TSpeedButton;
    FPJuliaDemBtn: TSpeedButton;
    MJSaveBtn: TSpeedButton;
    MJHelpBtn: TSpeedButton;
    edtCx: TEdit;
    edtCy: TEdit;
    edtMMaxIters: TEdit;
    Panel1: TPanel;
    Splitter1: TSplitter;
    PETabSheet: TTabSheet;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    EggDisplayBtn: TSpeedButton;
    EggSaverBtn: TSpeedButton;
    PEHelpBtn: TSpeedButton;
    EggCy: TEdit;
    EggCx: TEdit;
    Panel2: TPanel;
    Splitter2: TSplitter;
    PhoenixItersEdit: TEdit;
    DTTabSheet: TTabSheet;
    Label17: TLabel;
    Label18: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    DragonsTDisplayBtn: TSpeedButton;
    DragonsTSaveBtn: TSpeedButton;
    DragonsTeethHelpBtn: TSpeedButton;
    DragonsITEdit: TEdit;
    DtCx: TEdit;
    DtCy: TEdit;
    Panel3: TPanel;
    Splitter3: TSplitter;
    NLTabSheet: TTabSheet;
    Label23: TLabel;
    Label24: TLabel;
    Label26: TLabel;
    LobsterBtn: TSpeedButton;
    LobsterSaveBtn: TSpeedButton;
    NewtonLobsterHekpBtn: TSpeedButton;
    NewtMax: TEdit;
    NtCx: TEdit;
    NtCy: TEdit;
    Panel4: TPanel;
    ACTabSheet: TTabSheet;
    PcbSaveBtn: TSpeedButton;
    ACHelpBtn: TSpeedButton;
    Panel5: TPanel;
    MandelImage: TImage;
    JuliaImage: TImage;
    PhoenixImage: TImage;
    DragonsImage: TImage;
    EggImage: TImage;
    TeethImage: TImage;
    SaveDialog1: TSaveDialog;
    edtJMaxIters: TEdit;
    Label3: TLabel;
    EggItersEdit: TEdit;
    ColorPicker: TTabSheet;
    ColorFiler: TSpeedButton;
    ColorClears: TSpeedButton;
    ColorSaver: TSpeedButton;
    ColorsHelp: TSpeedButton;
    ColorFill: TSpeedButton;
    Color256Setter: TSpeedButton;
    ColorInverter: TSpeedButton;
    ColorSubvert: TSpeedButton;
    ColorFileEdit: TEdit;
    DrawGrid1: TDrawGrid;
    Label11: TLabel;
    DTeethITEdit: TEdit;
    SelectedColorLabel: TLabel;
    Panel8: TPanel;
    Panel7: TPanel;
    FPColorRG: TRadioGroup;
    ProgressBar1: TProgressBar;
    FXMaxLabel: TLabel;
    FXMinLabel: TLabel;
    FYMaxLabel: TLabel;
    FYMinLabel: TLabel;
    ViewLeftLabel: TLabel;
    ViewWidthLabel: TLabel;
    ViewTopLabel: TLabel;
    ViewHeightLabel: TLabel;
    FHQLabel: TLabel;
    CxLabel: TLabel;
    FVPLabel: TLabel;
    CyLabel: TLabel;
    ColorTwistCB: TCheckBox;
    ColorDialog1: TColorDialog;
    OpenDialog1: TOpenDialog;
    DrawGrid2: TDrawGrid;
    Color16Edit: TEdit;
    Selected16ColorLabel: TLabel;
    PopupMenu1: TPopupMenu;
    ForegroundColorSet2: TMenuItem;
    SmogFog256: TMenuItem;
    RedRanger256: TMenuItem;
    PurpleReigns256: TMenuItem;
    YellowSnow256: TMenuItem;
    GreenGoblin256: TMenuItem;
    AquaMarine256: TMenuItem;
    BlueMeanie256: TMenuItem;
    ColorPicker256: TMenuItem;
    Loaded256: TMenuItem;
    N3: TMenuItem;
    Loaded16: TMenuItem;
    ColorPicker16: TMenuItem;
    LandformsSet: TMenuItem;
    RGB16: TMenuItem;
    Win16Set: TMenuItem;
    BackgroundColor2: TMenuItem;
    White1: TMenuItem;
    Aqua1: TMenuItem;
    Fuchsia1: TMenuItem;
    Blue1: TMenuItem;
    Yellow1: TMenuItem;
    LimeGreen1: TMenuItem;
    Red1: TMenuItem;
    Silver1: TMenuItem;
    Gray1: TMenuItem;
    Teal1: TMenuItem;
    Purple1: TMenuItem;
    NavyBlue1: TMenuItem;
    OliveGreen1: TMenuItem;
    Green1: TMenuItem;
    Maroon1: TMenuItem;
    Black1: TMenuItem;
    Color16SubversionRG: TRadioGroup;
    ColorSetRG: TRadioGroup;
    Label19: TLabel;
    Label25: TLabel;
    NewtonBtn: TSpeedButton;
    NewtonSaveBtn: TSpeedButton;
    Label31: TLabel;
    Label37: TLabel;
    Label41: TLabel;
    LobsMax: TEdit;
    NtLobCx: TEdit;
    NtLobCy: TEdit;
    PhoenixCy: TEdit;
    Label42: TLabel;
    Label43: TLabel;
    PhoenixCx: TEdit;
    Label27: TLabel;
    DttCx: TEdit;
    Label28: TLabel;
    DttCy: TEdit;
    N1: TMenuItem;
    ResetAlltoDefault1: TMenuItem;
    DLATabSheet: TTabSheet;
    Panel9: TPanel;
    DlaImage: TImage;
    ScrollBox1: TScrollBox;
    ApollianiaImage: TImage;
    ScrollBox2: TScrollBox;
    PharoahImage: TImage;
    Splitter4: TSplitter;
    Splitter5: TSplitter;
    ACBtn: TSpeedButton;
    PCBBtn: TSpeedButton;
    AcSaveBtn: TSpeedButton;
    ACRG: TRadioGroup;
    DLACBtn: TSpeedButton;
    LobsterImage: TImage;
    NewtonImage: TImage;
    DLABtn: TSpeedButton;
    DLACentroidBtn: TSpeedButton;
    DlaLabel: TLabel;
    DlaStopBtn: TSpeedButton;
    JuliaClipEdit: TEdit;
    JuliaLevel: TCheckBox;
    JuliaLake: TCheckBox;
    JuliaDivisor: TCheckBox;
    DlaRg: TRadioGroup;
    MouseLocatorX: TMenuItem;
    MMSaveBtn: TSpeedButton;
    PhoenixDisplayBtn: TSpeedButton;
    PhoenixSaveBtn: TSpeedButton;
    DragonsDisplayBtn: TSpeedButton;
    DragonsSaveBtn: TSpeedButton;
    DlaHelpBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormResize(Sender: TObject);
procedure ShowDown;
    procedure ResetAlltoDefault1Click(Sender: TObject);

    procedure JuliaClipEditChange(Sender: TObject);
    procedure MouseLocatorXClick(Sender: TObject);

    procedure MJHelpBtnClick(Sender: TObject);
    procedure PEHelpBtnClick(Sender: TObject);
    procedure DragonsTeethHelpBtnClick(Sender: TObject);
    procedure NewtonLobsterHekpBtnClick(Sender: TObject);
    procedure ACHelpBtnClick(Sender: TObject);

    procedure edtMMaxItersChange(Sender: TObject);
    procedure edtCxChange(Sender: TObject);
    procedure FPManDemBtnClick(Sender: TObject);
    procedure FPJuliaDemBtnClick(Sender: TObject);
    procedure MMSaveBtnClick(Sender: TObject);
    procedure MJSaveBtnClick(Sender: TObject);    
procedure AllDemSaver;
    procedure MandelImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MandelImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
procedure frcMandelPaint
  (TopLeft, BottomRight: TPoint; AMode: TPenMode);
    procedure JuliaImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
procedure CplxSqrtFJUL(a, b: Real; out x, y: Real);
procedure Render(IsJulia:Boolean;Switch:Integer);

    
    procedure PhoenixImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PhoenixImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
procedure PhoenixImagePaint(x,y: integer);
    procedure PhoenixItersEditChange(Sender: TObject);
    procedure EggCxChange(Sender: TObject);
procedure RenderPEgg(IsEgg:Boolean;Switch:Integer);
    procedure EggDisplayBtnClick(Sender: TObject);
    procedure EggSaverBtnClick(Sender: TObject);

    procedure PageControl1Change(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DrawGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ColorFilerClick(Sender: TObject);
    procedure ColorSaverClick(Sender: TObject);
    procedure ColorClearsClick(Sender: TObject);
    procedure ColorsHelpClick(Sender: TObject);
    procedure Color256SetterClick(Sender: TObject);
    procedure ColorFillClick(Sender: TObject);
    procedure ColorInverterClick(Sender: TObject);
    procedure ColorSubvertClick(Sender: TObject);
    procedure DrawGrid2DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DrawGrid2SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
procedure FalseColors;
procedure Set16Colors;
procedure False16;
    procedure Black1Click(Sender: TObject);
    procedure Maroon1Click(Sender: TObject);
    procedure Green1Click(Sender: TObject);
    procedure OliveGreen1Click(Sender: TObject);
    procedure NavyBlue1Click(Sender: TObject);
    procedure Purple1Click(Sender: TObject);
    procedure Teal1Click(Sender: TObject);
    procedure Gray1Click(Sender: TObject);
    procedure Silver1Click(Sender: TObject);
    procedure Red1Click(Sender: TObject);
    procedure LimeGreen1Click(Sender: TObject);
    procedure Yellow1Click(Sender: TObject);
    procedure Blue1Click(Sender: TObject);
    procedure Fuchsia1Click(Sender: TObject);
    procedure Aqua1Click(Sender: TObject);
    procedure White1Click(Sender: TObject);
    procedure Win16SetClick(Sender: TObject);
    procedure RGB16Click(Sender: TObject);
    procedure LandformsSetClick(Sender: TObject);
    procedure ColorPicker16Click(Sender: TObject);
    procedure Loaded16Click(Sender: TObject);
procedure SiliconSets;
procedure FalseSets;
    procedure BlueMeanie256Click(Sender: TObject);
    procedure AquaMarine256Click(Sender: TObject);
    procedure GreenGoblin256Click(Sender: TObject);
    procedure YellowSnow256Click(Sender: TObject);
    procedure PurpleReigns256Click(Sender: TObject);
    procedure RedRanger256Click(Sender: TObject);
    procedure SmogFog256Click(Sender: TObject);
    procedure ColorPicker256Click(Sender: TObject);
    procedure Loaded256Click(Sender: TObject);

    procedure DragonsITEditChange(Sender: TObject);
    procedure DtCxChange(Sender: TObject);
    procedure DragonsImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DragonsImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
procedure DrawDragonCross(x,y: integer);
    procedure EggImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TeethImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
procedure DtRender(IsTeeth:Boolean;Switch:Integer);
    procedure DragonsTDisplayBtnClick(Sender: TObject);
    procedure DragonsTSaveBtnClick(Sender: TObject);

    procedure NewtonImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure LobsterImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure NewtonBtnClick(Sender: TObject);
    procedure LobsterBtnClick(Sender: TObject);

    procedure NewtMaxChange(Sender: TObject);
    procedure NtCxChange(Sender: TObject);
    procedure NewtonImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LobsterImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
procedure NewtonRender(IsLobster:Boolean;Switch:Integer);

    procedure ACBtnClick(Sender: TObject);
    procedure PCBBtnClick(Sender: TObject);
    procedure AcSaveBtnClick(Sender: TObject);
    procedure PcbSaveBtnClick(Sender: TObject);

    procedure DLABtnClick(Sender: TObject);
    procedure DLACBtnClick(Sender: TObject);
    procedure DLACentroidBtnClick(Sender: TObject);
    procedure DlaStopBtnClick(Sender: TObject);
    procedure NewtonSaveBtnClick(Sender: TObject);
    procedure LobsterSaveBtnClick(Sender: TObject);
    procedure PhoenixDisplayBtnClick(Sender: TObject);
    procedure PhoenixSaveBtnClick(Sender: TObject);
    procedure DragonsDisplayBtnClick(Sender: TObject);
    procedure DragonsSaveBtnClick(Sender: TObject);
    procedure DlaHelpBtnClick(Sender: TObject);

  private
    { Private declarations }
    {Color stuff}
    MandelImageMade,    JuliaImageMade,  MandelDrawing,
    PhoenixImageMade,   EggImageMade,    BusyEggPainting,
    DragonsImageMade,   TeethImageMade,  BusyPullingTeeth,
    NewtonImageMade,    LobsterImageMade, BusyNewtLobster,
    ApollianiaImageMade,CirclesImageMade,
    PharoahImageMade,   CollarBonedImageMade,
    DlaImageMade,        DlaStopRunning,
     MouseLocatorXChecked,
     NewtonBitmapDisplayed,LobsterBitmapDisplayed,
     DtBitmapDisplayed,
     PBitmapDisplayed,//,isEggLaidDem,,isJuliaLaidDem
     MBitmapDisplayed:Boolean;

     JuliaClip:Integer;
     Eggx,Eggy:Integer;     
     Origin, MovePt: TPoint; //Mandel Mousing lines
                               //Mandel never shows, Dragon never goes away
     frcMandel, frcJulia:TFractalRecord;
     frcNewton, frcLobster,
     frcDragon, frcTeeth,
     Phoenix,   Egg:TPhoenixRecord;
function GetColor(Token:Integer):ColorSet;
 {   function MViewToPixelX(const x: Real): integer;
    function MViewToPixelY(const y: Real): integer; }
    function MPixelToViewX(const x: integer): Real;
    function MPixelToViewY(const y: integer): Real;
    function JPixelToViewX(const x: integer): Real;
    function JPixelToViewY(const y: integer): Real;
{    function JViewToPixelX(const x: Real): integer;
    function JViewToPixelY(const y: Real): integer;}
//function EggPixelToViewX(const x: integer): Real;
//function EggPixelToViewY(const y: integer): Real;
    {PhoenixImagePaint
    function PViewToPixelX(const x: Real): integer;
    function PViewToPixelY(const y: Real): integer;}
  public
    { Public declarations }
  end;

var
  FractalForm: TFractalForm;

implementation

{$R *.DFM}
uses  dtmGlobals, dtmPOFrm,  DtmGlfrm, dtmfrm;
//fjul.pas
//fPhoenix2.pas  Fractal2.pas
//fGlfrm.dfm

procedure TFractalForm.FormCreate(Sender: TObject);
var i:Integer;
begin
    MandelImageMade:=False;  MandelDrawing:=False;
    JuliaImageMade:=False;
    PhoenixImageMade:=False;
    EggImageMade:=False;      BusyEggPainting:=False;
    DragonsImageMade:=False;
    TeethImageMade:=False;    BusyPullingTeeth:=False;
    NewtonImageMade:=False;
    LobsterImageMade:=False;   BusyNewtLobster:=False;
    ApollianiaImageMade:=False;
    CirclesImageMade:=False;
    PharoahImageMade:=False;
    CollarBonedImageMade:=False;
    DlaImageMade:=False;
    MouseLocatorXChecked:=True;
    JuliaClip:=10;
  top := FractalFormY;{0;}
  left := FractalFormX;{488;}
  Color16FName := 'COLOR16FILE.1CP';
  Color256FName := 'COLORFILE.2CP';
  Color16Edit.Text := Color16FName;
  ColorFileEdit.Text := Color256FName;
  for i := 0 to 15 do ColorArray[i] := RGB(0, 0, 255 - (i * 12));
  for i := 0 to 15 do
    ColorArray[i + 16] := RGB(0, 255 - (i * 12), 255 - (i * 12));
  for i := 0 to 15 do
    ColorArray[i + 32] := RGB(0, 255 - (i * 12), 0);
  for i := 0 to 15 do
    ColorArray[i + 48] := RGB(255 - (i * 12), 255 - (i * 12), 0);
  for i := 0 to 15 do
    ColorArray[i + 64] := RGB(255 - (i * 12), 0, 255 - (i * 12));
  for i := 0 to 15 do
    ColorArray[i + 80] := RGB(255 - (i * 12), 0, 0);
  for i := 0 to 15 do
    ColorArray[i + 96] := RGB(255 - (i * 12), 255 - (i * 12), 255 - (i
    * 12));
  for i := 0 to 15 do
    ColorArray[i + 112] := RGB(0, 0, 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 128] := RGB(0, 255 - (i * 14), 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 144] := RGB(0, 255 - (i * 14), 0);
  for i := 0 to 15 do
    ColorArray[i + 160] := RGB(255 - (i * 14), 255 - (i * 14), 0);
  for i := 0 to 15 do
    ColorArray[i + 176] := RGB(255 - (i * 14), 0, 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 192] := RGB(255 - (i * 14), 0, 0);
  for i := 0 to 15 do
    ColorArray[i + 208] := RGB(0, 255 - (i * 14), 0);
  for i := 0 to 15 do
    ColorArray[i + 224] := RGB(0, 255 - (i * 14), 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 240] := RGB(255 - (i * 14), 0, 0);
  Color256S := 2;
{  MainForm.SiliconSets;}
        for i := 0 to 255 do begin
          ColorRGBArray[0, i] := GetRValue(ColorArray[i]);
          ColorRGBArray[1, i] := GetGValue(ColorArray[i]);
          ColorRGBArray[2, i] := GetBValue(ColorArray[i]);
        end;
  FBackGroundColor := clBlue;
  Blue1.Checked := True;
  ///Fill ColorRGBArray with ColorArray
  AquaMarine256.Checked := True;
  RGBArray[0, 0] := 0; RGBArray[1, 0] := 0; RGBArray[2, 0] := 128;
  RGBArray[0, 1] := 0; RGBArray[1, 1] := 0; RGBArray[2, 1] := 255;
  RGBArray[0, 2] := 0; RGBArray[1, 2] := 128; RGBArray[2, 2] := 128;
  RGBArray[0, 3] := 0; RGBArray[1, 3] := 255; RGBArray[2, 3] := 255;
  RGBArray[0, 4] := 255; RGBArray[1, 4] := 255; RGBArray[2, 4] := 0;
  RGBArray[0, 5] := 128; RGBArray[1, 5] := 128; RGBArray[2, 5] := 0;
  RGBArray[0, 6] := 0; RGBArray[1, 6] := 255; RGBArray[2, 6] := 0;
  RGBArray[0, 7] := 0; RGBArray[1, 7] := 128; RGBArray[2, 7] := 0;
  RGBArray[0, 8] := 128; RGBArray[1, 8] := 128; RGBArray[2, 8] := 128;
  RGBArray[0, 9] := 255; RGBArray[1, 9] := 0; RGBArray[2, 9] := 255;
  RGBArray[0, 10] := 128; RGBArray[1, 10] := 0; RGBArray[2, 10] := 128;
  RGBArray[0, 11] := 192; RGBArray[1, 11] := 192; RGBArray[2, 11] := 192;
  RGBArray[0, 12] := 255; RGBArray[1, 12] := 0; RGBArray[2, 12] := 0;
  RGBArray[0, 13] := 128; RGBArray[1, 13] := 0; RGBArray[2, 13] := 0;
  RGBArray[0, 14] := 255; RGBArray[1, 14] := 255; RGBArray[2, 14] := 255;
  RGBArray[0, 15] := 0; RGBArray[1, 15] := 0; RGBArray[2, 15] := 0;
  LandformsSet.Checked := True;
FalseColors; //FalseColors Sets Menu per FBackGroundColor
False16;    //False16 CALLS Set16Colors
FalseSets;  // FalseSets BlueMeanie256  CALLS SiliconSets
end;

procedure TFractalForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
{If BitmapDisplayed then PhBitmap.Free;}
  FractalFormX := FractalForm.left;
  FractalFormY := FractalForm.top;
  DoSaver;
end;
procedure TFractalForm.FormDestroy(Sender: TObject);
begin
  If MandelImageMade then ;
  If JuliaImageMade then ;
  If PhoenixImageMade then ;
  If DragonsImageMade then ;
  If NewtonImageMade then ;
  If ApollianiaImageMade then ;
  If PharoahImageMade then ;
  If EggImageMade then ;
  If TeethImageMade then ;
  If LobsterImageMade then ;
  If CirclesImageMade then ;
  If CollarBonedImageMade then ;
  if DlaImageMade then ;
end;
procedure TFractalForm.FormShow(Sender: TObject);
begin
  //
end;
procedure TFractalForm.FormResize(Sender: TObject);
begin
{width:=540;
height:=371;}
end;
procedure TFractalForm.FormHide(Sender: TObject);
begin
//
end;

procedure TFractalForm.ResetAlltoDefault1Click(Sender: TObject);
begin
  ShowDown;
end;
//ONLY called by MAIN to SET  ...OR to RESET ALL
procedure TFractalForm.ShowDown;
begin
   frcNewton.MaxIterations:= 64;
   frcNewton.FXMax := 3.6;
   frcNewton.FXMin := -3.5; {71/53.25=1.33}
   frcNewton.FYMax := 3.6;//2.7;
   frcNewton.FYMin := -3.5;//-2.625;
   frcNewton.FHQ   := -0.003483;
   frcNewton.FVP := 0.268545;
  NtCx.Text := Format('%1.8f', [-0.003483]);
  NtCy.Text := Format('%1.8f', [0.268545]);
  NewtonBitmapDisplayed:=False;

  frcLobster.MaxIterations:= 14;
   frcLobster.FXMax := 2.7;//3.6;
   frcLobster.FXMin := -2.625;//-3.5; {71/53.25=1.33}
   frcLobster.FYMax := 2.7;
   frcLobster.FYMin := -2.625;
  frcLobster.FHQ   := -0.003483;
  frcLobster.FVP := 0.268545;
  NtLobCx.Text := Format('%1.8f', [-0.003483]);
  NtLobCy.Text := Format('%1.8f', [0.268545]);
  LobsterBitmapDisplayed:=False;

  frcDragon.MaxIterations:= 64;
  {frcDragon.FXMin := -2.15;
  frcDragon.FXMax := 4.25;
  frcDragon.FYMin := -3.2;
  frcDragon.FYMax := 3.2;}
  frcDragon.FXMin := -2.0;
  frcDragon.FXMax := 4.0;
  frcDragon.FYMin := -3.0;  //-2..4 is off center
  frcDragon.FYMax := 3.0;
  frcDragon.FHQ := -0.924069; {San Marcos Coordinates}
  frcDragon.FVP := 2.447261;
  DtCx.Text := Format('%1.8f', [-0.924069]);
  DtCy.Text := Format('%1.8f', [2.447261]);
  DtBitmapDisplayed:=False;

  frcTeeth.MaxIterations := 24;
  DttCx.Text := Format('%1.8f', [-0.924069]);
  DttCy.Text := Format('%1.8f', [2.447261]);
  frcTeeth.FXMin := -2.0;
  frcTeeth.FXMax := 2.0;    //-3..3 is centered SMALL
  frcTeeth.FYMin := -2.0;   //-2..2
  frcTeeth.FYMax := 2.0;
  frcTeeth.FHQ := -0.924069; {San Marcos Coordinates}
  frcTeeth.FVP := 2.447261;

  frcMandel.MaxIterations := 64;
  frcMandel.ViewLeft   := -2.0;
  frcMandel.ViewWidth  :=  4.0;
  frcMandel.ViewTop    := -2.0;
  frcMandel.ViewHeight :=  4.0;
  //frcMandel.Cx   Cy  NEVER set or USED
  frcMandel.Cx := 0.359171;
  frcMandel.Cy := 0.109141;
  MBitmapDisplayed :=False;
  frcJulia.MaxIterations := 24;
  frcJulia.ViewLeft   := -2.0;
  frcJulia.ViewWidth  :=  4.0;    {3.2}
  frcJulia.ViewTop    := -2.0;
  frcJulia.ViewHeight :=  4.0;
  frcJulia.Cx := 0.359171;
  frcJulia.Cy := 0.109141;
  edtCx.Text := Format('%1.8f', [0.359171]);
  edtCy.Text := Format('%1.8f', [0.109141]);

  Phoenix.MaxIterations:= 64;
  Phoenix.FHQ := -1.209169;;  Phoenix.FVP := 0.356338;
  PhoenixCx.Text := Format('%1.8f', [-1.209169]);
  PhoenixCy.Text := Format('%1.8f', [0.356338]);
  Phoenix.FXMin := -2.47;
  Phoenix.FXMax := 4.0;
  Phoenix.FYMin := -2.47;
  Phoenix.FYMax := 4.0;
  PBitmapDisplayed:=False;
  Egg.MaxIterations := 24;
  Egg.FHQ := -1.209169;;  Egg.FVP := 0.356338;
  EggCx.Text := Format('%1.8f', [-1.209169]);
  EggCy.Text := Format('%1.8f', [0.356338]);
  //Egg.FHQ := -0.003483;  Egg.FVP := 0.268545;
  //Egg.Cx :=-1.209169;  //Egg.Cy := 0.356338;
  Egg.FXMin := -2.0;
  Egg.FXMax := 2.0;
  Egg.FYMin := -2.0;
  Egg.FYMax := 2.0;
  Eggx:=0;Eggy:=0;

  PageControl1Change(Self);  //Makes Bitmaps for that page
end;
{==============================================================}
{==============================================================}
{  RGBArray: TColormatrix; 16 RGB's  3*16  [0..2, 0..15]}
{  ColorArray: array[0..255] of TColor; passing fancy}
{  ColorRGBArray: array[0..2, 0..255] of Byte;} {256 RGB's}
function TFractalForm.GetColor(Token:Integer):ColorSet;
//var Two, Zero:Byte;
Begin
  {If ColorTwistCB.Checked then
  begin
     Two:=0; Zero:=2;
  end else
  begin
     Two:=2; Zero:=0;
  end;}
  Case ColorSetRG.Itemindex of
  0:  //16 colors
    Begin
      Case FPColorRG.ItemIndex of  //Color Set Usage
      0: //16
        Begin
          Result[2]:= RGBArray[2, Token mod 16];
          Result[1]:= RGBArray[1, Token mod 16];
          Result[0]:= RGBArray[0, Token mod 16];
        End;
      1: //256
        Begin
          Result[2]:= ColorRGBArray[2, Token mod 16];
          Result[1]:= ColorRGBArray[1, Token mod 16];
          Result[0]:= ColorRGBArray[0, Token mod 16];
            //Result:=ColorArray[Token];
        End;
      2: //Horde
        Begin
            if Token mod 2 = 0 then
            begin
          Result[2]:= ColorRGBArray[2, Token mod 256];
          Result[1]:= ColorRGBArray[1, Token mod 256];
           Result[0]:= ColorRGBArray[0, Token mod 256];
            end
            else begin
          Result[2]:=RGBArray[2, Token mod 16];
          Result[1]:=RGBArray[1, Token mod 16];
          Result[0]:=RGBArray[0, Token mod 16];
            end;
        End;

      3://Pickled MOSTLY done to GET the Choice
        Begin
          Result[2]:=RGBArray[2, Token mod 16];
          Result[1]:=RGBArray[1, Token mod 16];
          Result[0]:=RGBArray[0, Token mod 16];
        End;
      4://Binary
        Begin        //1
          if (Token = 0) then begin
          Result[2]:=GetBValue(FBackGroundColor);
          Result[1]:=GetGValue(FBackGroundColor);
          Result[0]:= GetRValue(FBackGroundColor);
          end else //if (Token = 2) then
          begin
          Result[2]:=RGBArray[2, Token mod 16]; //0
          Result[1]:=RGBArray[1, Token mod 16];
          Result[0]:=RGBArray[0, Token mod 16];
          end;
        End;
      End;
    End;
  1:      //256 Colors
    Begin
      Case FPColorRG.ItemIndex of  //Color Set Usage
      0: //16
        Begin
          Result[2]:=ColorRGBArray[2, Token mod 16];
          Result[1]:=ColorRGBArray[1, Token mod 16];
          Result[0]:=ColorRGBArray[0, Token mod 16];
        End;
      1: //256
        Begin
          Result[2]:=ColorRGBArray[2, Token mod 256];
          Result[1]:=ColorRGBArray[1, Token mod 256];
          Result[0]:=ColorRGBArray[0, Token mod 256];
            //Result:=ColorArray[Token];
        End;
      2: //Horde
        Begin
           if Token mod 2 = 0 then
            begin
          Result[2]:=RGBArray[2, Token mod 16];
          Result[1]:=RGBArray[1, Token mod 16];
          Result[0]:=RGBArray[0, Token mod 16];
            end
            else begin
          Result[2]:=ColorRGBArray[2, Token mod 256];
          Result[1]:=ColorRGBArray[1, Token mod 256];
          Result[0]:=ColorRGBArray[0, Token mod 256];
            end;
        End;
      3://Pickled done in code from caller
        Begin
          Result[2]:=ColorRGBArray[2, Token mod 256];
          Result[1]:=ColorRGBArray[1, Token mod 256];
          Result[0]:=ColorRGBArray[0, Token mod 256];
        End;
      4: //Binary
        Begin
         if (Token = 0) then begin
          Result[2]:=GetBValue(FBackGroundColor);
          Result[1]:=GetGValue(FBackGroundColor);
          Result[0]:=GetRValue(FBackGroundColor);
          end else {if (Token = 2) then }begin
          Result[2]:=ColorRGBArray[2, Token mod 256];
          Result[1]:=ColorRGBArray[1, Token mod 256];
          Result[0]:=ColorRGBArray[0, Token mod 256];
          end;
        End;

      End;
    End else //Shut up compiler
    begin
          Result[2]:= RGBArray[2, 1];
          Result[1]:= RGBArray[1, 1];
          Result[0]:= RGBArray[0, 1];
    end;
  End;{Case}
End;

procedure TFractalForm.JuliaClipEditChange(Sender: TObject);
begin
  JuliaClip:=StrtoInt(JuliaClipEdit.Text); //JuliaClip:Integer;
end;

procedure TFractalForm.MouseLocatorXClick(Sender: TObject);
begin
  MouseLocatorX.Checked:= (not MouseLocatorX.Checked);
  MouseLocatorXChecked:=MouseLocatorX.Checked;
end;
{==============================================================}
{==============================================================}

procedure TFractalForm.MJHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(21000);
end;

procedure TFractalForm.PEHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(21100);
end;

procedure TFractalForm.DragonsTeethHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(21200);
end;

procedure TFractalForm.NewtonLobsterHekpBtnClick(Sender: TObject);
begin
  Application.HelpContext(21300);
end;

procedure TFractalForm.ACHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(21400);
end;

procedure TFractalForm.DlaHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(21500);
end;
procedure TFractalForm.ColorsHelpClick(Sender: TObject);
begin
  Application.HelpContext(21900);
end;
{==============================================================}
{==============================================================}


{==============================================================}
{==============================================================}
procedure TFractalForm.edtMMaxItersChange(Sender: TObject);
begin
  If frcMandel.MaxIterations <> StrToInt(edtMMaxIters.Text) then
  begin
    frcMandel.MaxIterations := StrToInt(edtMMaxIters.Text);
     Render(False,1);
  end;
  If frcJulia.MaxIterations <> StrToInt(edtJMaxIters.Text) then
  begin
    frcJulia.MaxIterations := StrToInt(edtJMaxIters.Text);
    Render(True,1);
   end;
end;

procedure TFractalForm.edtCxChange(Sender: TObject);
//var   i: Integer;   r: Real;
begin
   // Val((Sender as TEdit).Text, r, i);
    if Sender = edtCx then
      frcJulia.Cx := StrTofloat(edtCx.Text)
    else
      frcJulia.Cy := StrTofloat(edtCy.Text);
//   Render(False,1);Render(True,1);// frcMandel32.Invalidate;
end;

procedure TFractalForm.FPManDemBtnClick(Sender: TObject);
begin
  Render(False,2);
end;
procedure TFractalForm.MMSaveBtnClick(Sender: TObject);
begin
  Render(False,3);
end;
procedure TFractalForm.MJSaveBtnClick(Sender: TObject);
begin
  Render(True,3);
end;
procedure TFractalForm.FPJuliaDemBtnClick(Sender: TObject);
begin
  Render(True,2);
end;

procedure TFractalForm.AllDemSaver;
var
  FractalFileMatrix,FractalFileName: string;
  XCount, YCount : Integer;
  F_File: file of Smallint;
  T_File:TextFile;
begin
  {Save data as a DEM }
    {Save the Manmatrix DEM ..whatever-both-either
     is already SET : Dem Rcd Flm Deh }
    SaveDialog1.Filter := 'Fractal DEM|*.bin;*.dem';
    SaveDialog1.Filename := '*.bin';
    SaveDialog1.InitialDir:=DemPath;
    if (SaveDialog1.Execute) then
    begin
      DemPath:=ExtractFilePath(SaveDialog1.FileName);
      FractalFileName := ExtractFileName(SaveDialog1.FileName);
      FractalFileName := ChangeFileExt(FractalFilename, '.tpcfg');
      FractalFileMatrix :=ChangeFileExt(SaveDialog1.FileName, '.bin');
      Application.ProcessMessages;
      {  HTFPath    DemPath     ProgramPath}
      AssignFile(T_File, ProgramPath+FractalFileName);
      ReWrite(T_File);
      Writeln(T_File, 'HTFName='+HTFPath+ChangeFileExt(FractalFilename, '.htf'));
      Writeln(T_File,'WorldSizeX=256');
      Writeln(T_File,'WorldSizeY=256');
      Writeln(T_File,'TileSize=33');
      Writeln(T_File,'TileOverlap=1');
      Writeln(T_File,'DefaultZ=0');
      Writeln(T_File,'FilterZ=-32768');
      Writeln(T_File,'ZScale=1');
      Writeln(T_File,'DEMPath='+DemPath);
      //F:\dem\dem24k\Il-\St Clair\Monks_Mound\
      Writeln(T_File,'WholeTiles=0');
      Writeln(T_File,'DEMs="'+
           ChangeFileExt(FractalFilename, '.bin')+
           ',""0,0"",256x256,""16 bits (Intel)"""' );
      CloseFile(T_File);
      Application.ProcessMessages;
      AssignFile(F_File, FractalFileMatrix);
      ReWrite(F_File);
      if IoResult = 0 then
      begin
          for Ycount := 0 to 255 do
          begin
            ProgressBar1.Position :=
            Round((Ycount / 255) * 100);
            Application.ProcessMessages;
            for Xcount := 0 to 255 do
            begin
              Write(F_File, ManMatrix[Xcount, Ycount]);
            end;
          end;
          CloseFile(F_File);
          if (IoResult <> 0) then
            {DoMessages(30064)};
      end else {DoMessages(30065)};
    end;
  ProgressBar1.Position :=0;
end;

procedure TFractalForm.MandelImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  rx, ry: real;
  z: real;
begin
  if Shift = [ssLeft, ssCtrl] then
  begin
    Render(False,1);
    If MouseLocatorXChecked then
    begin
      Origin := Point(X, Y);
      frcMandelPaint(Origin, MovePt, pmCopy{pmNotXor});
    end;
    exit;
  end;
  if Shift = [ssLeft, ssShift] then
    z := 0.5
  else
  if Shift = [ssRight, ssShift] then
    z := -1.0
  else
  begin
      MandelImageMouseMove(Sender, Shift, X, Y);
    exit;
  end;
  {If shifted then Zoom else pass to the egg}
  rx := frcMandel.ViewLeft + (x * frcMandel.ViewWidth  / 256);
  ry := frcMandel.ViewTop  + ((256-y) * frcMandel.ViewHeight / 256);
  frcMandel.ViewLeft  := frcMandel.ViewLeft + z * (rx - frcMandel.ViewLeft);
  frcMandel.ViewWidth := frcMandel.ViewWidth * (1 - z);
  frcMandel.ViewTop   := frcMandel.ViewTop  + z * (ry - frcMandel.ViewTop);
  frcMandel.ViewHeight := frcMandel.ViewHeight * (1 - z);
  Render(False,1);
end;

procedure TFractalForm.MandelImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var rx, ry: real;
begin
  If (not MBitmapDisplayed) then Render(False,1); //Fist time to Show
  if Shift = [ssLeft] then
  begin
    rx :=
        frcMandel.ViewLeft +
        (x * frcMandel.ViewWidth
        / MandelImage.Width);
    ry :=
        frcMandel.ViewTop  +
        (({256-}y) * frcMandel.ViewHeight
        / MandelImage.Height);
    frcJulia.Cx := rx;
    frcJulia.Cy := ry;
    edtCx.Text := Format('%1.8f', [rx]);
    edtCy.Text := Format('%1.8f', [ry]);
   Render(True,1);//frcJulia32.Repaint;  Render(False,1);Render(True,1);
   // frcMandel32.Invalidate;
   If MouseLocatorXChecked then
   begin
      Origin  := Point(X, Y);
      frcMandelPaint(Origin, MovePt, pmCopy);
   end;
  end;
end;
procedure TFractalForm.frcMandelPaint
  (TopLeft, BottomRight: TPoint; AMode: TPenMode);
{var  x,y: integer;}
begin    {Lineto does NOT draw Last point of line}
  with MandelImage.Canvas do
  begin
  Pen.Mode := AMode;
  MandelImage.Canvas.Pen.Color := clWhite;
  {x := MViewToPixelX(frcJulia.Cx);
  y := MandelImage.Height-MViewToPixelY(frcJulia.Cy);
  MandelImage.Canvas.MoveTo(x - 3, y - 3);
  MandelImage.Canvas.LineTo(x + 4, y + 4);
  MandelImage.Canvas.MoveTo(x - 3, y + 3);
  MandelImage.Canvas.LineTo(x + 4, y - 4);}

  MandelImage.Canvas.MoveTo(TopLeft.x - 3, TopLeft.y - 3);
  MandelImage.Canvas.LineTo(TopLeft.x + 4, TopLeft.y + 4);
  MandelImage.Canvas.MoveTo(TopLeft.x - 3, TopLeft.y + 3);
  MandelImage.Canvas.LineTo(TopLeft.x + 4, TopLeft.y - 4);
  //Image2.Canvas.MoveTo(TopLeft.X, TopLeft.Y);
  //Image2.Canvas.LineTo(BottomRight.X, BottomRight.Y);
  end;
end;

{function TFractalForm.MViewToPixelX(const x: Real): integer;
begin
  Result := round((x - frcMandel.ViewLeft) * MandelImage.Width / frcMandel.ViewWidth);
end;
function TFractalForm.MViewToPixelY(const y: Real): integer;
begin
  Result := round((y - frcMandel.ViewTop) * MandelImage.Height / frcMandel.ViewHeight);
end;  }
function TFractalForm.MPixelToViewX(const x: integer): Real;
begin
  Result := frcMandel.ViewLeft + x * frcMandel.ViewWidth / MandelImage.Width;
end;

function TFractalForm.MPixelToViewY(const y: integer): Real;
begin
  Result := frcMandel.ViewTop + y * frcMandel.ViewHeight / MandelImage.Height;
end;
function TFractalForm.JPixelToViewX(const x: integer): Real;
begin
//  Result := frcMandel.ViewLeft + x * frcMandel.ViewWidth / MandelImage.Width;
  Result := frcJulia.ViewLeft + x * frcJulia.ViewWidth / MandelImage.Width;
end;
function TFractalForm.JPixelToViewY(const y: integer): Real;
begin
//  Result := frcMandel.ViewTop + y * frcMandel.ViewHeight / MandelImage.Height;
  Result := frcJulia.ViewTop + y * frcJulia.ViewHeight / MandelImage.Height;
end;
{function TFractalForm.JViewToPixelX(const x: Real): integer;
begin
  Result := round((x - frcMandel.ViewLeft) * MandelImage.Width / frcMandel.ViewWidth);
end;

function TFractalForm.JViewToPixelY(const y: Real): integer;
begin
  Result := round((y - frcMandel.ViewTop) * MandelImage.Height / frcMandel.ViewHeight);
end; }

procedure TFractalForm.JuliaImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  rx, ry: real;
  z: real;
begin    // z := 0.5;
  if Shift = [ssLeft, ssShift] then  z := 0.5
  else
  if Shift = [ssRight, ssShift] then z := -1.0
  else exit;

  rx := frcJulia.ViewLeft + (x * frcJulia.ViewWidth  / JuliaImage.Width);
  ry := frcJulia.ViewTop  + ((256-y) * frcJulia.ViewHeight / JuliaImage.Height);
  frcJulia.ViewLeft  := frcJulia.ViewLeft + z * (rx - frcJulia.ViewLeft);
  frcJulia.ViewWidth := frcJulia.ViewWidth * (1 - z);
  frcJulia.ViewTop   := frcJulia.ViewTop  + z * (ry - frcJulia.ViewTop);
  frcJulia.ViewHeight := frcJulia.ViewHeight * (1 - z);
  Render(True,1);//Render(False,1);Render(True,1);
end;

{==============================================================}
{==============================================================}

{==============================================================}
procedure TFractalForm.CplxSqrtFJUL(a, b: Real; out x, y: Real);
var
  r: Real;
begin
  r := sqrt(a*a + b*b);
  x := sqrt(0.5 * (r + a));
  if b < 0.0 then
    y := -sqrt(0.5 * (r - a))
  else
    y := sqrt(0.5 * (r - a));
end;
{==============================================================}
//IsJulia added NEED to put it in the Invalidate and elsewhere
procedure TFractalForm.Render(IsJulia:Boolean;Switch:Integer);
var
  PixelLine: PByteArray;
  PhBitmap: TBitmap;
  ColorSet3:ColorSet;
   maxcolx, maxrowy,  XCount, YCount, TempMan ,
  Pixelx,  x, y, i, j: integer;
  vx, vy: real;
  vx2: real;
  tx1, ty1: real;
  //tx2, ty2: real;
  lake: boolean;
  dx, dy: real;
  d, ld: real;
  label done;
begin
  //frcJulia  frcMandel
  MBitmapDisplayed:=True;
  PhBitmap:= TBitmap.create;
  Try
    PhBitmap.Width := 256;
    PhBitmap.Height := 256;
  PhBitmap.PixelFormat :=pf24bit;// MyPixelFormat;
  If Switch >1 then SetLength(ManMatrix, 256, 256);  
  PixelLine := PhBitmap.ScanLine[0];//Just to shut up compiler Warning
  if IsJulia then
  begin
    // see if it has a lake
    vx := 0;
    vy := 0;
    for i := 1 to 500 do
    begin
      if (vx * vx + vy * vy) > 4.0 then break;
      vx2 := vx * vx - vy * vy + frcJulia.Cx;
      vy :=  vx * vy * 2.0 + frcJulia.Cy;
      vx := vx2;
    end;
    lake := i > 500;
    tx1 := vx; ty1 := vy;   // trap point
  end
  else lake := false;
  //if lake then showmessage('lake');
  for y := 0 to JuliaImage.Height - 1 do
  begin  //If Dem  or DemSave then
    If Switch =1 then
    PixelLine := PhBitmap.ScanLine[y];
        ProgressBar1.Position :=
        Round((y / (DragonsImage.Width - 1)) * 100);
    for x := 0 to JuliaImage.Width - 1 do
    begin
      j := 255;
      if IsJulia then
      begin  //Could be done here Rather than Calling Out
        vx := JPixelToViewX(x);/// X and Y are the Incrementers
        vy := JPixelToViewY(y);
        ld := 0.0;
        for i := 0 to frcJulia.MaxIterations do
        begin
          if (vx * vx + vy * vy) > 4.0 then
          begin
            j := i;
            break;
          end;
          vx2 := vx * vx - vy * vy + frcJulia.Cx;
          vy :=  vx * vy * 2.0 + frcJulia.Cy;
          vx := vx2;
          if lake and (i > 9) then
          begin
            dx := vx - tx1;
            dy := vy - ty1;
            d := (dx * dx + dy * dy);
            if d < 0.001 then
            begin
              if d < ld then
              begin
                j := 255;//4 - 4*i;
                break;
              end;
              ld := d * 0.999;
            end
            else
              ld := ld * 0.99;
          end;
        end;
      end
      else // Mandelbrot
      begin
        vx := 0;
        vy := 0;
        frcMandel.Cx := MPixelToViewX(x);
        frcMandel.Cy := MPixelToViewY(y);

        // is point in main cardioid?
        // calculate stable fixed point
        tx1 := 1 - 4 * frcMandel.Cx;
        ty1 := 0 - 4 * frcMandel.Cy;
        {CplxSqrt}CplxSqrtFJUL(tx1, ty1, tx1, ty1);
        //tx2 := 0.5 + 0.5 * tx1;  this one not used because
        //ty2 := 0.0 + 0.5 * ty1;  it's not a stable fixed-point
        //tx1 := 0.5 - 0.5 * tx1;
        //ty1 := 0.0 - 0.5 * ty1;
        tx1 := 1.0 - tx1;  // doubling it
        //ty1 :=     - ty1; // not needed; it'll be squared
        d := (tx1 * tx1 + ty1 * ty1);
        // square of magnitude of derivative at fixed-point
        if d < 1.0 then
        begin
          j := 255;
          goto done;
        end;

        // is point in circle to left of main cardioid?
        dx := frcMandel.Cx + 1.0;
        d := dx * dx + frcMandel.Cy * frcMandel.Cy;
        if d < 0.0625 then
        begin
          j := 255;
          goto done;
        end;

        for i := 0 to frcMandel.MaxIterations do
        begin
          if (vx * vx + vy * vy) > 4.0 then
          begin
            j := i;
            break;
          end;
          vx2 := vx * vx - vy * vy + frcMandel.Cx;
          vy :=  vx * vy * 2.0 + frcMandel.Cy;
          vx := vx2;
        end;
      end;
      done:
      begin  //Set Pixel OR Set ManMatrix
        //Changed so the Clip cuts can be done to Mandelbrot Too
        //if JIsJulia then begin  end  else {ManMatrix[x, y] := j;};
        If JuliaLevel.Checked then
        begin
          If j < 0 then j:=0 else
          If j < JuliaClip then j:=JuliaClip;
        end;
        {Invert so Mass is lake}
        If JuliaLake.Checked then
        begin
          If j > JuliaClip then j:=j-JuliaClip;
          If j < 0 then j:=0;
        end;
        If JuliaDivisor.Checked then j:= j div JuliaClip;
              If (FPColorRG.ItemIndex=4) and IsJulia then
              begin   {San Marcos Colors}
                if (j < (frcJulia.MaxIterations)) then j := 0
                else         //Xsquare + Ysquare
                j := (Round((vx + vy) * 100) mod 6) + 1;
                if (y < (DragonsImage.Height div 2)) then j := j + 8;
              end;                                     //Xsquare + Ysquare
           If (FPColorRG.ItemIndex=3)then j := (Round((vx + vy) * 14) mod 14) +1;
          If Switch =1 then
          begin
              Pixelx := (x *3);
              ColorSet3:= GetColor(j);
                PixelLine[Pixelx] := ColorSet3[2];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[1];
          end else
          ManMatrix[x, y] := j;
      end;
    end;
  end;
  //IF Dem or DemSave then Process ManMatrix
  If Switch >1 then
  begin
  MaximumElevation := -2147483647;
  MinimumElevation := 2147483646;
  maxcolx:=  255;
  maxrowy := 255;
  for Ycount := 0 to maxrowy do
  begin
    PixelLine := PhBitmap.ScanLine[Ycount];
    ProgressBar1.Position := Round((Ycount / maxrowy) * 100);
    Application.ProcessMessages;
    for Xcount := 0 to maxcolx do
    begin
      TempMan:=ManMatrix[Xcount, 255-Ycount];
      if (MaximumElevation <= TempMan) then
      MaximumElevation := TempMan;
      if (MinimumElevation >= TempMan) then
      MinimumElevation := TempMan;
              Pixelx := (Xcount *3);
              ColorSet3:= GetColor(TempMan);
                PixelLine[Pixelx] := ColorSet3[2];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[0];
    end;
  end;
  ProgressBar1.Position :=0;
  Application.ProcessMessages;
  end;
If Switch =1 then
begin
  //Max..Min and into a Upside downBitmap
  if IsJulia then
  begin
    JuliaImage.Picture.Bitmap.Assign(PhBitmap);
  end else
  begin
    MandelImage.Picture.Bitmap.Assign(PhBitmap);
  end;
end else
If Switch =2 then
begin
dtmGlForm.Image1.Picture.Assign(PhBitmap);
dtmGlForm.Image2.Picture.Assign(PhBitmap);
dtmGlForm.FormShowDown(MandelImage.Width,MandelImage.Height);
dtmGlForm.show;
end else
If Switch =3 then
begin
AllDemSaver;
end;
  Finally
    PhBitmap.free;
  end;
   FXMaxLabel.Caption := Format('%1.8f', [frcMandel.ViewWidth]);//Egg.FXMax
   FXMinLabel.Caption := Format('%1.8f', [frcMandel.ViewLeft]);//Egg.FXMin
   FYMaxLabel.Caption := Format('%1.8f', [frcMandel.ViewHeight]);//Egg.FYMax
   FYMinLabel.Caption := Format('%1.8f', [frcMandel.ViewTop]);//Egg.FYMin
   ViewWidthLabel.Caption := Format('%1.8f', [frcJulia.ViewWidth]);//Egg.ViewWidth-
   ViewLeftLabel.Caption := Format('%1.8f', [frcJulia.ViewLeft]);//Egg.ViewLeft
   ViewHeightLabel.Caption := Format('%1.8f', [frcJulia.ViewHeight]);//Egg.ViewHeight-
   ViewTopLabel.Caption := Format('%1.8f', [frcJulia.ViewTop]);//Egg.ViewTop
   FHQLabel.Caption := Format('%1.8f', [frcMandel.Cx]);//Egg.FHQ
   FVPLabel.Caption := Format('%1.8f', [frcMandel.Cy]);//Egg.FVP
   CxLabel.Caption := Format('%1.8f', [frcJulia.Cx]);//Egg.Cx
   CyLabel.Caption := Format('%1.8f', [frcJulia.Cy]);//Egg.Cy
  ProgressBar1.Position :=0;
end;
{==============================================================}
{==============================================================}

{==============================================================}
{==============================================================}

{==============================================================}
{==============================================================}
procedure TFractalForm.PhoenixImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  rx, ry: real;
  z: real;
begin
  if Shift = [ssLeft, ssCtrl] then
  begin
    RenderPEgg(false,1);//PhimageryPaint;
    If MouseLocatorXChecked then
      PhoenixImagePaint(X, (y));
    exit;
  end;
  if Shift = [ssLeft, ssShift] then
    z := 0.5
  else
  if Shift = [ssRight, ssShift] then
    z := -1.0
  else
  begin
    if Sender = PhoenixImage then
     PhoenixImageMouseMove(Sender, Shift, X, Y);
    exit;
  end;
  {If shifted then below Zooms else pass movement }
{  f := (Sender as TFractal);}
{  rx := f.ViewLeft + x * f.ViewWidth  / f.Width;}
    rx := Phoenix.FXMin + (x * (Phoenix.FXMax) / 256);
{  ry := f.ViewTop  + y * f.ViewHeight / f.Height;}
                  {Flip to correct  Image upside down}
    ry := Phoenix.FYMin + ((256-y) * (Phoenix.FYMax) / 256);
  Phoenix.FXMin  := Phoenix.FXMin + z * (rx - Phoenix.FXMin);
  Phoenix.FXMax := Phoenix.FXMax * (1 - z);
  Phoenix.FYMin   := Phoenix.FYMin  + z * (ry - Phoenix.FYMin);
  Phoenix.FYMax := Phoenix.FYMax * (1 - z);
  //If PBitmapDisplayed then RenderPEgg(false) else
   RenderPEgg(false,1);//   PhimageryPaint; //so it zooms
end;

procedure TFractalForm.EggImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  rx, ry: real;
  z: real;
begin
  if Shift = [ssLeft, ssShift] then
    z := 0.5
  else
  if Shift = [ssRight, ssShift] then
    z := -1.0
  else
  begin
    exit;
  end;
  {If shifted then below Zooms else pass movement }
{  f := (Sender as TFractal);}
{  rx := f.ViewLeft + x * f.ViewWidth  / f.Width;}
    rx := Egg.FXMin + (x * (Egg.FXMax) / 256);
{  ry := f.ViewTop  + y * f.ViewHeight / f.Height;}
                  {Flip to correct  Image upside down}
    ry := Egg.FYMin + ((256-y) * (Egg.FYMax) / 256);
  Egg.FXMin  := Egg.FXMin + z * (rx - Egg.FXMin);
  Egg.FXMax := Egg.FXMax * (1 - z);
  Egg.FYMin   := Egg.FYMin  + z * (ry - Egg.FYMin);
  Egg.FYMax := Egg.FYMax * (1 - z);
    Eggx:=x;Eggy:=y;
  RenderPEgg(True,1);{  f.SetChanged;}
end;

procedure TFractalForm.PhoenixImagePaint(x,y: integer);
begin
  PhoenixImage.Canvas.Pen.Color := clWhite;
  PhoenixImage.Canvas.MoveTo(x - 3, (y) - 3);
  PhoenixImage.Canvas.LineTo(x + 4, (y) + 4);
  PhoenixImage.Canvas.MoveTo(x - 3, (y) + 3);
  PhoenixImage.Canvas.LineTo(x + 4, (y) - 4);
end;

procedure TFractalForm.PhoenixImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  rx, ry: real;
begin
  If (not PBitmapDisplayed) then RenderPEgg(False,1);//PhimageryPaint;
  if Shift = [ssLeft] then
  begin
{    rx := -2.7+ (x * 4.0 / 256);}
    rx := Phoenix.FXMin + (x * (Phoenix.FXMax) / 256);
{Phoenix1.ViewLeft + x * Phoenix1.ViewWidth  / Phoenix1.Width;}
{    ry := -2.0+ (y * 4.0 / 256);}
                      //(Filesizey-y)
    ry := Phoenix.FYMin + ((256-y) * (Phoenix.FYMax) / 256);
{Phoenix1.ViewTop  + y * Phoenix1.ViewHeight / Phoenix1.Height;}
  Egg.FHQ:= rx;
  Egg.FVP:= ry;
    //Egg.Cx := rx;    Egg.Cy := ry;
    EggCx.Text := Format('%1.8f', [rx]);
    EggCy.Text := Format('%1.8f', [ry]);
      Eggx:=x;Eggy:=y;
    RenderPEgg(True,1);//Repaint;
    //Draws the Location + cross
    If MouseLocatorXChecked then PhoenixImagePaint(X, (y));
  end;
end;



procedure TFractalForm.PhoenixItersEditChange(Sender: TObject);
var
  i: Longint;
begin
    i := StrToInt(EggItersEdit.Text);
    if (i<10)  then exit; //or (i>255)
    If Egg.MaxIterations <> StrToInt(EggItersEdit.Text) then
    begin
    Egg.MaxIterations := StrToInt(EggItersEdit.Text);
    EggItersEdit.Text:=Inttostr(Egg.MaxIterations);
    RenderPEgg(True,1);
    end;
    i := StrToInt(PhoenixItersEdit.Text);
    if (i<10) then exit;
    If Phoenix.MaxIterations <> StrToInt(PhoenixItersEdit.Text) then
    begin
    Phoenix.MaxIterations:= StrToInt(PhoenixItersEdit.Text);
    PhoenixItersEdit.Text:=Inttostr(Phoenix.MaxIterations);
    RenderPEgg(false,1);//PhimageryPaint;
    end;
end;

procedure TFractalForm.EggCxChange(Sender: TObject);
//var  i: Integer;   r: Real;
begin
    //Val((Sender as TEdit).Text, r, i);
    if Sender = EggCx then Egg.FHQ:= StrTofloat(EggCx.Text) else
    if Sender = EggCy then Egg.FVP:= StrTofloat(EggCy.Text) else
    if Sender = PhoenixCx then Phoenix.FHQ:= StrTofloat(PhoenixCx.Text) else
    if Sender = PhoenixCy then Phoenix.FVP:= StrTofloat(PhoenixCy.Text);
{    FHQ: Extended;  FVP: Extended;  Phoenix1.Invalidate;}
//    PhimageryPaint; //RenderPEgg(True);
end;


procedure TFractalForm.EggDisplayBtnClick(Sender: TObject);
begin
  RenderPEgg(True,2);
end;
procedure TFractalForm.PhoenixDisplayBtnClick(Sender: TObject);
begin
  RenderPEgg(False,2);
end;

procedure TFractalForm.PhoenixSaveBtnClick(Sender: TObject);
begin
  RenderPEgg(False,3);
end;
procedure TFractalForm.EggSaverBtnClick(Sender: TObject);
begin
  RenderPEgg(True,3);
end;


procedure TFractalForm.RenderPEgg(IsEgg:Boolean;Switch:Integer);
var
  ColorSet3:ColorSet;
  //Code,    i,   SetSelection,
  XCount, YCount, TempMan,
  Pixelx, maxcolx, maxrowy, FMcolor, rowy, colx: integer;
  //cos_theta, sin_theta, theta, YTemp,Temp,deltaY, Ysquare,max_size,
    Xi, Yi, Xisquare, Xitemp, deltaXi,
  Xtemp, X, Y, Xsquare, deltaX,  FHQ, FVP,
     deltaP, deltaQ: Extended;
  Bitmap: TBitmap;
  PixelLine: PByteArray;
  Q: array[0..3072] of Extended;
//  x, y, i: integer;
//  vx, vy: real;
//  vx2: real;
//  tx1, ty1: real;
  //tx2, ty2: real;
//  lake: boolean;
//  dx, dy: real;
//  d, ld: real;
{  label done;}
begin
  If BusyEggPainting then exit;
  BusyEggPainting:=True;
  If Switch>1 then SetLength(ManMatrix,256,256);
  Bitmap := TBitmap.create;
  Try
  Bitmap.PixelFormat :=pf24bit;
  Bitmap.Width := 256;
  Bitmap.Height := 256;
  PixelLine := Bitmap.ScanLine[0];
  maxcolx := (255 ); // PhoenixImage.Width
  maxrowy := (255 );
  if IsEgg then
  begin
    {Begin here   FVP := P;     FHQ := Q;}
     //   vx := 0;         vy := 0;
     //   Egg.FHQ := EggPixelToViewX(Eggx);
     //   Egg.FVP := EggPixelToViewY(Eggy);
      FVP := Egg.FVP;{FVP;}
      FHQ := Egg.FHQ;{FHQ;}
//     deltaXi:=(Egg.ViewWidth- Egg.ViewLeft)/ maxcolx ;
//    deltaX := (Egg.ViewHeight-Egg.ViewTop)/ maxrowy;
     deltaXi:=(Egg.FYMax- Egg.FYMin)/ maxcolx ;
    deltaX := (Egg.FYMax-Egg.FYMin)/ maxrowy;
    for colx := 0 to maxcolx do
    begin
              ProgressBar1.Position :=
        Round((colx / (maxcolx )) * 100);
      for rowy := 0 to maxrowy do
      begin
        If Switch=1 then
        PixelLine := Bitmap.ScanLine[rowy];
          Y := 0;
          Yi := 0;
//          X := Egg.ViewWidth - rowy * deltaX;
//          Xi := Egg.ViewLeft + colx * deltaXi;
          X := Egg.FYMax - rowy * deltaX;
          Xi := Egg.FXMin + colx * deltaXi;
          Xsquare := 0;
          Xisquare := 0;
          FMcolor := 0;
        while (FMcolor < Egg.MaxIterations) and
            ((Xsquare + Xisquare)< 4.0)
              do
        begin
          Xsquare := X * X;
            Xisquare := Xi * Xi;
            Xtemp := Xsquare - Xisquare + FVP + FHQ * Y;
            Xitemp := 2 * X * Xi + FHQ * Yi;
            Y := X;
            Yi := Xi;
            X := Xtemp;
            Xi := Xitemp;
          inc(FMcolor);
        end;
        //Changed so the Clip cuts can be done to Mandelbrot Too
        //if JIsJulia then begin  end  else {ManMatrix[x, y] := j;};
        If JuliaLevel.Checked then
        begin
          If FMcolor < 0 then FMcolor:=0 else
          If FMcolor < JuliaClip then FMcolor:=JuliaClip;
        end;
        {Invert so Mass is lake}
        If JuliaLake.Checked then
        begin
          If FMcolor > JuliaClip then FMcolor:=FMcolor-JuliaClip;
          If FMcolor < 0 then FMcolor:=0;
        end;
        If JuliaDivisor.Checked then FMcolor:= FMcolor div JuliaClip;
          If Switch =1 then
          begin
           If (FPColorRG.ItemIndex=3)then FMcolor := (Round((Xsquare +  Xisquare) * 14) mod 14) +1;

              Pixelx := (colx *3);
              ColorSet3:= GetColor(FMcolor);
                PixelLine[Pixelx] := ColorSet3[2];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[0];
          end else
          ManMatrix[colx, rowy] := FMcolor;
          {Pixelx := (colx *3);
              ColorSet3:= GetColor(FMcolor);
                PixelLine[Pixelx] := ColorSet3[2];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[0];}
      end;
    end;
  end else // Phoenix
  begin   //showmessage('GOTCHA..This never is DONE');
    {vx := 0; vy := 0;
     FCx := PixelToViewX(x);    FCy := PixelToViewY(y);}
    deltaP :=
    //(Egg.ViewWidth- Egg.ViewLeft)/ PhoenixImage.Width;
    //(Phoenix.FXMax - Phoenix.FXMin) / maxcolx;
    (Phoenix.FXMax ) / maxcolx;
    deltaQ :=
    //(Egg.ViewHeight-Egg.ViewTop)/ PhoenixImage.Height;
    //(Phoenix.FYMax - Phoenix.FYMin) / maxrowy;
      (Phoenix.FYMax ) / maxrowy;
    Q[0] :=(deltaQ*maxrowy) +Phoenix.FYMin;
           //Phoenix.FYMax;
    for rowy := 1 to maxrowy do Q[rowy] := Q[rowy - 1] - deltaQ;
    FVP :=//(Egg.ViewLeft*deltaP);   (Phoenix.FXMin + (0 * deltaP));
          //(Phoenix.FXMin  * deltaP);
          Phoenix.FXMin;
    for colx := 0 to maxcolx do begin
            ProgressBar1.Position :=
        Round((colx / (maxcolx )) * 100);
      for rowy := 0 to maxrowy do begin
        PixelLine := Bitmap.ScanLine[rowy];
        Y := 0;
        Yi := 0;
        X := 0;
        Xi := 0;
        FMcolor := 0;
        Xsquare := 0;
        Xisquare := 0;
        while (FMcolor < Phoenix.MaxIterations) and
          (Xsquare + Xisquare < 4.0) do
        begin
          Xsquare := X * X;
          Xisquare := Xi * Xi;
          Xtemp := Xsquare - Xisquare
                  + FVP + Q[rowy] * Y;
          Xitemp := 2 * X * Xi + Q[rowy] * Yi;
          Y := X;
          Yi := Xi;
          X := Xtemp;
          Xi := Xitemp;
          inc(FMcolor);
        end;
        //Changed so the Clip cuts can be done to Mandelbrot Too
        //if JIsJulia then begin  end  else {ManMatrix[x, y] := j;};
        If JuliaLevel.Checked then
        begin
          If FMcolor < 0 then FMcolor:=0 else
          If FMcolor < JuliaClip then FMcolor:=JuliaClip;
        end;
        {Invert so Mass is lake}
        If JuliaLake.Checked then
        begin
          If FMcolor > JuliaClip then FMcolor:=FMcolor-JuliaClip;
          If FMcolor < 0 then FMcolor:=0;
        end;
        If JuliaDivisor.Checked then FMcolor:= FMcolor div JuliaClip;
          If Switch =1 then
          begin
              Pixelx := (colx *3);
              ColorSet3:= GetColor(FMcolor);
                PixelLine[Pixelx] := ColorSet3[2];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[0];
          end else
          ManMatrix[colx, rowy] := FMcolor;
              {Pixelx := (colx *3);
              ColorSet3:= GetColor(FMcolor);
                PixelLine[Pixelx] := ColorSet3[2];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[0];}
      end;
      FVP := FVP + deltaP;
    end;
  end;
  //IF Dem or DemSave then Process ManMatrix
  If Switch >1 then
  begin
  MaximumElevation := -2147483647;
  MinimumElevation := 2147483646;
  maxcolx:=  255;
  maxrowy := 255;
  for Ycount := 0 to maxrowy do
  begin
    PixelLine := Bitmap.ScanLine[Ycount];
    ProgressBar1.Position := Round((Ycount / maxrowy) * 100);
    Application.ProcessMessages;
    for Xcount := 0 to maxcolx do
    begin
      TempMan:=ManMatrix[Xcount, 255-Ycount];
      if (MaximumElevation <= TempMan) then
      MaximumElevation := TempMan;
      if (MinimumElevation >= TempMan) then
      MinimumElevation := TempMan;
              Pixelx := (Xcount *3);
              ColorSet3:= GetColor(TempMan);
                PixelLine[Pixelx] := ColorSet3[2];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[0];
    end;
  end;
  ProgressBar1.Position :=0;
  Application.ProcessMessages;
  end;
If Switch =1 then
begin
  if IsEgg then
  begin
    EggImage.Picture.Bitmap.Assign(Bitmap);
    //EggImage.canvas.draw(0, 0, Bitmap);
  end else
  begin
    PhoenixImage.Picture.Bitmap.Assign(Bitmap);
   // PhoenixImage.canvas.draw(0, 0, Bitmap);
    PBitmapDisplayed:=True;
  end;
end else
If Switch =2 then
begin
dtmGlForm.Image1.Picture.Assign(Bitmap);
dtmGlForm.Image2.Picture.Assign(Bitmap);
dtmGlForm.FormShowDown(MandelImage.Width,MandelImage.Height);
dtmGlForm.show;
end else
If Switch =3 then
begin
AllDemSaver;
end;
   FXMaxLabel.Caption := Format('%1.8f', [Phoenix.FXMax]);//Egg.FXMax
   FXMinLabel.Caption := Format('%1.8f', [Phoenix.FXMin]);//Egg.FXMin
   FYMaxLabel.Caption := Format('%1.8f', [Phoenix.FYMax]);//Egg.FYMax
   FYMinLabel.Caption := Format('%1.8f', [Phoenix.FYMin]);//Egg.FYMin
   ViewWidthLabel.Caption := Format('%1.8f', [Egg.FXMax]);//Egg.ViewWidth-
   ViewLeftLabel.Caption := Format('%1.8f', [Egg.FXMin]);//Egg.ViewLeft
   ViewHeightLabel.Caption := Format('%1.8f', [Egg.FYMax]);//Egg.ViewHeight-
   ViewTopLabel.Caption := Format('%1.8f', [Egg.FYMin]);//Egg.ViewTop
   FHQLabel.Caption := Format('%1.8f', [Phoenix.FHQ]);//Egg.FHQ
   FVPLabel.Caption := Format('%1.8f', [Phoenix.FVP]);//Egg.FVP
   CxLabel.Caption := Format('%1.8f', [Egg.FHQ]);//Egg.Cx
   CyLabel.Caption := Format('%1.8f', [Egg.FVP]);//Egg.Cy
  ProgressBar1.Position :=0;
  Finally
      Bitmap.free;
  end;
  BusyEggPainting:=False;
end;
{
function TFractalForm.EggPixelToViewX(const x: integer): Real;
begin
  //Result := Egg.ViewLeft + x * Egg.ViewWidth / PhoenixImage.Width;
  Result := Egg.FxMin + x * Egg.FxMax / PhoenixImage.Width;
end;
function TFractalForm.EggPixelToViewY(const y: integer): Real;
begin
//  Result := Egg.ViewTop + y * Egg.ViewHeight / PhoenixImage.Height;
  Result := Egg.FyMin + y * Egg.FyMax / PhoenixImage.Height;
end; }
{PhoenixImagePaint
function TFractalForm.PViewToPixelX(const x: Real): integer;
begin
  Result := round((x - Egg.ViewLeft) * PhoenixImage.Width / Egg.ViewWidth);
end;
function TFractalForm.PViewToPixelY(const y: Real): integer;
begin
  Result := round((y - Egg.ViewTop) * PhoenixImage.Height / Egg.ViewHeight);
end;}
{==============================================================}
{==============================================================}


{==============================================================}
{==============================================================}

procedure TFractalForm.PageControl1Change(Sender: TObject);
var BitMap1 : TBitMap;
begin
  //if ((Sender as TPageControl).
  if (PageControl1.ActivePage = MJTabSheet) then
  begin
    If MandelImageMade then begin end else
    begin
      BitMap1 := TBitMap.Create;
      try  BitMap1.Height:=256; BitMap1.Width:=256;
        MandelImage.Canvas.Draw(0,0,BitMap1);
      finally
        BitMap1.Free;
      end;
      //Render(False,1);
      MandelImageMade:=True;
    end;
    If JuliaImageMade then begin end else
    begin
      BitMap1 := TBitMap.Create;
      try  BitMap1.Height:=256; BitMap1.Width:=256;
        JuliaImage.Canvas.Draw(0,0,BitMap1);
      finally
        BitMap1.Free;
      end;
      //Render(True,1);
      JuliaImageMade:=True;
    end;
  end else
  if (PageControl1.ActivePage = PETabSheet) then
  begin //    PhoenixImageMade:=False;       EggImageMade:=False;
    If PhoenixImageMade then begin end else
    begin
      BitMap1 := TBitMap.Create;
      try  BitMap1.Height:=256; BitMap1.Width:=256;
        PhoenixImage.Canvas.Draw(0,0,BitMap1);
      finally
        BitMap1.Free;
      end;
      PhoenixImageMade:=True;
    end;
    If EggImageMade then begin end else
    begin
      BitMap1 := TBitMap.Create;
      try  BitMap1.Height:=256; BitMap1.Width:=256;
        EggImage.Canvas.Draw(0,0,BitMap1);
      finally
        BitMap1.Free;
      end;
      //RenderPEgg(True);
      EggImageMade:=True;
    end;
  end else
  if (PageControl1.ActivePage = DTTabSheet) then
  begin  //   DragonsImageMade:=False; TeethImageMade:=False;
    If DragonsImageMade then begin end else
    begin
      BitMap1 := TBitMap.Create;
      try  BitMap1.Height:=256; BitMap1.Width:=256;
        DragonsImage.Canvas.Draw(0,0,BitMap1);
      finally
        BitMap1.Free;
      end;
      DragonsImageMade:=True;
    end;
    If TeethImageMade then begin end else
    begin
      BitMap1 := TBitMap.Create;
      try  BitMap1.Height:=256; BitMap1.Width:=256;
        TeethImage.Canvas.Draw(0,0,BitMap1);
      finally
        BitMap1.Free;
      end;
      TeethImageMade:=True;
    end;
  end else
  if (PageControl1.ActivePage = NLTabSheet) then
  begin //    NewtonImageMade:=False; LobsterImageMade:=False;
    If NewtonImageMade then begin end else
    begin
      BitMap1 := TBitMap.Create;
      try  BitMap1.Height:=256; BitMap1.Width:=256;
        NewtonImage.Canvas.Draw(0,0,BitMap1);
      finally
        BitMap1.Free;
      end;
      NewtonImageMade:=True;
    end;
    If LobsterImageMade then begin end else
    begin
      BitMap1 := TBitMap.Create;
      try  BitMap1.Height:=256; BitMap1.Width:=256;
        LobsterImage.Canvas.Draw(0,0,BitMap1);
      finally
        BitMap1.Free;
      end;
      LobsterImageMade:=True;
    end;
  end else
  if (PageControl1.ActivePage = ACTabSheet) then
  begin   //    ApollianiaImageMade:=False; CirclesImageMade:=False;
    If ApollianiaImageMade then begin end else
    begin
      BitMap1 := TBitMap.Create;
      try  BitMap1.Height:=480; BitMap1.Width:=640;
        ApollianiaImage.Canvas.Draw(0,0,BitMap1);
      finally
        BitMap1.Free;
      end;
      ApollianiaImageMade:=True;
    end;
    //    PharoahImageMade:=False;    CollarBonedImageMade:=False;
    If PharoahImageMade then begin end else
    begin
      BitMap1 := TBitMap.Create;
      try  BitMap1.Height:=480; BitMap1.Width:=640;
        PharoahImage.Canvas.Draw(0,0,BitMap1);
      finally
        BitMap1.Free;
      end;
      PharoahImageMade:=True;
    end;
  end else
//  DLATabSheet
  if (PageControl1.ActivePage = DLATabSheet) then
  begin//    DlaImageMade:=False;
    If DlaImageMade then begin end else
    begin
      BitMap1 := TBitMap.Create;
      try  BitMap1.Height:=256; BitMap1.Width:=524;
        DlaImage.Canvas.Draw(0,0,BitMap1);
      finally
        BitMap1.Free;
      end;
      DlaImageMade:=True;
    end;
  end;
end;

{==============================================================}
{==============================================================}


{==============================================================}
{==============================================================}
procedure TFractalForm.DrawGrid1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  index: integer;
begin
  index := ARow * DrawGrid1.ColCount + ACol;
  with Sender as TDrawGrid do
  begin {(ACol*ARow)}
    DrawGrid1.Canvas.Brush.Color := ColorArray[index];
      { clBackGround;}
    DrawGrid1.Canvas.FillRect(Rect);
{    DrawGrid1.Draw(Canvas,Rect.Left,Rect.Top,index);}
    if gdFocused in State then
      Canvas.DrawFocusRect(Rect);
    Canvas.Refresh;
  end;
end;

procedure TFractalForm.DrawGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var index: integer;
var RS, GS, BS: string;
begin
  index := ARow * DrawGrid1.ColCount + ACol;
  ColorDialog1.Color:=ColorArray[index];
  if ColorDialog1.Execute then
  begin
    ColorArray[index] := ColorDialog1.Color;
  {ColorArray[(ACol*ARow)]:=ColorDialog1.Color;}
              {(ACol*ARow) ... Mixes and duplicates values}
  Str(GetRValue(ColorArray[index]), RS);
  Str(GetGValue(ColorArray[index]), GS);
  Str(GetBValue(ColorArray[index]), BS);
  SelectedColorLabel.Caption :=
    '  Red: ' + RS + ', Green: ' + GS + ', Blue: ' + BS;
  ColorRGBArray[0, index]:=GetRValue(ColorArray[index]);
  ColorRGBArray[1, index]:=GetGValue(ColorArray[index]);
  ColorRGBArray[2, index]:=GetBValue(ColorArray[index]);
  end;
end;

procedure TFractalForm.ColorFilerClick(Sender: TObject);
var F_File: file of TColor;
  TempColor: TColor;
  i: Integer;
  FileS: string;
begin
  If ColorSetRG.Itemindex=0 then
  begin
  OpenDialog1.InitialDir := ProgramPath;
  FileS := Color16Edit.Text;
  OpenDialog1.FileName := FileS;
  if OpenDialog1.Execute then { Display Open dialog box }
  begin
    if (FileExists(OpenDialog1.Filename)) then begin
      AssignFile(F_File, OpenDialog1.Filename);
      Reset(F_File);
      if IoResult <> 0 then
      begin
        {DoMessages(30091)};
        Exit;
      end;
      for i := 0 to 15 do begin
        Read(F_File, TempColor);
        RGBArray[0, i] := GetRValue(TempColor);
        RGBArray[1, i] := GetGValue(TempColor);
        RGBArray[2, i] := GetBValue(TempColor);
      end;
      Color16Edit.Text := OpenDialog1.FileName;
    end else {DoMessages(30092)};
    PageControl1.ActivePage := DLATabSheet;
    PageControl1.ActivePage := ColorPicker;
  end;

  end else
  begin
  OpenDialog1.InitialDir := ProgramPath;
  FileS := ColorFileEdit.Text;
  OpenDialog1.FileName := FileS;
  if OpenDialog1.Execute then
  { Display Open dialog box }
  begin
    if (FileExists(OpenDialog1.Filename)) then
    begin
      AssignFile(F_File, OpenDialog1.Filename);
      Reset(F_File);
      if IoResult <> 0 then
        begin
        {DoMessages(30091)};
        Exit;
        end;
      for i := 0 to 255 do Read(F_File, ColorArray[i]);
      CloseFile(F_File);
  for i := 0 to 255 do
           begin
           ColorRGBArray[0, i]:=GetRValue(ColorArray[i]);
           ColorRGBArray[1, i]:=GetGValue(ColorArray[i]);
           ColorRGBArray[2, i]:=GetBValue(ColorArray[i]);
           end;      
    end else {DoMessages(30092)};
    PageControl1.ActivePage := DLATabSheet;
    PageControl1.ActivePage := ColorPicker;
  end;
  end;
end;

procedure TFractalForm.ColorSaverClick(Sender: TObject);
var F_File: file of TColor;
  i: Integer;
  FileS: string;
  Temp: TColor;
begin
  If ColorSetRG.Itemindex=0 then
  begin
  FileS := Color16Edit.Text;
  AssignFile(F_File, FileS);
  ReWrite(F_File);
  if IoResult <> 0 then
  begin
        //DoMessages(30091);
        Exit;
  end;
  for i := 0 to 15 do begin
    Temp := RGB(RGBArray[0, i], RGBArray[1, i], RGBArray[2, i]);
    Write(F_File, Temp);
  end;
  CloseFile(F_File);
  end else
  begin
  FileS := ColorFileEdit.Text;
{  If (FileExists(FileS)) THEN Begin}
  AssignFile(F_File, FileS);
  ReWrite(F_File);
  if IoResult <> 0 then
  begin
   // DoMessages(30091);
    Exit;
  end;
  for i := 0 to 255 do Write(F_File, ColorArray[i]);
  CloseFile(F_File);
  end;
end;

procedure TFractalForm.ColorClearsClick(Sender: TObject);
var i: Integer;
begin
  If ColorSetRG.Itemindex=0 then
  begin
  for i := 0 to 15 do begin
    RGBArray[0, i] := 255;
    RGBArray[1, i] := 255;
    RGBArray[2, i] := 255;
  end;
    PageControl1.ActivePage := DLATabSheet;
    PageControl1.ActivePage := ColorPicker;
  SetFocus;
  end else
  begin
  for i := 0 to 255 do ColorArray[i] := RGB(255, 255, 255);
  for i := 0 to 255 do
           begin
           ColorRGBArray[0, i]:=GetRValue(ColorArray[i]);
           ColorRGBArray[1, i]:=GetGValue(ColorArray[i]);
           ColorRGBArray[2, i]:=GetBValue(ColorArray[i]);
           end;  
  PageControl1.ActivePage := DLATabSheet;
  PageControl1.ActivePage := ColorPicker;
  SetFocus;
  end;
end;



procedure TFractalForm.ColorFillClick(Sender: TObject);
var i: Integer;
begin
  Randomize;
  If ColorSetRG.Itemindex=0 then
  begin
  for i := 0 to 15 do begin
    RGBArray[0, i] := Random(255);
    RGBArray[1, i] := Random(255);
    RGBArray[2, i] := Random(255);
  end;
    PageControl1.ActivePage := DLATabSheet;
    PageControl1.ActivePage := ColorPicker;
  SetFocus;
  end else
  begin
  for i := 0 to 255 do ColorArray[i] := Random(16000000);
  for i := 0 to 255 do
           begin
           ColorRGBArray[0, i]:=GetRValue(ColorArray[i]);
           ColorRGBArray[1, i]:=GetGValue(ColorArray[i]);
           ColorRGBArray[2, i]:=GetBValue(ColorArray[i]);
           end;
    PageControl1.ActivePage := DLATabSheet;
    PageControl1.ActivePage := ColorPicker;
  SetFocus;
  end;
end;

procedure TFractalForm.Color256SetterClick(Sender: TObject);
var i: Integer;
begin
  If ColorSetRG.Itemindex=0 then
  begin
{Win16Set.Checked ColorPicker16.Checked LandformsSet.Checked}
  if Win16Set.Checked then begin
    RGBArray[0, 0] := 0; RGBArray[1, 0] := 0; RGBArray[2, 0] := 0;
    RGBArray[0, 1] := 128; RGBArray[1, 1] := 0; RGBArray[2, 1] := 0;
    RGBArray[0, 2] := 0; RGBArray[1, 2] := 128; RGBArray[2, 2] := 0;
    RGBArray[0, 3] := 128; RGBArray[1, 3] := 128; RGBArray[2, 3] :=0;
    RGBArray[0, 4] := 0; RGBArray[1, 4] := 0; RGBArray[2, 4] := 128;
    RGBArray[0, 5] := 128; RGBArray[1, 5] := 0; RGBArray[2, 5] :=128;
    RGBArray[0, 6] := 0; RGBArray[1, 6] := 128; RGBArray[2, 6] :=128;
    RGBArray[0, 7] := 192; RGBArray[1, 7] := 192; RGBArray[2, 7] :=192;
    RGBArray[0, 8] := 128; RGBArray[1, 8] := 128; RGBArray[2, 8] :=128;
    RGBArray[0, 9] := 255; RGBArray[1, 9] := 0; RGBArray[2, 9] := 0;
    RGBArray[0, 10] := 0; RGBArray[1, 10] := 255; RGBArray[2, 10] :=0;
    RGBArray[0, 11] := 255; RGBArray[1, 11] := 255; RGBArray[2, 11]:= 0;
    RGBArray[0, 12] := 0; RGBArray[1, 12] := 0; RGBArray[2, 12] := 255;
    RGBArray[0, 13] := 255; RGBArray[1, 13] := 0; RGBArray[2, 13] := 255;
    RGBArray[0, 14] := 0; RGBArray[1, 14] := 255; RGBArray[2, 14] := 255;
    RGBArray[0, 15] := 255; RGBArray[1, 15] := 255; RGBArray[2, 15]:= 255;
  end else
    if LandformsSet.Checked then begin
      RGBArray[0, 0] := 0; RGBArray[1, 0] := 0; RGBArray[2, 0] := 128;
      RGBArray[0, 1] := 0; RGBArray[1, 1] := 0; RGBArray[2, 1] := 255;
      RGBArray[0, 2] := 0; RGBArray[1, 2] := 128; RGBArray[2, 2] :=128;
      RGBArray[0, 3] := 0; RGBArray[1, 3] := 255; RGBArray[2, 3] := 255;
      RGBArray[0, 4] := 255; RGBArray[1, 4] := 255; RGBArray[2, 4] :=0;
      RGBArray[0, 5] := 128; RGBArray[1, 5] := 128; RGBArray[2, 5] :=0;
      RGBArray[0, 6] := 0; RGBArray[1, 6] := 255; RGBArray[2, 6] := 0;
      RGBArray[0, 7] := 0; RGBArray[1, 7] := 128; RGBArray[2, 7] :=0;
      RGBArray[0, 8] := 128; RGBArray[1, 8] := 128; RGBArray[2, 8] := 128;
      RGBArray[0, 9] := 255; RGBArray[1, 9] := 0; RGBArray[2, 9] :=255;
      RGBArray[0, 10] := 128; RGBArray[1, 10] := 0; RGBArray[2, 10]:= 128;
      RGBArray[0, 11] := 192; RGBArray[1, 11] := 192; RGBArray[2, 11]:= 192;
      RGBArray[0, 12] := 255; RGBArray[1, 12] := 0; RGBArray[2, 12]:= 0;
      RGBArray[0, 13] := 128; RGBArray[1, 13] := 0; RGBArray[2, 13]:= 0;
      RGBArray[0, 14] := 255; RGBArray[1, 14] := 255; RGBArray[2, 14]:= 255;
      RGBArray[0, 15] := 0; RGBArray[1, 15] := 0; RGBArray[2, 15] := 0;
    end else
      if RGB16.Checked then begin
        RGBArray[0, 0] := 255; RGBArray[1, 0] := 0; RGBArray[2, 0] := 0;
        RGBArray[0, 1] := 225; RGBArray[1, 1] := 0; RGBArray[2, 1] := 0;
        RGBArray[0, 2] := 210; RGBArray[1, 2] := 0; RGBArray[2, 2] := 0;
        RGBArray[0, 3] := 195; RGBArray[1, 3] := 0; RGBArray[2, 3] := 0;
        RGBArray[0, 4] := 180; RGBArray[1, 4] := 0; RGBArray[2, 4] := 0;
        RGBArray[0, 5] := 0; RGBArray[1, 5] := 255; RGBArray[2, 5] := 0;
        RGBArray[0, 6] := 0; RGBArray[1, 6] := 225; RGBArray[2, 6] := 0;
        RGBArray[0, 7] := 0; RGBArray[1, 7] := 210; RGBArray[2, 7] := 0;
        RGBArray[0, 8] := 0; RGBArray[1, 8] := 195; RGBArray[2, 8] := 0;
        RGBArray[0, 9] := 0; RGBArray[1, 9] := 180; RGBArray[2, 9] := 0;
        RGBArray[0, 10] := 0; RGBArray[1, 10] := 0; RGBArray[2, 10]:= 255;
        RGBArray[0, 11] := 0; RGBArray[1, 11] := 0; RGBArray[2, 11]:= 240;
        RGBArray[0, 12] := 0; RGBArray[1, 12] := 0; RGBArray[2, 12]:= 225;
        RGBArray[0, 13] := 0; RGBArray[1, 13] := 0; RGBArray[2, 13]:= 210;
        RGBArray[0, 14] := 0; RGBArray[1, 14] := 0; RGBArray[2, 14]:= 195;
        RGBArray[0, 15] := 0; RGBArray[1, 15] := 0; RGBArray[2, 15]:= 180;
      end; {BGR would be reversed/...change R and B numbers}
    PageControl1.ActivePage := DLATabSheet;
    PageControl1.ActivePage := ColorPicker;
  SetFocus;

  end else
  begin
  case Color256S of
    1: for i := 0 to 255 do
      begin
        ColorRGBArray[0, i] := 0;
        ColorRGBArray[1, i] := 0;
        ColorRGBArray[2, i] := 255 - i;
        ColorArray[i] := RGB(ColorRGBArray[0, i],
                             ColorRGBArray[1, i],
                             ColorRGBArray[2, i]);
      end;
    2: for i := 0 to 255 do
      begin ColorRGBArray[0, i] := 0;
            ColorRGBArray[1, i] := 255 - i;
            ColorRGBArray[2, i] := 255 - i;
        ColorArray[i] := RGB(ColorRGBArray[0, i],
                             ColorRGBArray[1, i],
                             ColorRGBArray[2,i]);
      end;
    3: for i := 0 to 255 do
      begin ColorRGBArray[0, i] := 0;
            ColorRGBArray[1, i] := 255 - i;
            ColorRGBArray[2, i] := 0;
        ColorArray[i] := RGB(ColorRGBArray[0, i],
                             ColorRGBArray[1, i],
                             ColorRGBArray[2,i]);
      end;
    4: for i := 0 to 255 do
      begin ColorRGBArray[0, i] := 255 - i;
            ColorRGBArray[1, i] := 255 - i;
            ColorRGBArray[2,i] := 0;
        ColorArray[i] := RGB(ColorRGBArray[0, i],
                             ColorRGBArray[1, i],
                             ColorRGBArray[2, i]);
      end;
    5: for i := 0 to 255 do
      begin ColorRGBArray[0, i] := 255 - i;
            ColorRGBArray[1, i] := 0;
            ColorRGBArray[2, i] := 255 - i;
        ColorArray[i] := RGB(ColorRGBArray[0, i],
                             ColorRGBArray[1, i],
                             ColorRGBArray[2,i]);
      end;
    6: for i := 0 to 255 do
      begin ColorRGBArray[0, i] := 255 - i;
            ColorRGBArray[1, i] := 0;
            ColorRGBArray[2, i] :=0;
        ColorArray[i] := RGB(ColorRGBArray[0, i],
                             ColorRGBArray[1, i],
                             ColorRGBArray[2,i]);
      end;
    7: for i := 0 to 255 do
      begin ColorRGBArray[0, i] := 255 - i;
            ColorRGBArray[1, i] := 255 - i;
            ColorRGBArray[2,i] := 255 - i;
        ColorArray[i] := RGB(ColorRGBArray[0, i],
                             ColorRGBArray[1, i],
                             ColorRGBArray[2,i]);
      end;
  end; {of case}
  PageControl1.ActivePage := DLATabSheet;
  PageControl1.ActivePage := ColorPicker;
  SetFocus;
  end;
end;



procedure TFractalForm.ColorInverterClick(Sender: TObject);
var i: Integer;
Colors: array[0..2, 0..255] of Byte;
TR, TG, TB: Byte;
begin
  If ColorSetRG.Itemindex=0 then
  begin
  for i := 0 to 15 do begin
    TR := RGBArray[0, i];
    TG := RGBArray[1, i];
    TB := RGBArray[2, i];
    RGBArray[0, i] := 255 - TR;
    RGBArray[1, i] := 255 - TG;
    RGBArray[2, i] := 255 - TB;
  end;
    PageControl1.ActivePage := DLATabSheet;
    PageControl1.ActivePage := ColorPicker;
  SetFocus;
  end else
  begin
{ColorArray[0]:=RGB(Colors[0,0],Colors[1,0],Colors[2,0]);}
  if (GetRValue(ColorArray[0]) = 255) then
  begin for i := 0 to 255 do Colors[0, i] := i end
  else begin for i := 0 to 255 do Colors[0, i] := 0 end;
  if (GetGValue(ColorArray[0]) = 255) then
  begin for i := 0 to 255 do Colors[1, i] := i end
  else begin for i := 0 to 255 do Colors[1, i] := 0 end;
  if (GetBValue(ColorArray[0]) = 255) then
  begin for i := 0 to 255 do Colors[2, i] := i end
  else begin for i := 0 to 255 do Colors[2, i] := 0 end;
  for i := 0 to 255 do
    ColorArray[i] := RGB(Colors[0, i], Colors[1, i], Colors[2, i]);
  PageControl1.ActivePage := DLATabSheet;
  PageControl1.ActivePage := ColorPicker;
  SetFocus;
  end;
end;

procedure TFractalForm.ColorSubvertClick(Sender: TObject);
var Subversion: Integer;
 TempColor: Tcolor;
var i: Integer;
begin
  If ColorSetRG.Itemindex=0 then
  begin
  Subversion := Color16SubversionRG.ItemIndex;
  case Subversion of
    0: for i := 0 to 15 do
      begin TempColor := RGB(0, 0, 255 - (i * 12));
        RGBArray[0, i] := GetRValue(TempColor);
        RGBArray[1, i] := GetGValue(TempColor);
        RGBArray[2, i] := GetBValue(TempColor);
      end;
    1: for i := 0 to 15 do
      begin TempColor := RGB(0, 255 - (i * 12), 255 - (i * 12));
        RGBArray[0, i] := GetRValue(TempColor);
        RGBArray[1, i] := GetGValue(TempColor);
        RGBArray[2, i] := GetBValue(TempColor);
      end;
    2: for i := 0 to 15 do
      begin TempColor := RGB(0, 255 - (i * 12), 0);
        RGBArray[0, i] := GetRValue(TempColor);
        RGBArray[1, i] := GetGValue(TempColor);
        RGBArray[2, i] := GetBValue(TempColor);
      end;
    3: for i := 0 to 15 do
      begin TempColor := RGB(255 - (i * 12), 255 - (i * 12), 0);
        RGBArray[0, i] := GetRValue(TempColor);
        RGBArray[1, i] := GetGValue(TempColor);
        RGBArray[2, i] := GetBValue(TempColor);
      end;
    4: for i := 0 to 15 do
      begin TempColor := RGB(255 - (i * 12), 0, 255 - (i * 12));
        RGBArray[0, i] := GetRValue(TempColor);
        RGBArray[1, i] := GetGValue(TempColor);
        RGBArray[2, i] := GetBValue(TempColor);
      end;
    5: for i := 0 to 15 do
      begin TempColor := RGB(255 - (i * 12), 0, 0);
        RGBArray[0, i] := GetRValue(TempColor);
        RGBArray[1, i] := GetGValue(TempColor);
        RGBArray[2, i] := GetBValue(TempColor);
      end;
    6: for i := 0 to 15 do
      begin TempColor := RGB(255 - (i * 12), 255 - (i * 12), 255 - (i
        * 12));
        RGBArray[0, i] := GetRValue(TempColor);
        RGBArray[1, i] := GetGValue(TempColor);
        RGBArray[2, i] := GetBValue(TempColor);
      end;
  end; {Case}
    PageControl1.ActivePage := DLATabSheet;
    PageControl1.ActivePage := ColorPicker;
  SetFocus;
  end else
  begin
  for i := 0 to 15 do ColorArray[i] := RGB(0, 0, 255 - (i * 12));
  for i := 0 to 15 do
    ColorArray[i + 16] := RGB(0, 255 - (i * 12), 255 - (i * 12));
  for i := 0 to 15 do
    ColorArray[i + 32] := RGB(0, 255 - (i * 12), 0);
  for i := 0 to 15 do
    ColorArray[i + 48] := RGB(255 - (i * 12), 255 - (i * 12), 0);
  for i := 0 to 15 do
    ColorArray[i + 64] := RGB(255 - (i * 12), 0, 255 - (i * 12));
  for i := 0 to 15 do
    ColorArray[i + 80] := RGB(255 - (i * 12), 0, 0);
  for i := 0 to 15 do
    ColorArray[i + 96] := RGB(255 - (i * 12), 255 - (i * 12), 255 - (i* 12));

  for i := 0 to 15 do
    ColorArray[i + 112] := RGB(0, 0, 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 128] := RGB(0, 255 - (i * 14), 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 144] := RGB(0, 255 - (i * 14), 0);
  for i := 0 to 15 do
    ColorArray[i + 160] := RGB(255 - (i * 14), 255 - (i * 14), 0);
  for i := 0 to 15 do
    ColorArray[i + 176] := RGB(255 - (i * 14), 0, 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 192] := RGB(255 - (i * 14), 0, 0);
  for i := 0 to 15 do
    ColorArray[i + 208] := RGB(0, 255 - (i * 14), 0);
  for i := 0 to 15 do
    ColorArray[i + 224] := RGB(0, 255 - (i * 14), 255 - (i * 14));
  for i := 0 to 15 do
    ColorArray[i + 240] := RGB(255 - (i * 14), 0, 0);
  for i := 0 to 255 do
           begin
           ColorRGBArray[0, i]:=GetRValue(ColorArray[i]);
           ColorRGBArray[1, i]:=GetGValue(ColorArray[i]);
           ColorRGBArray[2, i]:=GetBValue(ColorArray[i]);
           end;

  PageControl1.ActivePage := DLATabSheet;
  PageControl1.ActivePage := ColorPicker;
  SetFocus;  
  end;
end;

procedure TFractalForm.DrawGrid2DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  index: integer;
begin
  index := ARow * DrawGrid2.ColCount + ACol;
  with Sender as TDrawGrid do
  begin {(ACol*ARow)}
    DrawGrid2.Canvas.Brush.Color :=
      RGB(RGBArray[0, index], RGBArray[1, index], RGBArray[2,
        index]);
    {ColorArray[index];}{ clBackGround;}
    DrawGrid2.Canvas.FillRect(Rect);
{    DrawGrid1.Draw(Canvas,Rect.Left,Rect.Top,index);}
    if gdFocused in State then
      Canvas.DrawFocusRect(Rect);
    Canvas.Refresh;
  end;
end;

procedure TFractalForm.DrawGrid2SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var index: integer;
var RS, GS, BS: string; TempColor: TColor;
begin
  index := ARow * DrawGrid2.ColCount + ACol;
  ColorDialog1.Color:=RGB(
    RGBArray[0, index],RGBArray[1, index],RGBArray[2, index]);
  if ColorDialog1.Execute then begin
    TempColor := ColorDialog1.Color;
    RGBArray[0, index] := GetRValue(TempColor);
    RGBArray[1, index] := GetGValue(TempColor);
    RGBArray[2, index] := GetBValue(TempColor);
  end;
  Str(GetRValue(RGBArray[0, index]), RS);
  Str(GetGValue(RGBArray[1, index]), GS);
  Str(GetBValue(RGBArray[2, index]), BS);
  Selected16ColorLabel.Caption :=
    '  Red: ' + RS + ', Green: ' + GS + ', Blue: ' + BS;
end;

(*************************************************************)
procedure TFractalForm.FalseColors;
begin
  Black1.Checked := False; { clBlack   }
  Maroon1.Checked := False; {clMaroon }
  Green1.Checked := False; {clGreen }
  OliveGreen1.Checked := False; {clOlive}
  NavyBlue1.Checked := False; {clNavy}
  Purple1.Checked := False; { clPurple }
  Teal1.Checked := False; {clTeal}
  Gray1.Checked := False; {clGray}
  Silver1.Checked := False; {clSilver}
  Red1.Checked := False; {  clRed  }
  LimeGreen1.Checked := False; {clime}
  Yellow1.Checked := False; { clYellow  }
  Blue1.Checked := False; { clBlue }
  Fuchsia1.Checked := False; {clFuchsia }
  Aqua1.Checked := False; {clAqua }
  White1.Checked := False; {  clWhite}
  if FBackGroundColor = clBlack then Black1.Checked := True else
    if FBackGroundColor = clWhite then White1.Checked := True else
      if FBackGroundColor = clAqua then Aqua1.Checked := True else
        if FBackGroundColor = clFuchsia then
          Fuchsia1.Checked := True else
          if FBackGroundColor = clBlue then
            Blue1.Checked := True else
            if FBackGroundColor = clYellow then
              Yellow1.Checked := True else
              if FBackGroundColor = clLime then
                LimeGreen1.Checked := True else
                if FBackGroundColor = clRed then
                  Red1.Checked := True else
                  if FBackGroundColor = clSilver then
                    Silver1.Checked := True else
                    if FBackGroundColor = clGray then
                      Gray1.Checked := True else
                      if FBackGroundColor = clTeal then
                        Teal1.Checked := True else
                        if FBackGroundColor = clPurple then
                          Purple1.Checked := True else
                          if FBackGroundColor = clNavy then
                            NavyBlue1.Checked := True else
                            if FBackGroundColor = clOlive then
                              OliveGreen1.Checked := True else
                              if FBackGroundColor = clGreen then
                                Green1.Checked := True else
                                if FBackGroundColor = clMaroon then
                                  Maroon1.Checked := True;
end;

procedure TFractalForm.Black1Click(Sender: TObject);
begin
  if (not Black1.Checked) then begin
    FBackGroundColor := clBlack;
    FalseColors;
  end;
end;

procedure TFractalForm.Maroon1Click(Sender: TObject);
begin
  if (not Maroon1.Checked) then begin
    FBackGroundColor := clMaroon;
    FalseColors;
  end;
end;

procedure TFractalForm.Green1Click(Sender: TObject);
begin
  if (not Green1.Checked) then begin
    FBackGroundColor := clGreen;
    FalseColors;
  end;
end;

procedure TFractalForm.OliveGreen1Click(Sender: TObject);
begin
  if (not OliveGreen1.Checked) then begin
    FBackGroundColor := clOlive;
    FalseColors;
  end;
end;

procedure TFractalForm.NavyBlue1Click(Sender: TObject);
begin
  if (not NavyBlue1.Checked) then begin
    FBackGroundColor := clNavy;
    FalseColors;
  end;
end;

procedure TFractalForm.Purple1Click(Sender: TObject);
begin
  if (not Purple1.Checked) then begin
    FBackGroundColor := clPurple;
    FalseColors;
  end;
end;

procedure TFractalForm.Teal1Click(Sender: TObject);
begin
  if (not Teal1.Checked) then begin
    FBackGroundColor := clTeal;
    FalseColors;
  end;
end;

procedure TFractalForm.Gray1Click(Sender: TObject);
begin
  if (not Gray1.Checked) then begin
    FBackGroundColor := clGray;
    FalseColors;
  end;
end;

procedure TFractalForm.Silver1Click(Sender: TObject);
begin
  if (not Silver1.Checked) then begin
    FBackGroundColor := clSilver;
    FalseColors;
  end;
end;

procedure TFractalForm.Red1Click(Sender: TObject);
begin
  if (not Red1.Checked) then begin
    FBackGroundColor := clRed;
    FalseColors;
  end;
end;

procedure TFractalForm.LimeGreen1Click(Sender: TObject);
begin
  if (not LimeGreen1.Checked) then begin
    FBackGroundColor := clLime;
    FalseColors;
  end;
end;

procedure TFractalForm.Yellow1Click(Sender: TObject);
begin
  if (not Yellow1.Checked) then begin
    FBackGroundColor := clYellow;
    FalseColors;
  end;
end;

procedure TFractalForm.Blue1Click(Sender: TObject);
begin
  if (not Blue1.Checked) then begin
    FBackGroundColor := clBlue;
    FalseColors;
  end;
end;

procedure TFractalForm.Fuchsia1Click(Sender: TObject);
begin
  if (not Fuchsia1.Checked) then begin
    FBackGroundColor := clFuchsia;
    FalseColors;
  end;
end;

procedure TFractalForm.Aqua1Click(Sender: TObject);
begin
  if (not Aqua1.Checked) then begin
    FBackGroundColor := clAqua;
    FalseColors;
  end;
end;

procedure TFractalForm.White1Click(Sender: TObject);
begin
  if (not White1.Checked) then begin
    FBackGroundColor := clWhite;
    FalseColors;
  end;
end;
(*************************************************************)
(*************************************************************)

procedure TFractalForm.Set16Colors;
var F_File: file of TColor; TempColor: TColor;
  i: Integer;
begin
  case Colorset16 of
    1: begin {Win16}
        Win16Set.Checked := True;
        RGBArray[0, 0] := 0; RGBArray[1, 0] := 0; RGBArray[2, 0] := 0;
        RGBArray[0, 1] := 128; RGBArray[1, 1] := 0; RGBArray[2, 1] := 0;
        RGBArray[0, 2] := 0; RGBArray[1, 2] := 128; RGBArray[2, 2] :=  0;
        RGBArray[0, 3] := 128; RGBArray[1, 3] := 128; RGBArray[2, 3]:= 0;
        RGBArray[0, 4] := 0; RGBArray[1, 4] := 0; RGBArray[2, 4] := 128;
        RGBArray[0, 5] := 128; RGBArray[1, 5] := 0; RGBArray[2, 5] := 128;
        RGBArray[0, 6] := 0; RGBArray[1, 6] := 128; RGBArray[2, 6] := 128;
        RGBArray[0, 7] := 192; RGBArray[1, 7] := 192; RGBArray[2, 7]:= 192;
        RGBArray[0, 8] := 128; RGBArray[1, 8] := 128; RGBArray[2, 8]:= 128;
        RGBArray[0, 9] := 255; RGBArray[1, 9] := 0; RGBArray[2, 9] := 0;
        RGBArray[0, 10] := 0; RGBArray[1, 10] := 255; RGBArray[2, 10]:= 0;
        RGBArray[0, 11] := 255; RGBArray[1, 11] := 255; RGBArray[2,11] := 0;
        RGBArray[0, 12] := 0; RGBArray[1, 12] := 0; RGBArray[2, 12] := 255;
        RGBArray[0, 13] := 255; RGBArray[1, 13] := 0; RGBArray[2, 13]:= 255;
        RGBArray[0, 14] := 0; RGBArray[1, 14] := 255; RGBArray[2, 14] := 255;
        RGBArray[0, 15] := 255; RGBArray[1, 15] := 255; RGBArray[2,15] := 255;
      end;
    2: begin {RGB}
        RGB16.Checked := True;
        RGBArray[0, 0] := 255; RGBArray[1, 0] := 0; RGBArray[2, 0] := 0;
        RGBArray[0, 1] := 225; RGBArray[1, 1] := 0; RGBArray[2, 1] := 0;
        RGBArray[0, 2] := 210; RGBArray[1, 2] := 0; RGBArray[2, 2] := 0;
        RGBArray[0, 3] := 195; RGBArray[1, 3] := 0; RGBArray[2, 3] := 0;
        RGBArray[0, 4] := 180; RGBArray[1, 4] := 0; RGBArray[2, 4] := 0;
        RGBArray[0, 5] := 0; RGBArray[1, 5] := 255; RGBArray[2, 5] := 0;
        RGBArray[0, 6] := 0; RGBArray[1, 6] := 225; RGBArray[2, 6] := 0;
        RGBArray[0, 7] := 0; RGBArray[1, 7] := 210; RGBArray[2, 7] := 0;
        RGBArray[0, 8] := 0; RGBArray[1, 8] := 195; RGBArray[2, 8] := 0;
        RGBArray[0, 9] := 0; RGBArray[1, 9] := 180; RGBArray[2, 9] := 0;
        RGBArray[0, 10] := 0; RGBArray[1, 10] := 0; RGBArray[2, 10]:= 255;
        RGBArray[0, 11] := 0; RGBArray[1, 11] := 0; RGBArray[2, 11]:= 240;
        RGBArray[0, 12] := 0; RGBArray[1, 12] := 0; RGBArray[2, 12]:= 225;
        RGBArray[0, 13] := 0; RGBArray[1, 13] := 0; RGBArray[2, 13]:= 210;
        RGBArray[0, 14] := 0; RGBArray[1, 14] := 0; RGBArray[2, 14]:= 195;
        RGBArray[0, 15] := 0; RGBArray[1, 15] := 0; RGBArray[2, 15]:= 180;
      end;
    3: begin {Landforms}
        LandformsSet.Checked := True;
        RGBArray[0, 0] := 0; RGBArray[1, 0] := 0; RGBArray[2, 0] := 128;
        RGBArray[0, 1] := 0; RGBArray[1, 1] := 0; RGBArray[2, 1] := 255;
        RGBArray[0, 2] := 0; RGBArray[1, 2] := 128; RGBArray[2, 2] := 128;
        RGBArray[0, 3] := 0; RGBArray[1, 3] := 255; RGBArray[2, 3] := 255;
        RGBArray[0, 4] := 255; RGBArray[1, 4] := 255; RGBArray[2, 4]:= 0;
        RGBArray[0, 5] := 128; RGBArray[1, 5] := 128; RGBArray[2, 5]:= 0;
        RGBArray[0, 6] := 0; RGBArray[1, 6] := 255; RGBArray[2, 6] :=  0;
        RGBArray[0, 7] := 0; RGBArray[1, 7] := 128; RGBArray[2, 7] :=  0;
        RGBArray[0, 8] := 128; RGBArray[1, 8] := 128; RGBArray[2, 8]:= 128;
        RGBArray[0, 9] := 255; RGBArray[1, 9] := 0; RGBArray[2, 9] :=  255;
        RGBArray[0, 10] := 128; RGBArray[1, 10] := 0; RGBArray[2, 10]:= 128;
        RGBArray[0, 11] := 192; RGBArray[1, 11] := 192; RGBArray[2, 11] := 192;
        RGBArray[0, 12] := 255; RGBArray[1, 12] := 0; RGBArray[2, 12] := 0;
        RGBArray[0, 13] := 128; RGBArray[1, 13] := 0; RGBArray[2, 13] := 0;
        RGBArray[0, 14] := 255; RGBArray[1, 14] := 255; RGBArray[2,14] := 255;
        RGBArray[0, 15] := 0; RGBArray[1, 15] := 0; RGBArray[2, 15] := 0;
      end;
    4: begin {Picker}
        ColorPicker16.Checked := True;
        RGBArray[0, 0] := 0; RGBArray[1, 0] := 0; RGBArray[2, 0] := 128;
        RGBArray[0, 1] := 0; RGBArray[1, 1] := 0; RGBArray[2, 1] := 255;
        RGBArray[0, 2] := 0; RGBArray[1, 2] := 128; RGBArray[2, 2] := 128;
        RGBArray[0, 3] := 0; RGBArray[1, 3] := 255; RGBArray[2, 3] := 255;
        RGBArray[0, 4] := 255; RGBArray[1, 4] := 255; RGBArray[2, 4]:= 0;
        RGBArray[0, 5] := 128; RGBArray[1, 5] := 128; RGBArray[2, 5]:= 0;
        RGBArray[0, 6] := 0; RGBArray[1, 6] := 255; RGBArray[2, 6] := 0;
        RGBArray[0, 7] := 0; RGBArray[1, 7] := 128; RGBArray[2, 7] :=  0;
        RGBArray[0, 8] := 128; RGBArray[1, 8] := 128; RGBArray[2, 8] := 128;
        RGBArray[0, 9] := 255; RGBArray[1, 9] := 0; RGBArray[2, 9] := 255;
        RGBArray[0, 10] := 128; RGBArray[1, 10] := 0; RGBArray[2, 10]:= 128;
        RGBArray[0, 11] := 192; RGBArray[1, 11] := 192; RGBArray[2,11] := 192;
        RGBArray[0, 12] := 255; RGBArray[1, 12] := 0; RGBArray[2, 12]:= 0;
        RGBArray[0, 13] := 128; RGBArray[1, 13] := 0; RGBArray[2, 13] := 0;
        RGBArray[0, 14] := 255; RGBArray[1, 14] := 255; RGBArray[2,14] := 255;
        RGBArray[0, 15] := 0; RGBArray[1, 15] := 0; RGBArray[2, 15] := 0;
      end;
    5: begin {Loader}
        Loaded16.Checked := True;
  {Load the Filename as the selected set???}
        if (FileExists(Color16FName)) then begin
          AssignFile(F_File, Color16FName);
          Reset(F_File);
          if IoResult <> 0 then
          begin
            {DoMessages(30091)};
          end;
          for i := 0 to 15 do begin
            Read(F_File, TempColor);
            RGBArray[0, i] := GetRValue(TempColor);
            RGBArray[1, i] := GetGValue(TempColor);
            RGBArray[2, i] := GetBValue(TempColor);
          end;
        end else
        begin
          Colorset16 := 3;
          False16;
          {DoMessages(30092)};
        end
      end;
  end; {of case}
end;

procedure TFractalForm.False16;
begin
  Win16Set.Checked := False;
  RGB16.Checked := False;
  LandformsSet.Checked := False;
  ColorPicker16.Checked := False;
  Loaded16.Checked := False;
  Set16Colors;
end;


procedure TFractalForm.Win16SetClick(Sender: TObject);
begin
  if (not Win16Set.Checked) then begin
    Colorset16 := 1; False16;
  end;
end;

procedure TFractalForm.RGB16Click(Sender: TObject);
begin
  if (not RGB16.Checked) then begin
    Colorset16 := 2; False16;
  end;
end;

procedure TFractalForm.LandformsSetClick(Sender: TObject);
begin
  if (not LandformsSet.Checked) then begin
    Colorset16 := 3; False16;
  end;
end;

procedure TFractalForm.ColorPicker16Click(Sender: TObject);
begin
  if (not ColorPicker16.Checked) then begin
    Colorset16 := 4; False16;
  end;
end;

procedure TFractalForm.Loaded16Click(Sender: TObject);
begin
  if (not Loaded16.Checked) then begin
    Colorset16 := 5; False16;
  end;
end;
(*************************************************************)


(*************************************************************)
procedure TFractalForm.SiliconSets;
var
  F_File: file of TColor;
  i: Integer;
begin
  case Color256S of
    1: begin
        BlueMeanie256.Checked := True;
        for i := 0 to 255 do begin
          ColorRGBArray[0, i] := 0;
          ColorRGBArray[1, i] := 0;
          ColorRGBArray[2, i] := 255 - i;
        end; end;
    2: begin
        AquaMarine256.Checked := True;
        for i := 0 to 255 do begin
          ColorRGBArray[0, i] := 0;
          ColorRGBArray[1, i] := 255 - i;
          ColorRGBArray[2, i] := 255 - i;
        end; end;
    3: begin
        GreenGoblin256.Checked := True;
        for i := 0 to 255 do begin
          ColorRGBArray[0, i] := 0;
          ColorRGBArray[1, i] := 255 - i;
          ColorRGBArray[2, i] := 0;
        end; end;
    4: begin
        YellowSnow256.Checked := True;
        for i := 0 to 255 do begin
          ColorRGBArray[0, i] := 255 - i;
          ColorRGBArray[1, i] := 255 - i;
          ColorRGBArray[2, i] := 0;
        end; end;
    5: begin
        PurpleReigns256.Checked := True;
        for i := 0 to 255 do begin
          ColorRGBArray[0, i] := 255 - i;
          ColorRGBArray[1, i] := 0;
          ColorRGBArray[2, i] := 255 - i;
        end; end;
    6: begin
        RedRanger256.Checked := True;
        for i := 0 to 255 do begin
          ColorRGBArray[0, i] := 255 - i;
          ColorRGBArray[1, i] := 0;
          ColorRGBArray[2, i] := 0;
        end; end;
    7: begin
        SmogFog256.Checked := True;
        for i := 0 to 255 do begin
          ColorRGBArray[0, i] := 255 - i;
          ColorRGBArray[1, i] := 255 - i;
          ColorRGBArray[2, i] := 255 - i;
        end; end;
    8: begin
        ColorPicker256.Checked := True;
        for i := 0 to 255 do begin
          ColorRGBArray[0, i] := GetRValue(ColorArray[i]);
          ColorRGBArray[1, i] := GetGValue(ColorArray[i]);
          ColorRGBArray[2, i] := GetBValue(ColorArray[i]);
        end;
        end;
    9: begin {Load filename set}
        if (FileExists(Color256Name)) then
        begin
          Loaded256.Checked := True;
          AssignFile(F_File, Color256Name);
          Reset(F_File);
          if IoResult <> 0 then
          begin
            {DoMessages(30091)};
          end else
          begin
            for i := 0 to 255 do Read(F_File, ColorArray[i]);
            CloseFile(F_File);
            for i := 0 to 255 do
            begin
              ColorRGBArray[0, i] := GetRValue(ColorArray[i]);
              ColorRGBArray[1, i] := GetGValue(ColorArray[i]);
              ColorRGBArray[2, i] := GetBValue(ColorArray[i]);
            end;
          end;
        end else
        begin
          Color256S := 2;
          FalseSets;
            {DoMessages(30092)};
        end;
      end;
(*
    10: begin {Load filename set}
        if (FileExists(Color256FTooName)) then begin
          LoadedToo56.Checked := True; ;
          AssignFile(F_File, Color256FTooName);
          Reset(F_File);
          if IoResult <> 0 then
          begin
            {DoMessages(30091)};
          end else begin
            for i := 0 to 255 do Read(F_File, ColorArray[i]);
            CloseFile(F_File);
            for i := 0 to 255 do begin
              ColorRGBArray[0, i] := GetRValue(ColorArray[i]);
              ColorRGBArray[1, i] := GetGValue(ColorArray[i]);
              ColorRGBArray[2, i] := GetBValue(ColorArray[i]);
            end;
          end;
        end else
          {DoMessages(30092)};
      end;
*)
  end; {of case}
  for i := 0 to 255 do
  begin
        ColorArray[i] := RGB(ColorRGBArray[0, i],
                             ColorRGBArray[1, i],
                             ColorRGBArray[2, i]);
  end;
end;

procedure TFractalForm.FalseSets;
begin
  BlueMeanie256.Checked := False;
  AquaMarine256.Checked := False;
  GreenGoblin256.Checked := False;
  YellowSnow256.Checked := False;
  PurpleReigns256.Checked := False;
  RedRanger256.Checked := False;
  SmogFog256.Checked := False;
  ColorPicker256.Checked := False;
  Loaded256.Checked := False;
  //LoadedToo56.Checked := False;
  SiliconSets;
end;

procedure TFractalForm.BlueMeanie256Click(Sender: TObject);
begin
  if (not BlueMeanie256.Checked) then begin
    Color256S := 1;
    FalseSets;
  end;
end;

procedure TFractalForm.AquaMarine256Click(Sender: TObject);
begin
  if (not AquaMarine256.Checked) then begin
    Color256S := 2;
    FalseSets;
  end;
end;

procedure TFractalForm.GreenGoblin256Click(Sender: TObject);
begin
  if (not GreenGoblin256.Checked) then begin
    Color256S := 3;
    FalseSets;
  end;
end;

procedure TFractalForm.YellowSnow256Click(Sender: TObject);
begin
  if (not YellowSnow256.Checked) then begin
    Color256S := 4;
    FalseSets;
  end;
end;

procedure TFractalForm.PurpleReigns256Click(Sender: TObject);
begin
  if (not PurpleReigns256.Checked) then begin
    Color256S := 5;
    FalseSets;
  end;
end;

procedure TFractalForm.RedRanger256Click(Sender: TObject);
begin
  if (not RedRanger256.Checked) then begin
    Color256S := 6;
    FalseSets;
  end;
end;

procedure TFractalForm.SmogFog256Click(Sender: TObject);
begin
  if (not SmogFog256.Checked) then begin
    Color256S := 7;
    FalseSets;
  end;
end;

procedure TFractalForm.ColorPicker256Click(Sender: TObject);
begin
  if (not ColorPicker256.Checked) then begin
    Color256S := 8;
    FalseSets;
  end;
end;

procedure TFractalForm.Loaded256Click(Sender: TObject);
begin
  if (not Loaded256.Checked) then begin
    Color256S := 9;
    FalseSets;
  end;
end;
(*************************************************************)
(*************************************************************)


(*************************************************************)
(*************************************************************)
procedure TFractalForm.DragonsITEditChange(Sender: TObject);
var
  i: Longint;
begin                // or (i>255)
    i := StrToInt(DragonsITEdit.Text);
    if (i<10) then exit;
    If i <> frcDragon.MaxIterations then
    begin
    frcDragon.MaxIterations:= StrToInt(DragonsITEdit.Text);
    DragonsITEdit.Text:=Inttostr(frcDragon.MaxIterations);
    DtRender(False,1);
    end;
    i := StrToInt(DTeethITEdit.Text);
    if (i<10) then exit;
    If i <> frcTeeth.MaxIterations then
    begin
    frcTeeth.MaxIterations := StrToInt(DTeethITEdit.Text);
    DTeethITEdit.Text:=Inttostr(frcTeeth.MaxIterations);
    DtRender(True,1);
    end;
end;

procedure TFractalForm.DtCxChange(Sender: TObject);
//var  i: Integer;  r: Real;
begin
   //Val((Sender as TEdit).Text, r, i);
    if Sender = DtCx then frcDragon.FHQ:= StrTofloat(DtCx.Text) else
    if Sender = DtCy then frcDragon.FVP:= StrTofloat(DtCy.Text) else
    if Sender = DttCx then frcTeeth.FHQ:= StrTofloat(DttCx.Text) else
    if Sender = DttCy then frcTeeth.FVP:= StrTofloat(DttCy.Text);
end;
procedure TFractalForm.DragonsImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  rx, ry: real;
  z: real;
begin
  if Shift = [ssLeft, ssCtrl] then
  begin
    DtRender(False,1);
      If MouseLocatorXChecked then
      DrawDragonCross(X, (y));
    exit;
  end;
  if Shift = [ssLeft, ssShift] then
    z := 0.5
  else
  if Shift = [ssRight, ssShift] then
    z := -1.0
  else
  begin
      DragonsImageMouseMove(Sender, Shift, X, Y);
    exit;
  end;
  {If shifted then Zoom else pass to the Teeth}
  //f := (Sender as TFractal);
  rx := frcDragon.FxMin + (x * frcDragon.FxMax  / 256);
  ry := frcDragon.FyMin  + ((256-y) * frcDragon.FyMax / 256);
  frcDragon.FxMin  := frcDragon.FxMin + z * (rx - frcDragon.FxMin);
  frcDragon.FxMax := frcDragon.FxMax * (1 - z);
  frcDragon.FyMin   := frcDragon.FyMin  + z * (ry - frcDragon.FyMin);
  frcDragon.FyMax := frcDragon.FyMax * (1 - z);
  DtRender(False,1);
end;

procedure TFractalForm.TeethImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  rx, ry: real;
  z: real;
begin
  if Shift = [ssLeft, ssShift] then
    z := 0.5
  else
  if Shift = [ssRight, ssShift] then
    z := -1.0
  else
  begin
     // DragonsImageMouseMove(Sender, Shift, X, Y);
    exit;
  end;
  {If shifted then Zoom else ignore.. this IS Teeth}
  rx := frcTeeth.FxMin + (x * frcTeeth.FxMax  / 256);
  ry := frcTeeth.FyMin  + ((256-y) * frcTeeth.FyMax / 256);
  frcTeeth.FxMin  := frcTeeth.FxMin + z * (rx - frcTeeth.FxMin);
  frcTeeth.FxMax := frcTeeth.FxMax * (1 - z);
  frcTeeth.FyMin   := frcTeeth.FyMin  + z * (ry - frcTeeth.FyMin);
  frcTeeth.FyMax := frcTeeth.FyMax * (1 - z);
  DtRender(True,1);
end;

procedure TFractalForm.DragonsImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var rx, ry: real;
begin   //First time to Show
  If (not DtBitmapDisplayed) then DtRender(False,1);
  if Shift = [ssLeft] then
  begin
    rx :=
        frcDragon.FxMin +
        (x * frcDragon.FxMax
        / 256);
    ry :=
        frcDragon.FyMin  +
        ((256-y) * frcDragon.FyMax
        / 256);
    {frcDragon}frcTeeth.FHQ := rx; //frcJulia
    {frcDragon}frcTeeth.FVP := ry;  //frcJulia
    dttCx.Text := Format('%1.8f', [rx]); //frcDragon  frcTeeth
    dttCy.Text := Format('%1.8f', [ry]);
   DtRender(True,1);
   // frcMandel32.Invalidate;
   If MouseLocatorXChecked then DrawDragonCross(X, (y));
  end;
end;

procedure TFractalForm.DrawDragonCross(x,y: integer);
{var  x,y: integer;}
begin    {Lineto does NOT draw Last point of line}
  DragonsImage.Canvas.Pen.Color := clWhite;
 // x := PViewToPixelX(Egg.Cx);        PhoenixImage.Height-
  //y := PhoenixImage.Height-PViewToPixelY(Egg.Cy);
  DragonsImage.Canvas.MoveTo(x - 3, (y) - 3);
  DragonsImage.Canvas.LineTo(x + 4, (y) + 4);
  DragonsImage.Canvas.MoveTo(x - 3, (y) + 3);
  DragonsImage.Canvas.LineTo(x + 4, (y) - 4);
end;

procedure TFractalForm.DtRender(IsTeeth:Boolean;Switch:Integer);
var
  ColorSet3:ColorSet;
  Code, i, SetSelection, Pixelx, Start_Col,
   XCount, YCount, TempMan,
    maxcolx, maxrowy, FMcolor, rowy, colx: integer;
  cos_theta, sin_theta, theta,
    Xi, Yi, Xisquare, Xitemp, deltaXi,
    Xtemp, YTemp, Temp, X, Y, Xsquare, Ysquare, deltaX, deltaY,
    FHQ, FVP,     temp_sq, temp_xy,
    max_size, deltaP, deltaQ: Extended;
  Bitmap: TBitmap;
  PixelLine: PByteArray;
  Q: array[0..3072] of Extended;
begin
  If BusyPullingTeeth then exit else
  BusyPullingTeeth:=True;
  Bitmap:= TBitmap.create;
  Try
  Bitmap.Width := 256;
  Bitmap.Height := 256;
  Bitmap.PixelFormat :=pf24bit;
  Start_Col := 0;
  If Switch >1 then SetLength(ManMatrix, 256, 256);
  PixelLine := Bitmap.ScanLine[0];//Just to shut up compiler Warning
  if IsTeeth then
  begin
      FVP := frcTeeth.FVP;        //frcDragon  frcTeeth
      FHQ := frcTeeth.FHQ;       // P := FVP;  Q := FHQ;
      max_size := 4.0;            // Cx Cy
      maxcolx := (DragonsImage.Width - 1); {x := 0 to 639}
      maxrowy := (DragonsImage.Height - 1);
        {P} deltaX := (frcTeeth.FXMax - frcTeeth.FXMin) / maxcolx;
        {Q} deltaY := (frcTeeth.FYMax - frcTeeth.FYMin) / maxrowy;
      for colx := start_col to maxcolx do begin
        ProgressBar1.Position :=
        Round((colx / (DragonsImage.Width - 1)) * 100);
        Application.ProcessMessages;
        for rowy := 0 to maxrowy do begin
          If Switch =1 then
          PixelLine := Bitmap.ScanLine[rowy];
          X := frcTeeth.FXMin + colx * deltaX;
          Y := frcTeeth.FYMax - rowy * deltaY;
          Xsquare := 0;
          Ysquare := 0;
          FMcolor := 0;

          while (FMcolor < frcTeeth.MaxIterations) and
            ((Xsquare + Ysquare) < max_size) do
          begin
{    YTemp :=2*X*Y;
     Xsquare := X*X;
     Ysquare := Y*Y;
     Y :=  YTemp + Q;
     X := Xsquare - Ysquare + P;}
            Xsquare := X * X;
            Ysquare := Y * Y;
            temp_sq := Ysquare - Xsquare;
            temp_xy := X * Y;
            temp_xy := temp_xy + temp_xy;
            Ytemp := FHQ * (temp_sq + X) - FVP * (temp_xy - Y);
            X := FVP * (temp_sq + X) + FHQ * (temp_xy - Y);
            Y := Ytemp;
            inc(FMcolor);
          end;
begin
        //Changed so the Clip cuts can be done to Mandelbrot Too
        //if JIsJulia then begin  end  else {ManMatrix[x, y] := j;};
        If JuliaLevel.Checked then
        begin
          If FMcolor < 0 then FMcolor:=0 else
          If FMcolor < JuliaClip then FMcolor:=JuliaClip;
        end;
        {Invert so Mass is lake}
        If JuliaLake.Checked then
        begin
          If FMcolor > JuliaClip then FMcolor:=FMcolor-JuliaClip;
          If FMcolor < 0 then FMcolor:=0;
        end;
        If JuliaDivisor.Checked then FMcolor:= FMcolor div JuliaClip;
          If Switch =1 then
          begin
              Pixelx := (colx *3);
              If FPColorRG.ItemIndex=4 then
              begin   {San Marcos Colors}
                if (FMcolor < (frcTeeth.MaxIterations)) then FMcolor := 0
                else
                FMcolor := (Round((Xsquare + Ysquare) * 100) mod 6) + 1;
                if (rowy < (DragonsImage.Height div 2)) then FMcolor := FMcolor + 8;
              end;
              ColorSet3:= GetColor(FMcolor);
                PixelLine[Pixelx] := ColorSet3[0];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[2];
          end else
          ManMatrix[colx, rowy] := FMcolor;

end;
        end; { of row }
       {FVP := P; FHQ := Q;} {	P := P + deltaP;}
      end; { of col }
  end else // Double Dragon
  begin
    max_size := 4.0;
    maxcolx := (DragonsImage.Width - 1); {x := 0 to 639}
    maxrowy := (DragonsImage.Height - 1);
    deltaP := (frcDragon.FXMax - frcDragon.FXMin) / maxcolx;
    deltaQ := (frcDragon.FYMax - frcDragon.FYMin) / maxrowy;
    Q[0] := frcDragon.FYMax;
    for rowy := 1 to maxrowy do Q[rowy] := Q[rowy - 1] - deltaQ;
    FVP := (frcDragon.FXMin + (start_col * deltaP));
    for colx := start_col to maxcolx do begin
      ProgressBar1.Position :=
      Round((colx / (DragonsImage.Width - 1))* 100);
      Application.ProcessMessages;
      for rowy := 0 to maxrowy do begin
        If Switch =1 then
        PixelLine := Bitmap.ScanLine[rowy];
        X := 0.5;
        Y := 0.0;
    {Xsquare := 0;
    Ysquare := 0;}
        FMcolor := 1;
         //PhoenixMaxIterations,    EggMaxIterations:Integer;
        while ((FMcolor < frcDragon.MaxIterations) and
          ((X * X + Y * Y) {(Xsquare + Ysquare)} < max_size)) do
        begin
{                                	Xsquare := X*X;
     Ysquare := Y*Y;
     Y:= 2*X*Y + Q[rowy];
     X := Xsquare - Ysquare + P;
     inc(FMcolor);}
          Xtemp := (Y - X) * (Y + X) + X;
          Ytemp := X * Y;
          Ytemp := Ytemp + Ytemp - Y;
          X := FVP * Xtemp + Q[rowy] * Ytemp;
          Y := Q[rowy] * Xtemp - FVP * Ytemp;
          inc(FMcolor);
        end;

//        if Color_Option = 0 then
begin
        //Changed so the Clip cuts can be done to Mandelbrot Too
        //if JIsJulia then begin  end  else {ManMatrix[x, y] := j;};
        If JuliaLevel.Checked then
        begin
          If FMcolor < 0 then FMcolor:=0 else
          If FMcolor < JuliaClip then FMcolor:=JuliaClip;
        end;
        {Invert so Mass is lake}
        If JuliaLake.Checked then
        begin
          If FMcolor > JuliaClip then FMcolor:=FMcolor-JuliaClip;
          If FMcolor < 0 then FMcolor:=0;
        end;
        If JuliaDivisor.Checked then FMcolor:= FMcolor div JuliaClip;
          If Switch =1 then
          begin
              Pixelx := (colx *3);
              ColorSet3:= GetColor(FMcolor);
                PixelLine[Pixelx] := ColorSet3[0];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[2];
          end else
          ManMatrix[colx, rowy] := FMcolor;
end;
      end; { of row }
      FVP := FVP + deltaP;
    end; { of col }
  end;
  //IF Dem or DemSave then Process ManMatrix
  If Switch >1 then
  begin
  MaximumElevation := -2147483647;
  MinimumElevation := 2147483646;
  maxcolx:=  255;
  maxrowy := 255;
  for Ycount := 0 to maxrowy do
  begin
    PixelLine := Bitmap.ScanLine[Ycount];
    ProgressBar1.Position := Round((Ycount / maxrowy) * 100);
    Application.ProcessMessages;
    for Xcount := 0 to maxcolx do
    begin
      TempMan:=ManMatrix[Xcount, 255-Ycount];
      if (MaximumElevation <= TempMan) then
      MaximumElevation := TempMan;
      if (MinimumElevation >= TempMan) then
      MinimumElevation := TempMan;
              Pixelx := (Xcount *3);
              ColorSet3:= GetColor(TempMan);
                PixelLine[Pixelx] := ColorSet3[0];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[2];
    end;
  end;
  ProgressBar1.Position :=0;
  Application.ProcessMessages;
  end;
If Switch =1 then
begin
  if IsTeeth then
  begin
    TeethImage.Picture.Bitmap.Assign(Bitmap);
    TeethImage.canvas.draw(0, 0, Bitmap);

  end else
  begin
    DragonsImage.Picture.Bitmap.Assign(Bitmap);
    DragonsImage.canvas.draw(0, 0, Bitmap);
    DtBitmapDisplayed:=True;
  end;
end else
If Switch =2 then
begin
dtmGlForm.Image1.Picture.Assign(Bitmap);
dtmGlForm.Image2.Picture.Assign(Bitmap);
dtmGlForm.FormShowDown(MandelImage.Width,MandelImage.Height);
dtmGlForm.show;
end else
If Switch =3 then
begin
AllDemSaver;
end;
   FXMaxLabel.Caption := Format('%1.8f', [frcDragon.FXMax]);//Egg.FXMax
   FXMinLabel.Caption := Format('%1.8f', [frcDragon.FXMin]);//Egg.FXMin
   FYMaxLabel.Caption := Format('%1.8f', [frcDragon.FYMax]);//Egg.FYMax
   FYMinLabel.Caption := Format('%1.8f', [frcDragon.FYMin]);//Egg.FYMin
   ViewWidthLabel.Caption := Format('%1.8f', [frcDragon.FXMax]);//Egg.ViewWidth-
   ViewLeftLabel.Caption := Format('%1.8f', [frcDragon.FYMin]);//Egg.ViewLeft
   ViewHeightLabel.Caption := Format('%1.8f', [frcDragon.FYMax]);//Egg.ViewHeight-
   ViewTopLabel.Caption := Format('%1.8f', [frcDragon.FXMin]);//Egg.ViewTop
   FHQLabel.Caption := Format('%1.8f', [frcDragon.FHQ]);//Egg.FHQ
   FVPLabel.Caption := Format('%1.8f', [frcDragon.FVP]);//Egg.FVP
   CxLabel.Caption := Format('%1.8f', [frcDragon.FHQ]);//Egg.Cx
   CyLabel.Caption := Format('%1.8f', [frcDragon.FVP]);//Egg.Cy
  ProgressBar1.Position :=0;
  BusyPullingTeeth:=False;
  Finally
    Bitmap.free;
  end;
end;



procedure TFractalForm.DragonsTDisplayBtnClick(Sender: TObject);
begin
  DtRender(True,2);
end;
procedure TFractalForm.DragonsDisplayBtnClick(Sender: TObject);
begin
  DtRender(False,2);
end;

procedure TFractalForm.DragonsSaveBtnClick(Sender: TObject);
begin
  DtRender(False,3);
end;
procedure TFractalForm.DragonsTSaveBtnClick(Sender: TObject);
begin
  DtRender(True,3);
end;

(*************************************************************)
(*************************************************************)


(*************************************************************)
(*************************************************************)
procedure TFractalForm.NewtonImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  rx, ry: real;
  z: real;
begin
  if Shift = [ssLeft, ssShift] then
    z := 0.5
  else
  if Shift = [ssRight, ssShift] then
    z := -1.0
  else
  begin
      NewtonImageMouseMove(Sender, Shift, X, Y);
    exit;
  end;
  {If shifted then Zoom else pass to the egg}
  //f := (Sender as TFractal);  FXMax FYMax   FXMin FYMin
  rx := frcNewton.FXMin + (x * frcNewton.FXMax  / NewtonImage.Width);
  ry := frcNewton.FYMin  + ((NewtonImage.Height-y) * frcNewton.FYMax / NewtonImage.Height);
  frcNewton.FXMin  := frcNewton.FXMin + z * (rx - frcNewton.FXMin);
  frcNewton.FXMax := frcNewton.FXMax * (1 - z);
  frcNewton.FYMin   := frcNewton.FYMin  + z * (ry - frcNewton.FYMin);
  frcNewton.FYMax := frcNewton.FYMax * (1 - z);
  NewtonRender(False,1);
end;

procedure TFractalForm.NewtonImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var rx, ry: real;
begin   //First time to Show   LobsterBitmapDisplayed NewtonBitmapDisplayed
  If (not NewtonBitmapDisplayed) then NewtonRender(False,1);
  if Shift = [ssLeft] then
  begin
    rx :=
        frcNewton.FXMin{ViewLeft} +
        (x * frcNewton.FXMax{ViewWidth}
        / NewtonImage.Width);   //all image the same size...
    ry :=
        frcNewton.FYMin{ViewTop}  +
        ((NewtonImage.Height-y) * frcNewton.FYMax{ViewHeight}
        / NewtonImage.Height);
    frcNewton.FHQ := rx; //frcJulia
    frcNewton.FVP := ry;  //frcJulia
    ntCx.Text := Format('%1.8f', [rx]);
    ntCy.Text := Format('%1.8f', [ry]);
   NewtonRender(false,1);
   // frcMandel32.Invalidate;
  end;
end;     //frcNewton.  frcLobster

procedure TFractalForm.NewtonRender(IsLobster:Boolean;Switch:Integer);
var
  Code, i, SetSelection, Pixelx, Start_Col,flag,
  XCount, YCount, TempMan,
    maxcolx, maxrowy, FMcolor, rowy, colx: integer;
  cos_theta, sin_theta, theta, temp1, temp2, temp3,
    Xi, Yi, Xisquare, Xitemp, deltaXi,
    Xtemp, YTemp, Temp, X, Y, Xsquare, Ysquare, deltaX, deltaY,
    FHQ, FVP,     temp_sq, temp_xy, Xnew,Ynew,
    Xold, Yold, denom,
    max_size, deltaP, deltaQ: Extended;
  ColorSet3:ColorSet;
  Bitmap: TBitmap;
  PixelLine: PByteArray;
  Q: array[0..3072] of Extended;
begin
  If BusyNewtLobster then exit else
  BusyNewtLobster:=True;
  Bitmap:= TBitmap.create;
  Try
  Bitmap.Width := NewtonImage.Width;
  Bitmap.Height := NewtonImage.Height;
  Bitmap.PixelFormat :=pf24bit;
  Start_Col := 0;                //NewtonImage.Height  NewtonImage.Width
  If Switch >1 then SetLength(ManMatrix, 256, 256);
  PixelLine := Bitmap.ScanLine[0];//Just to shut up compiler Warning
  if IsLobster then//Lobster
  begin
    max_size := 4.0;
    maxcolx := (NewtonImage.Width - 1); {x := 0 to 639}
    maxrowy := (NewtonImage.Height - 1);
{Newt1	deltaX := (XMax - XMin)/(maxcol);
 deltaY := (YMax - YMin)/(maxrow);}
    deltaX := (frcLobster.FXMax - frcLobster.FXMin) / maxcolx;
    deltaY := (frcLobster.FYMax - frcLobster.FYMin) / maxrowy;
{old this		Q[0] := FYMax;
  for rowy:=1 to maxrowy do Q[rowy] := Q[rowy-1] - deltaQ;
  P := (FXMin + (start_col * deltaP));}
    for colx := start_col to maxcolx do begin

      ProgressBar1.Position :=
      Round((colx / (maxcolx))* 100);
      Application.ProcessMessages;
      for rowy := 0 to maxrowy do begin
        If Switch =1 then
        PixelLine := Bitmap.ScanLine[rowy];
        X := frcLobster.FXMin + colx * deltaX;
        Y := frcLobster.FYMax - rowy * deltaY;
        Xold := 42;
        Yold := 42;
        FMcolor := 0;
        flag := 0;
        while (FMcolor <= frcLobster.MaxIterations) and (flag = 0) do
        begin
          Xsquare := X * X;
          Ysquare := Y * Y;
          denom := 3 * ((Xsquare - Ysquare) * (Xsquare -
            Ysquare) + 4 * Xsquare * Ysquare);
          if denom = 0 then
            denom := 0.00000001;
          X := 0.6666667 * X + (Xsquare - Ysquare) / denom;

          Y := 0.6666667 * Y - 2 * X * Y / denom;
          if (Xold = X) and (Yold = Y) then
            flag := 1;
          Xold := X;
          Yold := Y;
          inc(FMcolor);
        end;
begin
        //Changed so the Clip cuts can be done to Mandelbrot Too
        //if JIsJulia then begin  end  else {ManMatrix[x, y] := j;};
        If JuliaLevel.Checked then
        begin
          If FMcolor < 0 then FMcolor:=0 else
          If FMcolor < JuliaClip then FMcolor:=JuliaClip;
        end;
        {Invert so Mass is lake}
        If JuliaLake.Checked then
        begin
          If FMcolor > JuliaClip then FMcolor:=FMcolor-JuliaClip;
          If FMcolor < 0 then FMcolor:=0;
        end;
        If JuliaDivisor.Checked then FMcolor:= FMcolor div JuliaClip;
          If Switch =1 then
          begin
{              Pixelx := (x *3);
              ColorSet3:= GetColor(j);
                PixelLine[Pixelx] := ColorSet3[0];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[2];}

             // Pixelx := (colx *3);
        if FPColorRG.Itemindex = 0 then
        begin
               {Actual 16 color selection}{FMcolor mod 255;}
          if x > 0 then begin
            Pixelx := (colx * 3);
            PixelLine[Pixelx] := ((FMcolor mod 16) * 15);
              {RGBArray[2, FMcolor mod 5];}
            PixelLine[(Pixelx + 1)] := 0;
              {RGBArray[1, FMcolor mod 5];}
            PixelLine[(Pixelx + 2)] := 0;
              {RGBArray[0, FMcolor mod 5];}
          end
          else begin
            if ((x < -0.3) and (y > 0)) then begin
              Pixelx := (colx * 3);
              PixelLine[Pixelx] := 0;
                {RGBArray[2, ((FMcolor mod 5)+5)];}
              PixelLine[(Pixelx + 1)] := 0;
                {RGBArray[1, ((FMcolor mod 5)+5)];}
              PixelLine[(Pixelx + 2)] := ((FMcolor mod 16) * 15);
                {RGBArray[0, ((FMcolor mod 5)+5)];}
            end
            else begin
              Pixelx := (colx * 3);
              PixelLine[Pixelx] := 0;
                { RGBArray[2, ((FMcolor mod 6)+10)];}
              PixelLine[(Pixelx + 1)] := ((FMcolor mod 16) * 15);
                {RGBArray[1, ((FMcolor mod 6)+10)];}
              PixelLine[(Pixelx + 2)] := 0;
                {RGBArray[0, ((FMcolor mod 6)+10)];}
            end
          end; end
        else if FPColorRG.Itemindex = 1 then
        begin
{Actual 256 color selection}
          Pixelx := (colx * 3);
          PixelLine[Pixelx] := ColorRGBArray[0, FMcolor mod 255];
          PixelLine[(Pixelx + 1)] := ColorRGBArray[1, FMcolor mod 255];
          PixelLine[(Pixelx + 2)] := ColorRGBArray[2, FMcolor mod 255];
        end
        else if FPColorRG.Itemindex = 2 then
        begin {Actual Rotating color selection}
          if FMcolor mod 2 = 0 then
          begin
            Pixelx := (colx * 3);
            PixelLine[Pixelx] := ColorRGBArray[0, FMcolor mod 256];
            PixelLine[(Pixelx + 1)] := ColorRGBArray[1, FMcolor mod 256];
            PixelLine[(Pixelx + 2)] := ColorRGBArray[2, FMcolor mod 256];
          end
          else begin
            Pixelx := (colx * 3);
            PixelLine[Pixelx] := RGBArray[0, FMcolor mod 16];
            PixelLine[(Pixelx + 1)] := RGBArray[1, FMcolor mod 16];
            PixelLine[(Pixelx + 2)] := RGBArray[2, FMcolor mod 16];
          end; end
        else if FPColorRG.Itemindex = 3 then
        begin
          if X = 0 then
            FMcolor := 2
          else
          begin
            cos_theta := abs(X) / (sqrt(X * X + Y * Y));
            sin_theta := abs(Y) / (sqrt(X * X + Y * Y));
            theta := arctan(sin_theta / cos_theta);
            if (X < 0) and (Y >= 0) then
              theta := theta + 1.5707963
            else if (X < 0) and (Y < 0) then
              theta := theta + 3.14159625
            else if (X > 0) and (Y < 0) then
              theta := theta + 4.7123889;
            if (theta >= 0) and (theta <= 3.14159625) then
              FMcolor := 2
            else
              FMcolor := 1;
          end;
          if (FMcolor = 1) then begin
            Pixelx := (colx * 3);
            PixelLine[Pixelx] := GetRValue(FBackGroundColor);
            PixelLine[(Pixelx + 1)] := GetGValue(FBackGroundColor);
            PixelLine[(Pixelx + 2)] := GetBValue(FBackGroundColor);
          end else if (FMcolor = 2) then begin
            Pixelx := (colx * 3);
            PixelLine[Pixelx] := ColorRGBArray[0, 0];
            PixelLine[(Pixelx + 1)] := ColorRGBArray[1, 0];
            PixelLine[(Pixelx + 2)] := ColorRGBArray[2, 0];
          end
        end;
          end else
          ManMatrix[colx,rowy] := FMcolor;

end;
        end; { of row }
      end; { of col }
  end else
  begin   // NEWTON
    max_size := 4.0;       //NewtonImage.Height  NewtonImage.Width
    maxcolx := (NewtonImage.Width-1); {x := 0 to 639}
    maxrowy := (NewtonImage.Height-1);
{Newt1	deltaX := (XMax - XMin)/(maxcol);
 deltaY := (YMax - YMin)/(maxrow);}
    deltaX := (frcNewton.FXMax - frcNewton.FXMin) / maxcolx;
    deltaY := (frcNewton.FYMax - frcNewton.FYMin) / maxrowy;
{old this		Q[0] := FYMax;
  for rowy:=1 to maxrowy do Q[rowy] := Q[rowy-1] - deltaQ;
  P := (FXMin + (start_col * deltaP));}
    for colx := {start_col}0 to maxcolx do
    begin
      ProgressBar1.Position :=
      Round((colx / (maxcolx)) * 100);
      Application.ProcessMessages;
      for rowy := 0 to maxrowy do
      begin
        If Switch =1 then
        PixelLine := Bitmap.ScanLine[rowy];
        X := frcNewton.FXMin + colx * deltaX;
        Y := frcNewton.FYMax - rowy * deltaY;
{			Xsquare := 0;
   Ysquare := 0;}
        Xold := 42;
        Yold := 42;
        FMcolor := 0;
        flag := 0;
        while (FMcolor <= frcNewton.MaxIterations) and (flag = 0) do
        begin
          Xsquare := X * X;
          Ysquare := Y * Y;
          denom := (3 * Xsquare - 3 * Ysquare - 2);
          denom := denom * denom + 36 * Xsquare * Ysquare;
          if denom = 0 then
            denom := 0.00000001;
          temp1 := X * Xsquare - 3 * X * Ysquare - 2 * X - 5;
          temp2 := 3 * Xsquare - 3 * Ysquare - 2;
          temp3 := 3 * Xsquare * Y - Ysquare * Y - 2 * Y;
          X := X - (temp1 * temp2 - 6 * X * Y * temp3) / denom;
          Y := Y - (temp1 * (-6 * X * Y) + temp3 * temp2)
            / denom;
          Xnew := X;
          Ynew := Y;
          if (Xold = Xnew) and (Yold = Ynew) then
            flag := 1;
          Xold := X;
          Yold := Y;
          inc(FMcolor);
        end;
begin
        //Changed so the Clip cuts can be done to Mandelbrot Too
        //if JIsJulia then begin  end  else {ManMatrix[x, y] := j;};
        If JuliaLevel.Checked then
        begin
          If FMcolor < 0 then FMcolor:=0 else
          If FMcolor < JuliaClip then FMcolor:=JuliaClip;
        end;
        {Invert so Mass is lake}
        If JuliaLake.Checked then
        begin
          If FMcolor > JuliaClip then FMcolor:=FMcolor-JuliaClip;
          If FMcolor < 0 then FMcolor:=0;
        end;
        If JuliaDivisor.Checked then FMcolor:= FMcolor div JuliaClip;
          If Switch =1 then
          begin

        if FPColorRG.Itemindex = 0 then
        begin
 {Actual 16 color selection}
          if x > 0 then begin
            Pixelx := (colx * 3);
            PixelLine[Pixelx] := ((FMcolor mod 16) * 16);
              {RGBArray[0, FMcolor mod 5];}
            PixelLine[(Pixelx + 1)] := 0;
              {RGBArray[1, FMcolor mod 5];}
            PixelLine[(Pixelx + 2)] := 0;
              {RGBArray[2, FMcolor mod 5];}
          end
          else begin
            if ((x < -0.3) and (y > 0)) then begin
              Pixelx := (colx * 3);
              PixelLine[Pixelx] := 0;
                {RGBArray[0, ((FMcolor mod 5)+5)];}
              PixelLine[(Pixelx + 1)] := 0;
                {RGBArray[1, ((FMcolor mod 5)+5)];}
              PixelLine[(Pixelx + 2)] := ((FMcolor mod 16) * 16);
                { RGBArray[2, ((FMcolor mod 5)+5)];}
            end
            else begin
              Pixelx := (colx * 3);
              PixelLine[Pixelx] := 0;
                { RGBArray[0, ((FMcolor mod 6)+10)];}
              PixelLine[(Pixelx + 1)] := ((FMcolor mod 16) * 16);
                { RGBArray[1, ((FMcolor mod 6)+10)];}
              PixelLine[(Pixelx + 2)] := 0;
                { RGBArray[2, ((FMcolor mod 6)+10)];}
            end
          end; end
        else if FPColorRG.Itemindex = 1 then
        begin
 {Actual 16 color selection}
          if x > 0 then begin
            Pixelx := (colx * 3);
            PixelLine[Pixelx] := ColorRGBArray[0, FMcolor mod 8];
            PixelLine[(Pixelx + 1)] := ColorRGBArray[1, FMcolor mod 8];
            PixelLine[(Pixelx + 2)] := ColorRGBArray[2, FMcolor mod 8];
          end
          else begin
            if ((x < -0.3) and (y > 0)) then begin
              Pixelx := (colx * 3);
              PixelLine[Pixelx] := ColorRGBArray[0, ((FMcolor mod 8) + 15)];
              PixelLine[(Pixelx + 1)] := ColorRGBArray[1, ((FMcolor mod 8) +
                15)];
              PixelLine[(Pixelx + 2)] := ColorRGBArray[2, ((FMcolor mod 8) +
                15)];
            end
            else begin
              Pixelx := (colx * 3);
              PixelLine[Pixelx] := ColorRGBArray[0, ((FMcolor mod 8) + 32)];
              PixelLine[(Pixelx + 1)] := ColorRGBArray[1, ((FMcolor mod 8) +
                32)];
              PixelLine[(Pixelx + 2)] := ColorRGBArray[2, ((FMcolor mod 8) +
                32)];
            end
          end; end
        else if FPColorRG.Itemindex = 2 then
        begin {Actual Rotating color selection}
          if FMcolor mod 2 = 0 then
          begin
            Pixelx := (colx * 3);
            PixelLine[Pixelx] := ColorRGBArray[0, FMcolor mod 256];
            PixelLine[(Pixelx + 1)] := ColorRGBArray[1, FMcolor mod 256];
            PixelLine[(Pixelx + 2)] := ColorRGBArray[2, FMcolor mod 256];
          end
          else begin
            Pixelx := (colx * 3);
            PixelLine[Pixelx] := RGBArray[0, FMcolor mod 16];
            PixelLine[(Pixelx + 1)] := RGBArray[1, FMcolor mod 16];
            PixelLine[(Pixelx + 2)] := RGBArray[2, FMcolor mod 16];
          end; end
        else if FPColorRG.Itemindex = 3 then
        begin
          if X = 0 then
            FMcolor := 2
          else
          begin
            cos_theta := abs(X) / (sqrt(X * X + Y * Y));
            sin_theta := abs(Y) / (sqrt(X * X + Y * Y));
            theta := arctan(sin_theta / cos_theta);
            if (X < 0) and (Y >= 0) then
              theta := theta + 1.5707963
            else if (X < 0) and (Y < 0) then
              theta := theta + 3.14159625
            else if (X > 0) and (Y < 0) then
              theta := theta + 4.7123889;
            if (theta >= 0) and (theta <= 3.14159625) then
              FMcolor := 2
            else
              FMcolor := 1;
          end;
          if (FMcolor = 1) then begin
            Pixelx := (colx * 3);
            PixelLine[Pixelx] := GetRValue(FBackGroundColor);
            PixelLine[(Pixelx + 1)] := GetGValue(FBackGroundColor);
            PixelLine[(Pixelx + 2)] := GetBValue(FBackGroundColor);
          end else if (FMcolor = 2) then begin
            Pixelx := (colx * 3);
            PixelLine[Pixelx] := ColorRGBArray[0, 0];
            PixelLine[(Pixelx + 1)] := ColorRGBArray[1, 0];
            PixelLine[(Pixelx + 2)] := ColorRGBArray[2, 0];
          end
        end;
          end else
          ManMatrix[colx,rowy] := FMcolor;
end;
      end; { of row }
    end; { of col }
  end;
  //IF Dem or DemSave then Process ManMatrix
  If Switch >1 then
  begin
  MaximumElevation := -2147483647;
  MinimumElevation := 2147483646;
  maxcolx:=  255;
  maxrowy := 255;
  for Ycount := 0 to maxrowy do
  begin
    PixelLine := Bitmap.ScanLine[Ycount];
    ProgressBar1.Position := Round((Ycount / maxrowy) * 100);
    Application.ProcessMessages;
    for Xcount := 0 to maxcolx do
    begin
      TempMan:=ManMatrix[Xcount, 255-Ycount];
      if (MaximumElevation <= TempMan) then
      MaximumElevation := TempMan;
      if (MinimumElevation >= TempMan) then
      MinimumElevation := TempMan;
              Pixelx := (Xcount *3);
              ColorSet3:= GetColor(TempMan);
                PixelLine[Pixelx] := ColorSet3[0];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[2];

    end;
  end;
  ProgressBar1.Position :=0;
  Application.ProcessMessages;
  end;
If Switch =1 then
begin
  if IsLobster then
  begin
    LobsterImage.Picture.Bitmap.Assign(Bitmap);
    //LobsterImage.canvas.draw(0, 0, Bitmap);

    LobsterBitmapDisplayed:=True;
  end else
  begin
    NewtonImage.Picture.Bitmap.Assign(Bitmap);
    //NewtonImage.canvas.draw(0, 0, Bitmap);

    NewtonBitmapDisplayed:=True;
  end;
end else
If Switch =2 then
begin
dtmGlForm.Image1.Picture.Assign(Bitmap);
dtmGlForm.Image2.Picture.Assign(Bitmap);
dtmGlForm.FormShowDown(MandelImage.Width,MandelImage.Height);
dtmGlForm.show;
end else
If Switch =3 then
begin
AllDemSaver;
end;
   FXMaxLabel.Caption := Format('%1.8f', [frcNewton.FXMax]);//Egg.FXMax
   FXMinLabel.Caption := Format('%1.8f', [frcNewton.FXMin]);//Egg.FXMin
   FYMaxLabel.Caption := Format('%1.8f', [frcNewton.FYMax]);//Egg.FYMax
   FYMinLabel.Caption := Format('%1.8f', [frcNewton.FYMin]);//Egg.FYMin
   ViewLeftLabel.Caption := Format('%1.8f', [frcLobster.FXMin]);//Egg.ViewLeft
   ViewWidthLabel.Caption := Format('%1.8f', [frcLobster.FXMax]);//Egg.ViewWidth-
   ViewTopLabel.Caption := Format('%1.8f', [frcLobster.FYMin]);//Egg.ViewTop
   ViewHeightLabel.Caption := Format('%1.8f', [frcLobster.FYMax]);//Egg.ViewHeight-
   FHQLabel.Caption := Format('%1.8f', [frcNewton.FHQ]);//Egg.FHQ
   FVPLabel.Caption := Format('%1.8f', [frcNewton.FVP]);//Egg.FVP
   CxLabel.Caption := Format('%1.8f', [frcLobster.FHQ]);//Egg.Cx
   CyLabel.Caption := Format('%1.8f', [frcLobster.FVP]);//Egg.Cy
  ProgressBar1.Position :=0;
  BusyNewtLobster:=False;
  Finally
    Bitmap.free;
  end;
end;

procedure TFractalForm.LobsterImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  rx, ry: real;
  z: real;
begin
  if Shift = [ssLeft, ssShift] then
    z := 0.5
  else
  if Shift = [ssRight, ssShift] then
    z := -1.0
  else
  begin
      LobsterImageMouseMove(Sender, Shift, X, Y);
    exit;
  end;
  {If shifted then Zoom else pass to the egg}
  //f := (Sender as TFractal);  FXMax FYMax   FXMin FYMin
  rx := frcLobster.FXMin + (x * frcLobster.FYMax  / LobsterImage.Width);
  ry := frcLobster.FYMin  + ((LobsterImage.Height-y) * frcLobster.FXMax / LobsterImage.Height);
  frcLobster.FXMin  := frcLobster.FXMin + z * (rx - frcLobster.FXMin);
  frcLobster.FYMax := frcLobster.FYMax * (1 - z);
  frcLobster.FYMin   := frcLobster.FYMin  + z * (ry - frcLobster.FYMin);
  frcLobster.FXMax := frcLobster.FXMax * (1 - z);
  NewtonRender(True,1);
end;                    //LobsternImage.Height  LobsterImage.Width
procedure TFractalForm.LobsterImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var rx, ry: real;
begin   //First time to Show
  If (not LobsterBitmapDisplayed) then NewtonRender(True,1);
  if Shift = [ssLeft] then
  begin
    rx :=             // FXMax FYMax   FXMin FYMin
        frcLobster.FXMin +
        (x * frcLobster.FXMax
        / LobsterImage.Width);
    ry :=
        frcLobster.FYMin  +
        ((LobsterImage.Height-y) * frcLobster.FYMax
        / LobsterImage.Height);
    frcLobster.FHQ := rx; //frcJulia
    frcLobster.FVP := ry;  //frcJulia
    ntLobCx.Text := Format('%1.8f', [rx]); //frcDragon  frcTeeth
    ntLobCy.Text := Format('%1.8f', [ry]);
   NewtonRender(True,1);
   // frcMandel32.Invalidate;
  end;
end;

procedure TFractalForm.NewtMaxChange(Sender: TObject);
var
  i: Longint;
begin
    i := StrToInt(NewtMax.Text);
    if (i<10)  then exit; //or (i>255)
    If i <> frcNewton.MaxIterations then
    begin
    frcNewton.MaxIterations := StrToInt(NewtMax.Text);
    NewtMax.Text:=Inttostr(frcNewton.MaxIterations);
    NewtonRender(False,1);
    end;

    i := StrToInt(LobsMax.Text);
    if (i<10) then exit;
    If i <> frcLobster.MaxIterations then
    begin
    frcLobster.MaxIterations:= StrToInt(LobsMax.Text);
    LobsMax.Text:=Inttostr(frcLobster.MaxIterations);
    NewtonRender(True,1);
    end;
end;

procedure TFractalForm.NtCxChange(Sender: TObject);
//var   i: Integer;    r: Real;
begin
    //Val((Sender as TEdit).Text, r, i);
    if Sender = ntCx then frcNewton.FHQ:= StrTofloat(ntCx.Text) else
    if Sender = ntCy then frcNewton.FVP:= StrTofloat(ntCy.Text);
    if Sender = ntLobCx then frcLobster.FHQ:= StrTofloat(ntLobCx.Text) else
    if Sender = ntLobCy then frcLobster.FVP:= StrTofloat(ntLobCy.Text);
//NewtonRender(True);
end;

procedure TFractalForm.NewtonBtnClick(Sender: TObject);
begin
  NewtonRender(False,2);
end;

procedure TFractalForm.NewtonSaveBtnClick(Sender: TObject);
begin
  NewtonRender(False,3);
end;

procedure TFractalForm.LobsterSaveBtnClick(Sender: TObject);
begin
  NewtonRender(True,3);
end;
procedure TFractalForm.LobsterBtnClick(Sender: TObject);
begin
  NewtonRender(True,2);
end;

(*************************************************************)
(*************************************************************)


(*************************************************************)
(*************************************************************)
procedure TFractalForm.ACBtnClick(Sender: TObject);
var TempColor: TColor;
level,
{maxcolx,maxrowy,} color: integer;
  a, b, c, xa, xb, xc, ya, yb, yc, xs, ys: Extended;
  procedure node(xa: Extended; ya: Extended; a: Extended; xb:
    Extended; yb: Extended;
    b: Extended; xc: Extended; yc: Extended; c: Extended; xs:
      Extended; ys: Extended; s: Extended;
    level: integer); forward;
  procedure gen_circle(xa: Extended; ya: Extended; a: Extended; xb:
    Extended; yb: Extended;
    b: Extended; xc: Extended; yc: Extended; c: Extended; level:
      integer);
  var
    s, temp: Extended;
  begin
    dec(level);
    s := 1 / a + 1 / b + 1 / c + 2 * (sqrt(1 / (b * c) + 1 / (c * a)
      + 1 / (a * b)));
    s := 1 / s;
    temp := (s + a) * (s + a) - (s + b) * (s + b) - xa * xa + xb * xb
      - ya * ya + yb * yb;
    ys := (temp * (xc - xa) - (xb - xa) * ((s + a) * (s + a) - (s + c)
      * (s + c) - xa * xa
      + xc * xc - ya * ya + yc * yc)) / (2 * ((yb - ya) * (xc - xa) -
        (yc - ya) *
      (xb - xa)));
    xs := (temp - 2 * ys * (yb - ya)) / (2 * (xb - xa));
    inc(color);
    TempColor := RGB(RGBArray[0, color], RGBArray[1, color],
      RGBArray[2, color]);
    ApollianiaImage.Canvas.Brush.Color := TempColor;
      {ys and s *0.7291666}
{MainForm.Image2.Canvas.Ellipse(Round(xs+320),Round(240-ys),
Round(s),Round(s));}
    ApollianiaImage.Canvas.Ellipse(Round(xs + 320 - s), Round((240 -
      ys) - s),
      Round(xs + 320 + s), Round((240 - ys) + s));
{x1=a1-a2,y1=b1-b2,x2=a1+a2,y2=b1+b2}
    if level > 0 then
      node(xa, ya, a, xb, yb, b, xc, yc, c, xs, ys, s, level);
  end;
  procedure node(xa: Extended; ya: Extended;
    a: Extended; xb: Extended; yb: Extended;
    b: Extended; xc: Extended; yc: Extended;
    c: Extended; xs: Extended; ys: Extended;
    s: Extended;
    level: integer);
  begin
    gen_circle(xa, ya, a, xb, yb, b, xs, ys, s, level);
    gen_circle(xb, yb, b, xc, yc, c, xs, ys, s, level);
    gen_circle(xa, ya, a, xc, yc, c, xs, ys, s, level);
  end;
begin
  level :=ACRG.itemindex+1;
  a := 625;
  b := 375;
  c := 945;
  color := 1;
  xa := -725;
  ya := 235;
  xb := 275;
  yb := 268;
  xc := 180;
  yc := -1048;
  with ApollianiaImage.Canvas do begin
{	maxcolx :=(FYImageX-1);
 maxrowy := (FYImageY-1);}
{Brush.Color:=FBackGroundColor;
Brush.Style:=bsSolid;
FillRect(Rect(0,0,maxcolx,maxrowy));
TempColor:=RGB(255-GetRValue(FBackGroundColor),
                255-GetGValue(FBackGroundColor),
                255-GetBValue(FBackGroundColor));
Pen.Color := TempColor;
Font.Color:= TempColor;
MainForm.Show;}
    TempColor := RGB(RGBArray[0, color], RGBArray[1, color],
      RGBArray[2, color]);
    Brush.Color := TempColor; Pen.Color := TempColor;
{	SetFillStyle(1,color);
 setColor(color);}
{Ellipse(Round(xa+320),Round(240-ya),Round(a),Round(a));}
    Ellipse(Round(xa + 320 - a), Round((240 - ya) - a),
      Round(xa + 320 + a), Round((240 - ya) + a));
    inc(color);
 {	SetFillStyle(1,color);
 SetColor(color);}
    TempColor := RGB(RGBArray[0, color], RGBArray[1, color],
      RGBArray[2, color]);
    Brush.Color := TempColor; Pen.Color := TempColor;
{Ellipse(Round(xb+320),Round(240-yb),Round(b),Round(b));}
    Ellipse(Round(xb + 320 - b), Round((240 - yb) - b),
      Round(xb + 320 + b), Round((240 - yb) + b));
    inc(color);
 {	SetFillStyle(1,color);
 SetColor(color);}
    TempColor := RGB(RGBArray[0, color], RGBArray[1, color],
      RGBArray[2, color]);
    Brush.Color := TempColor; Pen.Color := TempColor;
{Ellipse(Round(xc+320),Round(240-yc),Round(c),Round(c));}
    Ellipse(Round((xc + 320) - c), Round((240 - yc) - c),
      Round(xc + 320 + c), Round((240 - yc) + c));
{x1=a1-a2,y1=b1-b2,x2=a1+a2,y2=b1+b2}
    gen_circle(xa, ya, a, xb, yb, b, xc, yc, c, level);
  end;
end; { of Apolly}
procedure TFractalForm.AcSaveBtnClick(Sender: TObject);
begin
  SaveDialog1.InitialDir := ProgramPath;
  SaveDialog1.FileName := 'Apolly.bmp';
  if SaveDialog1.Execute then { Display Open dialog box }
  ApollianiaImage.Picture.SaveToFile(SaveDialog1.FileName);
end;


procedure TFractalForm.PCBBtnClick(Sender: TObject);
var TempColor: TColor;
  GfColor, {maxcolx,maxrowy,}
    i: integer;
  a_line, b_line, x_o, y_o, radius, r_sq, height: Extended;
  xbig, ybig, rbig, rtan: Extended;
  procedure inverseOval(x: Extended; y: Extended; b: Extended;
    color: integer; aspect: Extended);
  var
    new_col, new_row: integer;
    length, new_length: Extended;
    a, a_square, b_square, two_a_square, two_b_square, four_a_square,
      four_b_square, d, row, col: longint;
  begin
    a := Round(b / aspect);
    b_square := Round(b * b);
    a_square := (a * a);
    row := Round(b);
    col := 0;
    two_a_square := a_square shl 1;
    four_a_square := a_square shl 2;
    four_b_square := b_square shl 2;
    two_b_square := b_square shl 1;
    d := two_a_square * ((row - 1) * (row)) + a_square +
      two_b_square * (1 - a_square);

    while a_square * row > b_square * col do
    begin
      length := sqrt((x_o - col - x) * (x_o - col - x) +
        (y_o - row - y) * (y_o - row - y));
      new_length := r_sq / length;
      new_col := Round(x_o - (x_o - col - x) * new_length / length);
      new_row := Round(-y_o + (y_o - row - y) * new_length / length);
{TempColor:=RGB(RGBArray[0,color],RGBArray[1,color],RGBArray[2,color]);}
      PharoahImage.Canvas.Pixels[new_col + 320, 240 -
        Round(new_row)] := TempColor;
      length := sqrt((x_o + col - x) * (x_o + col - x) +
        (y_o - row - y) * (y_o - row - y));
      new_length := r_sq / length;
      new_col := Round(x_o - (x_o + col - x) * new_length / length);
      new_row := Round(-y_o + (y_o - row - y) * new_length / length);
{TempColor:=RGB(RGBArray[0,color],RGBArray[1,color],RGBArray[2,color]);}
      PharoahImage.Canvas.Pixels[new_col + 320, 240 -
        Round(new_row)] := TempColor;
      length := sqrt((x_o - col - x) * (x_o - col - x) +
        (y_o + row - y) * (y_o + row - y));
      new_length := r_sq / length;
      new_col := Round(x_o - (x_o - col - x) * new_length / length);
      new_row := Round(-y_o + (y_o + row - y) * new_length / length);
{TempColor:=RGB(RGBArray[0,color],RGBArray[1,color],RGBArray[2,color]);}
      PharoahImage.Canvas.Pixels[new_col + 320, 240 -
        Round(new_row)] := TempColor;
      length := sqrt((x_o + col - x) * (x_o + col - x) +
        (y_o + row - y) * (y_o + row - y));
      new_length := r_sq / length;
      new_col := Round(x_o - (x_o + col - x) * new_length / length);
      new_row := Round(-y_o + (y_o + row - y) * new_length / length);
{TempColor:=RGB(RGBArray[0,color],RGBArray[1,color],RGBArray[2,color]);}
      PharoahImage.Canvas.Pixels[new_col + 320, 240 -
        Round(new_row)] := TempColor;
      if d >= 0 then
      begin
        dec(row);
        d := d - four_a_square * (row);
      end;
      d := d + two_b_square * (3 + (col shl 1));
      inc(col);
    end;

    d := two_b_square * (col + 1) * col + two_a_square * (row *
      (row - 2) + 1) + (1 - two_a_square) * b_square;
{ TempColor:=RGB(RGBArray[0,color],RGBArray[1,color],RGBArray[2,color]);}
    while row + 1 <> 0 do
    begin
      length := sqrt((x_o - col - x) * (x_o - col - x) +
        (y_o - row - y) * (y_o - row - y));
      new_length := r_sq / length;
      new_col := Round(x_o - (x_o - col - x) * new_length / length);
      new_row := Round(-y_o + (y_o - row - y) * new_length / length);
{ TempColor:=RGB(RGBArray[0,color],RGBArray[1,color],RGBArray[2,color]);}
      PharoahImage.Canvas.Pixels[new_col + 320, 240 -
        Round(new_row)] := TempColor;
      length := sqrt((x_o + col - x) * (x_o + col - x) +
        (y_o - row - y) * (y_o - row - y));
      new_length := r_sq / length;
      new_col := Round(x_o - (x_o + col - x) * new_length / length);
      new_row := Round(-y_o + (y_o - row - y) * new_length / length);
{TempColor:=RGB(RGBArray[0,color],RGBArray[1,color],RGBArray[2,color]);}
      PharoahImage.Canvas.Pixels[new_col + 320, 240 -
        Round(new_row)] := TempColor;
      length := sqrt((x_o - col - x) * (x_o - col - x) +
        (y_o + row - y) * (y_o + row - y));
      new_length := r_sq / length;
      new_col := Round(x_o - (x_o - col - x) * new_length / length);
      new_row := Round(-y_o + (y_o + row - y) * new_length / length);
{TempColor:=RGB(RGBArray[0,color],RGBArray[1,color],RGBArray[2,color]);}
      PharoahImage.Canvas.Pixels[new_col + 320, 240 -
        Round(new_row)] := TempColor;
      length := sqrt((x_o + col - x) * (x_o + col - x) +
        (y_o + row - y) * (y_o + row - y));
      new_length := r_sq / length;
      new_col := Round(x_o - (x_o + col - x) * new_length / length);
      new_row := Round(-y_o + (y_o + row - y) * new_length / length);
{TempColor:=RGB(RGBArray[0,color],RGBArray[1,color],RGBArray[2,color]);}
      PharoahImage.Canvas.Pixels[new_col + 320, 240 -
        Round(new_row)] := TempColor;
      if d <= 0 then
      begin
        inc(col);
        d := d + four_b_square * col;
      end;
      dec(row);
      d := d + two_a_square * (3 - (row shl 1));
    end;
{		b := b + 1;}
  end;

  procedure gen_circle(x: Extended; y: Extended; radius: Extended);
  begin
    inverseOval(x, y, radius, GFColor, 1.0);
    inverseOval(-x, y, radius, GFColor, 1.0);
  end;

begin
  with PharoahImage.Canvas do begin
{	maxcolx :=(FYImageX-1);
 maxrowy := (FYImageY-1); }
{Brush.Color:=FBackGroundColor;
Brush.Style:=bsSolid;
FillRect(Rect(0,0,maxcolx,maxrowy));
TempColor:=RGB(255-GetRValue(FBackGroundColor),
                255-GetGValue(FBackGroundColor),
                255-GetBValue(FBackGroundColor));
Pen.Color := TempColor;
Font.Color:= TempColor;
MainForm.Show;}
    GfColor := 14;
    r_sq := 400000;
    xbig := 0;
    ybig := 0;
    rbig := 220;
    rtan := 140;
{	xtan := 0;}
{	ytan := ybig + rbig - rtan;}
    y_o := ybig - rbig;
    x_o := xbig;
    TempColor := RGB(RGBArray[0, 14], RGBArray[1, 14], RGBArray[2,
      14]);
    Brush.Color := TempColor; Brush.Style := bsSolid; {0,360,}
{	Ellipse(Round(xbig+320),240 - Round(ybig),
                Round(rbig),Round(rbig));}
    Ellipse(100, 20, 540, 460);
{Big first      320,240,220,220}{x1=a1-a2,y1=b1-b2,x2=a1+a2,y2=b1+b2}
    TempColor := RGB(RGBArray[0, 15], RGBArray[1, 15], RGBArray[2,
      15]);
    Brush.Color := TempColor; Brush.Style := bsSolid; {0,360,}
{	Ellipse(Round(xtan+320),240 - Round(ytan),
                Round(rtan),Round(rtan));}
    Ellipse(180, 20, 460, 300);
{Little        320,160,140,140          }
    TempColor := RGB(RGBArray[0, 0], RGBArray[1, 0], RGBArray[2, 0]);
    Pen.Color := TempColor;
    Brush.Color := TempColor; Brush.Style := bsSolid;
    PharoahImage.Canvas.Ellipse(271, 362, 369, 460);
    TempColor := RGB(RGBArray[0, 1], RGBArray[1, 1], RGBArray[2, 1]);
    Pen.Color := TempColor;
    Brush.Color := TempColor; Brush.Style := bsSolid;
    PharoahImage.Canvas.Ellipse(154, 324, 240, 410);
    PharoahImage.Canvas.Ellipse(400, 324, 486, 410);
    TempColor := RGB(RGBArray[0, 2], RGBArray[1, 2], RGBArray[2, 2]);
    Pen.Color := TempColor;
    Brush.Color := TempColor; Brush.Style := bsSolid;
    PharoahImage.Canvas.Ellipse(104, 248, 169, 312);
    PharoahImage.Canvas.Ellipse(472, 248, 536, 312);

    a_line := r_sq / (2 * rbig);
    b_line := r_sq / (2 * rtan);
    height := (b_line - a_line);
    radius := height / 2;
    height := radius * sqrt(2.0);
    GfColor := 14;
    for i := 0 to 15 do
    begin
      Inc(GfColor);
      if GfColor > 13 then GfColor := 0;
      TempColor := RGB(RGBArray[0, GfColor], RGBArray[1, GfColor],
        RGBArray[2, GfColor]);
      gen_circle(x_o + height * i, y_o + a_line + radius, radius);
      gen_circle(x_o + height * i, y_o + a_line + radius / 2, radius
        / 2);
      gen_circle(x_o + height * i, y_o + b_line - radius / 2, radius
        / 2);
      gen_circle(x_o + height * i + height / 2, y_o + a_line +
        3 * radius / 4, radius / 4);
      gen_circle(x_o + height * i + height / 2, y_o + b_line -
        3 * radius / 4, radius / 4);
      gen_circle(x_o + height * i + height / 2, y_o + a_line + radius
        / 8,
        radius / 8);
      gen_circle(x_o + height * i + height / 2, y_o + b_line - radius
        / 8,
        radius / 8);
      gen_circle(x_o + height * i + height / 2, y_o + a_line +
        5 * radius / 12, radius / 12);
      gen_circle(x_o + height * i + height / 2, y_o + b_line -
        5 * radius / 12, radius / 12);
      gen_circle(x_o + height * i + 0.4 * height, y_o + a_line +
        0.3 * radius, radius / 10);
      gen_circle(x_o + height * i + 0.6 * height, y_o + a_line +
        0.3 * radius, radius / 10);
      gen_circle(x_o + height * i + 0.4 * height, y_o + b_line -
        0.3 * radius, radius / 10);
      gen_circle(x_o + height * i + 0.6 * height, y_o + b_line -
        0.3 * radius, radius / 10);
    end;
  end;
end; { of procedure IPharaoh }

procedure TFractalForm.PcbSaveBtnClick(Sender: TObject);
begin
  SaveDialog1.InitialDir := ProgramPath;
  SaveDialog1.FileName := 'Pharoh.bmp';
  if SaveDialog1.Execute then { Display Open dialog box }
  PharoahImage.Picture.SaveToFile(SaveDialog1.FileName);
end;
(*************************************************************)
(*************************************************************)


(*************************************************************)
(*************************************************************)
procedure TFractalForm.DlaStopBtnClick(Sender: TObject);
begin
  DlaStopRunning:=True;
end;
{Grow along bottom of screen}
procedure TFractalForm.DLABtnClick(Sender: TObject);
  {(Freq,F_Dim: Extended;Intensity:Integer)}
var
  TempColor: TColor;
  Contact: Boolean;
  Intensity,
  X, Y, HighestHigh, {CurrentX,CurrentY,} spacer,
    ICount, maxcolx, maxrowy: Integer;
  HighS, Xs, Ys: string;
begin
  DlaStopRunning:=False;
  Intensity:=dlarg.itemindex;
  with DlaImage.Canvas do begin
    maxcolx := (524 - 1);
    maxrowy := (256 - 1);
    HighestHigh := (256 - 5);
    Brush.Color:=FBackGroundColor;
    Brush.Style:=bsSolid;
    FillRect(Rect(0,0,524,256));
    TempColor:=RGB(255-GetRValue(FBackGroundColor),
                255-GetGValue(FBackGroundColor),
                255-GetBValue(FBackGroundColor));
    Pen.Color := TempColor;
    Font.Color:= TempColor;
    {Set up bottom line glue}
    Moveto(0,maxrowy);
    Lineto(maxcolx,maxrowy);
{Set up multi color line}
    for X := 0 to maxcolx do begin
      TempColor := RGB(ColorRGBArray[0, (Random(255) mod 255)],
        ColorRGBArray[1, (Random(255) mod 255)],
        ColorRGBArray[2, (Random(255) mod 255)]);
      Pixels[X, maxrowy] := TempColor;
    end;
{    MainForm.Show;}
    //Randomize;
   // bRotateImage := False; {in the Drawing...}
    //bRotatingImage := True;
    maxcolx := (524 - 3);
    X := random(maxcolx) + 1;
    Y := HighestHigh; {Start from HighestHigh + 3}
    str(X, Xs); str(Y, Ys); str(HighestHigh, HighS);
  DlaLabel.Caption := 'FX: ' + Xs + ', FY: ' + Ys +
      ',  High: ' + HighS;
    Application.ProcessMessages;
    repeat
      If DlaStopRunning then exit;
      for Spacer := 1 to 100 do begin
        X := random(maxcolx) + 1;
        Y := HighestHigh; {Start from HighestHigh + 3}
{Y:= (Random((maxrowy-(HighestHigh-2)))+HighestHigh);}
        if Y > maxrowy then Y := HighestHigh;
        Contact := True;
        ICount := 0;
        while Contact do begin {Drop bombers}
          if (FBackGroundColor <> Pixels[X + 1, Y + 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X + 1, Y + 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X - 1, Y + 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X - 1, Y + 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X, Y + 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X, Y + 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X + 1, Y]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X + 1, Y];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X - 1, Y]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X - 1, Y];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X + 1, Y - 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X + 1, Y - 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X - 1, Y - 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X - 1, Y - 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X, Y - 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X, Y - 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          X := X + (Random(3) - 1);
{Y := Y + (Random(3)-1);}{Keep in bounds}
          Y := Y + (Random(3)); {Keep in bounds.. always dropping}
          if X > maxcolx then
            X := ((maxcolx div 2) - round((random - random) * 100));
          if X < 1 then
            X := ((maxcolx div 2) + round((random - random) * 100));
          if Y > maxrowy then Y := HighestHigh;
          if Y < HighestHigh - 4 then Y := HighestHigh;
        end; {end of while}
      end; {of spacer}
      str(X, Xs); str(Y, Ys); str(HighestHigh, HighS);
     DlaLabel.Caption := 'FX: ' + Xs + ', FY: ' + Ys +
        ',  High: ' + HighS;
      Application.ProcessMessages;
    until ({(bRotateImage = True) or} (HighestHigh < 7));
  end;
end;


{Grow along bottom of screen}
procedure TFractalForm.DLACBtnClick(Sender: TObject);
var
  TempColor: TColor;
  Contact: Boolean;
  Intensity,
  X, Y, HighestHigh, {CurrentX,CurrentY,} Spacer,
    ICount, maxcolx, maxrowy: Integer;
  HighS, Xs, Ys: string;
begin
  DlaStopRunning:=False;
  Intensity:=dlarg.itemindex;
  with DlaImage.Canvas do begin
    maxcolx := (524 - 1);
    maxrowy := (256 - 1);
    HighestHigh := (256 - 5);
    Brush.Color:=FBackGroundColor;
    Brush.Style:=bsSolid;
    FillRect(Rect(0,0,524,256));
    TempColor:=RGB(255-GetRValue(FBackGroundColor),
                255-GetGValue(FBackGroundColor),
                255-GetBValue(FBackGroundColor));
    Pen.Color := TempColor;
    Font.Color:= TempColor;
    {Set up bottom line glue}
    Moveto(0, maxrowy);
    Lineto(maxcolx, maxrowy);
{Set up multi color line}
    for X := 0 to maxcolx do begin
      TempColor := RGB(ColorRGBArray[0, (Random(255) mod 255)],
        ColorRGBArray[1, (Random(255) mod 255)],
        ColorRGBArray[2, (Random(255) mod 255)]);
      Pixels[X, maxrowy] := TempColor;
    end;
{    MainForm.Show;}
//    Randomize;
//    bRotateImage := False; {in the Drawing...}
//    bRotatingImage := True;
    maxcolx := (524 - 3);
    X := random(maxcolx) + 1;
    Y := HighestHigh; {Start from HighestHigh + 3}
    str(X, Xs); str(Y, Ys); str(HighestHigh, HighS);
  DlaLabel.Caption := 'FX: ' + Xs + ', FY: ' + Ys +
      ',  High: ' + HighS;
    Application.ProcessMessages;
    repeat
      If DlaStopRunning then exit;
      for Spacer := 1 to 100 do begin
        X := (X mod 6);
        if X = 1 then
          X := ((maxcolx div 2) + round((random - random) * 100))
        else X := random(maxcolx) + 1;
{X:= (maxcolx div 2);}
        Y := HighestHigh; {Start from HighestHigh + 3}
{Y:= (Random((maxrowy-(HighestHigh-2)))+HighestHigh);}
        if Y > maxrowy then Y := HighestHigh;
        Contact := True;
        ICount := 0;
        while Contact do begin {Drop bombers}
          if (FBackGroundColor <> Pixels[X + 1, Y + 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X + 1, Y + 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X - 1, Y + 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X - 1, Y + 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X, Y + 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X, Y + 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X + 1, Y]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X + 1, Y];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X - 1, Y]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X - 1, Y];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X + 1, Y - 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X + 1, Y - 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X - 1, Y - 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X - 1, Y - 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
          if (FBackGroundColor <> Pixels[X, Y - 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then HighestHigh := Y - 3;
              TempColor := Pixels[X, Y - 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;

If (  {TempColor =}
    (FBackGroundColor <> Pixels[X+1,Y+1]) or
    (FBackGroundColor <> Pixels[X-1,Y+1]) or
    (FBackGroundColor <> Pixels[X,Y+1]) or
    (FBackGroundColor <> Pixels[X+1,Y]) or
    (FBackGroundColor <> Pixels[X-1,Y]) or
    (FBackGroundColor <> Pixels[X+1,Y-1]) or
    (FBackGroundColor <> Pixels[X-1,Y-1]) or
    (FBackGroundColor <> Pixels[X,Y-1])
    )  then
        begin  {Contacted so accumulate}
        If Y = HighestHigh Then HighestHigh:=Y-3;
        Pixels[X,Y]:= TempColor;
        Contact:= False;
        end;

str(X,Xs);str(Y,Ys);
DlaLabel.Caption:='FX: '+Xs+', FY: '+Ys;
Application.ProcessMessages;
          X := X + (Random(3) - 1);
{Y := Y + (Random(3)-1);}{Keep in bounds}
          Y := Y + (Random(3)); {Keep in bounds.. always dropping}
{If X > maxcolx Then X := ((maxcolx div 2)- round((random -random) *100));
If X < 1 Then X := ((maxcolx div 2)+ round((random -random) *100));}
          if X > maxcolx then X := (maxcolx div 2);
          if X < 1 then X := ((maxcolx div 2));
          if Y > maxrowy then Y := HighestHigh;
          if Y < HighestHigh - 4 then Y := HighestHigh;
        end; {end of while}
      end;
      str(X, Xs); str(Y, Ys); str(HighestHigh, HighS);
     DlaLabel.Caption := 'FX: ' + Xs + ', FY: ' + Ys +
        ',  High: ' + HighS;
      Application.ProcessMessages;
    until ({(bRotateImage = True) or} (HighestHigh < 7));
  end;
end;



{Grow at center of screen... make a box and throw at center}
  {(Freq,F_Dim: Extended;Points,Intensity:Integer)}
  //(DLA) Centroid [i] [0..5]
 // (DLA) Bottom Center [i] [0..5]
procedure TFractalForm.DLACentroidBtnClick(Sender: TObject);
var
  TempColor: TColor;
  Contact: Boolean; Spacer,
  Intensity,
  X, Y, HighestHigh, LowestLow, RightSide, LeftSide, Stepcounter,
    ICount, CenterX, CenterY, Centroid, maxcolx, maxrowy: Integer;
  HighS, Xs, Ys: string;
begin
  DlaStopRunning:=False;
  Intensity:=dlarg.itemindex;
  with DlaImage.Canvas do begin
    Brush.Color:=FBackGroundColor;
    Brush.Style:=bsSolid;
    FillRect(Rect(0,0,524,256));
    TempColor:=RGB(255-GetRValue(FBackGroundColor),
                255-GetGValue(FBackGroundColor),
                255-GetBValue(FBackGroundColor));
    Pen.Color := TempColor;
    Font.Color:= TempColor;
    //MainForm.Show;}
    {Set up bottom line glue}
    maxcolx := (10);
    maxrowy := (10);
    CenterX := (524 div 2);
    CenterY := (256 div 2);
{    HighestHigh:=(CenterY+5);
    LowestLow:=(CenterY-5);}
    HighestHigh := (CenterY - 5);
    LowestLow := (CenterY + 5);
    RightSide := (CenterX + 5);
    LeftSide := (CenterX - 5);
{Set up multi color line}
    for X := CenterX - 2 to CenterX + 2 do begin
      for Y := CenterY - 2 to CenterY + 2 do begin
        TempColor := RGB(ColorRGBArray[0, (Random(255) mod 255)],
          ColorRGBArray[1, (Random(255) mod 255)],
          ColorRGBArray[2, (Random(255) mod 255)]);
        Pixels[X, Y] := TempColor;
      end;
    end;
//    Randomize;
//    bRotateImage := False; {in the Drawing...}
//    bRotatingImage := True;
    X := CenterX;
    Y := HighestHigh;
    str(X, Xs); str(Y, Ys); str(HighestHigh, HighS);
    DlaLabel.Caption := 'FX: ' + Xs + ', FY: ' + Ys +
      ',  High: ' + HighS;
    Application.ProcessMessages;
    repeat
      If DlaStopRunning then exit;
      for Spacer := 1 to 100 do begin
        ICount := 0;
        Centroid := random(4);
        if Centroid = 0 then {center + (width * random + or -)}
        begin X := LeftSide;
 {    Y:=(CenterY+ ( (random(maxrowy div 2)) *(random(2) -random(2)) )  );}
          Y := (CenterY + ((random(maxrowy div 2)) - (random(maxrowy
            div 2))));

        end else
          if Centroid = 1 then {center + (width * random + or -)}
          begin X := RightSide;
{     Y:=(CenterY+ ( (random(maxrowy div 2)) *(random(2) -random(2))));}
            Y := (CenterY + ((random(maxrowy div 2)) - (random(maxrowy
              div 2))));

          end else
            if Centroid = 2 then {center + (width * random + or -)}
            begin
{     X:=(CenterX + ( (random(maxcolx div 2)) *(random(2) -random(2))));}
              X := (CenterX + ((random(maxcolx div 2)) -
                (random(maxcolx div 2))));
              Y := HighestHigh;
            end else
              if Centroid = 3 then {center + (width * random + or -)}
              begin
                X := (CenterX + ((random(maxcolx div 2)) -
                  (random(maxcolx div 2))));
                Y := LowestLow;
              end else ;{center + (width * random + or -)}
               { showmessage('oops 1');}
        Stepcounter := 0;
        Contact := True;
        while ((Contact) and (Stepcounter < 2000)) do
          begin {Drop bombers}
          inc(Stepcounter);
          case Centroid of {Keep in bounds.. always dropping}
            0: begin {Left}
                X := X + (Random(3) - 1);
                Y := Y + (Random(3) - 1); {  +(Random(2)-Random(2));}
              end;
            1: begin {Right}
                X := X + (Random(3) - 1); {  -(Random(2));}
                Y := Y + (Random(3) - 1); {  +(Random(2)-Random(2));}
              end;
            2: begin {Top}
                X := X + (Random(3) - 1);
                Y := Y + (Random(3) - 1); {+(Random(2));}
              end;
            3: begin {Bottom}
                X := X + (Random(3) - 1);
                Y := Y + (Random(3) - 1); {  -(Random(2));}
              end;
          else ;{showmessage('oops');}
          end; {of case}

          if (X < (LeftSide - 4)) then X := LeftSide;
          if (X > (RightSide + 4)) then X := RightSide;
          if (Y < (HighestHigh - 4)) then Y := HighestHigh;
          if (Y > (LowestLow + 4)) then Y := LowestLow;
{    HighestHigh:=(CenterY-5);
    LowestLow:=(CenterY+5);
    RightSide:=(CenterX+5);
    LeftSide:=(CenterX-5);}
          if (FBackGroundColor <> Pixels[X - 1, Y + 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then
                begin HighestHigh := Y - 3; inc(maxrowy, 6); end;
              if Y = LowestLow then
                begin LowestLow := Y + 3; inc(maxrowy, 6); end;
              if X = RightSide then
                begin RightSide := X + 3; inc(maxcolx, 6); end;
              if X = LeftSide then
                begin LeftSide := X - 3; inc(maxcolx, 6); end;
              TempColor := Pixels[X - 1, Y + 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end; { else}
          if (FBackGroundColor <> Pixels[X - 1, Y - 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount = Intensity) then begin
              if Y = HighestHigh then
                begin HighestHigh := Y - 3; inc(maxrowy, 6); end;
              if Y = LowestLow then
                begin LowestLow := Y + 3; inc(maxrowy, 6); end;
              if X = RightSide then
                begin RightSide := X + 3; inc(maxcolx, 6); end;
              if X = LeftSide then
                begin LeftSide := X - 3; inc(maxcolx, 6); end;
              TempColor := Pixels[X - 1, Y - 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end; { else}
          if (FBackGroundColor <> Pixels[X + 1, Y - 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then
                begin HighestHigh := Y - 3; inc(maxrowy, 6); end;
              if Y = LowestLow then
                begin LowestLow := Y + 3; inc(maxrowy, 6); end;
              if X = RightSide then
                begin RightSide := X + 3; inc(maxcolx, 6); end;
              if X = LeftSide then
                begin LeftSide := X - 3; inc(maxcolx, 6); end;
              TempColor := Pixels[X + 1, Y - 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end; { else}
          if (FBackGroundColor <> Pixels[X + 1, Y + 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then
                begin HighestHigh := Y - 3; inc(maxrowy, 6); end;
              if Y = LowestLow then
                begin LowestLow := Y + 3; inc(maxrowy, 6); end;
              if X = RightSide then
                begin RightSide := X + 3; inc(maxcolx, 6); end;
              if X = LeftSide then
                begin LeftSide := X - 3; inc(maxcolx, 6); end;
              TempColor := Pixels[X + 1, Y + 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end; { else}
          if (FBackGroundColor <> Pixels[X - 1, Y]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then
                begin HighestHigh := Y - 3; inc(maxrowy, 6); end;
              if Y = LowestLow then
                begin LowestLow := Y + 3; inc(maxrowy, 6); end;
              if X = RightSide then
                begin RightSide := X + 3; inc(maxcolx, 6); end;
              if X = LeftSide then
                begin LeftSide := X - 3; inc(maxcolx, 6); end;
              TempColor := Pixels[X - 1, Y];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end; { else}
          if (FBackGroundColor <> Pixels[X + 1, Y]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then
                begin HighestHigh := Y - 3; inc(maxrowy, 6); end;
              if Y = LowestLow then
                begin LowestLow := Y + 3; inc(maxrowy, 6); end;
              if X = RightSide then
                begin RightSide := X + 3; inc(maxcolx, 6); end;
              if X = LeftSide then
                begin LeftSide := X - 3; inc(maxcolx, 6); end;
              TempColor := Pixels[X + 1, Y];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end; { else}
          if (FBackGroundColor <> Pixels[X, Y + 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then
                begin HighestHigh := Y - 3; inc(maxrowy, 6); end;
              if Y = LowestLow then
                begin LowestLow := Y + 3; inc(maxrowy, 6); end;
              if X = RightSide then
                begin RightSide := X + 3; inc(maxcolx, 6); end;
              if X = LeftSide then
                begin LeftSide := X - 3; inc(maxcolx, 6); end;
              TempColor := Pixels[X, Y + 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end; { else}
          if (FBackGroundColor <> Pixels[X, Y - 1]) then
          begin {Contacted so accumulate}
            inc(ICount); if (ICount >= Intensity) then begin
              if Y = HighestHigh then
                begin HighestHigh := Y - 3; inc(maxrowy, 6); end;
              if Y = LowestLow then
                begin LowestLow := Y + 3; inc(maxrowy, 6); end;
              if X = RightSide then
                begin RightSide := X + 3; inc(maxcolx, 6); end;
              if X = LeftSide then
                begin LeftSide := X - 3; inc(maxcolx, 6); end;
              TempColor := Pixels[X, Y - 1];
              Pixels[X, Y] := TempColor;
              Contact := False;
            end; end;
str(X,Xs);str(Y,Ys);  str(StepCounter,HighS);
DlaLabel.Caption:='FX: '+Xs+', FY: '+Ys+',  Count: '+HighS;
Application.ProcessMessages;
        end; {end of while}
      end; {of spacer}
      str(X, Xs); str(Y, Ys); {str(HighestHigh,HighS);}
        str(StepCounter, HighS);
      DlaLabel.Caption := 'FX: ' + Xs + ', FY: ' + Ys +
        ',  High: ' + HighS;
      Application.ProcessMessages;
    until ({(bRotateImage = True)  or }
     (HighestHigh < 7) or (LowestLow > 256{FYImageY})
      or (RightSide > 524{FYImageX}) or (LeftSide < 7));
  end;
end;
(*************************************************************)
(*************************************************************)


(*************************************************************)
(*************************************************************)




end.
